import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsxs(_components.p, {
      children: ["JSX dapat menggunakan JavaScript untuk mengontrol aliran logika di template. Namun, tanpa Virtual DOM, penggunaan hal-hal naif seperti ", jsx(_components.code, {
        children: "Array.prototype.map"
      }), " akan sia-sia saja untuk membuat ulang semua node DOM pada setiap pembaruan. Alih-alih, pustaka Reaktif biasanya menggunakan pembantu template. Pada Solid, kami membungkusnya dalam komponen."]
    }), "\n", jsxs(_components.p, {
      children: ["Aliran kontrol yang paling dasar adalah percabangan bersyarat. Kompiler Solid cukup pintar untuk menangani ekspresi ternaries (", jsx(_components.code, {
        children: "a ? b : c"
      }), ") dan boolean (", jsx(_components.code, {
        children: "a && b"
      }), ") secara optimal. Namun, sering kali lebih mudah dibaca menggunakan komponen ", jsx(_components.code, {
        children: "<Show>"
      }), " pada Solid."]
    }), "\n", jsx(_components.p, {
      children: "Dalam contoh ini, kami hanya ingin menampilkan tombol yang sesuai dan mencerminkan keadaan saat ini (apakah pengguna login atau tidak). Perbarui JSX menjadi:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), "\n  when={", jsx(_components.span, {
          className: "hljs-title function_",
          children: "loggedIn"
        }), "()}\n  fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "button"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "onClick"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{toggle}"
            }), ">"]
          }), "Log in", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "button"
            }), ">"]
          })]
        }), "}\n>\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "button"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "onClick"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{toggle}"
            }), ">"]
          }), "Log out", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "button"
            }), ">"]
          })]
        }), "\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Prop ", jsx(_components.code, {
        children: "fallback"
      }), " bertindak sebagai ", jsx(_components.code, {
        children: "else"
      }), " dan akan ditampilkan jika kondisi yang diteruskan ke ", jsx(_components.code, {
        children: "when"
      }), " tidak benar/false."]
    }), "\n", jsx(_components.p, {
      children: "Sekarang ketika kamu mengklik tombol, itu akan berubah bolak-balik seperti yang diharapkan."
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
