import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsxs(_components.p, {
      children: ["Мы видели, что всякий раз, когда мы обращаемся к ", jsx(_components.code, {
        children: "Сигналу"
      }), " в JSX, он автоматически обновляет UI при изменении этого ", jsx(_components.code, {
        children: "Сигнала"
      }), ". Но сама функция компонента выполняется только один раз."]
    }), "\n", jsxs(_components.p, {
      children: ["Мы можем создавать новые выражения, которые зависят от ", jsx(_components.code, {
        children: "Сигналов"
      }), ", оборачивая его в функцию. Функция, которая обращается к ", jsx(_components.code, {
        children: "Сигналу"
      }), ", сама является ", jsx(_components.code, {
        children: "Сигналом"
      }), ": когда внутренний ", jsx(_components.code, {
        children: "Сигнал"
      }), " изменяется, обновляются и его считыватели."]
    }), "\n", jsxs(_components.p, {
      children: ["Введем функцию ", jsx(_components.code, {
        children: "doubleCount"
      }), ", удваивающую наш счетчик:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "doubleCount"
        }), " = (", jsx(_components.span, {
          className: "hljs-params"
        }), ") => ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "count"
        }), "() * ", jsx(_components.span, {
          className: "hljs-number",
          children: "2"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Затем мы можем вызвать ", jsx(_components.code, {
        children: "doubleCount"
      }), " точно так же, как ", jsx(_components.code, {
        children: "Cигнал"
      }), " в нашем JSX:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Count: {doubleCount()}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Мы называем подобные функции ", jsx(_components.code, {
        children: "производными Сигналами"
      }), " (", jsx(_components.code, {
        children: "deferred Signal"
      }), "), потому что они получают свою реактивность от ", jsx(_components.code, {
        children: "Сигнала"
      }), ", к которому они обращаются. Сами они не хранят значение (если вы создаете производный ", jsx(_components.code, {
        children: "Сигнал"
      }), ", но никогда не вызываете его, он будет удален из компилированного кода Solid, как и любая неиспользуемая функция), но они обновят любые ", jsx(_components.code, {
        children: "Эффекты"
      }), ", которые зависят от них, и вызовут ьь, если эти ", jsx(_components.code, {
        children: "Сигналы"
      }), " включены в представление."]
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
