import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsxs(_components.p, {
      children: ["Manchmal ist es wünschenswert, Lesezugriffe auf Signale nicht zu verfolgen, selbst innerhalb eines reaktiven Kontexts. Solid bietet dafür den ", jsx(_components.code, {
        children: "untrack"
      }), "-Helfer an, um zu verhindern, dass die umgebende Berechnung durch den Lesezugriff reaktiv auf Änderungen reagiert."]
    }), "\n", jsxs(_components.p, {
      children: ["Mal angenommen, wir wollen nicht, dass bei Änderungen von ", jsx(_components.code, {
        children: "b"
      }), " neu ein Log ausgegeben wird. Wir können das ", jsx(_components.code, {
        children: "b"
      }), "-Signal untracken, indem wir unseren Effekt wie folgt ändern:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "a"
        }), "(), ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "untrack"
        }), "(b));\n});\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Da Signale Funktionen sind, können sie direkt übergeben werden, aber ", jsx(_components.code, {
        children: "untrack"
      }), " kann auch Funktionen mit komplexerem Verhalten kapseln."]
    }), "\n", jsxs(_components.p, {
      children: ["Obwohl ", jsx(_components.code, {
        children: "untrack"
      }), " die Verfolgung von Lesezugriffen unterbindet, hat es keinen Effekt auf Schreibzugriffe, die weiterhin passieren und die Beobachter benachrichtigen."]
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
