import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsxs(_components.p, {
      children: ["在很多情况下，你可能希望将组件内部的 ref 暴露给父组件。我们仍然使用 ", jsx(_components.code, {
        children: "ref"
      }), " 属性来实现。表面上看，在组件上使用 ", jsx(_components.code, {
        children: "ref"
      }), " 与在原生元素上使用 ", jsx(_components.code, {
        children: "ref"
      }), " 非常相似。你可以将要赋值的变量或回调函数传递给 ref。"]
    }), "\n", jsxs(_components.p, {
      children: ["但是，组件作者有义务将该引用连接到内部元素以将其转发回来。为此，我们使用了 ", jsx(_components.code, {
        children: "props.ref"
      }), "。如果 ", jsx(_components.code, {
        children: "props.ref"
      }), " 被定义了，那么这是一个回调形式的 ", jsx(_components.code, {
        children: "ref"
      }), "，但是其中大部分细节对你来说是隐藏的，因为你很可能只是直接将 ref 分配给这个组件的 JSX 中的元素或其中组件之一。"]
    }), "\n", jsxs(_components.p, {
      children: ["为了让 logo 再次动起来，我们需要从 ", jsx(_components.code, {
        children: "canvas.tsx"
      }), " 转发引用。"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<canvas ref={props.", jsx(_components.span, {
          className: "hljs-property",
          children: "ref"
        }), "} width=", jsx(_components.span, {
          className: "hljs-string",
          children: "\"256\""
        }), " height=", jsx(_components.span, {
          className: "hljs-string",
          children: "\"256\""
        }), " />\n"]
      })
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
