import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsx(_components.p, {
      children: "有时你的组件和元素会接收可变数量的属性，将所有属性作为对象而不是单独传递就很有必要了。在组件中包装 DOM 元素时尤其如此，这是制作设计系统时的常见实践。"
    }), "\n", jsxs(_components.p, {
      children: ["为此，我们使用扩展运算符 ", jsx(_components.code, {
        children: "..."
      }), "。"]
    }), "\n", jsx(_components.p, {
      children: "就可以传递一个具有可变数量属性的对象："
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Info"
        }), " {...pkg} />\n"]
      })
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
