import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsx(_components.p, {
      children: "Manchmal ist es sinnvoll, Elemente außerhalb des normalen Layouts der App einzufügen. Z-Index reicht gelegentlich nicht aus, um mit verschiedenen Render-Kontexten für überlagernde Elemente wie Dialogen zu arbeiten."
    }), "\n", jsxs(_components.p, {
      children: ["Solid hat eine ", jsx(_components.code, {
        children: "<Portal>"
      }), "-Komponente, deren Kind-Elemente an einer beliebigen Stelle im DOM eingefügt werden. Normalerweise werden die Elemente in einem ", jsx(_components.code, {
        children: "<div>"
      }), " in ", jsx(_components.code, {
        children: "document.body"
      }), " gerendert."]
    }), "\n", jsxs(_components.p, {
      children: ["In dem Beispiel sehen wird, dass unser Popup-Dialog abgeschnitten wird. Wir können dieses Problem lösen, wenn wir das Element aus dem Fluss herausnehmen, indem wir es in ein ", jsx(_components.code, {
        children: "<Portal>"
      }), " stecken:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Portal"
        }), ">\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "class"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "\"popup\""
            }), ">"]
          }), "\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "h1"
            }), ">"]
          }), "Popup", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "h1"
            }), ">"]
          }), "\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "p"
            }), ">"]
          }), "Some text you might need for something or other.", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "p"
            }), ">"]
          }), "\n  ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Portal"
        }), ">\n"]
      })
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
