import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsx(_components.p, {
      children: "Solid의 반응성은 동기식입니다. 즉, 변경이 일어나면 다음 행에서 DOM이 업데이트된다는 뜻입니다.\nSolid의 세분화된 렌더링은 리액티브 시스템에서 발생한 업데이트를 전파할 뿐이므로 대부분의 경우 이는 문제가 없습니다.\n관련없는 변경 사항을 두 번 \"렌더링\"한다고 해서, 실제로 쓸데없는 작업이 낭비되는 것은 아닙니다."
    }), "\n", jsxs(_components.p, {
      children: ["만일 변경 사항이 서로 관련되어 있으면 어떻게 될까요?\nSolid의 ", jsx(_components.code, {
        children: "batch"
      }), " 헬퍼를 사용하게 되면 여러 변경 사항을 대기열에 넣은 다음, 옵저버에 알리기 전에 모두 동시에 적용할 수 있습니다.\n배치 내에서 업데이트된 시그널 값은 완료될 때까지 커밋되지 않습니다."]
    }), "\n", jsxs(_components.p, {
      children: ["이 예제에서 버튼 클릭시 두 이름을 모두 할당하고, 이는 렌더링된 업데이트를 두 번 트리거합니다.\n버튼을 클릭하면 콘솔에서 로그를 확인할 수 있습니다.\n이제 ", jsx(_components.code, {
        children: "set"
      }), " 호출을 배치로 래핑해 보겠습니다."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [" ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "updateNames"
        }), " = (", jsx(_components.span, {
          className: "hljs-params"
        }), ") => {\n    ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Button Clicked\""
        }), ");\n    ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "batch"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\n      ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setFirstName"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "firstName"
        }), "() + ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"n\""
        }), ");\n      ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setLastName"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "lastName"
        }), "() + ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"!\""
        }), ");\n    })\n  }\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "이제 됐습니다. 모든 변경 사항에 대해서 한 번만 알림이 오게 됩니다."
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
