import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsxs(_components.p, {
      children: ["편의를 위해 Solid는 계산에 필요한 디펜던시를 명시적으로 설정할 수 있도록 ", jsx(_components.code, {
        children: "on"
      }), " 헬퍼를 제공합니다.\n이는 주로 어떤 시그널이 추적되는지에 대한 명시적이고 간결한 방법으로 사용됩니다(다른 시그널들을 읽더라도 이들은 추적하지 않음). 추가로 ", jsx(_components.code, {
        children: "on"
      }), "은 ", jsx(_components.code, {
        children: "defer"
      }), " 옵션을 제공하는데, 이를 사용하면 계산이 즉시 실행되지 않고 첫번째 변경시에만 실행되도록 할 수 있습니다."]
    }), "\n", jsxs(_components.p, {
      children: ["이펙트가 ", jsx(_components.code, {
        children: "a"
      }), "가 변경된 경우만 실행되도록 하고, 값이 변경될 때까지 실행을 연기하도록 해 보겠습니다:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "on"
        }), "(a, ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "a"
          }), ") =>"]
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(a, ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "b"
        }), "());\n}, { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "defer"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), " }));\n"]
      })
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
