import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span",
    a: "a"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "<For>"
      }), " コンポーネントは、オブジェクトの配列をループするための最良の方法です。配列が変更されると、", jsx(_components.code, {
        children: "<For>"
      }), " は DOM 内のアイテムを再作成するのではなく、更新したり移動したりします。例を見てみましょう。"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), " each={", jsx(_components.span, {
          className: "hljs-title function_",
          children: "cats"
        }), "()}>{", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "cat, i"
          }), ") =>"]
        }), "\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "li"
            }), ">"]
          }), "\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "a"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "target"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "\"_blank\""
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "href"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{"
            }), "`", jsx(_components.span, {
              className: "hljs-attr",
              children: "https:"
            }), "//", jsx(_components.span, {
              className: "hljs-attr",
              children: "www.youtube.com"
            }), "/", jsx(_components.span, {
              className: "hljs-attr",
              children: "watch"
            }), "?", jsx(_components.span, {
              className: "hljs-attr",
              children: "v"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "${cat.id}"
            }), "`}>"]
          }), "\n      {i() + 1}: {cat.name}\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "a"
            }), ">"]
          }), "\n  ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "li"
            }), ">"]
          })]
        }), "\n}</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "<For>"
      }), " コンポーネントには、ループさせる配列を渡す ", jsx(_components.code, {
        children: "each"
      }), " というプロパティがひとつあります。"]
    }), "\n", jsxs(_components.p, {
      children: ["そして、", jsx(_components.code, {
        children: "<For>"
      }), " と ", jsx(_components.code, {
        children: "</For>"
      }), " の間に直接ノードを書き込むのではなく、コールバックを渡します。これは、JavaScript の ", jsxs(_components.a, {
        href: "https://developer.mozilla.org/ja/docs/Web/JavaScript/Reference/Global_Objects/Array/map#parameters",
        children: [jsx(_components.code, {
          children: "map"
        }), " コールバック"]
      }), "に似た関数です。配列の各要素に対して、その要素を第一引数、インデックスを第二引数としてコールバックが呼び出されます（この例では ", jsx(_components.code, {
        children: "cat"
      }), " と ", jsx(_components.code, {
        children: "i"
      }), " です）。これらをコールバック内で使用して、レンダリングするノードを返します。"]
    }), "\n", jsxs(_components.p, {
      children: ["インデックスは定数ではなく、Signal であることに注意してください。これは ", jsx(_components.code, {
        children: "<For>"
      }), " が \"参照キー\" であるためで、レンダリングする各ノードは配列の要素に結合されています。つまり、ある要素が配列の中で配置を変えた場合、破棄して再作成するのではなく、対応するノードも移動し、そのインデックスが変更されます。"]
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "each"
      }), " プロパティは配列を想定していますが、 ", jsx(_components.a, {
        href: "https://developer.mozilla.org/ja/docs/Web/JavaScript/Reference/Global_Objects/Array/from",
        children: jsx(_components.code, {
          children: "Array.from"
        })
      }), " や ", jsx(_components.a, {
        href: "https://developer.mozilla.org/ja/docs/Web/JavaScript/Reference/Global_Objects/Object/keys",
        children: jsx(_components.code, {
          children: "Object.keys"
        })
      }), " 、あるいは ", jsx(_components.a, {
        href: "https://developer.mozilla.org/ja/docs/Web/JavaScript/Reference/Operators/Spread_syntax",
        children: jsx(_components.code, {
          children: "spread syntax"
        })
      }), " などのユーティリティを使用すれば、他の反復可能オブジェクトを配列に変換できます。"]
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
