import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsxs(_components.p, {
      children: ["コンポーネント内から親への参照を公開したい場合が多々あります。そのためには、やはり ", jsx(_components.code, {
        children: "ref"
      }), " 属性を使用します。外から見ると、コンポーネントの ", jsx(_components.code, {
        children: "ref"
      }), " を使用することは、ネイティブ要素の ", jsx(_components.code, {
        children: "ref"
      }), " を使用することと非常によく似ています。代入される変数やコールバック関数を渡すことができます。"]
    }), "\n", jsxs(_components.p, {
      children: ["ただし、その ", jsx(_components.code, {
        children: "ref"
      }), " を内部の要素に接続して転送させるのはコンポーネント作者の責任です。そのためには、", jsx(_components.code, {
        children: "props.ref"
      }), " を利用します。これは、どちらかのタイプの ", jsx(_components.code, {
        children: "ref"
      }), " が指定されていればコールバック形式ですが、ほとんどの場合、このコンポーネントの JSX 内の要素やコンポーネントの ", jsx(_components.code, {
        children: "ref"
      }), " 属性に直接割り当てることになるので、この詳細はほとんどわかりません。"]
    }), "\n", jsxs(_components.p, {
      children: ["ロゴを再びアニメーションさせるには、", jsx(_components.code, {
        children: "canvas.tsx"
      }), " から ref を転送する必要があります:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<canvas ref={props.", jsx(_components.span, {
          className: "hljs-property",
          children: "ref"
        }), "} width=", jsx(_components.span, {
          className: "hljs-string",
          children: "\"256\""
        }), " height=", jsx(_components.span, {
          className: "hljs-string",
          children: "\"256\""
        }), " />\n"]
      })
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
