import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    a: "a",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsxs(_components.p, {
      children: [jsx(_components.a, {
        href: "https://ru.reactjs.org/docs/introducing-jsx.html",
        children: "JSX"
      }), " позволяет использовать JavaScript для управления логикой рендера напрямую в шаблонах. Однако без виртуального DOM наивное использование таких вещей, как ", jsx(_components.code, {
        children: "Array.prototype.map"
      }), ", привело бы к бесполезному воссозданию всех узлов DOM при каждом обновлении. Вместо этого в реактивных библиотеках часто используются помощники для рендера шаблонов. В Solid мы оборачиваем их в компоненты."]
    }), "\n", jsxs(_components.p, {
      children: ["Самый простой пример логики рендера это - условие. Несмотря на то, что компилятор Solid достаточно умен, чтобы оптимально обрабатывать тернарный оператор (", jsx(_components.code, {
        children: "a ? b : c"
      }), ") и оператор ", jsx(_components.code, {
        children: "&&"
      }), " (", jsx(_components.code, {
        children: "a && b"
      }), ") мы советуем использовать компонент ", " встроенный в Solid."]
    }), "\n", jsx(_components.p, {
      children: "В этом уроке мы хотели бы показать только одну кнопку, которая показывает вошел ли пользователь в систему. Давайте обновим наш JSX:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), "\n  when={", jsx(_components.span, {
          className: "hljs-title function_",
          children: "loggedIn"
        }), "()}\n  fallback={", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "button"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "onClick"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{toggle}"
            }), ">"]
          }), "Log in", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "button"
            }), ">"]
          })]
        }), "}\n>\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "button"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "onClick"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{toggle}"
            }), ">"]
          }), "Log out", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "button"
            }), ">"]
          })]
        }), "\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Пропс ", jsx(_components.code, {
        children: "fallback"
      }), " выполняет функцию ", jsx(_components.code, {
        children: "else"
      }), " и будет показан в том случае если условие, которое мы передали в ", jsx(_components.code, {
        children: "when"
      }), " вернёт ", jsx(_components.a, {
        href: "https://developer.mozilla.org/ru/docs/Glossary/Falsy",
        children: "falsy"
      }), " значение."]
    }), "\n", jsx(_components.p, {
      children: "Если мы нажмем на кнопку, то увидим как состояние переключается между двумя значениями, как вы и ожидаете."
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
