import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsxs(_components.p, {
      children: ["때로는 리액티브 컨텍스트 내에서도 시그널 읽기 작업을 추적하지 않는 것이 필요합니다.\nSolid는 래핑 계산이 읽기 작업을 추적하지 못하도록 하기 위해 ", jsx(_components.code, {
        children: "untrack"
      }), " 이라는 헬퍼를 제공합니다."]
    }), "\n", jsxs(_components.p, {
      children: ["예제에서 ", jsx(_components.code, {
        children: "b"
      }), "가 변경되었을 때, 로그를 출력하고 싶지 않다고 가정해 보겠습니다.\n이펙트를 다음과 같이 변경하여 ", jsx(_components.code, {
        children: "b"
      }), " 시그널을 추적 해제할 수 있습니다:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "a"
        }), "(), ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "untrack"
        }), "(b));\n});\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["시그널은 함수이기 때문에 직접 전달할 수 있지만, ", jsx(_components.code, {
        children: "untrack"
      }), "은 더 복잡한 동작으로 함수를 래핑할 수 있습니다."]
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "untrack"
      }), "이 읽기 추적을 비활성화하더라도, 쓰기 작업에는 영향을 미치지 않기 떄문에 쓰기 작업은 여전히 추적되고 옵저버에 알림이 가게 됩니다."]
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
