import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsx(_components.p, {
      children: "애플리케이션을 빌드할 때, 더 나은 모듈화와 재사용성을 위해 코드를 분리하고 싶을 것입니다. Solid에서는 이를 위해 컴포넌트를 만듭니다."
    }), "\n", jsxs(_components.p, {
      children: ["컴포넌트는 우리가 지금까지 사용해 온 ", jsx(_components.code, {
        children: "HelloWorld()"
      }), "와 같은 함수일 뿐입니다. 함수의 특별한 점은 JSX를 반환하고 다른 컴포넌트의 JSX에 의해 호출될 수 있다는 점입니다."]
    }), "\n", jsxs(_components.p, {
      children: ["이 예제에서는 ", jsx(_components.code, {
        children: "Nested"
      }), " 컴포넌트를 앱에 추가해 보겠습니다. 같은 파일에 여러 개의 컴포넌트를 넣을 수 있지만, 여기서는 다른 파일에 정의했습니다. 먼저 이 파일을 임포트해야 합니다:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Nested"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"./nested\""
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "그런 다음 JSX에 컴포넌트를 추가해야 합니다. 이전과 마찬가지로 여러개의 엘리먼트를 반환해야 하므로 Fragment로 래핑합니다:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "App"
        }), "(", jsx(_components.span, {
          className: "hljs-params"
        }), ") {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " (\n    ", jsxs(_components.span, {
          className: "xml",
          children: [jsx(_components.span, {
            className: "hljs-tag",
            children: "<>"
          }), "\n      ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "h1"
            }), ">"]
          }), "This is a Header", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "h1"
            }), ">"]
          }), "\n      ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Nested"
            }), " />"]
          }), "\n    ", jsx(_components.span, {
            className: "hljs-tag",
            children: "</>"
          })]
        }), "\n  );\n}\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["부모 컴포넌트가 처음 렌더링될 때, ", jsx(_components.code, {
        children: "Nested()"
      }), " 함수를 실행한 후 다시는 호출하지 않습니다. 모든 업데이트는 다음 장에서 다룰 Solid의 반응성 시스템에 의해 적용됩니다."]
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
