import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsxs(_components.p, {
      children: ["便宜上、Solid には ", jsx(_components.code, {
        children: "on"
      }), " ヘルパーが用意されており、計算のための明示的な依存関係を設定できます。これは主に、どの Signal を追跡するかをより明確にするための簡潔な方法として使用されます（他の Signal が読み込まれていても追跡しません）。さらに ", jsx(_components.code, {
        children: "on"
      }), " は、計算をすぐに実行せず、最初の変更時にのみ実行できるようにする ", jsx(_components.code, {
        children: "defer"
      }), " オプションを提供します。"]
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "a"
      }), " が更新されたときだけ Effect を実行し、値が変わるまで実行を延期するようにしてみましょう:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "on"
        }), "(a, ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "a"
          }), ") =>"]
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(a, ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "b"
        }), "());\n}, { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "defer"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), " }));\n"]
      })
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
