import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsxs(_components.p, {
      children: ["Zur Bequemlichkeit hat Solid einen ", jsx(_components.code, {
        children: "on"
      }), "-Helfer, der es ermöglicht, ausdrücklich Abhängigkeiten einer Berechnung zu definieren. Das ist hauptsächlich ein Weg, um prägnant zu zeigen, welche Signale verfolgt werden (und andere nicht zu verfolgen). Zusätzlich bietet ", jsx(_components.code, {
        children: "on"
      }), " eine ", jsx(_components.code, {
        children: "defer"
      }), "-Option, die es erlaubt, die initiale Berechnung nicht auszuführen und erst bei der ersten Änderung zu laufen."]
    }), "\n", jsxs(_components.p, {
      children: ["Lassen wir unseren Effekt nur laufen, wenn ", jsx(_components.code, {
        children: "a"
      }), " aktualisiert wird und verzögern die Ausführung, bis der Wert sich erstmals ändert:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "on"
        }), "(a, ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "a"
          }), ") =>"]
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(a, ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "b"
        }), "());\n}, { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "defer"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), " }));\n"]
      })
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
