import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span",
    em: "em",
    a: "a"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "<For>"
      }), " 컴포넌트를 사용해 객체 배열에 대해 반복을 편하게 할 수 있습니다. 배열이 변경되면, DOM에 있는 항목들을 다시 생성하는 대신 업데이트하거나 이동합니다. 예를 들어 보겠습니다."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), " each={", jsx(_components.span, {
          className: "hljs-title function_",
          children: "cats"
        }), "()}>{", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "cat, i"
          }), ") =>"]
        }), "\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "li"
            }), ">"]
          }), "\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "a"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "target"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "\"_blank\""
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "href"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{"
            }), "`", jsx(_components.span, {
              className: "hljs-attr",
              children: "https:"
            }), "//", jsx(_components.span, {
              className: "hljs-attr",
              children: "www.youtube.com"
            }), "/", jsx(_components.span, {
              className: "hljs-attr",
              children: "watch"
            }), "?", jsx(_components.span, {
              className: "hljs-attr",
              children: "v"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "${cat.id}"
            }), "`}>"]
          }), "\n      {i() + 1}: {cat.name}\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "a"
            }), ">"]
          }), "\n  ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "li"
            }), ">"]
          })]
        }), "\n}</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "<For>"
      }), " 컴포넌트에는 ", jsx(_components.code, {
        children: "each"
      }), "라는 prop이 하나 있는데, 반복할 배열을 전달합니다."]
    }), "\n", jsxs(_components.p, {
      children: ["그런 다음, ", jsx(_components.code, {
        children: "<For>"
      }), "와 ", jsx(_components.code, {
        children: "</For>"
      }), " 사이에 직접 노드를 작성하는 대신, ", jsx(_components.em, {
        children: "콜백"
      }), " 을 전달합니다. 이는 자바스크립트의 ", jsxs(_components.a, {
        href: "https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array/map#parameters",
        children: [jsx(_components.code, {
          children: "map"
        }), " 콜백"]
      }), "과 유사한 함수입니다. 배열의 각 요소에 대해, 요소를 첫 번째 인수로, 인덱스를 두 번째 인수로 사용해 콜백 함수가 호출됩니다. (이 예에서는 ", jsx(_components.code, {
        children: "cat"
      }), "과 ", jsx(_components.code, {
        children: "i"
      }), " 입니다.) 이 값들은 렌더링할 노드를 반환할 때 사용할 수 있습니다."]
    }), "\n", jsxs(_components.p, {
      children: ["인덱스는 상수가 아닌 ", jsx(_components.em, {
        children: "Signal"
      }), " 이라는 점에 유의해야 합니다. ", jsx(_components.code, {
        children: "<For>"
      }), "는 \"참조에 의해 키 지정\" 되기 때문에, 렌더링하는 각 노드는 배열의 요소에 연결됩니다. 즉, 배열에 있는 요소가 삭제 및 재생성되는 대신 위치가 변경되면 연결된 노드도 같이 이동해 해당 인덱스가 변경됩니다."]
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "each"
      }), " prop은 배열 타입만 사용해야 하지만, ", jsx(_components.a, {
        href: "https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array/from",
        children: jsx(_components.code, {
          children: "Array.from"
        })
      }), ", ", jsx(_components.a, {
        href: "https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/keys",
        children: jsx(_components.code, {
          children: "Object.keys"
        })
      }), ", 또는 ", jsx(_components.a, {
        href: "%60https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Operators/Spread_syntax%60",
        children: "스프레드 구문"
      }), "과 같은 유틸리티를 사용해 iterable 객체를 배열로 바꿀 수 있습니다."]
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
