import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsx(_components.p, {
      children: "Solid는 리액티브 시스템에 의해 생성, 소멸되기 때문에 라이프사이클이라고 할 만한 것이 거의 없습니다. 리액티브 시스템은 동기식으로 생성되고 업데이트되므로, 업데이트가 끝날 때까지 푸시되는 이펙트만 스케줄링됩니다."
    }), "\n", jsxs(_components.p, {
      children: ["우리는 기본적인 작업을 하는 개발자들이 이런 식으로 생각하지 않는다는 것을 발견했습니다. 그래서 이해를 쉽게 하기 위해 트래킹하지 않는 (재실행하지 않는) ", jsx(_components.code, {
        children: "createEffect"
      }), " 호출을 ", jsx(_components.code, {
        children: "onMount"
      }), "라는 별칭으로 지정했습니다. 이것은 단지 이펙트 호출일 뿐이지만, 모든 초기 렌더링이 완료되면 컴포넌트당 한 번만 실행된다는 확신을 가지고 사용할 수 있습니다."]
    }), "\n", jsxs(_components.p, {
      children: ["사진을 불러오기 위해 ", jsx(_components.code, {
        children: "onMount"
      }), " 훅을 사용해 봅시다:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "onMount"
        }), "(", jsx(_components.span, {
          className: "hljs-keyword",
          children: "async"
        }), " () => {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " res = ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "await"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fetch"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "`https://jsonplaceholder.typicode.com/photos?_limit=20`"
        }), ");\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setPhotos"
        }), "(", jsx(_components.span, {
          className: "hljs-keyword",
          children: "await"
        }), " res.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "json"
        }), "());\n});\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["라이프사이클은 브라우저에서만 실행되므로, ", jsx(_components.code, {
        children: "onMount"
      }), "에 있는 코드는 SSR 동안 서버에서 실행되지 않는다는 장점이 있습니다. 이 예제에서는 데이터를 가져오고 있지만, 일반적으로는 서버/브라우저 코디네이션을 위해 Solid의 Resource를 사용합니다."]
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
