import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [{
  "depth": 1,
  "value": "Solid のテスト",
  "children": [{
    "depth": 2,
    "value": "テストのセットアップ",
    "children": [{
      "depth": 3,
      "value": "Jest を設定する",
      "children": [{
        "depth": 4,
        "value": "solid-jest を使う",
        "children": []
      }, {
        "depth": 4,
        "value": "ts-jest を使う",
        "children": []
      }]
    }, {
      "depth": 3,
      "value": "TypeScript と Jest",
      "children": []
    }, {
      "depth": 3,
      "value": "uvu を設定する",
      "children": []
    }, {
      "depth": 3,
      "value": "カバレッジレポート",
      "children": []
    }, {
      "depth": 3,
      "value": "Watch モード",
      "children": []
    }, {
      "depth": 3,
      "value": "solid-testing-library",
      "children": []
    }, {
      "depth": 3,
      "value": "@testing-library/jest-dom",
      "children": []
    }, {
      "depth": 3,
      "value": "solid-dom-testing",
      "children": []
    }]
  }, {
    "depth": 2,
    "value": "テストのパターンとベストプラクティス",
    "children": [{
      "depth": 3,
      "value": "リアクティブな状態のテスト",
      "children": [{
        "depth": 4,
        "value": "Jest でのテスト",
        "children": []
      }, {
        "depth": 4,
        "value": "uvu でのテスト",
        "children": []
      }]
    }, {
      "depth": 3,
      "value": "ディレクティブのテスト",
      "children": [{
        "depth": 4,
        "value": "Jest でのテスト",
        "children": []
      }, {
        "depth": 4,
        "value": "uvu でのテスト",
        "children": []
      }]
    }, {
      "depth": 3,
      "value": "コンポーネントのテスト",
      "children": [{
        "depth": 4,
        "value": "Jest でのテスト",
        "children": []
      }, {
        "depth": 4,
        "value": "uvu でのテスト",
        "children": []
      }]
    }]
  }]
}];
function _createMdxContent(props) {
  const _components = Object.assign({
    h1: "h1",
    a: "a",
    p: "p",
    h2: "h2",
    h3: "h3",
    h4: "h4",
    pre: "pre",
    code: "code",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsxs(_components.h1, {
      id: "solid-のテスト",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#solid-のテスト",
        children: "#"
      }), "Solid のテスト"]
    }), "\n", jsx(_components.p, {
      children: "Solid のコードを本番環境で使用するには、テストする必要があります。すべてを手動でテストしたくはないので、自動テストが必要です。Solid コードのテストは、すべてをセットアップし、テストに役立ついくつかのパターンを知っていれば簡単に行うことができます。"
    }), "\n", jsxs(_components.h2, {
      id: "テストのセットアップ",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#テストのセットアップ",
        children: "#"
      }), "テストのセットアップ"]
    }), "\n", jsx(_components.p, {
      children: "テストをセットアップする前に、テストランナーを選択する必要があります。豊富な選択肢がありますが、ここでは両極端な 2 つの全く異なるプロジェクト、Jest と uvu に焦点を当てます。Jest は大きくて総合型、uvu は必要最低限のものだけをもたらします。もし他のテストランナーを使いたい場合でも、uvu のセットアップは他のほとんどのテストランナーでも動作するはずです。"
    }), "\n", jsxs(_components.h3, {
      id: "jest-を設定する",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#jest-を設定する",
        children: "#"
      }), "Jest を設定する"]
    }), "\n", jsx(_components.p, {
      children: "残念ながら、統合されているとはいえ Jest は ESM や TypeScript をそのままではサポートせず、トランスフォーマーの設定が必要です。"
    }), "\n", jsx(_components.p, {
      children: "主な選択肢は solid-jest と ts-jest です。solid-jest は Solid コードの変換に babel を使用し、TypeScript が使われている場合はテスト時の型チェックを省略します。ts-jest は TypeScript コンパイラを使用し、テスト時の型チェックを行います。"
    }), "\n", jsx(_components.p, {
      children: "TypeScript を使用していない場合は solid-jest を使用し、そうでない場合はテストの実行中に型チェックを行いたいかどうかを選択します。"
    }), "\n", jsxs(_components.h4, {
      id: "solid-jest-を使う",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#solid-jest-を使う",
        children: "#"
      }), "solid-jest を使う"]
    }), "\n", jsx(_components.p, {
      children: "必要な依存関係をインストールします:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-sh",
        children: ["> npm i --save-dev jest solid-jest ", jsx(_components.span, {
          className: "hljs-comment",
          children: "# もしくは yarn add -D もしくは pnpm"
        }), "\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "TypeScript の場合は:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-sh",
        children: ["> npm i --save-dev jest solid-jest @types/jest ", jsx(_components.span, {
          className: "hljs-comment",
          children: "# もしくは yarn add -D もしくは pnpm"
        }), "\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["次に ", jsx(_components.code, {
        children: ".babelrc"
      }), " を定義していなければ定義する必要があります:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: ["{\n  ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"presets\""
        }), ": [\n    ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"@babel/preset-env\""
        }), ",\n    ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"babel-preset-solid\""
        }), ",\n    ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// solid-jest で TS を使用する場合のみ"
        }), "\n    ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"@babel/preset-typescript\""
        }), "\n  ]\n}\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["そして ", jsx(_components.code, {
        children: "package.json"
      }), " を以下のように修正します:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: ["{\n  ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"scripts\""
        }), ": {\n    ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// ここに他のスクリプト"
        }), "\n    ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"test\""
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"jest\""
        }), "\n  },\n  ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"jest\""
        }), ": {\n    ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"preset\""
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-jest/preset/browser\""
        }), ",\n    ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// setupFiles や他のコンフィグを挿入します"
        }), "\n  }\n}\n"]
      })
    }), "\n", jsxs(_components.h4, {
      id: "ts-jest-を使う",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#ts-jest-を使う",
        children: "#"
      }), "ts-jest を使う"]
    }), "\n", jsx(_components.p, {
      children: "ts-jest を使うには、まずインストールする必要があります:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-sh",
        children: ["> npm i --save-dev jest ts-jest @types/jest ", jsx(_components.span, {
          className: "hljs-comment",
          children: "# もしくは yarn add -D もしくは pnpm"
        }), "\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["そして ", jsx(_components.code, {
        children: "package.json"
      }), " で設定します:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: ["{ \n  ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"scripts\""
        }), ": {\n    ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// ここに他のスクリプト"
        }), "\n    ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"test\""
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"jest\""
        }), "\n  },\n  ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"jest\""
        }), ": {\n    ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"preset\""
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"ts-jest\""
        }), ",\n    ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"globals\""
        }), ": {\n      ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"ts-jest\""
        }), ": {\n        ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"tsconfig\""
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"tsconfig.json\""
        }), ",\n        ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"babelConfig\""
        }), ": {\n          ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"presets\""
        }), ": [\n            ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"babel-preset-solid\""
        }), ",\n            ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"@babel/preset-env\""
        }), "\n          ]\n        }\n      }\n    },\n    ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// ブラウザモードでテストするために"
        }), "\n    ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// setupFiles と他の設定を挿入します:"
        }), "\n    ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"testEnvironment\""
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"jsdom\""
        }), ",\n    ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 残念ながら、solid はここでブラウザモードを検出できないので、"
        }), "\n    ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 正しいバージョンを手動で指定する必要があります:"
        }), "\n    ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"moduleNameMapper\""
        }), ": {\n      ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js/web\""
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"<rootDir>/node_modules/solid-js/web/dist/web.cjs\""
        }), ",\n      ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"<rootDir>/node_modules/solid-js/dist/solid.cjs\""
        }), "\n    }\n    ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Windows ユーザーは \"/\" を \"\\\" に置き換えてください"
        }), "\n  }\n}\n"]
      })
    }), "\n", jsxs(_components.h3, {
      id: "typescript-と-jest",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#typescript-と-jest",
        children: "#"
      }), "TypeScript と Jest"]
    }), "\n", jsx(_components.p, {
      children: "Jest はテスト機能をグローバルスコープに注入するので、TypeScript コンパイラを満たすために、型を tsconfig.json にロードする必要があります:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: ["{\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// tsconfig.json の一部"
        }), "\n  ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"types\""
        }), ": [", jsx(_components.span, {
          className: "hljs-string",
          children: "\"jest\""
        }), "]\n}\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["これには前述のように ", jsx(_components.code, {
        children: "@types/jest"
      }), " をインストールする必要があります。"]
    }), "\n", jsxs(_components.h3, {
      id: "uvu-を設定する",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#uvu-を設定する",
        children: "#"
      }), "uvu を設定する"]
    }), "\n", jsx(_components.p, {
      children: "まず、必要なパッケージをインストールする必要があります:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-sh",
        children: ["> npm i --save-dev uvu solid-register jsdom ", jsx(_components.span, {
          className: "hljs-comment",
          children: "# もしくは yarn add -D もしくは pnpm"
        }), "\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["次に ", jsx(_components.code, {
        children: "package.json"
      }), " でテストスクリプトを設定します:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-sh",
        children: ["> npm set-script ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "test"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"uvu -r solid-register\""
        }), "\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["追加の設定ファイルは ", jsx(_components.code, {
        children: "-r setup.ts"
      }), " で追加でき、テストでないものは ", jsx(_components.code, {
        children: "-i not-a-test.test.ts"
      }), " で無視できます。"]
    }), "\n", jsxs(_components.h3, {
      id: "カバレッジレポート",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#カバレッジレポート",
        children: "#"
      }), "カバレッジレポート"]
    }), "\n", jsx(_components.p, {
      children: "テストのコードカバレッジを確認したい場合、uvu のお気に入りのツールは c8 です。インストールと設定のために、以下を実行します:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-sh",
        children: ["> npm i --save-dev c8 ", jsx(_components.span, {
          className: "hljs-comment",
          children: "# もしくは yarn add -D もしくは pnpm"
        }), "\n> npm set-script ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"test:coverage\""
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"c8 uvu -r solid-register\""
        }), "\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["これで ", jsx(_components.code, {
        children: "npm run test:coverage"
      }), " を実行すると、テストのカバレッジが表示されるようになります。"]
    }), "\n", jsx(_components.p, {
      children: "HTML 形式のカバレッジレポートが欲しい場合は、（訳注: 原文がここで終わっている）"
    }), "\n", jsxs(_components.h3, {
      id: "watch-モード",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#watch-モード",
        children: "#"
      }), "Watch モード"]
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "uvu"
      }), " と ", jsx(_components.code, {
        children: "tape"
      }), " はどちらもすぐに使用できるウォッチモードはありませんが、 ", jsx(_components.code, {
        children: "chokidar-cli"
      }), " を使用して同じことを行うことができます:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-sh",
        children: ["> npm i --save-dev chokidar-cli ", jsx(_components.span, {
          className: "hljs-comment",
          children: "# もしくは yarn add -D もしくは pnpm"
        }), "\n> npm set-script ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"test:watch\""
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"chokidar src/**/*.ts src/**/*.tsx -c \\\"uvu -r solid-register\\\"\n# use .js/.jsx instead of .ts/.tsx\n"
        })]
      })
    }), "\n", jsxs(_components.p, {
      children: ["これで ", jsx(_components.code, {
        children: "npm run test:watch"
      }), " を実行すると、ファイルを変更するたびにテストが実行されるようになります。"]
    }), "\n", jsxs(_components.h3, {
      id: "solid-testing-library",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#solid-testing-library",
        children: "#"
      }), "solid-testing-library"]
    }), "\n", jsxs(_components.p, {
      children: ["もしコンポーネントをテストしたいのであれば、", jsx(_components.code, {
        children: "solid-testing-library"
      }), " を必ずインストールしてください:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-sh",
        children: ["> npm i --save-dev solid-testing-library ", jsx(_components.span, {
          className: "hljs-comment",
          children: "# もしくは yarn add -D もしくは pnpm"
        }), "\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "これにより、コンポーネントをレンダリングし、イベントを発生させ、ユーザーの視点から要素を選択できます。"
    }), "\n", jsxs(_components.h3, {
      id: "testing-libraryjest-dom",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#testing-libraryjest-dom",
        children: "#"
      }), "@testing-library/jest-dom"]
    }), "\n", jsxs(_components.p, {
      children: ["Jest を使用している場合、", jsx(_components.code, {
        children: "solid-testing-library"
      }), " は ", jsx(_components.code, {
        children: "@testing-library/jest-dom"
      }), " と非常にうまく動作します:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-sh",
        children: ["> npm i --save-dev @testing-library/jest-dom ", jsx(_components.span, {
          className: "hljs-comment",
          children: "# もしくは yarn add -D もしくは pnpm"
        }), "\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "そして、セットアップファイルで期待する拡張子をインポートします:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// test/jest-setup.ts"
        }), "\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "'@testing-library/jest-dom/extend-expect'"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "そして、package.json の以下の項目を使用して、Jest でロードします:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: ["{\n  ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"jest\""
        }), ": {\n    ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// ここに他の設定"
        }), "\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "setupFiles"
        }), ": [", jsx(_components.span, {
          className: "hljs-string",
          children: "\"@testing-library/jest-dom/extend-expect\""
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"regenerator-runtime\""
        }), "]\n  }\n}\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["また、", jsx(_components.code, {
        children: "tsconfig.json"
      }), " に型を含めることも忘れないでください:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: ["{\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// tsconfig.json の一部"
        }), "\n  ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"types\""
        }), ": [", jsx(_components.span, {
          className: "hljs-string",
          children: "\"jest\""
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"@testing-library/jest-dom\""
        }), "]\n}\n"]
      })
    }), "\n", jsxs(_components.h3, {
      id: "solid-dom-testing",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#solid-dom-testing",
        children: "#"
      }), "solid-dom-testing"]
    }), "\n", jsxs(_components.p, {
      children: ["uvu や tape などの他のテストランナーを使用している場合、 ", jsx(_components.code, {
        children: "solid-dom-testing"
      }), " には同様のアサーションをサポートするヘルパーがいくつかあります:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-sh",
        children: ["> npm i --save-dev solid-dom-testing ", jsx(_components.span, {
          className: "hljs-comment",
          children: "# もしくは yarn add -D もしくは pnpm"
        }), "\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "設定は不要で、必要に応じてテストでヘルパーをインポートして使用できます。"
    }), "\n", jsxs(_components.h2, {
      id: "テストのパターンとベストプラクティス",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#テストのパターンとベストプラクティス",
        children: "#"
      }), "テストのパターンとベストプラクティス"]
    }), "\n", jsx(_components.p, {
      children: "さて、テストツールのインストールが完了したら、次はそれらを使ってみましょう。これを簡単にするため、Solid はいくつかのすばらしいパターンをサポートしています。"
    }), "\n", jsxs(_components.h3, {
      id: "リアクティブな状態のテスト",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#リアクティブな状態のテスト",
        children: "#"
      }), "リアクティブな状態のテスト"]
    }), "\n", jsxs(_components.p, {
      children: ["メンテナンスを容易にするため、あるいは複数のビューをサポートできるようにするため、状態の一部をコンポーネントから分離しておきたい場合があります。この場合、テストの対象となるインターフェイスは状態そのものです。", jsx(_components.a, {
        href: "https://www.solidjs.com/docs/latest/api#createroot",
        children: "リアクティブルート"
      }), "の外では、状態は追跡されず、更新しても Effect や Memo がトリガーされないことに注意してください。"]
    }), "\n", jsxs(_components.p, {
      children: ["また、Effect は非同期でトリガーされるので、最終的な Effect にアサーションをラップするのに役立ちます。また、複数の変更に対する一連の Effect を観察するには、", jsx(_components.code, {
        children: "createRoot"
      }), " から必要なツールを返して、非同期のテスト関数で実行すると便利です（", jsx(_components.code, {
        children: "createRoot"
      }), " 自体は ", jsx(_components.code, {
        children: "async"
      }), " 関数を受け取ることができないので）。"]
    }), "\n", jsxs(_components.p, {
      children: ["例として、", jsx(_components.a, {
        href: "https://www.solidjs.com/examples/todos",
        children: "ToDo のサンプル"
      }), "にある ", jsx(_components.code, {
        children: "createLocalStorage"
      }), " をテストしてみましょう:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createEffect } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createStore, ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), ", ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "SetStoreFunction"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js/store\""
        }), ";\n\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createLocalStore<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "initState"
        }), ": T): [", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>, ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "SetStoreFunction"
        }), "<T>] {\n\t", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "(initState);\n\t", jsx(_components.span, {
          className: "hljs-keyword",
          children: "if"
        }), " (", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "localStorage"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "todos"
        }), ") ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "JSON"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "parse"
        }), "(", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "localStorage"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "todos"
        }), "));\n\t", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " (", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "localStorage"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "todos"
        }), " = ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "JSON"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "stringify"
        }), "(state)));\n\t", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " [state, setState];\n}\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["TODO コンポーネントを作成する代わりに、このモデルを単独でテストできます。その際、1. リアクティブな変更は ", jsx(_components.code, {
        children: "render"
      }), " または ", jsx(_components.code, {
        children: "createRoot"
      }), " によって提供される追跡コンテキストがある場合のみ動作すること、2. 非同期であるが ", jsx(_components.code, {
        children: "createEffect"
      }), " によってそれをキャッチできること、を念頭に置く必要があります。", jsx(_components.code, {
        children: "createRoot"
      }), " を使用すると、手動で廃棄のトリガーをできるという利点があります:"]
    }), "\n", jsxs(_components.h4, {
      id: "jest-でのテスト",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#jest-でのテスト",
        children: "#"
      }), "Jest でのテスト"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createLocalStore } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"./main.tsx\""
        }), ";\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createRoot, createEffect } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "describe"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"createLocalStore\""
        }), ", ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "beforeEach"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " { \n    ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "localStorage"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "removeItem"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"todos\""
        }), ");\n  });\n\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " initialState = {\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "todos"
        }), ": [],\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "newTitle"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"\""
        }), "\n  };\n\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "test"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"既存の状態を localStorage から読み取る\""
        }), ", ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createRoot"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "dispose"
          }), " =>"]
        }), " {\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " savedState = { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "todos"
        }), ": [], ", jsx(_components.span, {
          className: "hljs-attr",
          children: "newTitle"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"saved\""
        }), " };\n    ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "localStorage"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setItem"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"todos\""
        }), ", ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "JSON"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "stringify"
        }), "(savedState));\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createLocalStore"
        }), "(initialState);\n    ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "expect"
        }), "(state).", jsx(_components.span, {
          className: "hljs-title function_",
          children: "toEqual"
        }), "(savedState);\n    ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "dispose"
        }), "();\n  }));\n\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "test"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"新しい状態を localStorage に格納する\""
        }), ", ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createRoot"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "dispose"
          }), " =>"]
        }), " {\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createLocalStore"
        }), "(initialState);\n    ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"newTitle\""
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"updated\""
        }), ");\n    ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Effect をキャッチするため、Effect を使う"
        }), "\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "new"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ">(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "resolve"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\n      ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "expect"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "JSON"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "parse"
        }), "(", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "localStorage"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "todos"
        }), " || ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"\""
        }), "))\n        .", jsx(_components.span, {
          className: "hljs-title function_",
          children: "toEqual"
        }), "({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "todos"
        }), ": [], ", jsx(_components.span, {
          className: "hljs-attr",
          children: "newTitle"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"updated\""
        }), " });\n      ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "dispose"
        }), "();\n      ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "resolve"
        }), "();\n    }));\n  }));\n\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "test"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"状態を複数回更新する\""
        }), ", ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "async"
        }), " () => {\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " {dispose, setState} = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createRoot"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "dispose"
          }), " =>"]
        }), " {\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createLocalStore"
        }), "(initialState);\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " {dispose, setState};\n    });\n    ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"newTitle\""
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"first\""
        }), ");\n    ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// すべての Effect を解決するため 1 ティック待つ"
        }), "\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "await"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "new"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "done"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "setTimeout"
        }), "(done, ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), "));\n    ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "expect"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "JSON"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "parse"
        }), "(", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "localStorage"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "todos"
        }), " || ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"\""
        }), "))\n      .", jsx(_components.span, {
          className: "hljs-title function_",
          children: "toEqual"
        }), "({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "todos"
        }), ": [], ", jsx(_components.span, {
          className: "hljs-attr",
          children: "newTitle"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"first\""
        }), " });\n    ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"newTitle\""
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"second\""
        }), ");\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "await"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "new"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "done"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "setTimeout"
        }), "(done, ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), "));\n    ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "expect"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "JSON"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "parse"
        }), "(", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "localStorage"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "todos"
        }), " || ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"\""
        }), "))\n      .", jsx(_components.span, {
          className: "hljs-title function_",
          children: "toEqual"
        }), "({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "todos"
        }), ": [], ", jsx(_components.span, {
          className: "hljs-attr",
          children: "newTitle"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"first\""
        }), " });\n    ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "dispose"
        }), "();\n  });\n});\n"]
      })
    }), "\n", jsxs(_components.h4, {
      id: "uvu-でのテスト",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#uvu-でのテスト",
        children: "#"
      }), "uvu でのテスト"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createLocalStore } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"./main\""
        }), ";\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { suite } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"uvu\""
        }), ";\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " * ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "as"
        }), " assert ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"uvu/assert\""
        }), ";\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createEffect, createRoot } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\n\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " todoTest = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "suite"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"createLocalStore\""
        }), ");\n\ntodoTest.", jsx(_components.span, {
          className: "hljs-property",
          children: "before"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "each"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " { \n  ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "localStorage"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "removeItem"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"todos\""
        }), ");\n});\n\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " initialState = {\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "todos"
        }), ": [],\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "newTitle"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"\""
        }), "\n};\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "todoTest"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"既存の状態を localStorage から読み取る\""
        }), ", ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " \n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createRoot"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "dispose"
          }), " =>"]
        }), " {\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " savedState = { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "todos"
        }), ": [], ", jsx(_components.span, {
          className: "hljs-attr",
          children: "newTitle"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"saved\""
        }), " };\n    ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "localStorage"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setItem"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"todos\""
        }), ", ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "JSON"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "stringify"
        }), "(savedState));\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createLocalStore"
        }), "(initialState);\n    assert.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "equal"
        }), "(state, savedState);\n    ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "dispose"
        }), "();\n  }));\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "todoTest"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"新しい状態を localStorage に格納する\""
        }), ", ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), "\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createRoot"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "dispose"
          }), " =>"]
        }), " {\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [_, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createLocalStore"
        }), "(initialState);\n    ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"newTitle\""
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"updated\""
        }), ");\n    ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Effect をキャッチするため、Effect が必要"
        }), "\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "new"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ">(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "resolve"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\n      assert.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "equal"
        }), "(\n        ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "JSON"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "parse"
        }), "(", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "localStorage"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "todos"
        }), " || ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"\""
        }), "),\n        { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "todos"
        }), ": [], ", jsx(_components.span, {
          className: "hljs-attr",
          children: "newTitle"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"updated\""
        }), " }\n      );\n      ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "dispose"
        }), "();\n      ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "resolve"
        }), "();\n    }));\n  }));\n\ntodoTest.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "run"
        }), "();\n"]
      })
    }), "\n", jsxs(_components.h3, {
      id: "ディレクティブのテスト",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#ディレクティブのテスト",
        children: "#"
      }), "ディレクティブのテスト"]
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.a, {
        href: "https://www.solidjs.com/docs/latest/api#use%3A___",
        children: "ディレクティブ"
      }), "は再利用可能な方法で参照を使用できるようにします。これらは基本的に ", jsx(_components.code, {
        children: "(ref: HTMLElement, data: Accessor<any>) => void"
      }), " というパターンに従った関数です。", jsx(_components.a, {
        href: "https://www.solidjs.com/tutorial/bindings_directives?solved",
        children: "ディレクティブのチュートリアル"
      }), "では、アクセサーの引数にラップされたコールバックを呼び出す ", jsx(_components.code, {
        children: "clickOutside"
      }), " ディレクティブを定義しています。"]
    }), "\n", jsx(_components.p, {
      children: "コンポーネントを作成し、そこでディレクティブを使用することもできますが、その場合はディレクティブを直接テストするのではなく、ディレクティブの使用をテストすることになります。マウントされたノードとアクセサーを提供することで、ディレクティブの外面をテストする方がより簡単です:"
    }), "\n", jsxs(_components.h4, {
      id: "jest-でのテスト-1",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#jest-でのテスト-1",
        children: "#"
      }), "Jest でのテスト"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// click-outside.test.ts"
        }), "\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " clickOutside ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"click-outside\""
        }), ";\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createRoot } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { fireEvent } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-testing-library\""
        }), ";\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "describe"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"clickOutside\""
        }), ", ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " ref = ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "document"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createElement"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"div\""
        }), ");\n  \n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "beforeAll"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\n    ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "document"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "body"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "appendChild"
        }), "(ref);\n  });\n\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "afterAll"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\n    ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "document"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "body"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "removeChild"
        }), "(ref);\n  });\n\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "test"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"外側のクリックでトリガーされる\""
        }), ", ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createRoot"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "dispose"
          }), ") =>"]
        }), "\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "new"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ">(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "resolve"
          }), ") =>"]
        }), " {\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "let"
        }), " clickedOutside = ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), ";\n      ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "clickOutside"
        }), "(ref, ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " { clickedOutside = ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), "; });\n      ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "document"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "body"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "addEventListener"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"click\""
        }), ", ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\n        ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "expect"
        }), "(clickedOutside).", jsx(_components.span, {
          className: "hljs-title function_",
          children: "toBeTruthy"
        }), "();\n        ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "dispose"
        }), "();\n        ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "resolve"
        }), "();\n      });\n      fireEvent.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "click"
        }), "(", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "document"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "body"
        }), ");\n    })\n  ));\n\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "test"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"内側のクリックではトリガーされない\""
        }), ", ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createRoot"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "dispose"
          }), ") =>"]
        }), "\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "new"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ">(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "resolve"
          }), ") =>"]
        }), " {\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "let"
        }), " clickedOutside = ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), ";\n      ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "clickOutside"
        }), "(ref, ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " { clickedOutside = ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), "; });\n      ref.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "addEventListener"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"click\""
        }), ", ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\n        ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "expect"
        }), "(clickedOutside).", jsx(_components.span, {
          className: "hljs-title function_",
          children: "toBeFalsy"
        }), "();\n        ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "dispose"
        }), "();\n        ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "resolve"
        }), "();\n      });\n      fireEvent.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "click"
        }), "(ref);\n    })\n  ));\n});\n"]
      })
    }), "\n", jsxs(_components.h4, {
      id: "uvu-でのテスト-1",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#uvu-でのテスト-1",
        children: "#"
      }), "uvu でのテスト"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// click-outside.test.ts"
        }), "\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " clickOutside ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "'click-outside.tsx'"
        }), ";\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createRoot } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "'solid-js'"
        }), ";\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { fireEvent } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "'solid-testing-library'"
        }), ";\n\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " clickTest = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "suite"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'clickOutside'"
        }), ");\n\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " ref = ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "document"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createElement"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'div'"
        }), ");\n  \nclickTest.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "before"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "document"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "body"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "appendChild"
        }), "(ref);\n});\n\nclickTest.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "after"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "document"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "body"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "removeChild"
        }), "(ref);\n});\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "clickTest"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'外側のクリックでトリガーされる'"
        }), ", ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createRoot"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "dispose"
          }), ") =>"]
        }), "\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "new"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ">(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "resolve"
          }), ") =>"]
        }), " {\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "let"
        }), " clickedOutside = ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), ";\n    ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "clickOutside"
        }), "(ref, ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " { clickedOutside = ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), "; });\n    ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "document"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "body"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "addEventListener"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'click'"
        }), ", ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\n      assert.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "ok"
        }), "(clickedOutside);\n      ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "dispose"
        }), "();\n      ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "resolve"
        }), "();\n    });\n    fireEvent.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "click"
        }), "(", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "document"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "body"
        }), ");\n  })\n));\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "clickTest"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'内側のクリックではトリガーされない'"
        }), ", ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createRoot"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "dispose"
          }), ") =>"]
        }), "\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "new"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ">(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "resolve"
          }), ") =>"]
        }), " {\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "let"
        }), " clickedOutside = ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), ";\n    ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "clickOutside"
        }), "(ref, ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " { clickedOutside = ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), "; });\n    ref.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "addEventListener"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'click'"
        }), ", ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\n      assert.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "is"
        }), "(clickedOutside, ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), ");\n      ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "dispose"
        }), "();\n      ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "resolve"
        }), "();\n    });\n    fireEvent.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "click"
        }), "(ref);\n  })\n));\n\nclickTest.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "run"
        }), "();\n"]
      })
    }), "\n", jsxs(_components.h3, {
      id: "コンポーネントのテスト",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#コンポーネントのテスト",
        children: "#"
      }), "コンポーネントのテスト"]
    }), "\n", jsx(_components.p, {
      children: "テストするための、とてもシンプルなクリックカウンターコンポーネントを見てみましょう:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// main.tsx"
        }), "\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createSignal, ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Component"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\n\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Counter"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Component"
        }), " = ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [count, setCount] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ");\n\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "role"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "\"button\""
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "onClick"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{()"
            }), " =>"]
          }), " setCount(c => c + 1)}>\n    Count: {count()}\n  ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), ";\n}\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["まだインストールしていない場合は、必ず ", jsx(_components.code, {
        children: "solid-testing-library"
      }), " をインストールする必要があります。最も重要なヘルパーは、何とかして DOM にコンポーネントをレンダリングする ", jsx(_components.code, {
        children: "render"
      }), " と、実際のユーザーイベントに似た方法でイベントをディスパッチする ", jsx(_components.code, {
        children: "fireEvent"
      }), " と、グローバルセレクターを提供する ", jsx(_components.code, {
        children: "screen"
      }), " です。Jest を使用している場合は、 ", jsx(_components.code, {
        children: "@testing-library/jest-dom"
      }), " もインストールし、有用なアサーションを持つようにセットアップする必要があります。それ以外の場合は、上述の通り ", jsx(_components.code, {
        children: "solid-dom-testing"
      }), " をインストールします。"]
    }), "\n", jsxs(_components.h4, {
      id: "jest-でのテスト-2",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#jest-でのテスト-2",
        children: "#"
      }), "Jest でのテスト"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// main.test.tsx"
        }), "\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Counter"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"./main\""
        }), ";\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { cleanup, fireEvent, render, screen } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-testing-library\""
        }), ";\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "describe"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Counter\""
        }), ", ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "afterEach"
        }), "(cleanup);\n\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "test"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"ゼロから始まる\""
        }), ", ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\n    ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "render"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Counter"
            }), " />"]
          })
        }), ");\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " button = screen.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "getByRole"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"button\""
        }), ");\n    ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "expect"
        }), "(button).", jsx(_components.span, {
          className: "hljs-title function_",
          children: "toBeInTheDocument"
        }), "();\n    ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "expect"
        }), "(button).", jsx(_components.span, {
          className: "hljs-title function_",
          children: "toHaveTextContent"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Count: 0\""
        }), ");\n  });\n\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "test"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"クリックで値が 1 増える\""
        }), ", ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "async"
        }), " () => {\n    ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "render"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Counter"
            }), " />"]
          })
        }), ");\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " button = screen.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "getByRole"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"button\""
        }), ");\n    fireEvent.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "click"
        }), "(button);\n    ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// イベントループが終了するのにひとつのプロミスを解決する必要があります"
        }), "\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "await"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "resolve"
        }), "();\n    ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "expect"
        }), "(button).", jsx(_components.span, {
          className: "hljs-title function_",
          children: "toHaveTextContent"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Count: 1\""
        }), ");\n    fireEvent.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "click"
        }), "(button);\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "await"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "resolve"
        }), "();\n    ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "expect"
        }), "(button).", jsx(_components.span, {
          className: "hljs-title function_",
          children: "toHaveTextContent"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Count: 2\""
        }), ");\n  });\n});\n"]
      })
    }), "\n", jsxs(_components.h4, {
      id: "uvu-でのテスト-2",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#uvu-でのテスト-2",
        children: "#"
      }), "uvu でのテスト"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// main.test.tsx"
        }), "\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { suite } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"uvu\""
        }), ";\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " * ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "as"
        }), " assert ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"uvu/assert\""
        }), ";\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Counter"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"main\""
        }), ";\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { fireEvent, render, screen } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-testing-library\""
        }), ";\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { isInDocument, hasTextContent } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-dom-testing\""
        }), ";\n\n\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " testCounter = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "suite"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Counter\""
        }), ");\n\ntestCounter.", jsx(_components.span, {
          className: "hljs-property",
          children: "after"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "each"
        }), "(cleanup);\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "testCounter"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"ゼロから始まる\""
        }), ", ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " { getByRole } = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "render"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Counter"
            }), " />"]
          })
        }), ");\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " button = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "getByRole"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"button\""
        }), ");\n  assert.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "ok"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "isInDocument"
        }), "(button), ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"button not in dom\""
        }), ");\n  assert.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "ok"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "hasTextContent"
        }), "(button, ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Count: 0\""
        }), "), ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"wrong text content\""
        }), ");\n});\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "testCounter"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"クリックで値が 1 増える\""
        }), ", ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "async"
        }), " () => {\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "render"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Counter"
            }), " />"]
          })
        }), ");\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " button = screen.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "getByRole"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"button\""
        }), ");\n  fireEvent.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "click"
        }), "(button);\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// イベントループが終了するのにひとつのプロミスを解決する必要があります"
        }), "\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "await"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "resolve"
        }), "();\n  assert.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "ok"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "hasTextContent"
        }), "(button, ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Count: 1\""
        }), "), ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"not count 1 after first click\""
        }), ");\n  fireEvent.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "click"
        }), "(button);\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "await"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "resolve"
        }), "();\n  assert.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "ok"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "hasTextContent"
        }), "(button, ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Count: 2\""
        }), "), ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"not count 2 after first click\""
        }), ");\n});\n\ntestCounter.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "run"
        }), "();\n"]
      })
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
