import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [{
  "depth": 1,
  "value": "Basic Reactivity",
  "children": [{
    "depth": 2,
    "value": "createSignal",
    "children": [{
      "depth": 5,
      "value": "Options",
      "children": []
    }]
  }, {
    "depth": 2,
    "value": "createEffect",
    "children": []
  }, {
    "depth": 2,
    "value": "createMemo",
    "children": []
  }, {
    "depth": 2,
    "value": "createResource",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Lifecycles",
  "children": [{
    "depth": 2,
    "value": "onMount",
    "children": []
  }, {
    "depth": 2,
    "value": "onCleanup",
    "children": []
  }, {
    "depth": 2,
    "value": "onError",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Reactive Utilities",
  "children": [{
    "depth": 2,
    "value": "untrack",
    "children": []
  }, {
    "depth": 2,
    "value": "batch",
    "children": []
  }, {
    "depth": 2,
    "value": "on",
    "children": []
  }, {
    "depth": 2,
    "value": "createRoot",
    "children": []
  }, {
    "depth": 2,
    "value": "getOwner",
    "children": []
  }, {
    "depth": 2,
    "value": "runWithOwner",
    "children": []
  }, {
    "depth": 2,
    "value": "mergeProps",
    "children": []
  }, {
    "depth": 2,
    "value": "splitProps",
    "children": []
  }, {
    "depth": 2,
    "value": "useTransition",
    "children": []
  }, {
    "depth": 2,
    "value": "startTransition",
    "children": []
  }, {
    "depth": 2,
    "value": "observable",
    "children": []
  }, {
    "depth": 2,
    "value": "from",
    "children": []
  }, {
    "depth": 2,
    "value": "mapArray",
    "children": []
  }, {
    "depth": 2,
    "value": "indexArray",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Stores",
  "children": [{
    "depth": 2,
    "value": "Using Stores",
    "children": [{
      "depth": 3,
      "value": "createStore",
      "children": [{
        "depth": 4,
        "value": "Arrays in stores",
        "children": []
      }]
    }, {
      "depth": 3,
      "value": "Getters",
      "children": []
    }, {
      "depth": 3,
      "value": "Updating Stores",
      "children": []
    }]
  }, {
    "depth": 2,
    "value": "Store Utilities",
    "children": [{
      "depth": 3,
      "value": "produce",
      "children": []
    }, {
      "depth": 3,
      "value": "reconcile",
      "children": []
    }, {
      "depth": 3,
      "value": "unwrap",
      "children": []
    }, {
      "depth": 3,
      "value": "createMutable",
      "children": []
    }, {
      "depth": 3,
      "value": "modifyMutable",
      "children": []
    }]
  }]
}, {
  "depth": 1,
  "value": "Component APIs",
  "children": [{
    "depth": 2,
    "value": "createContext",
    "children": []
  }, {
    "depth": 2,
    "value": "useContext",
    "children": []
  }, {
    "depth": 2,
    "value": "children",
    "children": []
  }, {
    "depth": 2,
    "value": "lazy",
    "children": []
  }, {
    "depth": 2,
    "value": "createUniqueId",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Secondary Primitives",
  "children": [{
    "depth": 2,
    "value": "createDeferred",
    "children": []
  }, {
    "depth": 2,
    "value": "createRenderEffect",
    "children": []
  }, {
    "depth": 2,
    "value": "createComputed",
    "children": []
  }, {
    "depth": 2,
    "value": "createReaction",
    "children": []
  }, {
    "depth": 2,
    "value": "createSelector",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Rendering",
  "children": [{
    "depth": 2,
    "value": "render",
    "children": []
  }, {
    "depth": 2,
    "value": "hydrate",
    "children": []
  }, {
    "depth": 2,
    "value": "renderToString",
    "children": []
  }, {
    "depth": 2,
    "value": "renderToStringAsync",
    "children": []
  }, {
    "depth": 2,
    "value": "renderToStream",
    "children": []
  }, {
    "depth": 2,
    "value": "isServer",
    "children": []
  }, {
    "depth": 2,
    "value": "DEV",
    "children": []
  }, {
    "depth": 2,
    "value": "HydrationScript",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Control Flow",
  "children": [{
    "depth": 2,
    "value": "<For>",
    "children": []
  }, {
    "depth": 2,
    "value": "<Show>",
    "children": []
  }, {
    "depth": 2,
    "value": "<Switch>/<Match>",
    "children": []
  }, {
    "depth": 2,
    "value": "<Index>",
    "children": []
  }, {
    "depth": 2,
    "value": "<ErrorBoundary>",
    "children": []
  }, {
    "depth": 2,
    "value": "<Suspense>",
    "children": []
  }, {
    "depth": 2,
    "value": "<SuspenseList> (Experimental)",
    "children": []
  }, {
    "depth": 2,
    "value": "<Dynamic>",
    "children": []
  }, {
    "depth": 2,
    "value": "<Portal>",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Special JSX Attributes",
  "children": [{
    "depth": 2,
    "value": "ref",
    "children": []
  }, {
    "depth": 2,
    "value": "classList",
    "children": []
  }, {
    "depth": 2,
    "value": "style",
    "children": []
  }, {
    "depth": 2,
    "value": "innerHTML/textContent",
    "children": []
  }, {
    "depth": 2,
    "value": "on___",
    "children": []
  }, {
    "depth": 2,
    "value": "on:___/oncapture:___",
    "children": []
  }, {
    "depth": 2,
    "value": "use:___",
    "children": []
  }, {
    "depth": 2,
    "value": "prop:___",
    "children": []
  }, {
    "depth": 2,
    "value": "attr:___",
    "children": []
  }, {
    "depth": 2,
    "value": "/* @once */",
    "children": []
  }]
}];
function _createMdxContent(props) {
  const _components = Object.assign({
    h1: "h1",
    a: "a",
    p: "p",
    em: "em",
    code: "code",
    h2: "h2",
    pre: "pre",
    span: "span",
    blockquote: "blockquote",
    h5: "h5",
    strong: "strong",
    ul: "ul",
    li: "li",
    h3: "h3",
    h4: "h4"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsxs(_components.h1, {
      id: "basic-reactivity",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#basic-reactivity",
        children: "#"
      }), "Basic Reactivity"]
    }), "\n", jsxs(_components.p, {
      children: ["Solid's overall approach to reactivity is to wrap any reactive computation in\r\na function, and rerun that function when its dependencies update.\r\nThe Solid JSX compiler also wraps most JSX expressions (code in braces) with a\r\nfunction, so they automatically update (and trigger corresponding DOM updates)\r\nwhen their dependencies change.\r\nMore precisely, automatic rerunning of a function happens whenever the function\r\ngets called in a ", jsx(_components.em, {
        children: "tracking scope"
      }), ", such as a JSX expression\r\nor API calls that build \"computations\" (", jsx(_components.code, {
        children: "createEffect"
      }), ", ", jsx(_components.code, {
        children: "createMemo"
      }), ", etc.).\r\nBy default, the dependencies of a function get tracked automatically\r\nwhen they're called in a tracking scope, by detecting when the function reads\r\nreactive state (e.g., via a Signal getter or Store attribute).\r\nAs a result, you generally don't need to worry about dependencies yourselves.\r\n(But if automatic dependency tracking ever doesn't produce the results you\r\nwant, you can ", jsx(_components.a, {
        href: "#reactive-utilities",
        children: "override dependency tracking"
      }), ".)\r\nThis approach makes reactivity ", jsx(_components.em, {
        children: "composable"
      }), ": calling one function\r\nwithin another function generally causes the calling function\r\nto inherit the dependencies of the called function."]
    }), "\n", jsxs(_components.h2, {
      id: "createsignal",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createsignal",
        children: "#"
      }), jsx(_components.code, {
        children: "createSignal"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createSignal } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createSignal<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "initialValue"
        }), ": T,\r\n  options?: { equals?: ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " | (", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev: T, next: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ") }\r\n): [", jsx(_components.span, {
          className: "hljs-attr",
          children: "get"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T, ", jsx(_components.span, {
          className: "hljs-attr",
          children: "set"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v: T"
          }), ") =>"]
        }), " T];\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// available types for return value of createSignal:"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " { ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Signal"
        }), ", ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Accessor"
        }), ", ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Setter"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Signal"
        }), "<T> = [", jsx(_components.span, {
          className: "hljs-attr",
          children: "get"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Accessor"
        }), "<T>, ", jsx(_components.span, {
          className: "hljs-attr",
          children: "set"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Setter"
        }), "<T>];\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Accessor"
        }), "<T> = ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T;\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Setter"
        }), "<T> = ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v: T | ((prev?: T) => T)"
          }), ") =>"]
        }), " T;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Signals are the most basic reactive primitive. They track a single value\r\n(which can be any JavaScript object) that changes over time.\r\nThe Signal's value starts out equal to the passed first argument\r\n", jsx(_components.code, {
        children: "initialValue"
      }), " (or ", jsx(_components.code, {
        children: "undefined"
      }), " if there are no arguments).\r\nThe ", jsx(_components.code, {
        children: "createSignal"
      }), " function returns a pair of functions as a two-element array:\r\na ", jsx(_components.em, {
        children: "getter"
      }), " (or ", jsx(_components.em, {
        children: "accessor"
      }), ") and a ", jsx(_components.em, {
        children: "setter"
      }), ". In typical use, you would\r\ndestructure this array into a named Signal like so:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [count, setCount] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ");\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [ready, setReady] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Calling the getter (e.g., ", jsx(_components.code, {
        children: "count()"
      }), " or ", jsx(_components.code, {
        children: "ready()"
      }), ")\r\nreturns the current value of the Signal.\r\nCrucial to automatic dependency tracking, calling the getter\r\nwithin a tracking scope causes the calling function to depend on this Signal,\r\nso that function will rerun if the Signal gets updated."]
    }), "\n", jsxs(_components.p, {
      children: ["Calling the setter (e.g., ", jsx(_components.code, {
        children: "setCount(nextCount)"
      }), " or ", jsx(_components.code, {
        children: "setReady(nextReady)"
      }), ")\r\nsets the Signal's value and ", jsx(_components.em, {
        children: "updates"
      }), " the Signal\r\n(triggering dependents to rerun)\r\nif the value actually changed (see details below).\r\nAs its only argument, the setter takes either the new value for the signal,\r\nor a function that maps the last value of the signal to a new value.\r\nThe setter also returns the updated value. For example:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// read signal's current value, and"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// depend on signal if in a tracking scope"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// (but nonreactive outside of a tracking scope):"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " currentCount = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "count"
        }), "();\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// or wrap any computation with a function,"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// and this function can be used in a tracking scope:"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "doubledCount"
        }), " = (", jsx(_components.span, {
          className: "hljs-params"
        }), ") => ", jsx(_components.span, {
          className: "hljs-number",
          children: "2"
        }), " * ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "count"
        }), "();\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// or build a tracking scope and depend on signal:"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " countDisplay = ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "{count()}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// write signal by providing a value:"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setReady"
        }), "(", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), ");\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// write signal by providing a function setter:"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " newCount = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setCount"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev"
          }), ") =>"]
        }), " prev + ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.blockquote, {
      children: ["\n", jsx(_components.p, {
        children: "If you want to store a function in a Signal you must use the function form:"
      }), "\n", jsx(_components.pre, {
        children: jsxs(_components.code, {
          className: "hljs language-js",
          children: [jsx(_components.span, {
            className: "hljs-title function_",
            children: "setValue"
          }), "(", jsx(_components.span, {
            className: "hljs-function",
            children: "() =>"
          }), " myFunction);\n"]
        })
      }), "\n", jsxs(_components.p, {
        children: ["However, functions are not treated specially as the ", jsx(_components.code, {
          children: "initialValue"
        }), " argument\r\nto ", jsx(_components.code, {
          children: "createSignal"
        }), ", so you should pass a function initial value as is:"]
      }), "\n", jsx(_components.pre, {
        children: jsxs(_components.code, {
          className: "hljs language-js",
          children: [jsx(_components.span, {
            className: "hljs-keyword",
            children: "const"
          }), " [func, setFunc] = ", jsx(_components.span, {
            className: "hljs-title function_",
            children: "createSignal"
          }), "(myFunction);\n"]
        })
      }), "\n"]
    }), "\n", jsxs(_components.p, {
      children: ["Unless you're in a ", jsx(_components.a, {
        href: "#batch",
        children: "batch"
      }), ", ", jsx(_components.a, {
        href: "#createEffect",
        children: "effect"
      }), ", or\r\n", jsx(_components.a, {
        href: "#use-transition",
        children: "transition"
      }), ", signals update immediately when you set them.\r\nFor example:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "setReady"
        }), "(", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), ");\r\n", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "assert"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "ready"
        }), "() === ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), ");\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setReady"
        }), "(", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), ");\r\n", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "assert"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "ready"
        }), "() === ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), ");\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "If you're not sure whether your code will be run in a batch or transition\r\n(e.g., library code), you should avoid making this assumption."
    }), "\n", jsxs(_components.h5, {
      id: "options",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#options",
        children: "#"
      }), "Options"]
    }), "\n", jsxs(_components.p, {
      children: ["Several primitives in Solid take an \"options\" object\r\nas an optional last argument.\r\n", jsx(_components.code, {
        children: "createSignal"
      }), "'s options object allows you to provide an\r\n", jsx(_components.code, {
        children: "equals"
      }), " option. For example:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [getValue, setValue] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(initialValue, { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "equals"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " });\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["By default, when calling a signal's setter, the signal only updates (and causes\r\ndependents to rerun) if the new value is actually different than the old value,\r\naccording to JavaScript's ", jsx(_components.code, {
        children: "==="
      }), " operator."]
    }), "\n", jsxs(_components.p, {
      children: ["Alternatively, you can set ", jsx(_components.code, {
        children: "equals"
      }), " to ", jsx(_components.code, {
        children: "false"
      }), " to always rerun dependents after\r\nthe setter is called, or you can pass your own function for testing equality.\r\nSome examples:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// use { equals: false } to allow modifying object in-place;"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// normally this wouldn't be seen as an update because the"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// object has the same identity before and after change"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [object, setObject] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "count"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), " }, { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "equals"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " });\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setObject"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "current"
          }), ") =>"]
        }), " {\r\n  current.", jsx(_components.span, {
          className: "hljs-property",
          children: "count"
        }), " += ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), ";\r\n  current.", jsx(_components.span, {
          className: "hljs-property",
          children: "updated"
        }), " = ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "new"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Date"
        }), "();\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " current;\r\n});\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// use { equals: false } signal as trigger without value:"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [depend, rerun] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), ", { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "equals"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " });\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// now calling depend() in a tracking scope"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// makes that scope rerun whenever rerun() gets called"
        }), "\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// define equality based on string length:"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [myString, setMyString] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"string\""
        }), ", {\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "equals"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "newVal, oldVal"
          }), ") =>"]
        }), " newVal.", jsx(_components.span, {
          className: "hljs-property",
          children: "length"
        }), " === oldVal.", jsx(_components.span, {
          className: "hljs-property",
          children: "length"
        }), ",\r\n});\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setMyString"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"strung\""
        }), "); ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// considered equal to the last value and won't cause updates"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setMyString"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"stranger\""
        }), "); ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// considered different and will cause updates"
        }), "\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "createeffect",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createeffect",
        children: "#"
      }), jsx(_components.code, {
        children: "createEffect"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createEffect } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createEffect<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v: T"
          }), ") =>"]
        }), " T, value?: T): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Effects are a general way to make arbitrary code (\"side effects\")\r\nrun whenever dependencies change, e.g., to modify the DOM manually.\r\n", jsx(_components.code, {
        children: "createEffect"
      }), " creates a new computation that runs the given function\r\nin a tracking scope, thus automatically tracking its dependencies,\r\nand automatically reruns the function whenever the dependencies update.\r\nFor example:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [a, setA] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(initialValue);\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// effect that depends on signal `a`"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "doSideEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "a"
        }), "()));\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["The effect function gets called with an argument equal to the value returned\r\nfrom the effect function's last execution, or on the first call,\r\nequal to the optional second argument to ", jsx(_components.code, {
        children: "createEffect"
      }), ".\r\nThis allows you to compute diffs without creating an additional closure\r\nto remember the last computed value. For example:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev"
          }), ") =>"]
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " sum = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "a"
        }), "() + ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "b"
        }), "();\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "if"
        }), " (sum !== prev) ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"sum changed to\""
        }), ", sum);\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " sum;\r\n}, ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Effects are meant primarily for side effects that read but don't write\r\nto the reactive system:\r\nit's best to avoid setting signals in effects, which without care\r\ncan cause additional rendering or even infinite effect loops.\r\nInstead, prefer using ", jsx(_components.a, {
        href: "#creatememo",
        children: jsx(_components.code, {
          children: "createMemo"
        })
      }), " to compute new values\r\nthat depend on other reactive values, so the reactive system knows what\r\ndepends on what, and can optimize accordingly.\r\nIf you do set signals in an effect,\r\nthe effect function is automatically wrapped in ", jsx(_components.a, {
        href: "#batch",
        children: jsx(_components.code, {
          children: "batch"
        })
      }), ",\r\nmeaning that all signal changes inside the effect propagate only after the\r\neffect finishes. This causes several signal updates to trigger only\r\none update, and avoids unwanted side effects from happening in the middle\r\nof your side effects.\r\nIn fact, if multiple effects all trigger at once, they collectively\r\nget wrapped into a single ", jsx(_components.code, {
        children: "batch"
      }), "."]
    }), "\n", jsxs(_components.p, {
      children: ["The ", jsx(_components.em, {
        children: "first"
      }), " execution of the effect function is not immediate;\r\nit's scheduled to run after the current rendering phase\r\n(e.g., after calling the function passed to ", jsx(_components.a, {
        href: "#render",
        children: jsx(_components.code, {
          children: "render"
        })
      }), ",\r\n", jsx(_components.a, {
        href: "#createroot",
        children: jsx(_components.code, {
          children: "createRoot"
        })
      }), ", or ", jsx(_components.a, {
        href: "#runwithowner",
        children: jsx(_components.code, {
          children: "runWithOwner"
        })
      }), ").\r\nIf you want to wait for the first execution to occur, use\r\n", jsx(_components.a, {
        href: "https://developer.mozilla.org/en-US/docs/Web/API/queueMicrotask",
        children: jsx(_components.code, {
          children: "queueMicrotask"
        })
      }), "\r\n(which runs before the browser renders the DOM) or\r\n", jsx(_components.code, {
        children: "await Promise.resolve()"
      }), " or ", jsx(_components.code, {
        children: "setTimeout(..., 0)"
      }), "\r\n(which run after browser rendering).\r\nAfter this first execution, effects generally run immediately when\r\ntheir dependencies update (unless you're in a ", jsx(_components.a, {
        href: "#batch",
        children: "batch"
      }), " or\r\n", jsx(_components.a, {
        href: "#use-transition",
        children: "transition"
      }), "). For example:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// assume this code is in a component function, so is part of a rendering phase"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [count, setCount] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ");\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// this effect prints count at the beginning and when it changes"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"count =\""
        }), ", ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "count"
        }), "()));\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// effect won't run yet"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"hello\""
        }), ");\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setCount"
        }), "(", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), "); ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// effect still won't run yet"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setCount"
        }), "(", jsx(_components.span, {
          className: "hljs-number",
          children: "2"
        }), "); ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// effect still won't run yet"
        }), "\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "queueMicrotask"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// now `count = 2` will print"
        }), "\r\n  ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"microtask\""
        }), ");\r\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setCount"
        }), "(", jsx(_components.span, {
          className: "hljs-number",
          children: "3"
        }), "); ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// immediately prints `count = 3`"
        }), "\r\n  ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"goodbye\""
        }), ");\r\n});\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// --- overall output: ---"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// hello"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// count = 2"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// microtask"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// count = 3"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// goodbye"
        }), "\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["This delay in first execution is useful because it means\r\nan effect defined in a component scope runs after\r\nthe JSX returned by the component gets added the DOM.\r\nIn particular, ", jsx(_components.a, {
        href: "#ref",
        children: jsx(_components.code, {
          children: "ref"
        })
      }), "s will already be set.\r\nThus you can use an effect to manipulate the DOM manually,\r\ncall vanilla JS libraries, or other side effects."]
    }), "\n", jsxs(_components.p, {
      children: ["Note that the first run of the effect still runs before the browser renders\r\nthe DOM to the screen (similar to React's ", jsx(_components.code, {
        children: "useLayoutEffect"
      }), ").\r\nIf you need to wait until after rendering (e.g., to measure the rendering),\r\nyou can use ", jsx(_components.code, {
        children: "await Promise.resolve()"
      }), " (or ", jsx(_components.code, {
        children: "Promise.resolve().then(...)"
      }), "),\r\nbut note that subsequent use of reactive state (such as signals)\r\nwill not trigger the effect to rerun, as tracking is not\r\npossible after an ", jsx(_components.code, {
        children: "async"
      }), " function uses ", jsx(_components.code, {
        children: "await"
      }), ".\r\nThus you should use all dependencies before the promise."]
    }), "\n", jsxs(_components.p, {
      children: ["If you'd rather an effect run immediately even for its first run,\r\nuse ", jsx(_components.a, {
        href: "#createrendereffect",
        children: jsx(_components.code, {
          children: "createRenderEffect"
        })
      }), " or\r\n", jsx(_components.a, {
        href: "#createcomputed",
        children: jsx(_components.code, {
          children: "createComputed"
        })
      }), "."]
    }), "\n", jsxs(_components.p, {
      children: ["You can clean up your side effects in between executions of the effect function\r\nby calling ", jsx(_components.a, {
        href: "#oncleanup",
        children: jsx(_components.code, {
          children: "onCleanup"
        })
      }), " ", jsx(_components.em, {
        children: "inside"
      }), " the effect function.\r\nSuch a cleanup function gets called both in between effect executions and\r\nwhen the effect gets disposed (e.g., the containing component unmounts).\r\nFor example:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// listen to event dynamically given by eventName signal"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " event = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "eventName"
        }), "();\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "callback"
        }), " = (", jsx(_components.span, {
          className: "hljs-params",
          children: "e"
        }), ") => ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(e);\r\n  ref.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "addEventListener"
        }), "(event, callback);\r\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onCleanup"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ref.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "removeEventListener"
        }), "(event, callback));\r\n});\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "creatememo",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#creatememo",
        children: "#"
      }), jsx(_components.code, {
        children: "createMemo"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createMemo } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createMemo<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v: T"
          }), ") =>"]
        }), " T,\r\n  value?: T,\r\n  options?: { equals?: ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " | (", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev: T, next: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ") }\r\n): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Memos let you efficiently use a derived value in many reactive computations.\r\n", jsx(_components.code, {
        children: "createMemo"
      }), " creates a readonly reactive value equal to the return value of\r\nthe given function and makes sure that function only gets executed when its dependencies change."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " value = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createMemo"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "computeExpensiveValue"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "a"
        }), "(), ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "b"
        }), "()));\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// read value"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "value"
        }), "();\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["In Solid, you often don't need to wrap functions in memos;\r\nyou can alternatively just define and call a regular function\r\nto get similar reactive behavior.\r\nThe main difference is when you call the function in multiple reactive settings.\r\nIn this case, when the function's dependencies update, the function will get\r\ncalled multiple times unless it is wrapped in ", jsx(_components.code, {
        children: "createMemo"
      }), ". For example:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " user = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createMemo"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "searchForUser"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "username"
        }), "()));\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// compare with: const user = () => searchForUser(username());"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " (\r\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "ul"
            }), ">"]
          }), "\r\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "li"
            }), ">"]
          }), "Your name is \"{user()?.name}\"", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "li"
            }), ">"]
          }), "\r\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "li"
            }), ">"]
          }), "\r\n      Your email is ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "code"
            }), ">"]
          }), "{user()?.email}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "code"
            }), ">"]
          }), "\r\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "li"
            }), ">"]
          }), "\r\n  ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "ul"
            }), ">"]
          })]
        }), "\r\n);\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["When the ", jsx(_components.code, {
        children: "username"
      }), " signal updates, ", jsx(_components.code, {
        children: "searchForUser"
      }), " will get called just once.\r\nIf the returned user actually changed, the ", jsx(_components.code, {
        children: "user"
      }), " memo updates, and then both\r\nlist items will update automatically."]
    }), "\n", jsxs(_components.p, {
      children: ["If we had instead defined ", jsx(_components.code, {
        children: "user"
      }), " as a plain function\r\n", jsx(_components.code, {
        children: "() => searchForUser(username())"
      }), ", then ", jsx(_components.code, {
        children: "searchForUser"
      }), " would have been\r\ncalled twice, once when updating each list item."]
    }), "\n", jsxs(_components.p, {
      children: ["Another key difference is that a memo can shield dependents from updating\r\nwhen the memo's dependencies change but the resulting memo value doesn't.\r\nLike ", jsx(_components.a, {
        href: "#createsignal",
        children: jsx(_components.code, {
          children: "createSignal"
        })
      }), ", the derived signal made by ", jsx(_components.code, {
        children: "createMemo"
      }), "\r\n", jsx(_components.em, {
        children: "updates"
      }), " (and triggers dependents to rerun) only when the value returned by\r\nthe memo function actually changes from the previous value,\r\naccording to JavaScript's ", jsx(_components.code, {
        children: "==="
      }), " operator.\r\nAlternatively, you can pass an options object with ", jsx(_components.code, {
        children: "equals"
      }), " set to ", jsx(_components.code, {
        children: "false"
      }), "\r\nto always update the memo when its dependencies change,\r\nor you can pass your own ", jsx(_components.code, {
        children: "equals"
      }), " function for testing equality."]
    }), "\n", jsxs(_components.p, {
      children: ["The memo function gets called with an argument equal to the value returned\r\nfrom the memo function's last execution, or on the first call,\r\nequal to the optional second argument to ", jsx(_components.code, {
        children: "createMemo"
      }), ".\r\nThis is useful for reducing computations, for example:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// track the sum of all values taken on by input() as it updates"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " sum = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createMemo"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "input"
        }), "() + prev, ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ");\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "The memo function should not change other signals by calling setters\r\n(it should be \"pure\").\r\nThis enables Solid to optimize the execution order of memo updates\r\naccording to their dependency graph, so that all memos can update\r\nat most once in response to a dependency change."
    }), "\n", jsxs(_components.h2, {
      id: "createresource",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createresource",
        children: "#"
      }), jsx(_components.code, {
        children: "createResource"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createResource } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " { ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ResourceReturn"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ResourceReturn"
        }), "<T> = [\r\n  {\r\n    (): T | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), ";\r\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "loading"
        }), ": ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ";\r\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "error"
        }), ": ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ";\r\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "latest"
        }), ": T | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), ";\r\n  },\r\n  {\r\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "mutate"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: T | ", jsx(_components.span, {
              className: "hljs-literal",
              children: "undefined"
            })]
          }), ") =>"]
        }), " T | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), ";\r\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "refetch"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["info: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "unknown"
            })]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<T> | T;\r\n  }\r\n];\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createResource<T, U = ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), ">(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fetcher"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["\r\n    k: U,\r\n    info: { value: T | ", jsx(_components.span, {
              className: "hljs-literal",
              children: "undefined"
            }), "; refetching: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "boolean"
            }), " | ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "unknown"
            }), " }\r\n  "]
          }), ") =>"]
        }), " T | ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<T>,\r\n  options?: { initialValue?: T }\r\n): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ResourceReturn"
        }), "<T>;\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createResource<T, U>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "source"
        }), ": U | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "null"
        }), " | (", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " U | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "null"
        }), "),\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fetcher"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["\r\n    k: U,\r\n    info: { value: T | ", jsx(_components.span, {
              className: "hljs-literal",
              children: "undefined"
            }), "; refetching: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "boolean"
            }), " | ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "unknown"
            }), " }\r\n  "]
          }), ") =>"]
        }), " T | ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<T>,\r\n  options?: { initialValue?: T }\r\n): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ResourceReturn"
        }), "<T>;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Creates a signal that reflects the result of an async request."
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "createResource"
      }), " takes an asynchronous fetcher function and returns a signal that is updated with the resulting data when the fetcher completes."]
    }), "\n", jsxs(_components.p, {
      children: ["There are two ways to use ", jsx(_components.code, {
        children: "createResource"
      }), ": you can pass the fetcher function as the sole argument, or you can additionally pass a source signal as the first argument. The source signal will retrigger the fetcher whenever it changes, and its value will be passed to the fetcher."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [data, { mutate, refetch }] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createResource"
        }), "(fetchData);\n"]
      })
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [data, { mutate, refetch }] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createResource"
        }), "(sourceSignal, fetchData);\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["In these snippets, the fetcher is the function ", jsx(_components.code, {
        children: "fetchData"
      }), ", and ", jsx(_components.code, {
        children: "data()"
      }), " is undefined until ", jsx(_components.code, {
        children: "fetchData"
      }), " finishes resolving. In the first case, ", jsx(_components.code, {
        children: "fetchData"
      }), " will be called immediately.\r\nIn the second, ", jsx(_components.code, {
        children: "fetchData"
      }), " will be called as soon as ", jsx(_components.code, {
        children: "sourceSignal"
      }), " has any value other than ", jsx(_components.code, {
        children: "false"
      }), ", ", jsx(_components.code, {
        children: "null"
      }), ", or ", jsx(_components.code, {
        children: "undefined"
      }), ".\r\nIt will be called again whenever the value of ", jsx(_components.code, {
        children: "sourceSignal"
      }), " changes, and that value will always be passed to ", jsx(_components.code, {
        children: "fetchData"
      }), " as its first argument."]
    }), "\n", jsxs(_components.p, {
      children: ["You can call ", jsx(_components.code, {
        children: "mutate"
      }), " to directly update the ", jsx(_components.code, {
        children: "data"
      }), " signal (it works like any other signal setter). You can also call ", jsx(_components.code, {
        children: "refetch"
      }), " to rerun the fetcher directly, and pass an optional argument to provide additional info to the fetcher: ", jsx(_components.code, {
        children: "refetch(info)"
      }), "."]
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "data"
      }), " works like a normal signal getter: use ", jsx(_components.code, {
        children: "data()"
      }), " to read the last returned value of ", jsx(_components.code, {
        children: "fetchData"
      }), ".\r\nBut it also has extra reactive properties: ", jsx(_components.code, {
        children: "data.loading"
      }), " tells you if the fetcher has been called but not returned, and ", jsx(_components.code, {
        children: "data.error"
      }), " tells you if the request has errored out; if so, it contains the error thrown by the fetcher. (Note: if you anticipate errors, you may want to wrap ", jsx(_components.code, {
        children: "createResource"
      }), " in an ", jsx(_components.a, {
        href: "#%3Cerrorboundary%3E",
        children: "ErrorBoundary"
      }), ".)"]
    }), "\n", jsxs(_components.p, {
      children: ["As of ", jsx(_components.strong, {
        children: "1.4.0"
      }), ", ", jsx(_components.code, {
        children: "data.latest"
      }), " will return the last returned value and won't trigger ", jsx(_components.a, {
        href: "#%3Csuspense%3E",
        children: "Suspense"
      }), " and ", jsx(_components.a, {
        href: "#usetransition",
        children: "transitions"
      }), "; if no value has been returned yet, ", jsx(_components.code, {
        children: "data.latest"
      }), " acts the same as ", jsx(_components.code, {
        children: "data()"
      }), ". This can be useful if you want to show the out-of-date data while the new data is loading."]
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "loading"
      }), ", ", jsx(_components.code, {
        children: "error"
      }), ", and ", jsx(_components.code, {
        children: "latest"
      }), " are reactive getters and can be tracked."]
    }), "\n", jsxs(_components.p, {
      children: ["The ", jsx(_components.code, {
        children: "fetcher"
      }), " is the async function that you provide to ", jsx(_components.code, {
        children: "createResource"
      }), " to actually fetch the data.\r\nIt is passed two arguments: the value of the source signal (if provided), and an info object with two properties: ", jsx(_components.code, {
        children: "value"
      }), " and ", jsx(_components.code, {
        children: "refetching"
      }), ". ", jsx(_components.code, {
        children: "value"
      }), " tells you the previously fetched value.\r\n", jsx(_components.code, {
        children: "refetching"
      }), " is ", jsx(_components.code, {
        children: "true"
      }), " if the fetcher was triggered using the ", jsx(_components.code, {
        children: "refetch"
      }), " function and ", jsx(_components.code, {
        children: "false"
      }), " otherwise.\r\nIf the ", jsx(_components.code, {
        children: "refetch"
      }), " function was called with an argument (", jsx(_components.code, {
        children: "refetch(info)"
      }), "), ", jsx(_components.code, {
        children: "refetching"
      }), " is set to that argument."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "async"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fetchData"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "source, { value, refetching }"
        }), ") {\r\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Fetch the data and return a value."
        }), "\r\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "//`source` tells you the current value of the source signal;"
        }), "\r\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "//`value` tells you the last returned value of the fetcher;"
        }), "\r\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "//`refetching` is true when the fetcher is triggered by calling `refetch()`,"
        }), "\r\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// or equal to the optional data passed: `refetch(info)`"
        }), "\r\n}\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [data, { mutate, refetch }] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createResource"
        }), "(getQuery, fetchData);\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// read value"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "data"
        }), "();\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// check if loading"
        }), "\r\ndata.", jsx(_components.span, {
          className: "hljs-property",
          children: "loading"
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// check if errored"
        }), "\r\ndata.", jsx(_components.span, {
          className: "hljs-property",
          children: "error"
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// directly set value without creating promise"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mutate"
        }), "(optimisticValue);\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// refetch the last request explicitly"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "refetch"
        }), "();\n"]
      })
    }), "\n", jsx(_components.p, {
      children: jsx(_components.strong, {
        children: "New in v1.4.0"
      })
    }), "\n", jsxs(_components.p, {
      children: ["If you're using ", jsx(_components.code, {
        children: "renderToStream"
      }), ", you can tell Solid to wait for a resource before flushing the stream using the ", jsx(_components.code, {
        children: "deferStream"
      }), " option:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// fetches a user and streams content as soon as possible"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [user] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createResource"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " params.", jsx(_components.span, {
          className: "hljs-property",
          children: "id"
        }), ", fetchUser);\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// fetches a user but only streams content after this resource has loaded"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [user] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createResource"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " params.", jsx(_components.span, {
          className: "hljs-property",
          children: "id"
        }), ", fetchUser, {\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "deferStream"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), ",\r\n});\n"]
      })
    }), "\n", jsxs(_components.h1, {
      id: "lifecycles",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#lifecycles",
        children: "#"
      }), "Lifecycles"]
    }), "\n", jsxs(_components.h2, {
      id: "onmount",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#onmount",
        children: "#"
      }), jsx(_components.code, {
        children: "onMount"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { onMount } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onMount"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["fn: () => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "void"
          })]
        }), "): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Registers a method that runs after initial render and elements have been mounted. Ideal for using ", jsx(_components.code, {
        children: "ref"
      }), "s and managing other one time side effects. It is equivalent to a ", jsx(_components.code, {
        children: "createEffect"
      }), " which does not have any dependencies."]
    }), "\n", jsxs(_components.h2, {
      id: "oncleanup",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#oncleanup",
        children: "#"
      }), jsx(_components.code, {
        children: "onCleanup"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { onCleanup } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onCleanup"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["fn: () => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "void"
          })]
        }), "): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Registers a cleanup method that executes on disposal or recalculation of the current reactive scope. Can be used in any Component or Effect."
    }), "\n", jsxs(_components.h2, {
      id: "onerror",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#onerror",
        children: "#"
      }), jsx(_components.code, {
        children: "onError"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { onError } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onError"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["fn: (err: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "any"
          }), ") => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "void"
          })]
        }), "): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Registers an error handler method that executes when child scope errors. Only the nearest scope error handlers execute. Rethrow to trigger up the line."
    }), "\n", jsxs(_components.h1, {
      id: "reactive-utilities",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#reactive-utilities",
        children: "#"
      }), "Reactive Utilities"]
    }), "\n", jsx(_components.p, {
      children: "These helpers provide the ability to better schedule updates and control how reactivity is tracked."
    }), "\n", jsxs(_components.h2, {
      id: "untrack",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#untrack",
        children: "#"
      }), jsx(_components.code, {
        children: "untrack"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { untrack } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " untrack<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T): T;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Ignores tracking any of the dependencies in the executing code block and returns the value."
    }), "\n", jsxs(_components.h2, {
      id: "batch",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#batch",
        children: "#"
      }), jsx(_components.code, {
        children: "batch"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { batch } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " batch<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T): T;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Holds committing updates within the block until the end to prevent unnecessary recalculation. This means that reading values on the next line will not have updated yet. ", jsx(_components.a, {
        href: "#createstore",
        children: "Solid Store"
      }), "'s set method, ", jsx(_components.a, {
        href: "#createmutable",
        children: "Mutable Store"
      }), "'s array methods, and Effects automatically wrap their code in a batch."]
    }), "\n", jsxs(_components.h2, {
      id: "on",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#on",
        children: "#"
      }), jsx(_components.code, {
        children: "on"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { on } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " on<T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Array"
        }), "<", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), "> | (", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), "), U>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "deps"
        }), ": T,\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "input: T, prevInput: T, prevValue?: U"
          }), ") =>"]
        }), " U,\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "options"
        }), ": { defer?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), " } = {}\r\n): ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prevValue?: U"
          }), ") =>"]
        }), " U | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "on"
      }), " is designed to be passed into a computation to make its dependencies explicit. If an array of dependencies is passed, ", jsx(_components.code, {
        children: "input"
      }), " and ", jsx(_components.code, {
        children: "prevInput"
      }), " are arrays."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "on"
        }), "(a, ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(v, ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "b"
        }), "())));\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// is equivalent to:"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " v = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "a"
        }), "();\r\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "untrack"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(v, ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "b"
        }), "()));\r\n});\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "You can also not run the computation immediately and instead opt in for it to only run on change by setting the defer option to true."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// doesn't run immediately"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "on"
        }), "(a, ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(v), { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "defer"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), " }));\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setA"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"new\""
        }), "); ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// now it runs"
        }), "\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Please note that on ", jsx(_components.code, {
        children: "stores"
      }), " and ", jsx(_components.code, {
        children: "mutable"
      }), ", adding or removing a property from the parent object will trigger an effect. See ", jsx(_components.a, {
        href: "#createMutable",
        children: jsx(_components.code, {
          children: "createMutable"
        })
      })]
    }), "\n", jsxs(_components.h2, {
      id: "createroot",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createroot",
        children: "#"
      }), jsx(_components.code, {
        children: "createRoot"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createRoot } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createRoot<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["dispose: () => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "void"
            })]
          }), ") =>"]
        }), " T): T;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Creates a new non-tracked owner scope that doesn't auto-dispose. This is useful for nested reactive scopes that you do not wish to release when the parent re-evaluates."
    }), "\n", jsxs(_components.p, {
      children: ["All Solid code should be wrapped in one of these top level as they ensure that all memory/computations are freed up. Normally you do not need to worry about this as ", jsx(_components.code, {
        children: "createRoot"
      }), " is embedded into all ", jsx(_components.code, {
        children: "render"
      }), " entry functions."]
    }), "\n", jsxs(_components.h2, {
      id: "getowner",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#getowner",
        children: "#"
      }), jsx(_components.code, {
        children: "getOwner"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { getOwner } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "getOwner"
        }), "(", jsx(_components.span, {
          className: "hljs-params"
        }), "): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Owner"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Gets the reactive scope that owns the currently running code, e.g.,\r\nfor passing into a later call to ", jsx(_components.code, {
        children: "runWithOwner"
      }), " outside of the current scope."]
    }), "\n", jsxs(_components.p, {
      children: ["Internally, computations (effects, memos, etc.) create owners which are\r\nchildren of their owner, all the way up to the root owner created by\r\n", jsx(_components.code, {
        children: "createRoot"
      }), " or ", jsx(_components.code, {
        children: "render"
      }), ". In particular, this ownership tree lets Solid\r\nautomatically clean up a disposed computation by traversing its subtree\r\nand calling all ", jsx(_components.a, {
        href: "#oncleanup",
        children: jsx(_components.code, {
          children: "onCleanup"
        })
      }), " callbacks.\r\nFor example, when a ", jsx(_components.code, {
        children: "createEffect"
      }), "'s dependencies change, the effect calls\r\nall descendant ", jsx(_components.code, {
        children: "onCleanup"
      }), " callbacks before running the effect function again.\r\nCalling ", jsx(_components.code, {
        children: "getOwner"
      }), " returns the current owner node that is responsible\r\nfor disposal of the current execution block."]
    }), "\n", jsxs(_components.p, {
      children: ["Components are not computations, so do not create an owner node, but they are\r\ntypically rendered from a ", jsx(_components.code, {
        children: "createEffect"
      }), " which does, so the result is similar:\r\nwhen a component gets unmounted, all descendant ", jsx(_components.code, {
        children: "onCleanup"
      }), " callbacks get\r\ncalled. Calling ", jsx(_components.code, {
        children: "getOwner"
      }), " from a component scope returns the owner that is\r\nresponsible for rendering and unmounting that component."]
    }), "\n", jsxs(_components.p, {
      children: ["Note that the owning reactive scope isn't necessarily ", jsx(_components.em, {
        children: "tracking"
      }), ".\r\nFor example, ", jsx(_components.a, {
        href: "#untrack",
        children: jsx(_components.code, {
          children: "untrack"
        })
      }), " turns off tracking for the duration\r\nof a function (without creating a new reactive scope), as do\r\ncomponents created via JSX (", jsx(_components.code, {
        children: "<Component ...>"
      }), ")."]
    }), "\n", jsxs(_components.h2, {
      id: "runwithowner",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#runwithowner",
        children: "#"
      }), jsx(_components.code, {
        children: "runWithOwner"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { runWithOwner } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "'solid-js'"
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " runWithOwner<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "owner"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Owner"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["() => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "void"
            })]
          }), ") =>"]
        }), " T): T;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Executes the given function under the provided owner,\r\ninstead of (and without affecting) the owner of the outer scope.\r\nBy default, computations created by ", jsx(_components.code, {
        children: "createEffect"
      }), ", ", jsx(_components.code, {
        children: "createMemo"
      }), ", etc.\r\nare owned by the owner of the currently executing code (the return value of\r\n", jsx(_components.code, {
        children: "getOwner"
      }), "), so in particular will get disposed when their owner does.\r\nCalling ", jsx(_components.code, {
        children: "runWithOwner"
      }), " provides a way to override this default to a manually\r\nspecified owner (typically, the return value from a previous call to\r\n", jsx(_components.code, {
        children: "getOwner"
      }), "), enabling more precise control of when computations get disposed."]
    }), "\n", jsx(_components.p, {
      children: "Having a (correct) owner is important for two reasons:"
    }), "\n", jsxs(_components.ul, {
      children: ["\n", jsxs(_components.li, {
        children: ["Computations without an owner cannot be cleaned up. For example, if you call\r\n", jsx(_components.code, {
          children: "createEffect"
        }), " without an owner (e.g., in the global scope), the effect will\r\ncontinue running forever, instead of being disposed when its owner gets\r\ndisposed."]
      }), "\n", jsxs(_components.li, {
        children: [jsx(_components.a, {
          href: "#usecontext",
          children: jsx(_components.code, {
            children: "useContext"
          })
        }), " obtains context by walking up the owner tree\r\nto find the nearest ancestor providing the desired context.\r\nSo without an owner you cannot look up any provided context\r\n(and with the wrong owner, you might obtain the wrong context)."]
      }), "\n"]
    }), "\n", jsxs(_components.p, {
      children: ["Manually setting the owner is especially helpful when doing reactivity outside\r\nof any owner scope. In particular, asynchronous computation\r\n(via either ", jsx(_components.code, {
        children: "async"
      }), " functions or callbacks like ", jsx(_components.code, {
        children: "setTimeout"
      }), ")\r\nlose the automatically set owner, so remembering the original owner via\r\n", jsx(_components.code, {
        children: "getOwner"
      }), " and restoring it via ", jsx(_components.code, {
        children: "runWithOwner"
      }), " is necessary in these cases.\r\nFor example:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " owner = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "getOwner"
        }), "();\r\n", jsx(_components.span, {
          className: "hljs-built_in",
          children: "setTimeout"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// This callback gets run without owner."
        }), "\r\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Restore owner via runWithOwner:"
        }), "\r\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "runWithOwner"
        }), "(owner, ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " foo = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "useContext"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "FooContext"
        }), ");\r\n    ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\r\n      ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(foo);\r\n    });\r\n  });\r\n}, ", jsx(_components.span, {
          className: "hljs-number",
          children: "1000"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Note that owners are not what determines dependency tracking,\r\nso ", jsx(_components.code, {
        children: "runWithOwner"
      }), " does not help with tracking in asynchronous functions;\r\nuse of reactive state in the asynchronous part (e.g. after the first ", jsx(_components.code, {
        children: "await"
      }), ")\r\nwill not be tracked as a dependency."]
    }), "\n", jsxs(_components.h2, {
      id: "mergeprops",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#mergeprops",
        children: "#"
      }), jsx(_components.code, {
        children: "mergeProps"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { mergeProps } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mergeProps"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["...sources: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "any"
          })]
        }), "): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["A reactive object ", jsx(_components.code, {
        children: "merge"
      }), " method. Useful for setting default props for components in case caller doesn't provide them. Or cloning the props object including reactive properties."]
    }), "\n", jsx(_components.p, {
      children: "This method works by using a proxy and resolving properties in reverse order. This allows for dynamic tracking of properties that aren't present when the prop object is first merged."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// default props"
        }), "\r\nprops = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mergeProps"
        }), "({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "name"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Smith\""
        }), " }, props);\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// clone props"
        }), "\r\nnewProps = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mergeProps"
        }), "(props);\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// merge props"
        }), "\r\nprops = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mergeProps"
        }), "(props, otherProps);\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "splitprops",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#splitprops",
        children: "#"
      }), jsx(_components.code, {
        children: "splitProps"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { splitProps } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " splitProps<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": T,\r\n  ...", jsx(_components.span, {
          className: "hljs-attr",
          children: "keys"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Array"
        }), "<(keyof T)[]>\r\n): [...", jsx(_components.span, {
          className: "hljs-attr",
          children: "parts"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Partial"
        }), "<T>];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Splits a reactive object by keys."
    }), "\n", jsx(_components.p, {
      children: "It takes a reactive object and any number of arrays of keys; for each array of keys, it will return a reactive object with just those properties of the original object. The last reactive object in the returned array will have any leftover properties of the original object."
    }), "\n", jsx(_components.p, {
      children: "This can be useful if you want to consume a subset of props and pass the rest to a child."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "MyComponent"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "props"
        }), ") {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [local, others] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "splitProps"
        }), "(props, [", jsx(_components.span, {
          className: "hljs-string",
          children: "\"children\""
        }), "]);\r\n\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " (\r\n    ", jsxs(_components.span, {
          className: "xml",
          children: [jsx(_components.span, {
            className: "hljs-tag",
            children: "<>"
          }), "\r\n      ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "{local.children}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "\r\n      ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Child"
            }), " {", jsx(_components.span, {
              className: "hljs-attr",
              children: "...others"
            }), "} />"]
          }), "\r\n    ", jsx(_components.span, {
            className: "hljs-tag",
            children: "</>"
          })]
        }), "\r\n  );\r\n}\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Because ", jsx(_components.code, {
        children: "splitProps"
      }), " takes any number of arrays, we can split a props object\r\nas much as we wish (if, for example, we had multiple child components that\r\neach required a subset of the props)."]
    }), "\n", jsx(_components.p, {
      children: "Let's say a component was passed six props:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MyComponent"
        }), " a={", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), "} b={", jsx(_components.span, {
          className: "hljs-number",
          children: "2"
        }), "} c={", jsx(_components.span, {
          className: "hljs-number",
          children: "3"
        }), "} d={", jsx(_components.span, {
          className: "hljs-number",
          children: "4"
        }), "} e={", jsx(_components.span, {
          className: "hljs-number",
          children: "5"
        }), "} foo=", jsx(_components.span, {
          className: "hljs-string",
          children: "\"bar\""
        }), " />;\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "MyComponent"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "props"
        }), ") {\r\n  ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(props); ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {a: 1, b: 2, c: 3, d: 4, e: 5, foo: \"bar\"}"
        }), "\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [vowels, consonants, leftovers] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "splitProps"
        }), "(\r\n    props,\r\n    [", jsx(_components.span, {
          className: "hljs-string",
          children: "\"a\""
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"e\""
        }), "],\r\n    [", jsx(_components.span, {
          className: "hljs-string",
          children: "\"b\""
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"c\""
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"d\""
        }), "]\r\n  );\r\n  ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(vowels); ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {a: 1, e: 5}"
        }), "\r\n  ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(consonants); ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {b: 2, c: 3, d: 4}"
        }), "\r\n  ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(leftovers.", jsx(_components.span, {
          className: "hljs-property",
          children: "foo"
        }), "); ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// bar"
        }), "\r\n}\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "usetransition",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#usetransition",
        children: "#"
      }), jsx(_components.code, {
        children: "useTransition"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { useTransition } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "useTransition"
        }), "(", jsx(_components.span, {
          className: "hljs-params"
        }), "): [\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "pending"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ",\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "startTransition"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["fn: () => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "void"
            })]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ">\r\n];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Used to batch async updates in a transaction deferring commit until all async processes are complete. This is tied into Suspense and only tracks resources read under Suspense boundaries."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [isPending, start] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "useTransition"
        }), "();\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// check if transitioning"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "isPending"
        }), "();\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// wrap in transition"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "start"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setSignal"
        }), "(newValue), ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-comment",
          children: "/* transition is done */"
        }), ")\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "starttransition",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#starttransition",
        children: "#"
      }), jsx(_components.code, {
        children: "startTransition"
      })]
    }), "\n", jsx(_components.p, {
      children: jsx(_components.strong, {
        children: "New in v1.1.0"
      })
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { startTransition } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "'solid-js'"
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-attr",
          children: "startTransition"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["fn: () => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "void"
            })]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ">;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Similar to ", jsx(_components.code, {
        children: "useTransition"
      }), " except there is no associated pending state. This one can just be used directly to start the Transition."]
    }), "\n", jsxs(_components.h2, {
      id: "observable",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#observable",
        children: "#"
      }), jsx(_components.code, {
        children: "observable"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { observable } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " observable<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "input"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Observable"
        }), "<T>;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["This method takes a signal and produces an Observable.\r\nYou can consume it from another Observable library of your choice, typically\r\nwith the ", jsx(_components.code, {
        children: "from"
      }), " operator."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// How to integrate rxjs with a solid.js signal"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { observable } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"rxjs\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [s, set] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ");\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " obsv$ = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "from"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "observable"
        }), "(s));\r\n\r\nobsv$.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "subscribe"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(v));\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["You can also use ", jsx(_components.code, {
        children: "from"
      }), " without ", jsx(_components.code, {
        children: "rxjs"
      }), "; see below."]
    }), "\n", jsxs(_components.h2, {
      id: "from",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#from",
        children: "#"
      }), jsx(_components.code, {
        children: "from"
      })]
    }), "\n", jsx(_components.p, {
      children: jsx(_components.strong, {
        children: "New in v1.1.0"
      })
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), "<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "producer"
        }), ":\r\n    | (", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "setter: (v: T) => T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ")\r\n    | {\r\n        ", jsx(_components.span, {
          className: "hljs-attr",
          children: "subscribe"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["\r\n          fn: (v: T) => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "void"
            }), "\r\n        "]
          }), ") =>"]
        }), " (", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ") | { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "unsubscribe"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), " };\r\n      }\r\n): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["A helper to make it easier to interop with external producers like RxJS observables or with Svelte Stores. This basically turns any subscribable (object with a ", jsx(_components.code, {
        children: "subscribe"
      }), " method) into a Signal and manages subscription and disposal."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " signal = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "from"
        }), "(obsv$);\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "It can also take a custom producer function where the function is passed a setter function returns a unsubscribe function:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " clock = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "from"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "set"
          }), ") =>"]
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " t = ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "setInterval"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "set"
        }), "(", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), "), ", jsx(_components.span, {
          className: "hljs-number",
          children: "1000"
        }), ");\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "clearInterval"
        }), "(t);\r\n});\n"]
      })
    }), "\n", jsxs(_components.blockquote, {
      children: ["\n", jsxs(_components.p, {
        children: ["Note: Signals created by ", jsx(_components.code, {
          children: "from"
        }), " have equality checks turned off to interface better with external streams and sources."]
      }), "\n"]
    }), "\n", jsxs(_components.h2, {
      id: "maparray",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#maparray",
        children: "#"
      }), jsx(_components.code, {
        children: "mapArray"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { mapArray } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " mapArray<T, U>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "list"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "readonly"
        }), " T[],\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "mapFn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: T, i: () => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "number"
            })]
          }), ") =>"]
        }), " U\r\n): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " U[];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Reactive map helper that caches each item by reference to reduce unnecessary mapping on updates. It only runs the mapping function once per value and then moves or removes it as needed. The index argument is a signal. The map function itself is not tracking."
    }), "\n", jsxs(_components.p, {
      children: ["Underlying helper for the ", jsx(_components.code, {
        children: "<For>"
      }), " control flow."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " mapped = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mapArray"
        }), "(source, ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "model"
          }), ") =>"]
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [name, setName] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(model.", jsx(_components.span, {
          className: "hljs-property",
          children: "name"
        }), ");\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [description, setDescription] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(model.", jsx(_components.span, {
          className: "hljs-property",
          children: "description"
        }), ");\r\n\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " {\r\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": model.", jsx(_components.span, {
          className: "hljs-property",
          children: "id"
        }), ",\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "name"
        }), "() {\r\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "name"
        }), "();\r\n    },\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "description"
        }), "() {\r\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "description"
        }), "();\r\n    },\r\n    setName,\r\n    setDescription,\r\n  };\r\n});\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "indexarray",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#indexarray",
        children: "#"
      }), jsx(_components.code, {
        children: "indexArray"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { indexArray } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " indexArray<T, U>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "list"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "readonly"
        }), " T[],\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "mapFn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: () => T, i: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "number"
            })]
          }), ") =>"]
        }), " U\r\n): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " U[];\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Similar to ", jsx(_components.code, {
        children: "mapArray"
      }), " except it maps by index. The item is a signal and the index is now the constant."]
    }), "\n", jsxs(_components.p, {
      children: ["Underlying helper for the ", jsx(_components.code, {
        children: "<Index>"
      }), " control flow."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " mapped = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "indexArray"
        }), "(source, ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "model"
          }), ") =>"]
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " {\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "id"
        }), "() {\r\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "model"
        }), "().", jsx(_components.span, {
          className: "hljs-property",
          children: "id"
        }), "\r\n    }\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "firstInitial"
        }), "() {\r\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "model"
        }), "().", jsx(_components.span, {
          className: "hljs-property",
          children: "firstName"
        }), "[", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), "];\r\n    },\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fullName"
        }), "() {\r\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsxs(_components.span, {
          className: "hljs-string",
          children: ["`", jsx(_components.span, {
            className: "hljs-subst",
            children: "${model().firstName}"
          }), " ", jsx(_components.span, {
            className: "hljs-subst",
            children: "${model().lastName}"
          }), "`"]
        }), ";\r\n    },\r\n  }\r\n});\n"]
      })
    }), "\n", jsxs(_components.h1, {
      id: "stores",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#stores",
        children: "#"
      }), "Stores"]
    }), "\n", jsxs(_components.p, {
      children: ["These APIs are available at ", jsx(_components.code, {
        children: "solid-js/store"
      }), ". They allow the creation of stores: ", jsx(_components.a, {
        href: "https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Proxy",
        children: "proxy objects"
      }), " that allow a tree of signals to be independently tracked and modified."]
    }), "\n", jsxs(_components.h2, {
      id: "using-stores",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#using-stores",
        children: "#"
      }), "Using Stores"]
    }), "\n", jsxs(_components.h3, {
      id: "createstore",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createstore",
        children: "#"
      }), jsx(_components.code, {
        children: "createStore"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createStore } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js/store\""
        }), ";\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " { ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "StoreNode"
        }), ", ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), ", ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "SetStoreFunction"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js/store\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createStore<T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "StoreNode"
        }), ">(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "state"
        }), ": T | ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>\r\n): [", jsx(_components.span, {
          className: "hljs-attr",
          children: "get"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>, ", jsx(_components.span, {
          className: "hljs-attr",
          children: "set"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "SetStoreFunction"
        }), "<T>];\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T> = T;  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// conceptually readonly, but not typed as such"
        }), "\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "The create function takes an initial state, wraps it in a store, and returns a readonly proxy object and a setter function."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "(initialValue);\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// read value"
        }), "\r\nstate.", jsx(_components.span, {
          className: "hljs-property",
          children: "someValue"
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// set value"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "merge"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"thisValue\""
        }), " });\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"path\""
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"to\""
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"value\""
        }), ", newValue);\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "As proxies, store objects only track when a property is accessed."
    }), "\n", jsxs(_components.p, {
      children: ["When nested objects are accessed, stores will produce nested store objects, and this applies all the way down the tree. However, this only applies to arrays and plain objects. Classes are not wrapped, so objects like ", jsx(_components.code, {
        children: "Date"
      }), ", ", jsx(_components.code, {
        children: "HTMLElement"
      }), ", ", jsx(_components.code, {
        children: "RegExp"
      }), ", ", jsx(_components.code, {
        children: "Map"
      }), ", ", jsx(_components.code, {
        children: "Set"
      }), " won't be granularly reactive as properties on a store."]
    }), "\n", jsxs(_components.h4, {
      id: "arrays-in-stores",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#arrays-in-stores",
        children: "#"
      }), "Arrays in stores"]
    }), "\n", jsxs(_components.p, {
      children: ["As of version ", jsx(_components.strong, {
        children: "1.4.0"
      }), ", the top level state object can be an array. In prior versions, create an object to wrap the array:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "//After Solid 1.4.0"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [todos, setTodos] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "([\r\n  { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "title"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Thing I have to do\""
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "done"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " },\r\n  { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "2"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "title"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Learn a New Framework\""
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "done"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " },\r\n]);\r\n...\r\n<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), " each={todos}>{", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "todo"
          }), " =>"]
        }), " ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Todo"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "todo"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{todo}"
            }), " />"]
          })
        }), "}</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), ">;\n"]
      })
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "//Before 1.4.0"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "todos"
        }), ": [\r\n    { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "title"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Thing I have to do\""
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "done"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " },\r\n    { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "2"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "title"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Learn a New Framework\""
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "done"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " },\r\n  ],\r\n});\r\n<For each={state.todos}>{(todo) => <Todo todo={todo} />}<For>;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Note that modifying an array inside a store will not trigger computations that subscribe to the array directly. For example:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(state.", jsx(_components.span, {
          className: "hljs-property",
          children: "todos"
        }), ");\r\n});\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//This will not trigger the effect:"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(todos, state.", jsx(_components.span, {
          className: "hljs-property",
          children: "todos"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "length"
        }), ", { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "3"
        }), " });\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//This will trigger the effect, because the array reference changes:"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"todos\""
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev"
          }), ") =>"]
        }), " [...prev, { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "3"
        }), " }]);\n"]
      })
    }), "\n", jsxs(_components.h3, {
      id: "getters",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#getters",
        children: "#"
      }), "Getters"]
    }), "\n", jsx(_components.p, {
      children: "Store objects support the use of getters to store calculated values."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "user"
        }), ": {\r\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "firstName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"John\""
        }), ",\r\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "lastName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Smith\""
        }), ",\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fullName"
        }), "() {\r\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsxs(_components.span, {
          className: "hljs-string",
          children: ["`", jsxs(_components.span, {
            className: "hljs-subst",
            children: ["${", jsx(_components.span, {
              className: "hljs-variable language_",
              children: "this"
            }), ".firstName}"]
          }), " ", jsxs(_components.span, {
            className: "hljs-subst",
            children: ["${", jsx(_components.span, {
              className: "hljs-variable language_",
              children: "this"
            }), ".lastName}"]
          }), "`"]
        }), ";\r\n    },\r\n  },\r\n});\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "These are getters that rerun when accessed,\r\nso you still need to use a memo if you want to cache a value:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "let"
        }), " fullName;\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "user"
        }), ": {\r\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "firstName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"John\""
        }), ",\r\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "lastName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Smith\""
        }), ",\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fullName"
        }), "() {\r\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fullName"
        }), "();\r\n    },\r\n  },\r\n});\r\nfullName = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createMemo"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsxs(_components.span, {
          className: "hljs-string",
          children: ["`", jsx(_components.span, {
            className: "hljs-subst",
            children: "${state.user.firstName}"
          }), " ", jsx(_components.span, {
            className: "hljs-subst",
            children: "${state.user.lastName}"
          }), "`"]
        }), ");\n"]
      })
    }), "\n", jsxs(_components.h3, {
      id: "updating-stores",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#updating-stores",
        children: "#"
      }), "Updating Stores"]
    }), "\n", jsxs(_components.p, {
      children: ["Changes can take the form of function that passes previous state and returns new state or a value. Objects are always shallowly merged. Set values to ", jsx(_components.code, {
        children: "undefined"
      }), " to delete them from the Store."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "firstName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"John\""
        }), ",\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "lastName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Miller\""
        }), ",\r\n});\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "firstName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Johnny\""
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "middleName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Lee\""
        }), " });\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// ({ firstName: 'Johnny', middleName: 'Lee', lastName: 'Miller' })"
        }), "\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "state"
          }), ") =>"]
        }), " ({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "preferredName"
        }), ": state.", jsx(_components.span, {
          className: "hljs-property",
          children: "firstName"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "lastName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Milner\""
        }), " }));\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// ({ firstName: 'Johnny', preferredName: 'Johnny', middleName: 'Lee', lastName: 'Milner' })"
        }), "\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "It supports paths including key arrays, object ranges, and filter functions."
    }), "\n", jsx(_components.p, {
      children: "setState also supports nested setting where you can indicate the path to the change. When nested the state you are updating may be other non Object values. Objects are still merged but other values (including Arrays) are replaced."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "counter"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "2"
        }), ",\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "list"
        }), ": [\r\n    { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "23"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "title"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Birds'"
        }), " }\r\n    { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "27"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "title"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Fish'"
        }), " }\r\n  ]\r\n});\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'counter'"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "c"
          }), " =>"]
        }), " c + ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), ");\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'list'"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "l"
          }), " =>"]
        }), " [...l, {", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "43"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "title"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Marsupials'"
        }), "}]);\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'list'"
        }), ", ", jsx(_components.span, {
          className: "hljs-number",
          children: "2"
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "'read'"
        }), ", ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), ");\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   counter: 3,"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   list: ["
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { id: 23, title: 'Birds' }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { id: 27, title: 'Fish' }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { id: 43, title: 'Marsupials', read: true }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   ]"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// }"
        }), "\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Path can be string keys, array of keys, iterating objects ({from, to, by}), or filter functions. This gives incredible expressive power to describe state changes."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "todos"
        }), ": [\r\n    { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "task"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Finish work'"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "completed"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " }\r\n    { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "task"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Go grocery shopping'"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "completed"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " }\r\n    { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "task"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Make dinner'"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "completed"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " }\r\n  ]\r\n});\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'todos'"
        }), ", [", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ", ", jsx(_components.span, {
          className: "hljs-number",
          children: "2"
        }), "], ", jsx(_components.span, {
          className: "hljs-string",
          children: "'completed'"
        }), ", ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), ");\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   todos: ["
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Finish work', completed: true }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Go grocery shopping', completed: false }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Make dinner', completed: true }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   ]"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// }"
        }), "\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'todos'"
        }), ", { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "from"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "to"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), " }, ", jsx(_components.span, {
          className: "hljs-string",
          children: "'completed'"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "c"
          }), " =>"]
        }), " !c);\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   todos: ["
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Finish work', completed: false }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Go grocery shopping', completed: true }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Make dinner', completed: true }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   ]"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// }"
        }), "\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'todos'"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "todo"
          }), " =>"]
        }), " todo.", jsx(_components.span, {
          className: "hljs-property",
          children: "completed"
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "'task'"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "t"
          }), " =>"]
        }), " t + ", jsx(_components.span, {
          className: "hljs-string",
          children: "'!'"
        }), ")\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   todos: ["
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Finish work', completed: false }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Go grocery shopping!', completed: true }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Make dinner!', completed: true }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   ]"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// }"
        }), "\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'todos'"
        }), ", {}, ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "todo"
          }), " =>"]
        }), " ({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "marked"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "completed"
        }), ": !todo.", jsx(_components.span, {
          className: "hljs-property",
          children: "completed"
        }), " }))\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   todos: ["
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Finish work', completed: true, marked: true }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Go grocery shopping!', completed: false, marked: true }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Make dinner!', completed: false, marked: true }"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   ]"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// }"
        }), "\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "store-utilities",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#store-utilities",
        children: "#"
      }), "Store Utilities"]
    }), "\n", jsxs(_components.h3, {
      id: "produce",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#produce",
        children: "#"
      }), jsx(_components.code, {
        children: "produce"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { produce } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js/store\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " produce<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "state: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), "\r\n): ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["\r\n  state: T ", jsx(_components.span, {
              className: "hljs-keyword",
              children: "extends"
            }), " NotWrappable ? T : Store<T>\r\n"]
          }), ") =>"]
        }), " T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "NotWrappable"
        }), " ? T : ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Immer inspired API for Solid's Store objects that allows for localized mutation."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(\r\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "produce"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "s"
          }), ") =>"]
        }), " {\r\n    s.", jsx(_components.span, {
          className: "hljs-property",
          children: "user"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "name"
        }), " = ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Frank\""
        }), ";\r\n    s.", jsx(_components.span, {
          className: "hljs-property",
          children: "list"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "push"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Pencil Crayon\""
        }), ");\r\n  })\r\n);\n"]
      })
    }), "\n", jsxs(_components.h3, {
      id: "reconcile",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#reconcile",
        children: "#"
      }), jsx(_components.code, {
        children: "reconcile"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { reconcile } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js/store\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " reconcile<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "value"
        }), ": T | ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>,\r\n  options?: {\r\n    key?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "null"
        }), ";\r\n    merge?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ";\r\n  } = { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "key"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"id\""
        }), " }\r\n): ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["\r\n  state: T ", jsx(_components.span, {
              className: "hljs-keyword",
              children: "extends"
            }), " NotWrappable ? T : Store<T>\r\n"]
          }), ") =>"]
        }), " T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "NotWrappable"
        }), " ? T : ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Diffs data changes when we can't apply granular updates. Useful for when dealing with immutable data from stores or large API responses."
    }), "\n", jsxs(_components.p, {
      children: ["The key is used when available to match items. By default ", jsx(_components.code, {
        children: "merge"
      }), " false does referential checks where possible to determine equality and replaces where items are not referentially equal. ", jsx(_components.code, {
        children: "merge"
      }), " true pushes all diffing to the leaves and effectively morphs the previous data to the new value."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// subscribing to an observable"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " unsubscribe = store.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "subscribe"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "{ todos }"
          }), ") =>"]
        }), " (\r\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'todos'"
        }), ", ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "reconcile"
        }), "(todos)));\r\n);\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onCleanup"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "unsubscribe"
        }), "());\n"]
      })
    }), "\n", jsxs(_components.h3, {
      id: "unwrap",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#unwrap",
        children: "#"
      }), jsx(_components.code, {
        children: "unwrap"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { unwrap } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js/store\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "unwrap"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "store: Store<T>"
        }), "): T;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Returns the underlying data in the store without a proxy."
    }), "\n", jsxs(_components.h3, {
      id: "createmutable",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createmutable",
        children: "#"
      }), jsx(_components.code, {
        children: "createMutable"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createMutable } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "'solid-js/store'"
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createMutable<T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "StoreNode"
        }), ">(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "state"
        }), ": T | ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>,\r\n): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Creates a new mutable Store proxy object. Stores only trigger updates on values changing. Tracking is done by intercepting property access and automatically tracks deep nesting via proxy."
    }), "\n", jsx(_components.p, {
      children: "Useful for integrating external systems or as a compatibility layer with MobX/Vue."
    }), "\n", jsxs(_components.blockquote, {
      children: ["\n", jsxs(_components.p, {
        children: [jsx(_components.strong, {
          children: "Note:"
        }), " A mutable state can be passed around and mutated anywhere, which can make it harder to follow and easier to break unidirectional flow. It is generally recommended to use ", jsx(_components.code, {
          children: "createStore"
        }), " instead. The ", jsx(_components.code, {
          children: "produce"
        }), " modifier can give many of the same benefits without any of the downsides."]
      }), "\n"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " state = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createMutable"
        }), "(initialValue);\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// read value"
        }), "\r\nstate.", jsx(_components.span, {
          className: "hljs-property",
          children: "someValue"
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// set value"
        }), "\r\nstate.", jsx(_components.span, {
          className: "hljs-property",
          children: "someValue"
        }), " = ", jsx(_components.span, {
          className: "hljs-number",
          children: "5"
        }), ";\r\n\r\nstate.", jsx(_components.span, {
          className: "hljs-property",
          children: "list"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "push"
        }), "(anotherValue);\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Mutables support setters along with getters."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " user = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createMutable"
        }), "({\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "firstName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"John\""
        }), ",\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "lastName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Smith\""
        }), ",\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fullName"
        }), "() {\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsxs(_components.span, {
          className: "hljs-string",
          children: ["`", jsxs(_components.span, {
            className: "hljs-subst",
            children: ["${", jsx(_components.span, {
              className: "hljs-variable language_",
              children: "this"
            }), ".firstName}"]
          }), " ", jsxs(_components.span, {
            className: "hljs-subst",
            children: ["${", jsx(_components.span, {
              className: "hljs-variable language_",
              children: "this"
            }), ".lastName}"]
          }), "`"]
        }), ";\r\n  },\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "set"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fullName"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "value"
        }), ") {\r\n    [", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "this"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "firstName"
        }), ", ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "this"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "lastName"
        }), "] = value.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "split"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\" \""
        }), ");\r\n  },\r\n});\n"]
      })
    }), "\n", jsxs(_components.h3, {
      id: "modifymutable",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#modifymutable",
        children: "#"
      }), jsx(_components.code, {
        children: "modifyMutable"
      })]
    }), "\n", jsx(_components.p, {
      children: jsx(_components.strong, {
        children: "New in v1.4.0"
      })
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { modifyMutable } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "'solid-js/store'"
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " modifyMutable<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "mutable"
        }), ": T, ", jsx(_components.span, {
          className: "hljs-attr",
          children: "modifier"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "state: T"
          }), ") =>"]
        }), " T): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["This helper function simplifies making multiple changes to a mutable Store\r\n(as returned by ", jsx(_components.a, {
        href: "#createmutable",
        children: jsx(_components.code, {
          children: "createMutable"
        })
      }), ")\r\nin a single ", jsx(_components.a, {
        href: "#batch",
        children: jsx(_components.code, {
          children: "batch"
        })
      }), ",\r\nso that dependant computations update just once instead of once per update.\r\nThe first argument is the mutable Store to modify,\r\nand the second argument is a Store modifier such as those returned by\r\n", jsx(_components.a, {
        href: "#reconcile",
        children: jsx(_components.code, {
          children: "reconcile"
        })
      }), " or ", jsx(_components.a, {
        href: "#produce",
        children: jsx(_components.code, {
          children: "produce"
        })
      }), ".\r\n(If you pass in your own modifier function, beware that its argument is\r\nan unwrapped version of the Store.)"]
    }), "\n", jsx(_components.p, {
      children: "For example, suppose we have a UI depending on multiple fields of a mutable:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-tsx",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " state = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createMutable"
        }), "({\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "user"
        }), ": {\r\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "firstName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"John\""
        }), ",\r\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "lastName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Smith\""
        }), ",\r\n  },\r\n});\r\n\r\n", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "h1"
            }), ">"]
          }), "Hello {state.user.firstName + ' ' + state.user.lastName}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "h1"
            }), ">"]
          })]
        }), "\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Modifying ", jsx(_components.em, {
        children: "n"
      }), " fields in sequence will cause the UI to update ", jsx(_components.em, {
        children: "n"
      }), " times:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: ["state.", jsx(_components.span, {
          className: "hljs-property",
          children: "user"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "firstName"
        }), " = ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Jake\""
        }), ";  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// triggers update"
        }), "\r\nstate.", jsx(_components.span, {
          className: "hljs-property",
          children: "user"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "lastName"
        }), " = ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Johnson\""
        }), ";  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// triggers another update"
        }), "\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["To trigger just a single update, we could modify the fields in a ", jsx(_components.code, {
        children: "batch"
      }), ":"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "batch"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\r\n  state.", jsx(_components.span, {
          className: "hljs-property",
          children: "user"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "firstName"
        }), " = ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Jake\""
        }), ";\r\n  state.", jsx(_components.span, {
          className: "hljs-property",
          children: "user"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "lastName"
        }), " = ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Johnson\""
        }), ";\r\n});\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "modifyMutable"
      }), " combined with ", jsx(_components.code, {
        children: "reconcile"
      }), " or ", jsx(_components.code, {
        children: "produce"
      }), "\r\nprovides two alternate ways to do similar things:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// Replace state.user with the specified object (deleting any other fields)"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "modifyMutable"
        }), "(state.", jsx(_components.span, {
          className: "hljs-property",
          children: "user"
        }), ", ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "reconcile"
        }), "({\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "firstName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Jake\""
        }), ",\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "lastName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Johnson\""
        }), ",\r\n});\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Modify two fields in batch, triggering just one update"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "modifyMutable"
        }), "(state.", jsx(_components.span, {
          className: "hljs-property",
          children: "user"
        }), ", ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "produce"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "u"
          }), ") =>"]
        }), " {\r\n  u.", jsx(_components.span, {
          className: "hljs-property",
          children: "firstName"
        }), " = ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Jake\""
        }), ";\r\n  u.", jsx(_components.span, {
          className: "hljs-property",
          children: "lastName"
        }), " = ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Johnson\""
        }), ";\r\n});\n"]
      })
    }), "\n", jsxs(_components.h1, {
      id: "component-apis",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#component-apis",
        children: "#"
      }), "Component APIs"]
    }), "\n", jsxs(_components.h2, {
      id: "createcontext",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createcontext",
        children: "#"
      }), jsx(_components.code, {
        children: "createContext"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createContext } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " { ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Context"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Context"
        }), "<T> {\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "symbol"
        }), ";\r\n  ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Provider"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["props: { value: T; children: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "any"
            }), " }"]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ";\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "defaultValue"
        }), ": T;\r\n}\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createContext<T>(defaultValue?: T): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Context"
        }), "<T | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), ">;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Context provides a form of dependency injection in Solid. It is used to save from needing to pass data as props through intermediate components."
    }), "\n", jsxs(_components.p, {
      children: ["This function creates a new context object that can be used with ", jsx(_components.code, {
        children: "useContext"
      }), " and provides the ", jsx(_components.code, {
        children: "Provider"
      }), " control flow. Default Context is used when no ", jsx(_components.code, {
        children: "Provider"
      }), " is found above in the hierarchy."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "CounterContext"
        }), " = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createContext"
        }), "([{ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "count"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), " }, {}]);\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "CounterProvider"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "props"
        }), ") {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "count"
        }), ": props.", jsx(_components.span, {
          className: "hljs-property",
          children: "count"
        }), " || ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), " });\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " counter = [\r\n    state,\r\n    {\r\n      ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "increment"
        }), "(", jsx(_components.span, {
          className: "hljs-params"
        }), ") {\r\n        ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"count\""
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "c"
          }), ") =>"]
        }), " c + ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), ");\r\n      },\r\n      ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "decrement"
        }), "(", jsx(_components.span, {
          className: "hljs-params"
        }), ") {\r\n        ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"count\""
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "c"
          }), ") =>"]
        }), " c - ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), ");\r\n      },\r\n    },\r\n  ];\r\n\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " (\r\n    ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "CounterContext.Provider"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "value"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{counter}"
            }), ">"]
          }), "\r\n      {props.children}\r\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "CounterContext.Provider"
            }), ">"]
          })]
        }), "\r\n  );\r\n}\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["The value passed to provider is passed to ", jsx(_components.code, {
        children: "useContext"
      }), " as is. That means wrapping as a reactive expression will not work. You should pass in Signals and Stores directly instead of accessing them in the JSX."]
    }), "\n", jsxs(_components.h2, {
      id: "usecontext",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#usecontext",
        children: "#"
      }), jsx(_components.code, {
        children: "useContext"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { useContext } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " useContext<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "context"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Context"
        }), "<T>): T;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Used to grab context to allow for deep passing of props without having to pass them through each Component function."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, { increment, decrement }] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "useContext"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "CounterContext"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "children",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#children",
        children: "#"
      }), jsx(_components.code, {
        children: "children"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { children } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " { ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ", ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ResolvedChildren"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "children"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "fn: () => JSX.Element"
        }), "): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ResolvedChildren"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["The ", jsx(_components.code, {
        children: "children"
      }), " helper is for complicated interactions with ", jsx(_components.code, {
        children: "props.children"
      }), ",\r\nwhen you're not just passing children on to another component\r\nusing ", jsx(_components.code, {
        children: "{props.children}"
      }), " once in JSX.\r\nNormally you pass in a getter for ", jsx(_components.code, {
        children: "props.children"
      }), " like so:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " resolved = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "children"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " props.", jsx(_components.span, {
          className: "hljs-property",
          children: "children"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["The return value is a ", jsx(_components.a, {
        href: "#creatememo",
        children: "memo"
      }), " evaluating to the resolved children,\r\nwhich updates whenever the children change.\r\nUsing this memo instead of accessing ", jsx(_components.code, {
        children: "props.children"
      }), " directly\r\nhas some important advantages in some scenarios.\r\nThe underlying issue is that, when you specify component children via JSX,\r\nSolid automatically defines ", jsx(_components.code, {
        children: "props.children"
      }), " as a property getter,\r\nso that the children are created (in particular, DOM is created)\r\nwhenever ", jsx(_components.code, {
        children: "props.children"
      }), " gets accessed. Two particular consequences:"]
    }), "\n", jsxs(_components.ul, {
      children: ["\n", jsxs(_components.li, {
        children: ["If you access ", jsx(_components.code, {
          children: "props.children"
        }), " multiple times, the children\r\n(and associated DOM) get created multiple times.\r\nThis is useful if you want the DOM to be duplicated (as DOM nodes can appear\r\nin only one parent element), but in many cases it creates redundant DOM nodes.\r\nIf you instead call ", jsx(_components.code, {
          children: "resolved()"
        }), " multiple times, you re-use the same children."]
      }), "\n", jsxs(_components.li, {
        children: ["If you access ", jsx(_components.code, {
          children: "props.children"
        }), " outside of a tracking scope (e.g., in an\r\nevent handler), then you create children that will never be cleaned up.\r\nIf you instead call ", jsx(_components.code, {
          children: "resolved()"
        }), ", you re-use the already resolved children.\r\nYou also guarantee that the children are tracked in the current component,\r\nas opposed to another tracking scope such as another component."]
      }), "\n"]
    }), "\n", jsxs(_components.p, {
      children: ["In addition, the ", jsx(_components.code, {
        children: "children"
      }), " helper \"resolves\" children by\r\ncalling argumentless functions and flattening arrays of arrays into an array.\r\nFor example, a child specified with JSX like ", jsx(_components.code, {
        children: "{signal() * 2}"
      }), " gets wrapped into\r\na getter function ", jsx(_components.code, {
        children: "() => count() * 2"
      }), " in ", jsx(_components.code, {
        children: "props.children"
      }), ", but gets evaluated\r\nto an actual number in ", jsx(_components.code, {
        children: "resolved"
      }), ", properly depending on a ", jsx(_components.code, {
        children: "count"
      }), " signal."]
    }), "\n", jsxs(_components.p, {
      children: ["If the given ", jsx(_components.code, {
        children: "props.children"
      }), " is not an array\r\n(which occurs when the JSX tag has a single child),\r\nthen the ", jsx(_components.code, {
        children: "children"
      }), " helper will not normalize it into an array.\r\nThis is useful behavior e.g. when the intention is to pass a single function\r\nas a child, which can be detected via ", jsx(_components.code, {
        children: "typeof resolved() === 'function'"
      }), ".\r\nIf you want to normalize to an array, you can use\r\n", jsx(_components.code, {
        children: "Array.isArray(resolved()) ? resolved() : [resolved()]"
      }), "."]
    }), "\n", jsxs(_components.p, {
      children: ["Here is an example of automatically setting the ", jsx(_components.code, {
        children: "class"
      }), " attribute of any\r\nchild that resolves to an ", jsx(_components.code, {
        children: "Element"
      }), ", in addition to rendering the children:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-tsx",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " resolved = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "children"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " props.", jsx(_components.span, {
          className: "hljs-property",
          children: "children"
        }), ");\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "let"
        }), " list = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "resolved"
        }), "();\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "if"
        }), " (!", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Array"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "isArray"
        }), "(list)) list = [list];\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "for"
        }), " (", jsx(_components.span, {
          className: "hljs-keyword",
          children: "let"
        }), " child ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "of"
        }), " list) child?.", jsx(_components.span, {
          className: "hljs-property",
          children: "setAttribute"
        }), "?.(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"class\""
        }), ", ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "myClass"
        }), "());\r\n});\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "{resolved()}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "(Note that this approach is not particularly recommended:\r\nit is usually better to follow a declarative approach of passing\r\nin the desired class via props or context to the children components.)"
    }), "\n", jsxs(_components.p, {
      children: ["On the other hand, you don't need (and in some cases, don't want)\r\nto use the ", jsx(_components.code, {
        children: "children"
      }), " helper if you're just passing ", jsx(_components.code, {
        children: "props.children"
      }), "\r\non to another component or element via JSX:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-tsx",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "Wrapper"
        }), " = (", jsx(_components.span, {
          className: "hljs-params",
          children: "props"
        }), ") => {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "{props.children}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), ";\r\n};\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["An important aspect of the ", jsx(_components.code, {
        children: "children"
      }), " helper is that it forces the children\r\nto be created and resolved, as it accesses ", jsx(_components.code, {
        children: "props.children"
      }), " immediately.\r\nThis can be undesirable for conditional rendering,\r\ne.g., when using the children within a ", jsx(_components.a, {
        href: "#%3Cshow%3E",
        children: jsx(_components.code, {
          children: "<Show>"
        })
      }), " component.\r\nFor example, the following code always evaluates the children:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-tsx",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " resolved = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "children"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " props.", jsx(_components.span, {
          className: "hljs-property",
          children: "children"
        }), ");\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Show"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "when"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{visible()}"
            }), ">"]
          }), "{resolved()}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "Show"
            }), ">"]
          })]
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["To evaluate the children only when ", jsx(_components.code, {
        children: "<Show>"
      }), " would render them, you can\r\npush the call to ", jsx(_components.code, {
        children: "children"
      }), " inside a component or a function within ", jsx(_components.code, {
        children: "<Show>"
      }), ",\r\nwhich only evaluates its children when the ", jsx(_components.code, {
        children: "when"
      }), " condition is true.\r\nAnother nice workaround is to pass ", jsx(_components.code, {
        children: "props.children"
      }), " to the ", jsx(_components.code, {
        children: "children"
      }), " helper\r\nonly when you actually want to evaluate the children:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " resolved = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "children"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "visible"
        }), "() && props.", jsx(_components.span, {
          className: "hljs-property",
          children: "children"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "lazy",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#lazy",
        children: "#"
      }), jsx(_components.code, {
        children: "lazy"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { lazy } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " lazy<T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Component"
        }), "<", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ">>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<{ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "default"
        }), ": T }>\r\n): T & { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "preload"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<T> };\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Used to lazy load components to allow for code splitting. Components are not loaded until rendered. Lazy loaded components can be used the same as its statically imported counterpart, receiving props etc... Lazy components trigger ", jsx(_components.code, {
        children: "<Suspense>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// wrap import"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ComponentA"
        }), " = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "lazy"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "import"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"./ComponentA\""
        }), "));\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// use in JSX"
        }), "\r\n", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "ComponentA"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "title"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{props.title}"
            }), " />"]
          })
        }), ";\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "createuniqueid",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createuniqueid",
        children: "#"
      }), jsx(_components.code, {
        children: "createUniqueId"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createUniqueId } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createUniqueId"
        }), "(", jsx(_components.span, {
          className: "hljs-params"
        }), "): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "A universal id generator that is stable across server/browser."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " id = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createUniqueId"
        }), "();\n"]
      })
    }), "\n", jsxs(_components.blockquote, {
      children: ["\n", jsxs(_components.p, {
        children: [jsx(_components.strong, {
          children: "Note"
        }), " on the server this only works under hydratable components"]
      }), "\n"]
    }), "\n", jsxs(_components.h1, {
      id: "secondary-primitives",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#secondary-primitives",
        children: "#"
      }), "Secondary Primitives"]
    }), "\n", jsx(_components.p, {
      children: "You probably won't need them for your first app, but these are useful tools to have."
    }), "\n", jsxs(_components.h2, {
      id: "createdeferred",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createdeferred",
        children: "#"
      }), jsx(_components.code, {
        children: "createDeferred"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createDeferred } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createDeferred<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "source"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T,\r\n  options?: {\r\n    timeoutMs?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "number"
        }), ";\r\n    equals?: ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " | (", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev: T, next: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ");\r\n  }\r\n): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Creates a readonly that only notifies downstream changes when the browser is idle. ", jsx(_components.code, {
        children: "timeoutMs"
      }), " is the maximum time to wait before forcing the update."]
    }), "\n", jsxs(_components.h2, {
      id: "createrendereffect",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createrendereffect",
        children: "#"
      }), jsx(_components.code, {
        children: "createRenderEffect"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createRenderEffect } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createRenderEffect<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v: T"
          }), ") =>"]
        }), " T, value?: T): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["A render effect is a computation similar to a regular effect\r\n(as created by ", jsx(_components.a, {
        href: "#createeffect",
        children: jsx(_components.code, {
          children: "createEffect"
        })
      }), "),\r\nbut differs in when Solid schedules the first execution of the effect function.\r\nWhile ", jsx(_components.code, {
        children: "createEffect"
      }), " waits for the current rendering phase to be complete,\r\n", jsx(_components.code, {
        children: "createRenderEffect"
      }), " immediately calls the function.\r\nThus the effect runs as DOM elements are being created and updated,\r\nbut possibly before specific elements of interest have been created,\r\nand probably before those elements have been connected to the document.\r\nIn particular, ", jsx(_components.a, {
        href: "#ref",
        children: jsx(_components.code, {
          children: "ref"
        })
      }), "s will not be set before the initial effect call.\r\nIndeed, Solid uses ", jsx(_components.code, {
        children: "createRenderEffect"
      }), " to implement the rendering phase\r\nitself, including setting of ", jsx(_components.code, {
        children: "ref"
      }), "s."]
    }), "\n", jsxs(_components.p, {
      children: ["Reactive updates to render effects are identical to effects: they queue up in\r\nresponse to a reactive change (e.g., a single signal update, or a ", jsx(_components.code, {
        children: "batch"
      }), " of\r\nchanges, or collective changes during an entire render phase) and run in a\r\nsingle ", jsx(_components.a, {
        href: "#batch",
        children: jsx(_components.code, {
          children: "batch"
        })
      }), " afterward (together with effects).\r\nIn particular, all signal updates within a render effect are batched."]
    }), "\n", jsxs(_components.p, {
      children: ["Here is an example of the behavior.\r\n(Compare with the example in ", jsx(_components.a, {
        href: "#createeffect",
        children: jsx(_components.code, {
          children: "createEffect"
        })
      }), ".)"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// assume this code is in a component function, so is part of a rendering phase"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [count, setCount] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ");\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// this effect prints count at the beginning and when it changes"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createRenderEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"count =\""
        }), ", ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "count"
        }), "()));\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// render effect runs immediately, printing `count = 0`"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"hello\""
        }), ");\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setCount"
        }), "(", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), "); ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// effect won't run yet"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setCount"
        }), "(", jsx(_components.span, {
          className: "hljs-number",
          children: "2"
        }), "); ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// effect won't run yet"
        }), "\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "queueMicrotask"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// now `count = 2` will print"
        }), "\r\n  ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"microtask\""
        }), ");\r\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setCount"
        }), "(", jsx(_components.span, {
          className: "hljs-number",
          children: "3"
        }), "); ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// immediately prints `count = 3`"
        }), "\r\n  ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"goodbye\""
        }), ");\r\n});\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// --- overall output: ---"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// count = 0   [this is the only added line compared to createEffect]"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// hello"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// count = 2"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// microtask"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// count = 3"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// goodbye"
        }), "\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Just like ", jsx(_components.code, {
        children: "createEffect"
      }), ", the effect function gets called with an argument\r\nequal to the value returned from the effect function's last execution,\r\nor on the first call, equal to the optional second argument to\r\n", jsx(_components.code, {
        children: "createRenderEffect"
      }), "."]
    }), "\n", jsxs(_components.h2, {
      id: "createcomputed",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createcomputed",
        children: "#"
      }), jsx(_components.code, {
        children: "createComputed"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createComputed } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createComputed<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v: T"
          }), ") =>"]
        }), " T, value?: T): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "createComputed"
      }), " creates a new computation that immediately runs the given\r\nfunction in a tracking scope, thus automatically tracking its dependencies,\r\nand automatically reruns the function whenever the dependencies changes.\r\nThe function gets called with an argument equal to the value returned\r\nfrom the function's last execution, or on the first call,\r\nequal to the optional second argument to ", jsx(_components.code, {
        children: "createComputed"
      }), ".\r\nNote that the return value of the function is not otherwise exposed;\r\nin particular, ", jsx(_components.code, {
        children: "createComputed"
      }), " has no return value."]
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "createComputed"
      }), " is the most immediate form of reactivity in Solid, and is\r\nmost useful for building other reactive primitives.\r\n(For example, some other Solid primitives are built from ", jsx(_components.code, {
        children: "createComputed"
      }), ".)\r\nBut it should be used with care, as ", jsx(_components.code, {
        children: "createComputed"
      }), " can easily cause more\r\nunnecessary updates than other reactive primitives.\r\nBefore using it, consider the closely related primitives\r\n", jsx(_components.a, {
        href: "#creatememo",
        children: jsx(_components.code, {
          children: "createMemo"
        })
      }), " and ", jsx(_components.a, {
        href: "#createrendereffect",
        children: jsx(_components.code, {
          children: "createRenderEffect"
        })
      }), "."]
    }), "\n", jsxs(_components.p, {
      children: ["Like ", jsx(_components.code, {
        children: "createMemo"
      }), ", ", jsx(_components.code, {
        children: "createComputed"
      }), " calls its function immediately on updates\r\n(unless you're in a ", jsx(_components.a, {
        href: "#batch",
        children: "batch"
      }), ", ", jsx(_components.a, {
        href: "#createEffect",
        children: "effect"
      }), ", or\r\n", jsx(_components.a, {
        href: "#use-transition",
        children: "transition"
      }), ").\r\nHowever, while ", jsx(_components.code, {
        children: "createMemo"
      }), " functions should be pure (not set any signals),\r\n", jsx(_components.code, {
        children: "createComputed"
      }), " functions can set signals.\r\nRelated, ", jsx(_components.code, {
        children: "createMemo"
      }), " offers a readonly signal for the return value of the\r\nfunction, whereas to do the same with ", jsx(_components.code, {
        children: "createComputed"
      }), " you would need to\r\nset a signal within the function.\r\nIf it is possible to use pure functions and ", jsx(_components.code, {
        children: "createMemo"
      }), ", this is likely\r\nmore efficient, as Solid optimizes the execution order of memo updates,\r\nwhereas updating a signal within ", jsx(_components.code, {
        children: "createComputed"
      }), " will immediately trigger\r\nreactive updates some of which may turn out to be unnecessary\r\n(unless you take care by wrapping in\r\n", jsx(_components.a, {
        href: "#batch",
        children: jsx(_components.code, {
          children: "batch"
        })
      }), ", ", jsx(_components.a, {
        href: "#untrack",
        children: jsx(_components.code, {
          children: "untrack"
        })
      }), ", etc.)."]
    }), "\n", jsxs(_components.p, {
      children: ["Like ", jsx(_components.code, {
        children: "createRenderEffect"
      }), ", ", jsx(_components.code, {
        children: "createComputed"
      }), " calls its function for the first\r\ntime immediately. But they differ in how updates are performed.\r\nWhile ", jsx(_components.code, {
        children: "createComputed"
      }), " generally updates immediately, ", jsx(_components.code, {
        children: "createRenderEffect"
      }), "\r\nupdates queue to run in a single ", jsx(_components.code, {
        children: "batch"
      }), " (along with ", jsx(_components.code, {
        children: "createEffect"
      }), "s)\r\nafter the current render phase.\r\nThus ", jsx(_components.code, {
        children: "createRenderEffect"
      }), " can perform fewer overall updates,\r\nbut is slightly less immediate."]
    }), "\n", jsxs(_components.h2, {
      id: "createreaction",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createreaction",
        children: "#"
      }), jsx(_components.code, {
        children: "createReaction"
      })]
    }), "\n", jsx(_components.p, {
      children: jsx(_components.strong, {
        children: "New in v1.3.0"
      })
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createReaction } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createReaction"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["onInvalidate: () => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "void"
          })]
        }), "): ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["fn: () => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "void"
            })]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Sometimes it is useful to separate tracking from re-execution. This primitive registers a side effect that is run the first time the expression wrapped by the returned tracking function is notified of a change."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [s, set] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"start\""
        }), ");\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " track = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createReaction"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"something\""
        }), "));\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// next time s changes run the reaction"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "track"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "s"
        }), "());\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "set"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"end\""
        }), "); ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// \"something\""
        }), "\r\n\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "set"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"final\""
        }), "); ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// no-op as reaction only runs on first update, need to call track again."
        }), "\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "createselector",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createselector",
        children: "#"
      }), jsx(_components.code, {
        children: "createSelector"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createSelector } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createSelector<T, U>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "source"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T,\r\n  fn?: ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "a: U, b: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), "\r\n): ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "k: U"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Creates a conditional signal that only notifies subscribers when entering or exiting their key matching the value. Useful for delegated selection state. As it makes the operation O(2) instead of O(n)."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " isSelected = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSelector"
        }), "(selectedId);\r\n\r\n", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "For"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "each"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{list()}"
            }), ">"]
          }), "\r\n  {(item) => ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "li"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "classList"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{{"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "active:"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "isSelected"
            }), "(", jsx(_components.span, {
              className: "hljs-attr",
              children: "item.id"
            }), ") }}>"]
          }), "{item.name}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "li"
            }), ">"]
          }), "}\r\n", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "For"
            }), ">"]
          })]
        }), ";\n"]
      })
    }), "\n", jsxs(_components.h1, {
      id: "rendering",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#rendering",
        children: "#"
      }), "Rendering"]
    }), "\n", jsxs(_components.p, {
      children: ["These imports are exposed from ", jsx(_components.code, {
        children: "solid-js/web"
      }), "."]
    }), "\n", jsxs(_components.h2, {
      id: "render",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#render",
        children: "#"
      }), jsx(_components.code, {
        children: "render"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { render } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js/web\""
        }), ";\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " { ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ", ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MountableElement"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js/web\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "render"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "code: () => JSX.Element, element: MountableElement"
        }), "): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["This is the browser app entry point.\r\nProvide a top-level component function and an element to mount to.\r\nIt is recommended this element be empty:\r\nwhile ", jsx(_components.code, {
        children: "render"
      }), " will just append children,\r\nthe returned ", jsx(_components.code, {
        children: "dispose"
      }), " function will remove all children."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " dispose = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "render"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ", ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "document"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "getElementById"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"app\""
        }), "));\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// or"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " dispose = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "render"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "App"
            }), " />"]
          })
        }), ", ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "document"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "getElementById"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"app\""
        }), "));\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["It's important that the first argument is a function: do not pass JSX directly\r\n(as in ", jsx(_components.code, {
        children: "render(<App/>, ...)"
      }), "), because this will call ", jsx(_components.code, {
        children: "App"
      }), " before ", jsx(_components.code, {
        children: "render"
      }), " can\r\nset up a root to track signal dependencies within ", jsx(_components.code, {
        children: "App"
      }), "."]
    }), "\n", jsxs(_components.h2, {
      id: "hydrate",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#hydrate",
        children: "#"
      }), jsx(_components.code, {
        children: "hydrate"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { hydrate } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js/web\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "hydrate"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "fn: () => JSX.Element, node: MountableElement"
        }), "): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["This method is similar to ", jsx(_components.code, {
        children: "render"
      }), " except it attempts to rehydrate what is already rendered to the DOM. When initializing in the browser a page has already been server rendered."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " dispose = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "hydrate"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ", ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "document"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "getElementById"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"app\""
        }), "));\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "rendertostring",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#rendertostring",
        children: "#"
      }), jsx(_components.code, {
        children: "renderToString"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { renderToString } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js/web\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " renderToString<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T,\r\n  options?: {\r\n    nonce?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\r\n    renderId?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\r\n  }\r\n): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Renders to a string synchronously. The function also generates a script tag for progressive hydration. Options include eventNames to listen to before the page loads and play back on hydration, and nonce to put on the script tag."
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "renderId"
      }), " is used to namespace renders when having multiple top level roots."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " html = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "renderToString"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "rendertostringasync",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#rendertostringasync",
        children: "#"
      }), jsx(_components.code, {
        children: "renderToStringAsync"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { renderToStringAsync } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js/web\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " renderToStringAsync<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T,\r\n  options?: {\r\n    timeoutMs?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "number"
        }), ";\r\n    renderId?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\r\n    nonce?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\r\n  }\r\n): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ">;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Same as ", jsx(_components.code, {
        children: "renderToString"
      }), " except it will wait for all ", jsx(_components.code, {
        children: "<Suspense>"
      }), " boundaries to resolve before returning the results. Resource data is automatically serialized into the script tag and will be hydrated on client load."]
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "renderId"
      }), " is used to namespace renders when having multiple top level roots."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " html = ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "await"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "renderToStringAsync"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "rendertostream",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#rendertostream",
        children: "#"
      }), jsx(_components.code, {
        children: "renderToStream"
      })]
    }), "\n", jsx(_components.p, {
      children: jsx(_components.strong, {
        children: "New in v1.3.0"
      })
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { renderToStream } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js/web\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " renderToStream<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T,\r\n  options?: {\r\n    nonce?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\r\n    renderId?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\r\n    onCompleteShell?: ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\r\n    onCompleteAll?: ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\r\n  }\r\n): {\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "pipe"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["writable: { write: (v: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "string"
            }), ") => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "void"
            }), " }"]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "pipeTo"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "writable: WritableStream"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\r\n};\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "This method renders to a stream. It renders the content synchronously including any Suspense fallback placeholders, and then continues to stream the data and HTML from any async resource as it completes."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// node"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "renderToStream"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ").", jsx(_components.span, {
          className: "hljs-title function_",
          children: "pipe"
        }), "(res);\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// web stream"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " { readable, writable } = ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "new"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "TransformStream"
        }), "();\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "renderToStream"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ").", jsx(_components.span, {
          className: "hljs-title function_",
          children: "pipeTo"
        }), "(writable);\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "onCompleteShell"
      }), " fires when synchronous rendering is complete before writing the first flush to the stream out to the browser. ", jsx(_components.code, {
        children: "onCompleteAll"
      }), " is called when all server Suspense boundaries have settled. ", jsx(_components.code, {
        children: "renderId"
      }), " is used to namespace renders when having multiple top level roots."]
    }), "\n", jsxs(_components.blockquote, {
      children: ["\n", jsxs(_components.p, {
        children: ["Note this API replaces the previous ", jsx(_components.code, {
          children: "pipeToWritable"
        }), " and ", jsx(_components.code, {
          children: "pipeToNodeWritable"
        }), " APIs."]
      }), "\n"]
    }), "\n", jsxs(_components.h2, {
      id: "isserver",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#isserver",
        children: "#"
      }), jsx(_components.code, {
        children: "isServer"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { isServer } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js/web\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " ", jsx(_components.span, {
          className: "hljs-attr",
          children: "isServer"
        }), ": ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "This indicates that the code is being run as the server or browser bundle. As the underlying runtimes export this as a constant boolean it allows bundlers to eliminate the code and their used imports from the respective bundles."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "if"
        }), " (isServer) {\r\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// I will never make it to the browser bundle"
        }), "\r\n} ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "else"
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// won't be run on the server;"
        }), "\r\n}\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "dev",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#dev",
        children: "#"
      }), jsx(_components.code, {
        children: "DEV"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "DEV"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " ", jsx(_components.span, {
          className: "hljs-attr",
          children: "DEV"
        }), ": ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "object"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["On the client, Solid provides\r\n(via ", jsx(_components.a, {
        href: "https://nodejs.org/api/packages.html#conditional-exports",
        children: "conditional exports"
      }), ")\r\ndifferent builds depending on whether the ", jsx(_components.code, {
        children: "development"
      }), " condition is set.\r\nDevelopment mode provides some additional checking — e.g. detecting accidental\r\nuse of multiple instances of Solid — which are removed in production builds."]
    }), "\n", jsxs(_components.p, {
      children: ["If you want code to run only in development mode (most useful in libraries),\r\nyou can check whether the ", jsx(_components.code, {
        children: "DEV"
      }), " export is defined. Note that it is always\r\ndefined on the server, so you may want to combine with ", jsx(_components.a, {
        href: "#isserver",
        children: jsx(_components.code, {
          children: "isServer"
        })
      }), ":"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "DEV"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { isServer } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js/web\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "if"
        }), " (", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "DEV"
        }), " && !isServer) {\r\n  ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(...);\r\n}\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "hydrationscript",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#hydrationscript",
        children: "#"
      }), jsx(_components.code, {
        children: "HydrationScript"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { generateHydrationScript, ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "HydrationScript"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js/web\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "generateHydrationScript"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["options: {\r\n  nonce?: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "string"
          }), ";\r\n  eventNames?: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "string"
          }), "[];\r\n}"]
        }), "): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "HydrationScript"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["props: {\r\n  nonce?: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "string"
          }), ";\r\n  eventNames?: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "string"
          }), "[];\r\n}"]
        }), "): ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Hydration Script is a special script that should be placed once on the page to bootstrap hydration before Solid's runtime has loaded. It comes both as a function that can be called and inserted in an your HTML string, or as a Component if you are rendering JSX from the ", jsx(_components.code, {
        children: "<html>"
      }), " tag."]
    }), "\n", jsxs(_components.p, {
      children: ["The options are for the ", jsx(_components.code, {
        children: "nonce"
      }), " to be put on the script tag and any event names for that Solid should capture before scripts have loaded and replay during hydration. These events are limited to those that Solid delegates which include most UI Events that are composed and bubble. By default it is only ", jsx(_components.code, {
        children: "click"
      }), " and ", jsx(_components.code, {
        children: "input"
      }), " events."]
    }), "\n", jsxs(_components.h1, {
      id: "control-flow",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#control-flow",
        children: "#"
      }), "Control Flow"]
    }), "\n", jsxs(_components.p, {
      children: ["For reactive control flow to be performant, we have to control how elements are created. For example, calling ", jsx(_components.code, {
        children: "array.map"
      }), " is inefficient as it always maps the entire array."]
    }), "\n", jsx(_components.p, {
      children: "This means helper functions. Wrapping these in components is convenient way for terse templating and allows users to compose and build their own control flow components."
    }), "\n", jsxs(_components.p, {
      children: ["These built-in control flow components will be automatically imported. All except ", jsx(_components.code, {
        children: "Portal"
      }), " and ", jsx(_components.code, {
        children: "Dynamic"
      }), " are exported from both ", jsx(_components.code, {
        children: "solid-js"
      }), " and ", jsx(_components.code, {
        children: "solid-js/web"
      }), ". ", jsx(_components.code, {
        children: "Portal"
      }), " and ", jsx(_components.code, {
        children: "Dynamic"
      }), ", which are DOM-specific, are exported by ", jsx(_components.code, {
        children: "solid-js/web"
      }), "."]
    }), "\n", jsxs(_components.blockquote, {
      children: ["\n", jsx(_components.p, {
        children: "Note: All callback/render function children of control flow are non-tracking. This allows for nesting state creation, and better isolates reactions."
      }), "\n"]
    }), "\n", jsxs(_components.h2, {
      id: "for",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#for",
        children: "#"
      }), jsx(_components.code, {
        children: "<For>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), "<T, U ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ">(", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": {\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "each"
        }), ": ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "readonly"
        }), " T[];\r\n  fallback?: ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "children"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["item: T, index: () => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "number"
            })]
          }), ") =>"]
        }), " U;\r\n}): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " U[];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "A referentially keyed loop with efficient updating of only changed items.\r\nThe callback takes the current item as the first argument:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), " each={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "list"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\r\n  {", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "item"
          }), ") =>"]
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "{item}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), ">\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "The optional second argument is an index signal:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), " each={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "list"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\r\n  {", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "item, index"
          }), ") =>"]
        }), " (\r\n    ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "\r\n      #{index()} {item}\r\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "\r\n  )}\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "show",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#show",
        children: "#"
      }), jsx(_components.code, {
        children: "<Show>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), "<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": {\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "when"
        }), ": T | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "null"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), ";\r\n  fallback?: ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "children"
        }), ": ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), " | (", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "item: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ");\r\n}): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["The Show control flow is used to conditional render part of the view: it renders ", jsx(_components.code, {
        children: "children"
      }), " when the ", jsx(_components.code, {
        children: "when"
      }), " is truthy, an ", jsx(_components.code, {
        children: "fallback"
      }), " otherwise. It is similar to the ternary operator (", jsx(_components.code, {
        children: "when ? children : fallback"
      }), ") but is ideal for templating JSX."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), " when={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "count"
        }), " > ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\r\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "My Content", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), ">\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Show can also be used as a way of keying blocks to a specific data model. Ex the function is re-executed whenever the user model is replaced."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), " when={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "user"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\r\n  {", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "user"
          }), ") =>"]
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "{user.firstName}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "switchmatch",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#switchmatch",
        children: "#"
      }), jsx(_components.code, {
        children: "<Switch>"
      }), "/", jsx(_components.code, {
        children: "<Match>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Switch"
        }), ", ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Match"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " { ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MatchProps"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "Switch"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "props: {\r\n  fallback?: JSX.Element;\r\n  children: JSX.Element;\r\n}"
        }), "): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MatchProps"
        }), "<T> = {\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "when"
        }), ": T | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "null"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), ";\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "children"
        }), ": ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), " | (", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "item: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ");\r\n};\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Match"
        }), "<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MatchProps"
        }), "<T>);\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Useful for when there are more than 2 mutual exclusive conditions.\r\nFor example, it can be used to perform basic routing:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Switch"
        }), " fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Not Found", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\r\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Match"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "when"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{state.route"
            }), " === ", jsx(_components.span, {
              className: "hljs-string",
              children: "\"home\""
            }), "}>"]
          }), "\r\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Home"
            }), " />"]
          }), "\r\n  ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "Match"
            }), ">"]
          })]
        }), "\r\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Match"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "when"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{state.route"
            }), " === ", jsx(_components.span, {
              className: "hljs-string",
              children: "\"settings\""
            }), "}>"]
          }), "\r\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Settings"
            }), " />"]
          }), "\r\n  ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "Match"
            }), ">"]
          })]
        }), "\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Switch"
        }), ">\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Match also supports function children to serve as keyed flow."
    }), "\n", jsxs(_components.h2, {
      id: "index",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#index",
        children: "#"
      }), jsx(_components.code, {
        children: "<Index>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), "<T, U ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ">(", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": {\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "each"
        }), ": ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "readonly"
        }), " T[];\r\n  fallback?: ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "children"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["item: () => T, index: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "number"
            })]
          }), ") =>"]
        }), " U;\r\n}): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " U[];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Non-keyed list iteration (rendered nodes are keyed to an array index). This is useful when there is no conceptual key, like if the data consists of primitives and it is the index that is fixed rather than the value."
    }), "\n", jsx(_components.p, {
      children: "The item is a signal:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), " each={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "list"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\r\n  {", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "item"
          }), ") =>"]
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "{item()}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), ">\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Optional second argument is an index number:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), " each={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "list"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\r\n  {", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "item, index"
          }), ") =>"]
        }), " (\r\n    ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "\r\n      #{index} {item()}\r\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "\r\n  )}\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "errorboundary",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#errorboundary",
        children: "#"
      }), jsx(_components.code, {
        children: "<ErrorBoundary>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ErrorBoundary"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "ErrorBoundary"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["props: {\r\n  fallback: JSX.Element | ((err: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "any"
          }), ", reset: () => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "void"
          }), ") => JSX.Element);\r\n  children: JSX.Element;\r\n}"]
        }), "): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Catches uncaught errors and renders fallback content."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ErrorBoundary"
        }), " fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Something went terribly wrong", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\r\n  ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "MyComp"
            }), " />"]
          })
        }), "\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ErrorBoundary"
        }), ">\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Also supports callback form which passes in error and a reset function."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ErrorBoundary"
        }), "\r\n  fallback={", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "err, reset"
          }), ") =>"]
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "onClick"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{reset}"
            }), ">"]
          }), "Error: {err.toString()}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}\r\n>\r\n  ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "MyComp"
            }), " />"]
          })
        }), "\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ErrorBoundary"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "suspense",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#suspense",
        children: "#"
      }), jsx(_components.code, {
        children: "<Suspense>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Suspense"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "Suspense"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "props: {\r\n  fallback?: JSX.Element;\r\n  children: JSX.Element;\r\n}"
        }), "): ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["A component that tracks all resources read under it and shows a fallback placeholder state until they are resolved. What makes ", jsx(_components.code, {
        children: "Suspense"
      }), " different than ", jsx(_components.code, {
        children: "Show"
      }), " is it is non-blocking in that both branches exist at the same time even if not currently in the DOM."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Suspense"
        }), " fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\r\n  ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "AsyncComponent"
            }), " />"]
          })
        }), "\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Suspense"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "suspenselist-experimental",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#suspenselist-experimental",
        children: "#"
      }), jsx(_components.code, {
        children: "<SuspenseList>"
      }), " (Experimental)"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "SuspenseList"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "SuspenseList"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["props: {\r\n  children: JSX.Element;\r\n  revealOrder: ", jsx(_components.span, {
            className: "hljs-string",
            children: "\"forwards\""
          }), " | ", jsx(_components.span, {
            className: "hljs-string",
            children: "\"backwards\""
          }), " | ", jsx(_components.span, {
            className: "hljs-string",
            children: "\"together\""
          }), ";\r\n  tail?: ", jsx(_components.span, {
            className: "hljs-string",
            children: "\"collapsed\""
          }), " | ", jsx(_components.span, {
            className: "hljs-string",
            children: "\"hidden\""
          }), ";\r\n}"]
        }), "): ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "SuspenseList"
      }), " allows for coordinating multiple parallel ", jsx(_components.code, {
        children: "Suspense"
      }), " and ", jsx(_components.code, {
        children: "SuspenseList"
      }), " components. It controls the order in which content is revealed to reduce layout thrashing and has an option to collapse or hide fallback states."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "SuspenseList"
        }), " revealOrder=", jsx(_components.span, {
          className: "hljs-string",
          children: "\"forwards\""
        }), " tail=", jsx(_components.span, {
          className: "hljs-string",
          children: "\"collapsed\""
        }), ">\r\n  ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "ProfileDetails"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "user"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{resource.user}"
            }), " />"]
          })
        }), "\r\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Suspense"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "fallback"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{"
            }), "<", jsx(_components.span, {
              className: "hljs-attr",
              children: "h2"
            }), ">"]
          }), "Loading posts...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "h2"
            }), ">"]
          }), "}>\r\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "ProfileTimeline"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "posts"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{resource.posts}"
            }), " />"]
          }), "\r\n  ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "Suspense"
            }), ">"]
          })]
        }), "\r\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Suspense"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "fallback"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{"
            }), "<", jsx(_components.span, {
              className: "hljs-attr",
              children: "h2"
            }), ">"]
          }), "Loading fun facts...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "h2"
            }), ">"]
          }), "}>\r\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "ProfileTrivia"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "trivia"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{resource.trivia}"
            }), " />"]
          }), "\r\n  ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "Suspense"
            }), ">"]
          })]
        }), "\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "SuspenseList"
        }), ">\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "SuspenseList is still experimental and does not have full SSR support."
    }), "\n", jsxs(_components.h2, {
      id: "dynamic",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#dynamic",
        children: "#"
      }), jsx(_components.code, {
        children: "<Dynamic>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Dynamic"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js/web\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Dynamic"
        }), "<T>(\r\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": T & {\r\n    children?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ";\r\n    component?: ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Component"
        }), "<T> | ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " | keyof ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "IntrinsicElements"
        }), ";\r\n  }\r\n): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "This component lets you insert an arbitrary Component or tag and passes the props through to it."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Dynamic"
        }), " component={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "component"
        }), "} someProp={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "something"
        }), "} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "portal",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#portal",
        children: "#"
      }), jsx(_components.code, {
        children: "<Portal>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Portal"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js/web\""
        }), ";\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "Portal"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["props: {\r\n  mount?: Node;\r\n  useShadow?: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "boolean"
          }), ";\r\n  isSVG?: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "boolean"
          }), ";\r\n  children: JSX.Element;\r\n}"]
        }), "): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Text"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "This inserts the element in the mount node. Useful for inserting Modals outside of the page layout. Events still propagate through the Component Hierarchy."
    }), "\n", jsxs(_components.p, {
      children: ["The portal is mounted in a ", jsx(_components.code, {
        children: "<div>"
      }), " unless the target is the document head. ", jsx(_components.code, {
        children: "useShadow"
      }), " places the element in a Shadow Root for style isolation, and ", jsx(_components.code, {
        children: "isSVG"
      }), " is required if inserting into an SVG element so that the ", jsx(_components.code, {
        children: "<div>"
      }), " is not inserted."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Portal"
        }), " mount={", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "document"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "getElementById"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"modal\""
        }), ")}>\r\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "My Content", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "\r\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Portal"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h1, {
      id: "special-jsx-attributes",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#special-jsx-attributes",
        children: "#"
      }), "Special JSX Attributes"]
    }), "\n", jsx(_components.p, {
      children: "In general Solid attempts to stick to DOM conventions. Most props are treated as attributes on native elements and properties on Web Components, but a few of them have special behavior."
    }), "\n", jsx(_components.p, {
      children: "For custom namespaced attributes with TypeScript you need to extend Solid's JSX namespace:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "declare"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "module"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "namespace"
        }), " JSX {\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Directives"
        }), " {\r\n      ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// use:____"
        }), "\r\n    }\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ExplicitProperties"
        }), " {\r\n      ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// prop:____"
        }), "\r\n    }\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ExplicitAttributes"
        }), " {\r\n      ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// attr:____"
        }), "\r\n    }\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "CustomEvents"
        }), " {\r\n      ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// on:____"
        }), "\r\n    }\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "CustomCaptureEvents"
        }), " {\r\n      ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// oncapture:____"
        }), "\r\n    }\r\n  }\r\n}\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "ref",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#ref",
        children: "#"
      }), jsx(_components.code, {
        children: "ref"
      })]
    }), "\n", jsx(_components.p, {
      children: "Refs are a way of getting access to underlying DOM elements in our JSX. While it is true one could just assign an element to a variable, it is more optimal to leave components in the flow of JSX. Refs are assigned at render time but before the elements are connected to the DOM. They come in 2 flavors."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// variable assigned directly by ref"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "let"
        }), " myDiv;\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// use onMount or createEffect to read after connected to DOM"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onMount"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(myDiv));\r\n\r\n", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "ref"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{myDiv}"
            }), " />"]
          })
        }), "\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Or, callback function (called before connected to DOM)"
        }), "\r\n", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "ref"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{el"
            }), " =>"]
          }), " console.log(el)} />"]
        }), "\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Refs can also be used on Components. They still need to be attached on the other side."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "MyComp"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "props"
        }), ") {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "ref"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{props.ref}"
            }), " />"]
          })
        }), ";\r\n}\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "App"
        }), "(", jsx(_components.span, {
          className: "hljs-params"
        }), ") {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "let"
        }), " myDiv;\r\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onMount"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(myDiv.", jsx(_components.span, {
          className: "hljs-property",
          children: "clientWidth"
        }), "));\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "MyComp"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "ref"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{myDiv}"
            }), " />"]
          })
        }), ";\r\n}\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "classlist",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#classlist",
        children: "#"
      }), jsx(_components.code, {
        children: "classList"
      })]
    }), "\n", jsxs(_components.p, {
      children: ["Solid offers two ways to set the ", jsx(_components.code, {
        children: "class"
      }), " of an element:\r\n", jsx(_components.code, {
        children: "class"
      }), " and ", jsx(_components.code, {
        children: "classList"
      }), " attributes."]
    }), "\n", jsxs(_components.p, {
      children: ["First, you can set ", jsx(_components.code, {
        children: "class=..."
      }), " like any other attribute. For example:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// Two static classes"
        }), "\r\n<div ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "class"
        }), "=", jsx(_components.span, {
          className: "hljs-string",
          children: "\"active editing\""
        }), " />\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// One dynamic class, deleting class attribute if it's not needed"
        }), "\r\n", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "class"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{state.active"
            }), " ? '", jsx(_components.span, {
              className: "hljs-attr",
              children: "active"
            }), "' ", jsx(_components.span, {
              className: "hljs-attr",
              children: ":"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "undefined"
            }), "} />"]
          })
        }), "\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Two dynamic classes"
        }), "\r\n", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "class"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{"
            }), "`${", jsx(_components.span, {
              className: "hljs-attr",
              children: "state.active"
            }), " ? '", jsx(_components.span, {
              className: "hljs-attr",
              children: "active"
            }), "' ", jsx(_components.span, {
              className: "hljs-attr",
              children: ":"
            }), " ''} ${", jsx(_components.span, {
              className: "hljs-attr",
              children: "state.currentId"
            }), " === ", jsx(_components.span, {
              className: "hljs-string",
              children: "row.id"
            }), " ? '", jsx(_components.span, {
              className: "hljs-attr",
              children: "editing"
            }), "' ", jsx(_components.span, {
              className: "hljs-attr",
              children: ":"
            }), " ''}} />"]
          })
        }), "\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["(Note that ", jsx(_components.code, {
        children: "className=..."
      }), " was deprecated in Solid 1.4.)"]
    }), "\n", jsxs(_components.p, {
      children: ["Alternatively, the ", jsx(_components.code, {
        children: "classList"
      }), " pseudo-attribute lets you specify an object,\r\nwhere each key is a class and the value is treated as a boolean\r\nrepresenting whether to include that class.\r\nFor example (matching the last example):"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<div\r\n  classList={{ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "active"
        }), ": state.", jsx(_components.span, {
          className: "hljs-property",
          children: "active"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "editing"
        }), ": state.", jsx(_components.span, {
          className: "hljs-property",
          children: "currentId"
        }), " === row.", jsx(_components.span, {
          className: "hljs-property",
          children: "id"
        }), " }}\r\n/>\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["This example compiles to a ", jsx(_components.a, {
        href: "#createrendereffect",
        children: "render effect"
      }), "\r\nthat dynamically calls\r\n", jsx(_components.a, {
        href: "https://developer.mozilla.org/en-US/docs/Web/API/DOMTokenList/toggle",
        children: jsx(_components.code, {
          children: "element.classList.toggle"
        })
      }), "\r\nto turn each class on or off, only when the corresponding boolean changes.\r\nFor example, when ", jsx(_components.code, {
        children: "state.active"
      }), " becomes ", jsx(_components.code, {
        children: "true"
      }), " [", jsx(_components.code, {
        children: "false"
      }), "], the element gains\r\n[loses] the ", jsx(_components.code, {
        children: "active"
      }), " class."]
    }), "\n", jsxs(_components.p, {
      children: ["The value passed into ", jsx(_components.code, {
        children: "classList"
      }), " can be any expression (including a signal\r\ngetter) that evaluates to an appropriate object. Some examples:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// Dynamic class name and value"
        }), "\r\n<div classList={{ [", jsx(_components.span, {
          className: "hljs-title function_",
          children: "className"
        }), "()]: ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "classOn"
        }), "() }} />;\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Signal class list"
        }), "\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [classes, setClasses] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "({});\r\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setClasses"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "c"
          }), ") =>"]
        }), " ({ ...c, ", jsx(_components.span, {
          className: "hljs-attr",
          children: "active"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), " }));\r\n", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "classList"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{classes()}"
            }), " />"]
          })
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["It's also possible, but dangerous, to mix ", jsx(_components.code, {
        children: "class"
      }), " and ", jsx(_components.code, {
        children: "classList"
      }), ".\r\nThe main safe situation is when ", jsx(_components.code, {
        children: "class"
      }), " is set to a static string (or nothing),\r\nand ", jsx(_components.code, {
        children: "classList"
      }), " is reactive.\r\n(", jsx(_components.code, {
        children: "class"
      }), " could also be set to a static computed value as in\r\n", jsx(_components.code, {
        children: "class={baseClass()}"
      }), ", but then it should appear\r\nbefore any ", jsx(_components.code, {
        children: "classList"
      }), " pseudo-attributes.)\r\nIf both ", jsx(_components.code, {
        children: "class"
      }), " and ", jsx(_components.code, {
        children: "classList"
      }), " are reactive,\r\nyou can get unexpected behavior:\r\nwhen the ", jsx(_components.code, {
        children: "class"
      }), " value changes, Solid sets the entire ", jsx(_components.code, {
        children: "class"
      }), " attribute,\r\nso will overwrite any toggles made by ", jsx(_components.code, {
        children: "classList"
      }), "."]
    }), "\n", jsxs(_components.p, {
      children: ["Because ", jsx(_components.code, {
        children: "classList"
      }), " is a compile-time pseudo-attribute,\r\nit does not work in a prop spread like ", jsx(_components.code, {
        children: "<div {...props} />"
      }), "\r\nor in ", jsx(_components.code, {
        children: "<Dynamic>"
      }), "."]
    }), "\n", jsxs(_components.h2, {
      id: "style",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#style",
        children: "#"
      }), jsx(_components.code, {
        children: "style"
      })]
    }), "\n", jsxs(_components.p, {
      children: ["Solid's ", jsx(_components.code, {
        children: "style"
      }), " attribute lets you provide either a CSS string or\r\nan object where keys are CSS property names:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// string"
        }), "\r\n<div style={", jsxs(_components.span, {
          className: "hljs-string",
          children: ["`color: green; height: ", jsx(_components.span, {
            className: "hljs-subst",
            children: "${state.height}"
          }), "px`"]
        }), "} />\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// object"
        }), "\r\n", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "style"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{{"
            }), "\r\n  ", jsx(_components.span, {
              className: "hljs-attr",
              children: "color:"
            }), " \"", jsx(_components.span, {
              className: "hljs-attr",
              children: "green"
            }), "\",\r\n  ", jsx(_components.span, {
              className: "hljs-attr",
              children: "height:"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "state.height"
            }), " + \"", jsx(_components.span, {
              className: "hljs-attr",
              children: "px"
            }), "\" }}\r\n/>"]
          })
        }), "\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Unlike ", jsxs(_components.a, {
        href: "https://reactjs.org/docs/dom-elements.html#style",
        children: ["React's ", jsx(_components.code, {
          children: "style"
        }), " attribute"]
      }), ",\r\nSolid uses ", jsx(_components.code, {
        children: "element.style.setProperty"
      }), " under the hood. This means you need to use\r\nthe lower-case, dash-separated version of property names\r\ninstead of the JavaScript camel-cased version,\r\nsuch as ", jsx(_components.code, {
        children: "\"background-color\""
      }), " rather than ", jsx(_components.code, {
        children: "backgroundColor"
      }), ".\r\nThis actually leads to better performance and consistency with SSR output."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// string"
        }), "\r\n<div style={", jsxs(_components.span, {
          className: "hljs-string",
          children: ["`color: green; background-color: ", jsx(_components.span, {
            className: "hljs-subst",
            children: "${state.color}"
          }), "; height: ", jsx(_components.span, {
            className: "hljs-subst",
            children: "${state.height}"
          }), "px`"]
        }), "} />\r\n\r\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// object"
        }), "\r\n", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "style"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{{"
            }), "\r\n  ", jsx(_components.span, {
              className: "hljs-attr",
              children: "color:"
            }), " \"", jsx(_components.span, {
              className: "hljs-attr",
              children: "green"
            }), "\",\r\n  \"", jsx(_components.span, {
              className: "hljs-attr",
              children: "background-color"
            }), "\"", jsx(_components.span, {
              className: "hljs-attr",
              children: ":"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "state.color"
            }), ",\r\n  ", jsx(_components.span, {
              className: "hljs-attr",
              children: "height:"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "state.height"
            }), " + \"", jsx(_components.span, {
              className: "hljs-attr",
              children: "px"
            }), "\" }}\r\n/>"]
          })
        }), "\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "This also means you can set CSS variables! For example:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// set css variable"
        }), "\r\n<div style={{ ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"--my-custom-color\""
        }), ": state.", jsx(_components.span, {
          className: "hljs-property",
          children: "themeColor"
        }), " }} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "innerhtmltextcontent",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#innerhtmltextcontent",
        children: "#"
      }), jsx(_components.code, {
        children: "innerHTML"
      }), "/", jsx(_components.code, {
        children: "textContent"
      })]
    }), "\n", jsxs(_components.p, {
      children: ["These work the same as their property equivalent. Set a string and they will be set. ", jsx(_components.strong, {
        children: "Be careful!!"
      }), " Setting ", jsx(_components.code, {
        children: "innerHTML"
      }), " with any data that could be exposed to an end user as it could be a vector for malicious attack. ", jsx(_components.code, {
        children: "textContent"
      }), " while generally not needed is actually a performance optimization when you know the children will only be text as it bypasses the generic diffing routine."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<div textContent={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "text"
        }), "} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "on___",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#on___",
        children: "#"
      }), jsx(_components.code, {
        children: "on___"
      })]
    }), "\n", jsxs(_components.p, {
      children: ["Event handlers in Solid typically take the form of ", jsx(_components.code, {
        children: "onclick"
      }), " or ", jsx(_components.code, {
        children: "onClick"
      }), " depending on style."]
    }), "\n", jsx(_components.p, {
      children: "Solid uses semi-synthetic event delegation for common UI events that are composed and bubble. This improves performance for these common events."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<div onClick={", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "e"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(e.", jsx(_components.span, {
          className: "hljs-property",
          children: "currentTarget"
        }), ")} />\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Solid also supports passing an array to the event handler to bind a value to the first argument of the event handler. This doesn't use ", jsx(_components.code, {
        children: "bind"
      }), " or create an additional closure, so it is a highly optimized way of delegating events."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "handler"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "itemId, e"
        }), ") {\r\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "/*...*/"
        }), "\r\n}\r\n\r\n<ul>\r\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "For"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "each"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{state.list}"
            }), ">"]
          }), "{(item) => ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "li"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "onClick"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{[handler,"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "item.id"
            }), "]} />"]
          }), "}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "For"
            }), ">"]
          })]
        }), "\r\n</ul>;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Events are never rebound and the bindings are not reactive, as it is expensive to attach and detach listeners.\r\nSince event handlers are called like any other function each time an event fires, there is no need for reactivity; shortcut your handler if desired."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// if defined, call it; otherwise don't."
        }), "\r\n<div onClick={", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " props.", jsx(_components.span, {
          className: "hljs-property",
          children: "handleClick"
        }), "?.()} />\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Note that ", jsx(_components.code, {
        children: "onChange"
      }), " and ", jsx(_components.code, {
        children: "onInput"
      }), " work according to their native behavior. ", jsx(_components.code, {
        children: "onInput"
      }), " will fire immediately after the value has changed; for ", jsx(_components.code, {
        children: "<input>"
      }), " fields, ", jsx(_components.code, {
        children: "onChange"
      }), " will only fire after the field loses focus."]
    }), "\n", jsxs(_components.h2, {
      id: "on___oncapture___",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#on___oncapture___",
        children: "#"
      }), jsx(_components.code, {
        children: "on:___"
      }), "/", jsx(_components.code, {
        children: "oncapture:___"
      })]
    }), "\n", jsxs(_components.p, {
      children: ["For any other events, perhaps ones with unusual names, or ones you wish not to be delegated, there are the ", jsx(_components.code, {
        children: "on"
      }), " namespace events. This attribute adds an event listener verbatim."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<div ", jsx(_components.span, {
          className: "hljs-attr",
          children: "on"
        }), ":", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Weird"
        }), "-", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Event"
        }), "={", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "e"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "alert"
        }), "(e.", jsx(_components.span, {
          className: "hljs-property",
          children: "detail"
        }), ")} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "use___",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#use___",
        children: "#"
      }), jsx(_components.code, {
        children: "use:___"
      })]
    }), "\n", jsx(_components.p, {
      children: "These are custom directives. In a sense this is just syntax sugar over ref but allows us to easily attach multiple directives to a single element. A directive is a function with the following signature:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "directive"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["element: Element, accessor: () => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "any"
          })]
        }), "): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Directive functions are called at render time but before being added to the DOM. You can do whatever you'd like in them including create signals, effects, register clean-up etc."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [name, setName] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"\""
        }), ");\r\n\r\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "model"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "el, value"
        }), ") {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [field, setField] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "value"
        }), "();\r\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createRenderEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " (el.", jsx(_components.span, {
          className: "hljs-property",
          children: "value"
        }), " = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "field"
        }), "()));\r\n  el.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "addEventListener"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"input\""
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "e"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setField"
        }), "(e.", jsx(_components.span, {
          className: "hljs-property",
          children: "target"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "value"
        }), "));\r\n}\r\n\r\n<input type=", jsx(_components.span, {
          className: "hljs-string",
          children: "\"text\""
        }), " ", jsx(_components.span, {
          className: "hljs-attr",
          children: "use"
        }), ":model={[name, setName]} />;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "To register with TypeScript extend the JSX namespace."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "declare"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "module"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), " {\r\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "namespace"
        }), " JSX {\r\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Directives"
        }), " {\r\n      ", jsx(_components.span, {
          className: "hljs-attr",
          children: "model"
        }), ": [", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "any"
            })]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), "];\r\n    }\r\n  }\r\n}\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "prop___",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#prop___",
        children: "#"
      }), jsx(_components.code, {
        children: "prop:___"
      })]
    }), "\n", jsx(_components.p, {
      children: "Forces the prop to be treated as a property instead of an attribute."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<div ", jsx(_components.span, {
          className: "hljs-attr",
          children: "prop"
        }), ":scrollTop={props.", jsx(_components.span, {
          className: "hljs-property",
          children: "scrollPos"
        }), " + ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"px\""
        }), "} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "attr___",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#attr___",
        children: "#"
      }), jsx(_components.code, {
        children: "attr:___"
      })]
    }), "\n", jsx(_components.p, {
      children: "Forces the prop to be treated as a attribute instead of an property. Useful for Web Components where you want to set attributes."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<my-element ", jsx(_components.span, {
          className: "hljs-attr",
          children: "attr"
        }), ":status={props.", jsx(_components.span, {
          className: "hljs-property",
          children: "status"
        }), "} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "-once-",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#-once-",
        children: "#"
      }), jsx(_components.code, {
        children: "/* @once */"
      })]
    }), "\n", jsx(_components.p, {
      children: "Solid's compiler uses a heuristic for reactive wrapping and lazy evaluation of JSX expressions. Does it contain a function call, a property access, or JSX? If yes we wrap it in a getter when passed to components or in an effect if passed to native elements."
    }), "\n", jsxs(_components.p, {
      children: ["Knowing this heuristic and its limitations, we can reduce overhead of things we know will never change by accessing them outside of the JSX. A lone variable will never be wrapped. We can also tell the compiler not to wrap them by starting the expression with a comment decorator ", jsx(_components.code, {
        children: "/* @once */"
      }), "."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MyComponent"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "static"
        }), "={", jsx(_components.span, {
          className: "hljs-comment",
          children: "/*@once*/"
        }), " state.", jsx(_components.span, {
          className: "hljs-property",
          children: "wontUpdate"
        }), "} />\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "This also works on children."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MyComponent"
        }), ">{", jsx(_components.span, {
          className: "hljs-comment",
          children: "/*@once*/"
        }), " state.", jsx(_components.span, {
          className: "hljs-property",
          children: "wontUpdate"
        }), "}</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MyComponent"
        }), ">\n"]
      })
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
