import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [{
  "depth": 1,
  "value": "Reattività semplice",
  "children": [{
    "depth": 2,
    "value": "createSignal",
    "children": []
  }, {
    "depth": 2,
    "value": "createEffect",
    "children": []
  }, {
    "depth": 2,
    "value": "createMemo",
    "children": []
  }, {
    "depth": 2,
    "value": "createResource",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Cicli vitali",
  "children": [{
    "depth": 2,
    "value": "onMount",
    "children": []
  }, {
    "depth": 2,
    "value": "onCleanup",
    "children": []
  }, {
    "depth": 2,
    "value": "onError",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Utilità reattive",
  "children": [{
    "depth": 2,
    "value": "untrack",
    "children": []
  }, {
    "depth": 2,
    "value": "batch",
    "children": []
  }, {
    "depth": 2,
    "value": "on",
    "children": []
  }, {
    "depth": 2,
    "value": "createRoot",
    "children": []
  }, {
    "depth": 2,
    "value": "mergeProps",
    "children": []
  }, {
    "depth": 2,
    "value": "splitProps",
    "children": []
  }, {
    "depth": 2,
    "value": "useTransition",
    "children": []
  }, {
    "depth": 2,
    "value": "observable",
    "children": []
  }, {
    "depth": 2,
    "value": "mapArray",
    "children": []
  }, {
    "depth": 2,
    "value": "indexArray",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Stores",
  "children": [{
    "depth": 2,
    "value": "createStore",
    "children": [{
      "depth": 3,
      "value": "Getters",
      "children": []
    }, {
      "depth": 3,
      "value": "Aggiornamento dei negozi Store",
      "children": []
    }]
  }, {
    "depth": 2,
    "value": "produce",
    "children": []
  }, {
    "depth": 2,
    "value": "reconcile",
    "children": []
  }, {
    "depth": 2,
    "value": "createMutable",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "API dei componenti",
  "children": [{
    "depth": 2,
    "value": "createContext",
    "children": []
  }, {
    "depth": 2,
    "value": "useContext",
    "children": []
  }, {
    "depth": 2,
    "value": "children",
    "children": []
  }, {
    "depth": 2,
    "value": "lazy",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Primitive secondarie",
  "children": [{
    "depth": 2,
    "value": "createDeferred",
    "children": []
  }, {
    "depth": 2,
    "value": "createComputed",
    "children": []
  }, {
    "depth": 2,
    "value": "createRenderEffect",
    "children": []
  }, {
    "depth": 2,
    "value": "createSelector",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Rendering",
  "children": [{
    "depth": 2,
    "value": "render",
    "children": []
  }, {
    "depth": 2,
    "value": "hydrate",
    "children": []
  }, {
    "depth": 2,
    "value": "renderToString",
    "children": []
  }, {
    "depth": 2,
    "value": "renderToStringAsync",
    "children": []
  }, {
    "depth": 2,
    "value": "pipeToNodeWritable",
    "children": []
  }, {
    "depth": 2,
    "value": "pipeToWritable",
    "children": []
  }, {
    "depth": 2,
    "value": "isServer",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Controllo del flusso",
  "children": [{
    "depth": 2,
    "value": "<For>",
    "children": []
  }, {
    "depth": 2,
    "value": "<Show>",
    "children": []
  }, {
    "depth": 2,
    "value": "<Switch>/<Match>",
    "children": []
  }, {
    "depth": 2,
    "value": "<Index>",
    "children": []
  }, {
    "depth": 2,
    "value": "<ErrorBoundary>",
    "children": []
  }, {
    "depth": 2,
    "value": "<Suspense>",
    "children": []
  }, {
    "depth": 2,
    "value": "<SuspenseList> (Experimental)",
    "children": []
  }, {
    "depth": 2,
    "value": "<Dynamic>",
    "children": []
  }, {
    "depth": 2,
    "value": "<Portal>",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Special JSX Attributes",
  "children": [{
    "depth": 2,
    "value": "ref",
    "children": []
  }, {
    "depth": 2,
    "value": "classList",
    "children": []
  }, {
    "depth": 2,
    "value": "style",
    "children": []
  }, {
    "depth": 2,
    "value": "innerHTML/textContent",
    "children": []
  }, {
    "depth": 2,
    "value": "on___",
    "children": []
  }, {
    "depth": 2,
    "value": "on:___/oncapture:___",
    "children": []
  }, {
    "depth": 2,
    "value": "use:___",
    "children": []
  }, {
    "depth": 2,
    "value": "prop:___",
    "children": []
  }, {
    "depth": 2,
    "value": "attr:___",
    "children": []
  }, {
    "depth": 2,
    "value": "/* @once */",
    "children": []
  }]
}];
function _createMdxContent(props) {
  const _components = Object.assign({
    h1: "h1",
    a: "a",
    h2: "h2",
    code: "code",
    pre: "pre",
    span: "span",
    p: "p",
    blockquote: "blockquote",
    h3: "h3",
    strong: "strong"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsxs(_components.h1, {
      id: "reattività-semplice",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#reattività-semplice",
        children: "#"
      }), "Reattività semplice"]
    }), "\n", jsxs(_components.h2, {
      id: "createsignal",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createsignal",
        children: "#"
      }), jsx(_components.code, {
        children: "createSignal"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createSignal<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "value"
        }), ": T,\n  options?: { name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), "; equals?: ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " | (", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev: T, next: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ") }\n): [", jsx(_components.span, {
          className: "hljs-attr",
          children: "get"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T, ", jsx(_components.span, {
          className: "hljs-attr",
          children: "set"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v: T"
          }), ") =>"]
        }), " T];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "La primitiva reattiva più elementare utilizzata per tracciare un singolo valore che cambia nel tempo è createSignal. La funzione create restituisce una coppia di funzioni get e set per accedere e aggiornare il segnale."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [leggereValore, assegnaValore] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(valorePredefinito);\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// assegna il valore con un setter di funzioni"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "leggereValore"
        }), "();\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// assegna il valore con un setter di funzioni"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "assegnaValore"
        }), "(valoreSuccessivo);\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// assegna il valore con un setter di funzioni"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "assegnaValore"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "assegnaValore"
          }), ") =>"]
        }), " assegnaValore + successivo);\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Remember to access signals under a tracking scope if you wish them to react to updates. Tracking scopes are functions that are passed to computations like ", jsx(_components.code, {
        children: "createEffect"
      }), " or JSX expressions."]
    }), "\n", jsxs(_components.blockquote, {
      children: ["\n", jsx(_components.p, {
        children: "Per memorizzare una funzione in un segnale utilizzerai il modulo funzione:"
      }), "\n", jsx(_components.pre, {
        children: jsxs(_components.code, {
          className: "hljs language-js",
          children: [jsx(_components.span, {
            className: "hljs-title function_",
            children: "assegnaValore"
          }), "(", jsx(_components.span, {
            className: "hljs-function",
            children: "() =>"
          }), " ilFunzione);\n"]
        })
      }), "\n"]
    }), "\n", jsxs(_components.h2, {
      id: "createeffect",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createeffect",
        children: "#"
      }), jsx(_components.code, {
        children: "createEffect"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createEffect<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v: T"
          }), ") =>"]
        }), " T,\n  value?: T,\n  options?: { name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " }\n): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Questo creerà un nuovo calcolo che tiene traccia automaticamente delle dipendenze. Viene eseguito dopo ogni rendering in cui è cambiata una dipendenza. È ideale per l'utilizzo di ", jsx(_components.code, {
        children: "ref"
      }), "s e la gestione di altri effetti collaterali."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [a, assegnaA] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(valorePredefinito);\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// effetto che dipende dal segnale `a`"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "altroAffetto"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "a"
        }), "()));\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "La funzione effetto viene chiamata con il valore restituito dall'ultima esecuzione della funzione effetto. Questo valore può essere inizializzato come secondo argomento opzionale. Questo può essere utile per differenziare senza creare una chiusura aggiuntiva."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev"
          }), ") =>"]
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " somma = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "a"
        }), "() + ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "b"
        }), "();\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "if"
        }), " (somma !== prev) ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(somma);\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " somma;\n}, ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "creatememo",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#creatememo",
        children: "#"
      }), jsx(_components.code, {
        children: "createMemo"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createMemo<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v: T"
          }), ") =>"]
        }), " T,\n  value?: T,\n  options?: { name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), "; equals?: ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " | (", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev: T, next: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ") }\n): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Crea un segnale derivato di sola lettura che ricalcola il suo valore ogni volta che le dipendenze del codice eseguito vengono aggiornate."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " ottenereValore = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createMemo"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "calcoloImpegnativo"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "a"
        }), "(), ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "b"
        }), "()));\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// leggere valore"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "ottenereValore"
        }), "();\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "La funzione memo viene chiamata con il valore restituito dall'ultima esecuzione della funzione memo. Questo valore può essere inizializzato come secondo argomento opzionale. Questo è utile per ridurre i calcoli."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " somma = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createMemo"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "somma"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "input"
        }), "() + somma, ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "createresource",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createresource",
        children: "#"
      }), jsx(_components.code, {
        children: "createResource"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ResourceReturn"
        }), "<T> = [\n  {\n    (): T | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), ";\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "loading"
        }), ": ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ";\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "error"
        }), ": ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ";\n  },\n  {\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "mutate"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: T | ", jsx(_components.span, {
              className: "hljs-literal",
              children: "undefined"
            })]
          }), ") =>"]
        }), " T | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), ";\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "refetch"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n  }\n];\n\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createResource<T, U = ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), ">(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fetcher"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["k: U, getPrev: () => T | ", jsx(_components.span, {
              className: "hljs-literal",
              children: "undefined"
            })]
          }), ") =>"]
        }), " T | ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<T>,\n  options?: { initialValue?: T; name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " }\n): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ResourceReturn"
        }), "<T>;\n\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createResource<T, U>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "source"
        }), ": U | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "null"
        }), " | (", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " U | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "null"
        }), "),\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fetcher"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["k: U, getPrev: () => T | ", jsx(_components.span, {
              className: "hljs-literal",
              children: "undefined"
            })]
          }), ") =>"]
        }), " T | ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<T>,\n  options?: { initialValue?: T; name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " }\n): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ResourceReturn"
        }), "<T>;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Crea un segnale in grado di gestire le richieste asincrone. Il ", jsx(_components.code, {
        children: "fetcher"
      }), " è una funzione asincrona che accetta il valore di ritorno della ", jsx(_components.code, {
        children: "sorgente"
      }), " se fornito e restituisce una Promessa il cui valore risolto è impostato nella risorsa."]
    }), "\n", jsx(_components.p, {
      children: "Il recuperatore non è reattivo. Usa il primo argomento opzionale se desideri che venga eseguito più di una volta. Se l'origine si risolve in false, null o undefined, non verrà recuperato."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [data, { mutate, refetch }] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createResource"
        }), "(getQuery, fetchData);\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// leggere valore"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "data"
        }), "();\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// controlla se stai caricando"
        }), "\ndata.", jsx(_components.span, {
          className: "hljs-property",
          children: "loading"
        }), ";\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// controlla se sbagli"
        }), "\ndata.", jsx(_components.span, {
          className: "hljs-property",
          children: "error"
        }), ";\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// impostare direttamente il valore senza creare promesse"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mutate"
        }), "(valoreOttmista);\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// recupera l'ultima richiesta solo perché"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "refetch"
        }), "();\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "\"loading\" ed \"error\" sono getter reattivi e possono essere tracciati."
    }), "\n", jsxs(_components.h1, {
      id: "cicli-vitali",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#cicli-vitali",
        children: "#"
      }), "Cicli vitali"]
    }), "\n", jsxs(_components.h2, {
      id: "onmount",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#onmount",
        children: "#"
      }), jsx(_components.code, {
        children: "onMount"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onMount"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["fn: () => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "void"
          })]
        }), "): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Registra un metodo che viene eseguito dopo che tutti gli elementi di rendering iniziali sono stati montati. Questo è l'ideale per usare ", jsx(_components.code, {
        children: "ref"
      }), "s e gestire altri effetti collaterali di una volta. È equivalente a un ", jsx(_components.code, {
        children: "createEffect"
      }), " che non ha dipendenze."]
    }), "\n", jsxs(_components.h2, {
      id: "oncleanup",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#oncleanup",
        children: "#"
      }), jsx(_components.code, {
        children: "onCleanup"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onCleanup"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["fn: () => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "void"
          })]
        }), "): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Registra un metodo di pulizia che viene eseguito in caso di eliminazione o ricalcolo dell'ambito reattivo corrente. Può essere utilizzato in qualsiasi componente o effetto."
    }), "\n", jsxs(_components.h2, {
      id: "onerror",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#onerror",
        children: "#"
      }), jsx(_components.code, {
        children: "onError"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onError"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["fn: (err: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "any"
          }), ") => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "void"
          })]
        }), "): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Registra un metodo del gestore degli errori che viene eseguito in caso di errori nell'ambito figlio. Vengono eseguiti solo i gestori di errori di ambito più vicini. Rilancia per attivare la linea."
    }), "\n", jsxs(_components.h1, {
      id: "utilità-reattive",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#utilità-reattive",
        children: "#"
      }), "Utilità reattive"]
    }), "\n", jsx(_components.p, {
      children: "Questi helper offrono la possibilità di pianificare più facilmente gli aggiornamenti. Controllano anche come viene tracciata la reattività."
    }), "\n", jsxs(_components.h2, {
      id: "untrack",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#untrack",
        children: "#"
      }), jsx(_components.code, {
        children: "untrack"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " untrack<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T): T;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Ignora il rilevamento delle dipendenze nel blocco di codice in esecuzione e restituisce il valore."
    }), "\n", jsxs(_components.h2, {
      id: "batch",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#batch",
        children: "#"
      }), jsx(_components.code, {
        children: "batch"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " batch<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T): T;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Trattiene il processo di commit degli aggiornamenti. Qualunque cosa sia dichiarata all'interno del blocco viene conservata fino a quando la funzione non si risolve per evitare ricalcoli non necessari. La lettura dei valori sulle righe successive all'interno del blocco non verrà quindi aggiornata consecutivamente."
    }), "\n", jsx(_components.p, {
      children: "Nota: Solid Store, un modello di dati più avanzato disponibile in Solid, avvolge automaticamente i metodi set ed Effect con batch."
    }), "\n", jsxs(_components.h2, {
      id: "on",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#on",
        children: "#"
      }), jsx(_components.code, {
        children: "on"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " on<T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Array"
        }), "<", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), "> | (", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), "), U>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "deps"
        }), ": T,\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "input: T, prevInput: T, prevValue?: U"
          }), ") =>"]
        }), " U,\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "options"
        }), ": { defer?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), " } = {}\n): ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prevValue?: U"
          }), ") =>"]
        }), " U | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "\"on\" è progettato per essere passato in un calcolo per rendere esplicite le sue dipendenze. Se viene passato un array di dipendenze, allora \"input\" e \"prevInput\" saranno array."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "on"
        }), "(a, ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(v, ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "b"
        }), "())));\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// è equivalente a:"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " v = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "a"
        }), "();\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "untrack"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(v, ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "b"
        }), "()));\n});\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Puoi anche impedire l'esecuzione immediata del calcolo. È possibile specificare di assegnare la modifica impostando l'opzione di rinvio su true."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// non viene eseguito immediatamente"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "on"
        }), "(a, ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(v), { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "defer"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), " }));\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setA"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"new\""
        }), "); ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// ora funziona"
        }), "\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "createroot",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createroot",
        children: "#"
      }), jsx(_components.code, {
        children: "createRoot"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createRoot<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["dispose: () => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "void"
            })]
          }), ") =>"]
        }), " T): T;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Crea un nuovo contesto non tracciato. Inoltre non è auto-smaltato. Ciò è utile per i contesti reattivi nidificati che non si desidera rilasciare quando il genitore rivaluta. Questo può essere usato come un potente modello per la memorizzazione nella cache."
    }), "\n", jsxs(_components.p, {
      children: ["Tutto il codice Solid dovrebbe essere racchiuso in uno di questi livelli superiori in quanto assicurano che tutta la memoria/i calcoli siano liberati. Normalmente non devi preoccuparti di questo dato che ", jsx(_components.code, {
        children: "createRoot"
      }), " è incorporato in tutte le funzioni di immissione di ", jsx(_components.code, {
        children: "render"
      }), "."]
    }), "\n", jsxs(_components.h2, {
      id: "mergeprops",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#mergeprops",
        children: "#"
      }), jsx(_components.code, {
        children: "mergeProps"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mergeProps"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["...sources: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "any"
          })]
        }), "): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Un metodo di \"unione\" reattivo. È utile per impostare gli oggetti di scena predefiniti per i componenti nel caso in cui il chiamante non li fornisca. È anche utile per clonare l'oggetto props con proprietà reattive."
    }), "\n", jsx(_components.p, {
      children: "Questo metodo funziona utilizzando un proxy e risolvendo le proprietà in ordine inverso. Ciò consente il tracciamento dinamico delle proprietà che non sono presenti quando l'oggetto prop viene unito per la prima volta."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// proprietà predefinite"
        }), "\nprops = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mergeProps"
        }), "({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "nome"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Davide\""
        }), " }, props);\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// proprietà del clone"
        }), "\nnewProps = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mergeProps"
        }), "(proprietà);\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// proprietà unite"
        }), "\nprops = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mergeProps"
        }), "(props, altreProprieta);\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "splitprops",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#splitprops",
        children: "#"
      }), jsx(_components.code, {
        children: "splitProps"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " splitProps<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": T,\n  ...", jsx(_components.span, {
          className: "hljs-attr",
          children: "keys"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Array"
        }), "<(keyof T)[]>\n): [...", jsx(_components.span, {
          className: "hljs-attr",
          children: "parts"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Partial"
        }), "<T>];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Questo è un sostituto della destrutturazione. Divide un oggetto reattivo per chiavi mantenendo la reattività."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [locale, altre] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "splitProps"
        }), "(props, [", jsx(_components.span, {
          className: "hljs-string",
          children: "\"children\""
        }), "]);\n\n<>\n  <Child {...altre} />\n  <div>{locale.children}<div>\n</>\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "usetransition",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#usetransition",
        children: "#"
      }), jsx(_components.code, {
        children: "useTransition"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "useTransition"
        }), "(", jsx(_components.span, {
          className: "hljs-params"
        }), "): [\n  ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ",\n  ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["fn: () => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "void"
            }), ", cb?: () => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "void"
            })]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), "\n];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Utilizzato per eseguire in batch gli aggiornamenti asincroni in una transazione rinviando il commit fino al completamento di tutti i processi asincroni. Questo processo è legato a Suspense e tiene traccia solo delle risorse lette sotto i limiti di Suspense."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [sospeso, inizio] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "useTransition"
        }), "();\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// controlla se stai effettuando la transizione"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "sospeso"
        }), "();\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// avvolgere in transizione"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "inizio"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setSignal"
        }), "(nuovoValore), ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-comment",
          children: "/* la transizione è fatta */"
        }), ")\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "observable",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#observable",
        children: "#"
      }), jsx(_components.code, {
        children: "observable"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " observable<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "input"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Observable"
        }), "<T>;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Un metodo che prende un segnale e produce un semplice osservabile. Puoi consumarlo dalla libreria Observable di tua scelta. Questo di solito accade con l'operatore ", jsx(_components.code, {
        children: "from"
      }), "."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"rxjs\""
        }), ";\n\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [s, set] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ");\n\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " obsv$ = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "from"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "observable"
        }), "(s));\n\nobsv$.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "subscribe"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(v));\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "maparray",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#maparray",
        children: "#"
      }), jsx(_components.code, {
        children: "mapArray"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " mapArray<T, U>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "list"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "readonly"
        }), " T[],\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "mapFn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: T, i: () => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "number"
            })]
          }), ") =>"]
        }), " U\n): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " U[];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Un aiutante di mappa reattivo che memorizza nella cache ogni elemento per riferimento. Questo viene utilizzato per ridurre la mappatura non necessaria sugli aggiornamenti. Esegue la funzione di mappatura solo una volta per valore, quindi la sposta o la rimuove secondo necessità. L'argomento index è un segnale. La funzione mappa stessa non sta tracciando."
    }), "\n", jsxs(_components.p, {
      children: ["Questo è un helper sottostante per il componente del flusso di controllo integrato ", jsx(_components.code, {
        children: "<For>"
      }), "."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " mapped = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mapArray"
        }), "(source, ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "modella"
          }), ") =>"]
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [nome, assegnaNome] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(modella.", jsx(_components.span, {
          className: "hljs-property",
          children: "nome"
        }), ");\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [modella, assegnaDescrizione] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(modella.", jsx(_components.span, {
          className: "hljs-property",
          children: "modella"
        }), ");\n\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " {\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": model.", jsx(_components.span, {
          className: "hljs-property",
          children: "id"
        }), ",\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "nome"
        }), "() {\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "nome"
        }), "();\n    },\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "descrizione"
        }), "() {\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "descrizione"
        }), "();\n    }\n    assegnaNome,\n    assegnaDescrizione\n  }\n});\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "indexarray",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#indexarray",
        children: "#"
      }), jsx(_components.code, {
        children: "indexArray"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " indexArray<T, U>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "list"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "readonly"
        }), " T[],\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "mapFn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: () => T, i: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "number"
            })]
          }), ") =>"]
        }), " U\n): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " U[];\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["È simile a ", jsx(_components.code, {
        children: "mapArray"
      }), " tranne che mappa per indice. L'elemento è un segnale e l'indice è ora la costante."]
    }), "\n", jsxs(_components.p, {
      children: ["Helper sottostante per il flusso di controllo ", jsx(_components.code, {
        children: "<Index>"
      }), "."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " mapped = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "indexArray"
        }), "(source, ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "modella"
          }), ") =>"]
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " {\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "id"
        }), "() {\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "modella"
        }), "().", jsx(_components.span, {
          className: "hljs-property",
          children: "id"
        }), "\n    }\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "firstInitial"
        }), "() {\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "modella"
        }), "().", jsx(_components.span, {
          className: "hljs-property",
          children: "nome"
        }), "[", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), "];\n    },\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fullName"
        }), "() {\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsxs(_components.span, {
          className: "hljs-string",
          children: ["`", jsx(_components.span, {
            className: "hljs-subst",
            children: "${modella().nome}"
          }), " ", jsx(_components.span, {
            className: "hljs-subst",
            children: "${modella().cognome}"
          }), "`"]
        }), ";\n    },\n  }\n});\n"]
      })
    }), "\n", jsxs(_components.h1, {
      id: "stores",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#stores",
        children: "#"
      }), "Stores"]
    }), "\n", jsxs(_components.p, {
      children: ["Queste API sono disponibili su ", jsx(_components.code, {
        children: "solid-js/store"
      }), "."]
    }), "\n", jsxs(_components.h2, {
      id: "createstore",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createstore",
        children: "#"
      }), jsx(_components.code, {
        children: "createStore"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createStore<T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "StoreNode"
        }), ">(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "state"
        }), ": T | ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>,\n  options?: { name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " }\n): [", jsx(_components.span, {
          className: "hljs-attr",
          children: "get"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>, ", jsx(_components.span, {
          className: "hljs-attr",
          children: "set"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "SetStoreFunction"
        }), "<T>];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Questa utility crea un albero di Segnali come proxy. Consente di tenere traccia dei singoli valori in strutture dati nidificate. La funzione create restituisce un oggetto proxy di sola lettura e una funzione setter."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "(initialValue);\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// legerre valore"
        }), "\nstate.", jsx(_components.span, {
          className: "hljs-property",
          children: "unValore"
        }), ";\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// set value"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "merge"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"questoValore\""
        }), " });\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"percorso\""
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"verso\""
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"valore\""
        }), ", nuovoValore);\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Poiché gli oggetti Store sono proxy, tengono traccia solo dell'accesso alla proprietà. All'accesso, Store produce in modo ricorsivo oggetti nidificati su dati nidificati. Questo tuttavia avvolge solo array e oggetti semplici. Le classi non sono chiuse. Elementi come ", jsx(_components.code, {
        children: "Date"
      }), ", ", jsx(_components.code, {
        children: "HTMLElement"
      }), ", ", jsx(_components.code, {
        children: "RegExp"
      }), ", ", jsx(_components.code, {
        children: "Map"
      }), ", ", jsx(_components.code, {
        children: "Set"
      }), " non sono granularmente reattivi."]
    }), "\n", jsx(_components.p, {
      children: "Si noti che l'oggetto di stato di livello superiore non può essere tracciato senza accedere a una proprietà su di esso. Non è adatto per le cose su cui si esegue l'iterazione poiché l'aggiunta di nuove chiavi o indici non può attivare gli aggiornamenti. Quindi dovresti mettere qualsiasi elenco su una chiave di stato piuttosto che provare a usare l'oggetto di stato stesso."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// metti la lista come chiave sull'oggetto di stato"
        }), "\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "elenco"
        }), ": [] });\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// accedere alla proprietà `elenco` sull'oggetto stato"
        }), "\n", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "For"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "each"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{state.elenco}"
            }), ">"]
          }), "{articolo => /*...*/}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "For"
            }), ">"]
          })]
        }), "\n"]
      })
    }), "\n", jsxs(_components.h3, {
      id: "getters",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#getters",
        children: "#"
      }), "Getters"]
    }), "\n", jsx(_components.p, {
      children: "Gli oggetti Store supportano l'uso di getter per memorizzare i valori calcolati."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "user"
        }), ": {\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "nome"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Davide\""
        }), ",\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "cognome"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Italiano\""
        }), ",\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "nome"
        }), "() {\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsxs(_components.span, {
          className: "hljs-string",
          children: ["`", jsxs(_components.span, {
            className: "hljs-subst",
            children: ["${", jsx(_components.span, {
              className: "hljs-variable language_",
              children: "this"
            }), ".nome}"]
          }), " ", jsxs(_components.span, {
            className: "hljs-subst",
            children: ["${", jsx(_components.span, {
              className: "hljs-variable language_",
              children: "this"
            }), ".cognome}"]
          }), "`"]
        }), ";\n    },\n  },\n});\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Questi sono semplici getter. È comunque necessario utilizzare un Memo se si desidera memorizzare nella cache un valore:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "let"
        }), " nomeECognome;\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [stato, assegnareStato] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "user"
        }), ": {\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "nome"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Davide\""
        }), ",\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "cognome"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Italiano\""
        }), ",\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "nomeECognome"
        }), "() {\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "nomeECognome"
        }), "();\n    },\n  },\n});\nnomeECognome = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createMemo"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsxs(_components.span, {
          className: "hljs-string",
          children: ["`", jsx(_components.span, {
            className: "hljs-subst",
            children: "${state.user.nome}"
          }), " ", jsx(_components.span, {
            className: "hljs-subst",
            children: "${state.user.cognome}"
          }), "`"]
        }), ");\n"]
      })
    }), "\n", jsxs(_components.h3, {
      id: "aggiornamento-dei-negozi-store",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#aggiornamento-dei-negozi-store",
        children: "#"
      }), "Aggiornamento dei negozi Store"]
    }), "\n", jsx(_components.p, {
      children: "Le modifiche possono assumere la forma di funzioni che forniscono lo stato precedente e restituiscono un nuovo stato o un valore. Gli oggetti sono sempre uniti in modo superficiale. Imposta i valori su \"non definito\" per eliminarli dallo Store."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [stato, assegnareStato] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "nome"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"John\""
        }), ",\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "cognome"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Azzuro\""
        }), ",\n});\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "assegnareStato"
        }), "({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "nome"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Davide\""
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "middleName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Paolo\""
        }), " });\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// ({ nome: 'Davide', middleName: 'Paolo', cognome: 'Italiano' })"
        }), "\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "assegnareStato"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "stato"
          }), ") =>"]
        }), " ({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "nomePreferito"
        }), ": state.", jsx(_components.span, {
          className: "hljs-property",
          children: "nome"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "cognome"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Azzuro\""
        }), " }));\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// ({ nome: 'Davide', nomePreferito: 'Davide', middleName: 'Paolo', cognome: 'Azzuro' })"
        }), "\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Store supporta percorsi inclusi array di chiavi, intervalli di oggetti e funzioni di filtro."
    }), "\n", jsx(_components.p, {
      children: "In questo esempio, assegnareStato supporta anche l'impostazione nidificata in cui è possibile indicare il percorso della modifica. Quando nidificato, lo stato che stai aggiornando potrebbe essere altri valori non Object. Gli oggetti vengono ancora uniti ma gli altri valori (inclusi gli array) vengono sostituiti."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [stato, assegnareStato] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "counter"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "2"
        }), ",\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "elenco"
        }), ": [\n    { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "23"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "titolo"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Uccelli'"
        }), " }\n    { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "27"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "titolo"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Pesce'"
        }), " }\n  ]\n});\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "assegnareStato"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'counter'"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "c"
          }), " =>"]
        }), " c + ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), ");\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "assegnareStato"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'elenco'"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "l"
          }), " =>"]
        }), " [...l, { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "43"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "titolo"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Marsupiali'"
        }), " }]);\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "assegnareStato"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'elenco'"
        }), ", ", jsx(_components.span, {
          className: "hljs-number",
          children: "2"
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "'legerre'"
        }), ", ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), ");\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   counter: 3,"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   elenco: ["
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { id: 23, titolo: 'Uccelli' }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { id: 27, titolo: 'Pesce' }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { id: 43, titolo: 'Marsupiali', read: true }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   ]"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// }"
        }), "\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Il percorso può essere costituito da chiavi stringa, array di chiavi, oggetti iterativi ({da, a, per}) o funzioni di filtro. Dà un incredibile potere espressivo per descrivere i cambiamenti di stato."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [stato, assegnareStato] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "compiti"
        }), ": [\n    { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "compito"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Finito di lavorare'"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fatto"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " }\n    { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "compito"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Andare a fare la spesa'"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fatto"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " }\n    { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "compito"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Preparare la cena'"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fatto"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " }\n  ]\n});\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "assegnareStato"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'todos'"
        }), ", [", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ", ", jsx(_components.span, {
          className: "hljs-number",
          children: "2"
        }), "], ", jsx(_components.span, {
          className: "hljs-string",
          children: "'completato'"
        }), ", ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), ");\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   compiti: ["
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { compito: 'Finito di lavorare', fatta: true }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { compito: 'Andare a fare la spesa', fatta: false }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { compito: 'Preparare la cena', fatta: true }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   ]"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// }"
        }), "\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "assegnareStato"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'todos'"
        }), ", { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "from"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "to"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), " }, ", jsx(_components.span, {
          className: "hljs-string",
          children: "'fatta'"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "c"
          }), " =>"]
        }), " !c);\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   compiti: ["
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { compito: 'Finito di lavorare', fatta: false }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { compito: 'Andare a fare la spesa', fatta: false }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { compito: 'Preparare la cena', fatta: true }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   ]"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// }"
        }), "\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "assegnareStato"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'compiti'"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "compiti"
          }), " =>"]
        }), " compiti.", jsx(_components.span, {
          className: "hljs-property",
          children: "fatta"
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "'compito'"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "t"
          }), " =>"]
        }), " t + ", jsx(_components.span, {
          className: "hljs-string",
          children: "'!'"
        }), ")\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   compiti: ["
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { compito: 'Finito di lavorare', fatta: false }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { compito: 'Andare a fare la spesa', fatta: true }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { compito: 'Preparare la cena', fatta: true }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   ]"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// }"
        }), "\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "assegnareStato"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'compiti'"
        }), ", {}, ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "compiti"
          }), " =>"]
        }), " ({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "marked"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fatta"
        }), ": !todo.", jsx(_components.span, {
          className: "hljs-property",
          children: "fatta"
        }), " }))\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   compiti: ["
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { compito: 'Finish work', fatta: true, marked: true }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { compito: 'Go grocery shopping!', fatta: false, marked: true }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { compito: 'Make dinner!', fatta: false, marked: true }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   ]"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// }"
        }), "\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "produce",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#produce",
        children: "#"
      }), jsx(_components.code, {
        children: "produce"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " produce<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "state: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), "\n): ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["\n  state: T ", jsx(_components.span, {
              className: "hljs-keyword",
              children: "extends"
            }), " NotWrappable ? T : Store<T>\n"]
          }), ") =>"]
        }), " T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "NotWrappable"
        }), " ? T : ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "API ispirata a \"Immer\" per oggetti Solid's Store che consente la mutazione localizzata."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "produce"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "s"
          }), ") =>"]
        }), " {\n    s.", jsx(_components.span, {
          className: "hljs-property",
          children: "utente"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "nome"
        }), " = ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Franco\""
        }), ";\n    s.", jsx(_components.span, {
          className: "hljs-property",
          children: "lista"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "push"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Matita\""
        }), ");\n  })\n);\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "reconcile",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#reconcile",
        children: "#"
      }), jsx(_components.code, {
        children: "reconcile"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " reconcile<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "value"
        }), ": T | ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>,\n  options?: {\n    key?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "null"
        }), ";\n    merge?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ";\n  } = { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "key"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"id\""
        }), " }\n): ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["\n  state: T ", jsx(_components.span, {
              className: "hljs-keyword",
              children: "extends"
            }), " NotWrappable ? T : Store<T>\n"]
          }), ") =>"]
        }), " T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "NotWrappable"
        }), " ? T : ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Questa utility rileva la modifica dei dati differenziali quando non è possibile applicare aggiornamenti granulari. Utile per quando si tratta di dati immutabili da negozi o risposte API di grandi dimensioni."
    }), "\n", jsxs(_components.p, {
      children: ["La chiave viene utilizzata quando disponibile per abbinare gli elementi. Per impostazione predefinita, ", jsx(_components.code, {
        children: "merge"
      }), " false esegue controlli referenziali ove possibile per determinare l'uguaglianza e sostituisce laddove gli elementi non sono referenziali uguali. ", jsx(_components.code, {
        children: "merge"
      }), " true spinge tutte le differenze alle foglie e trasforma efficacemente i dati precedenti nel nuovo valore."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// subscribing to an observable"
        }), "\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " anulla = store.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "subscribe"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "{ todos }"
          }), ") =>"]
        }), " (\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'compiti'"
        }), ", ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "reconcile"
        }), "(todos)));\n);\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onCleanup"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "anulla"
        }), "());\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "createmutable",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createmutable",
        children: "#"
      }), jsx(_components.code, {
        children: "createMutable"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createMutable<T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "StoreNode"
        }), ">(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "state"
        }), ": T | ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>,\n  options?: { name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " }\n): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T> {\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Crea un nuovo oggetto proxy Store mutabile. Registra solo gli aggiornamenti dei trigger in caso di modifica dei valori. Il tracciamento viene gestito intercettando l'accesso alla proprietà e traccia automaticamente l'annidamento profondo tramite proxy."
    }), "\n", jsx(_components.p, {
      children: "Utile per l'integrazione di sistemi esterni o come livello di compatibilità con MobX/Vue."
    }), "\n", jsxs(_components.blockquote, {
      children: ["\n", jsxs(_components.p, {
        children: [jsx(_components.strong, {
          children: "Nota:"
        }), " uno stato mutabile può essere passato e mutato ovunque. Può rendere più difficile da seguire e più facile interrompere il flusso unidirezionale. In genere si consiglia di utilizzare invece createStore. Il modificatore di produzione può dare molti degli stessi benefici senza nessuno degli svantaggi."]
      }), "\n"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " stato = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createMutable"
        }), "(initialValue);\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// legerre valore"
        }), "\nstato.", jsx(_components.span, {
          className: "hljs-property",
          children: "valore"
        }), ";\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// assegna valore"
        }), "\nstato.", jsx(_components.span, {
          className: "hljs-property",
          children: "valore"
        }), " = ", jsx(_components.span, {
          className: "hljs-number",
          children: "5"
        }), ";\n\nstato.", jsx(_components.span, {
          className: "hljs-property",
          children: "lista"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "push"
        }), "(altroValore);\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "I mutabili supportano i setter insieme ai getter."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " persona = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createMutable"
        }), "({\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "nome"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"John\""
        }), ",\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "cognome"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Smith\""
        }), ",\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "nome"
        }), "() {\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsxs(_components.span, {
          className: "hljs-string",
          children: ["`", jsxs(_components.span, {
            className: "hljs-subst",
            children: ["${", jsx(_components.span, {
              className: "hljs-variable language_",
              children: "this"
            }), ".nome}"]
          }), " ", jsxs(_components.span, {
            className: "hljs-subst",
            children: ["${", jsx(_components.span, {
              className: "hljs-variable language_",
              children: "this"
            }), ".cognome}"]
          }), "`"]
        }), ";\n  },\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "set"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "cognome"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "value"
        }), ") {\n    [", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "this"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "nome"
        }), ", ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "this"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "cognome"
        }), "] = valore.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "split"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\" \""
        }), ");\n  },\n});\n"]
      })
    }), "\n", jsxs(_components.h1, {
      id: "api-dei-componenti",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#api-dei-componenti",
        children: "#"
      }), "API dei componenti"]
    }), "\n", jsxs(_components.h2, {
      id: "createcontext",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createcontext",
        children: "#"
      }), jsx(_components.code, {
        children: "createContext"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Context"
        }), "<T> {\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "symbol"
        }), ";\n  ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Provider"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["props: { value: T; children: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "any"
            }), " }"]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ";\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "defaultValue"
        }), ": T;\n}\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createContext<T>(defaultValue?: T): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Context"
        }), "<T | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), ">;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Il contesto fornisce una forma di iniezione di dipendenza in Solid. Viene utilizzato per evitare di dover passare dati come oggetti di scena attraverso componenti intermedi."
    }), "\n", jsxs(_components.p, {
      children: ["Questa funzione crea un nuovo oggetto di contesto che può essere utilizzato con ", jsx(_components.code, {
        children: "useContext"
      }), " e fornisce il flusso di controllo ", jsx(_components.code, {
        children: "Provider"
      }), ". Il contesto predefinito viene utilizzato quando nella gerarchia non viene trovato alcun \"provider\"."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ContestoContatore"
        }), " = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createContext"
        }), "([{ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "conta"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), " }, {}]);\n\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "Fornitrice"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "props"
        }), ") {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [stato, assegnaStato] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "conta"
        }), ": props.", jsx(_components.span, {
          className: "hljs-property",
          children: "conta"
        }), " || ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), " });\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " store = [\n    stato,\n    {\n      ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "incremento"
        }), "(", jsx(_components.span, {
          className: "hljs-params"
        }), ") {\n        ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "assegnaStato"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"conta\""
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "c"
          }), ") =>"]
        }), " c + ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), ");\n      },\n      ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "decremento"
        }), "(", jsx(_components.span, {
          className: "hljs-params"
        }), ") {\n        ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "assegnaStato"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"conta\""
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "c"
          }), ") =>"]
        }), " c - ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), ");\n      },\n    },\n  ];\n\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " (\n    ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Fornitrice.Provider"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "value"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{store}"
            }), ">"]
          }), "{props.children}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "Fornitrice.Provider"
            }), ">"]
          })]
        }), "\n  );\n}\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Il valore fornito al provider viene passato a \"useContext\" così com'è. Ciò significa che il wrapping come espressione reattiva non funzionerà. Dovresti passare direttamente a Segnali e Negozi invece di accedervi in JSX."
    }), "\n", jsxs(_components.h2, {
      id: "usecontext",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#usecontext",
        children: "#"
      }), jsx(_components.code, {
        children: "useContext"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " useContext<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "context"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Context"
        }), "<T>): T;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Utilizzato per acquisire il contesto e consente il passaggio profondo degli oggetti di scena senza doverli passare attraverso ciascuna funzione del componente."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [stato, { incremento, decremento }] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "useContext"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ContestoContatore"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "children",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#children",
        children: "#"
      }), jsx(_components.code, {
        children: "children"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "children"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["fn: () => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "any"
          })]
        }), "): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Utilizzato per semplificare l'interazione con ", jsx(_components.code, {
        children: "props.children"
      }), ". Questo helper risolve qualsiasi reattività nidificata e restituisce un memo. È l'approccio consigliato per utilizzare ", jsx(_components.code, {
        children: "props.children"
      }), " per qualsiasi cosa diversa dal passaggio diretto a JSX."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " list = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "children"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " props.", jsx(_components.span, {
          className: "hljs-property",
          children: "children"
        }), ");\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// fare qualcosa con loro"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "lista"
        }), "());\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "lazy",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#lazy",
        children: "#"
      }), jsx(_components.code, {
        children: "lazy"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " lazy<T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Component"
        }), "<", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ">>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<{ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "default"
        }), ": T }>\n): T & { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "preload"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<T> };\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Utilizzato per caricare lentamente i componenti per consentire la suddivisione del codice. I componenti non vengono caricati fino al rendering. I componenti caricati pigri possono essere usati come la loro controparte importata staticamente, ricevendo oggetti di scena ecc... I componenti pigri attivano ", jsx(_components.code, {
        children: "<Suspense>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// avvolgere l'importazione"
        }), "\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ComponenteA"
        }), " = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "lazy"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "import"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"./ComponentA\""
        }), "));\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// utilizzare in JSX"
        }), "\n", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "ComponenteA"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "title"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{props.title}"
            }), " />"]
          })
        }), ";\n"]
      })
    }), "\n", jsxs(_components.h1, {
      id: "primitive-secondarie",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#primitive-secondarie",
        children: "#"
      }), "Primitive secondarie"]
    }), "\n", jsx(_components.p, {
      children: "Probabilmente non ti serviranno per la tua prima app, ma questi utili strumenti per avere."
    }), "\n", jsxs(_components.h2, {
      id: "createdeferred",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createdeferred",
        children: "#"
      }), jsx(_components.code, {
        children: "createDeferred"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createDeferred<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "source"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T,\n  options?: {\n    timeoutMs?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "number"
        }), ";\n    name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\n    equals?: ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " | (", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev: T, next: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ");\n  }\n): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Crea un readonly che notifica le modifiche downstream solo quando il browser è inattivo. ", jsx(_components.code, {
        children: "timeoutMs"
      }), " è il tempo massimo di attesa prima di forzare l'aggiornamento."]
    }), "\n", jsxs(_components.h2, {
      id: "createcomputed",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createcomputed",
        children: "#"
      }), jsx(_components.code, {
        children: "createComputed"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createComputed<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v: T"
          }), ") =>"]
        }), " T,\n  value?: T,\n  options?: { name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " }\n): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Crea una proprietà di sola lettura che notifica le modifiche downstream solo quando il browser è inattivo. ", jsx(_components.code, {
        children: "timeoutMs"
      }), " è il tempo massimo di attesa prima di forzare l'aggiornamento."]
    }), "\n", jsxs(_components.h2, {
      id: "createrendereffect",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createrendereffect",
        children: "#"
      }), jsx(_components.code, {
        children: "createRenderEffect"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createRenderEffect<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v: T"
          }), ") =>"]
        }), " T,\n  value?: T,\n  options?: { name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " }\n): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Crea un nuovo calcolo che tiene traccia automaticamente delle dipendenze. Viene eseguito anche durante la fase di rendering poiché gli elementi DOM vengono creati e aggiornati ma non necessariamente collegati. Tutti gli aggiornamenti DOM interni vengono eseguiti in questo momento."
    }), "\n", jsxs(_components.h2, {
      id: "createselector",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createselector",
        children: "#"
      }), jsx(_components.code, {
        children: "createSelector"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createSelector<T, U>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "source"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T,\n  fn?: ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "a: U, b: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ",\n  options?: { name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " }\n): ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "k: U"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Questo crea un segnale condizionale che notifica agli abbonati solo quando entrano o escono dalla loro chiave che corrisponde al valore. Utile per lo stato di selezione delegata. Poiché esegue l'operazione O(2) invece di O(n)."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " selezionata = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSelector"
        }), "(selectedId);\n\n", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "For"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "each"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{lista()}"
            }), ">"]
          }), "\n  {(item) => (\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "li"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "classList"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{{"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "attivo:"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "selezionata"
            }), "(", jsx(_components.span, {
              className: "hljs-attr",
              children: "item.id"
            }), ") }}>"]
          }), "{articolo.nome}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "li"
            }), ">"]
          }), "\n  )}\n", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "For"
            }), ">"]
          })]
        }), ";\n"]
      })
    }), "\n", jsxs(_components.h1, {
      id: "rendering",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#rendering",
        children: "#"
      }), "Rendering"]
    }), "\n", jsxs(_components.p, {
      children: ["Queste importazioni sono esposte da ", jsx(_components.code, {
        children: "solid-js/web"
      }), "."]
    }), "\n", jsxs(_components.h2, {
      id: "render",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#render",
        children: "#"
      }), jsx(_components.code, {
        children: "render"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "render"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "\n  code: () => JSX.Element,\n  element: MountableElement\n"
        }), "): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Questo è il punto di ingresso dell'app del browser. Fornisce una definizione o una funzione del componente di primo livello e un elemento su cui montare. È consigliabile che questo elemento rimanga vuoto poiché la funzione di eliminazione restituita cancellerà tutti i figli."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " smaltire = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "render"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ", ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "document"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "getElementById"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"app\""
        }), "));\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "hydrate",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#hydrate",
        children: "#"
      }), jsx(_components.code, {
        children: "hydrate"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "hydrate"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "\n  fn: () => JSX.Element,\n  node: MountableElement\n"
        }), "): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Questo metodo è simile a \"render\" tranne che tenta di reidratare ciò che è già stato reso al DOM."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " dispose = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "hydrate"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ", ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "document"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "getElementById"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"app\""
        }), "));\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "rendertostring",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#rendertostring",
        children: "#"
      }), jsx(_components.code, {
        children: "renderToString"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " renderToString<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T,\n  options?: {\n    eventNames?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), "[];\n    nonce?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\n  }\n): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Esegue il rendering in una stringa in modo sincrono. La funzione genera anche un tag script per l'idratazione progressiva. Le opzioni includono nomi di eventi da ascoltare prima che la pagina venga caricata e riprodurre su Hydratio. Come bonus viene fornito un nonce da mettere sul tag script."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " html = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "renderToString"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "rendertostringasync",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#rendertostringasync",
        children: "#"
      }), jsx(_components.code, {
        children: "renderToStringAsync"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " renderToStringAsync<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T,\n  options?: {\n    eventNames?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), "[];\n    timeoutMs?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "number"
        }), ";\n    nonce?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\n  }\n): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ">;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Uguale a ", jsx(_components.code, {
        children: "renderToString"
      }), " tranne che attenderà che tutti i limiti di ", jsx(_components.code, {
        children: "<Suspense>"
      }), " vengano risolti prima di restituire i risultati. I dati delle risorse vengono serializzati automaticamente nel tag script e vengono idratati al caricamento del client."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " html = ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "await"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "renderToStringAsync"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "pipetonodewritable",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#pipetonodewritable",
        children: "#"
      }), jsx(_components.code, {
        children: "pipeToNodeWritable"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "PipeToWritableResults"
        }), " = {\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "startWriting"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "write"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "string"
            })]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "abort"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n};\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " pipeToNodeWritable<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T,\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "writable"
        }), ": { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "write"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "string"
            })]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), " },\n  options?: {\n    eventNames?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), "[];\n    nonce?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\n    noScript?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ";\n    onReady?: ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "r: PipeToWritableResults"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n    onComplete?: ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "r: PipeToWritableResults"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), " | ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ">;\n  }\n): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Questo metodo esegue il rendering in un flusso Node. Esegue il rendering del contenuto in modo sincrono, inclusi eventuali segnaposto di fallback di Suspense. Quindi continua a trasmettere i dati da qualsiasi risorsa asincrona man mano che viene completata."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "pipeToNodeWritable"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ", res);\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["L'opzione ", jsx(_components.code, {
        children: "onReady"
      }), " è utile per scrivere nel flusso attorno al rendering dell'app principale. Ricorda se usi \"onReady\" per chiamare manualmente \"startWriting\"."]
    }), "\n", jsxs(_components.h2, {
      id: "pipetowritable",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#pipetowritable",
        children: "#"
      }), jsx(_components.code, {
        children: "pipeToWritable"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "PipeToWritableResults"
        }), " = {\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "write"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "string"
            })]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "abort"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "script"
        }), ": ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\n};\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " pipeToWritable<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T,\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "writable"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "WritableStream"
        }), ",\n  options?: {\n    eventNames?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), "[];\n    nonce?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\n    noScript?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ";\n    onReady?: ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["\n      writable: { write: (v: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "string"
            }), ") => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "void"
            }), " },\n      r: PipeToWritableResults\n    "]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n    onComplete?: ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["\n      writable: { write: (v: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "string"
            }), ") => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "void"
            }), " },\n      r: PipeToWritableResults\n    "]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n  }\n): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Questo metodo esegue il rendering in un flusso web. Esegue il rendering del contenuto in modo sincrono, inclusi eventuali segnaposto di fallback di Suspense. Quindi continua a trasmettere i dati da qualsiasi risorsa asincrona man mano che viene completata."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " { readable, writable } = ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "new"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "TransformStream"
        }), "();\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "pipeToWritable"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ", writable);\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["L'opzione ", jsx(_components.code, {
        children: "onReady"
      }), " è utile per scrivere nel flusso attorno al rendering dell'app principale. Ricorda se usi \"onReady\" per chiamare manualmente \"startWriting\"."]
    }), "\n", jsxs(_components.h2, {
      id: "isserver",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#isserver",
        children: "#"
      }), jsx(_components.code, {
        children: "isServer"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " ", jsx(_components.span, {
          className: "hljs-attr",
          children: "isServer"
        }), ": ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Ciò indica che il codice viene eseguito come server o bundle del browser. Poiché i runtime sottostanti esportano, questo valore fornisce un valore booleano costante e consente ai bundler di eliminare il codice e le importazioni utilizzate dai rispettivi bundle."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "if"
        }), " (isServer) {\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Non arriverò mai al bundle del browser"
        }), "\n} ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "else"
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Non verrà eseguito sul server;"
        }), "\n}\n"]
      })
    }), "\n", jsxs(_components.h1, {
      id: "controllo-del-flusso",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#controllo-del-flusso",
        children: "#"
      }), "Controllo del flusso"]
    }), "\n", jsxs(_components.p, {
      children: ["Solid utilizza componenti per il controllo del flusso. Affinché la reattività sia performante, dobbiamo controllare come vengono creati gli elementi. Ad esempio con le liste una semplice ", jsx(_components.code, {
        children: "mappa"
      }), " è inefficiente. Mappa sempre tutto. Ciò significa funzioni di supporto."]
    }), "\n", jsx(_components.p, {
      children: "Il wrapping di questi in componenti è un modo conveniente per modelli concisi e consente agli utenti di comporre e costruire i propri flussi di controllo."
    }), "\n", jsxs(_components.p, {
      children: ["Questi flussi di controllo integrati verranno importati automaticamente. Tutti tranne \"Portal\" e \"Dynamic\" vengono esportati da \"solid-js\". Quei due che sono specifici del DOM vengono esportati da ", jsx(_components.code, {
        children: "solid-js/web"
      }), "."]
    }), "\n", jsxs(_components.blockquote, {
      children: ["\n", jsx(_components.p, {
        children: "Nota: tutte le funzioni figlio di callback/render del flusso di controllo non sono tracciabili. Ciò consente la creazione dello stato di nidificazione e isola meglio le reazioni."
      }), "\n"]
    }), "\n", jsxs(_components.h2, {
      id: "for",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#for",
        children: "#"
      }), jsx(_components.code, {
        children: "<For>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), "<T, U ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ">(", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": {\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "each"
        }), ": ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "readonly"
        }), " T[];\n  fallback?: ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "children"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["item: T, index: () => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "number"
            })]
          }), ") =>"]
        }), " U;\n}): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " U[];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Semplice flusso di controllo del ciclo con chiave referenziale."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), " each={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "list"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\n  {", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "item"
          }), ") =>"]
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "{item}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), ">\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Il secondo argomento opzionale è un segnale di indice:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), " each={stato.", jsx(_components.span, {
          className: "hljs-property",
          children: "lista"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Caricamento in corso...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\n  {", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "articolo, numero"
          }), ") =>"]
        }), " (\n    ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "\n      #{numero()} {articolo}\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "\n  )}\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "show",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#show",
        children: "#"
      }), jsx(_components.code, {
        children: "<Show>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), "<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": {\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "when"
        }), ": T | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "null"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), ";\n  fallback?: ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "children"
        }), ": ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), " | (", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "item: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ");\n}): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Il flusso di controllo Show viene utilizzato per il rendering condizionale di parte della vista. È simile all'operatore ternario (", jsx(_components.code, {
        children: "a ? b : c"
      }), ") ma è ideale per creare modelli JSX."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), " when={stato.", jsx(_components.span, {
          className: "hljs-property",
          children: "contaggio"
        }), " > ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Caricamento in corso...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "I miei contenuti", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), ">\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Show può anche essere usato come un modo per inserire blocchi in un modello di dati specifico. Ad esempio, la funzione viene rieseguita ogni volta che il modello utente viene sostituito."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), " when={stato.", jsx(_components.span, {
          className: "hljs-property",
          children: "persona"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Caricamento in corso...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\n  {", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "persona"
          }), ") =>"]
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "{persona.nome}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "switchmatch",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#switchmatch",
        children: "#"
      }), jsx(_components.code, {
        children: "<Switch>"
      }), "/", jsx(_components.code, {
        children: "<Match>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "Switch"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "props: {\n  fallback?: JSX.Element;\n  children: JSX.Element;\n}"
        }), "): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MatchProps"
        }), "<T> = {\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "when"
        }), ": T | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "null"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), ";\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "children"
        }), ": ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), " | (", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "item: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ");\n};\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Match"
        }), "<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MatchProps"
        }), "<T>);\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Il componente Switch è utile quando sono presenti più di 2 condizioni di mutua esclusione. Può essere usato per fare cose come un semplice routing."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Switch"
        }), " fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Non trovato", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Match"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "when"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{stato.route"
            }), " === ", jsx(_components.span, {
              className: "hljs-string",
              children: "\"home\""
            }), "}>"]
          }), "\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Home"
            }), " />"]
          }), "\n  ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "Match"
            }), ">"]
          })]
        }), "\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Match"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "when"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{stato.route"
            }), " === ", jsx(_components.span, {
              className: "hljs-string",
              children: "\"settings\""
            }), "}>"]
          }), "\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Settings"
            }), " />"]
          }), "\n  ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "Match"
            }), ">"]
          })]
        }), "\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Switch"
        }), ">\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Match supporta anche i figli di funzione per fungere da flusso con chiave."
    }), "\n", jsxs(_components.h2, {
      id: "index",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#index",
        children: "#"
      }), jsx(_components.code, {
        children: "<Index>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), "<T, U ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ">(", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": {\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "each"
        }), ": ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "readonly"
        }), " T[];\n  fallback?: ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "children"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["item: () => T, index: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "number"
            })]
          }), ") =>"]
        }), " U;\n}): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " U[];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Questo componente viene utilizzato per l'iterazione di elenchi senza chiave (righe con chiave per l'indice). Questo è utile quando non c'è una chiave concettuale. Ad esempio se i dati sono primitivi ed è l'indice che è fisso piuttosto che il valore."
    }), "\n", jsx(_components.p, {
      children: "L'oggetto è un segnale:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), " each={stato.", jsx(_components.span, {
          className: "hljs-property",
          children: "lista"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Caricamento in corso...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\n  {", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "articolo"
          }), ") =>"]
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "{articolo()}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), ">\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Il secondo argomento facoltativo è un numero di indice:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), " each={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "list"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Caricamento in corso...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\n  {", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "articolo, numero"
          }), ") =>"]
        }), " (\n    ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "\n      #{numero} {item()}\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "\n  )}\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "errorboundary",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#errorboundary",
        children: "#"
      }), jsx(_components.code, {
        children: "<ErrorBoundary>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "ErrorBoundary"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["props: {\n  fallback: JSX.Element | ((err: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "any"
          }), ", reset: () => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "void"
          }), ") => JSX.Element);\n  children: JSX.Element;\n}"]
        }), "): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Contiene errori non rilevati e rende il contenuto di fallback."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ErrorBoundary"
        }), " fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Qualcosa è andato terribilmente storto", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\n  ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "MioComponente"
            }), " />"]
          })
        }), "\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ErrorBoundary"
        }), ">\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Supporta anche il modulo di callback che passa per errore e una funzione di ripristino."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ErrorBoundary"
        }), "\n  fallback={", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "err, reset"
          }), ") =>"]
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "onClick"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{reset}"
            }), ">"]
          }), "Error: {err}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}\n>\n  ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "MioComponente"
            }), " />"]
          })
        }), "\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ErrorBoundary"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "suspense",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#suspense",
        children: "#"
      }), jsx(_components.code, {
        children: "<Suspense>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "Suspense"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "props: {\n  fallback?: JSX.Element;\n  children: JSX.Element;\n}"
        }), "): ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Un componente che tiene traccia di tutte le risorse lette sotto di esso e mostra uno stato segnaposto di fallback fino a quando non vengono risolte. Ciò che rende \"Suspense\" diverso da \"Show\" è che non è bloccante in quanto entrambi i rami esistono contemporaneamente anche se non sono attualmente nel DOM."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Suspense"
        }), " fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Caricamento in corso...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\n  ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "AsyncComponent"
            }), " />"]
          })
        }), "\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Suspense"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "suspenselist-experimental",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#suspenselist-experimental",
        children: "#"
      }), jsx(_components.code, {
        children: "<SuspenseList>"
      }), " (Experimental)"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "SuspenseList"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["props: {\n  children: JSX.Element;\n  revealOrder: ", jsx(_components.span, {
            className: "hljs-string",
            children: "\"forwards\""
          }), " | ", jsx(_components.span, {
            className: "hljs-string",
            children: "\"backwards\""
          }), " | ", jsx(_components.span, {
            className: "hljs-string",
            children: "\"together\""
          }), ";\n  tail?: ", jsx(_components.span, {
            className: "hljs-string",
            children: "\"collapsed\""
          }), " | ", jsx(_components.span, {
            className: "hljs-string",
            children: "\"hidden\""
          }), ";\n}"]
        }), "): ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "SuspenseList"
      }), " coordina più componenti paralleli ", jsx(_components.code, {
        children: "Suspense"
      }), " e ", jsx(_components.code, {
        children: "SuspenseList"
      }), ". Controlla l'ordine in cui il contenuto viene rivelato per ridurre il thrashing del layout e ha un'opzione per comprimere o nascondere gli stati di fallback."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "SuspenseList"
        }), " revealOrder=", jsx(_components.span, {
          className: "hljs-string",
          children: "\"forwards\""
        }), " tail=", jsx(_components.span, {
          className: "hljs-string",
          children: "\"collapsed\""
        }), ">\n  ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "ProfileDetails"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "persona"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{resource.persona}"
            }), " />"]
          })
        }), "\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Suspense"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "fallback"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{"
            }), "<", jsx(_components.span, {
              className: "hljs-attr",
              children: "h2"
            }), ">"]
          }), "Caricamento post...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "h2"
            }), ">"]
          }), "}>\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "ProfileTimeline"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "posts"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{resource.posts}"
            }), " />"]
          }), "\n  ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "Suspense"
            }), ">"]
          })]
        }), "\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Suspense"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "fallback"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{"
            }), "<", jsx(_components.span, {
              className: "hljs-attr",
              children: "h2"
            }), ">"]
          }), "Caricamento di fatti divertenti...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "h2"
            }), ">"]
          }), "}>\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "ProfileTrivia"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "trivia"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{resource.trivia}"
            }), " />"]
          }), "\n  ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "Suspense"
            }), ">"]
          })]
        }), "\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "SuspenseList"
        }), ">\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "SuspenseList è ancora sperimentale e non ha il pieno supporto SSR."
    }), "\n", jsxs(_components.h2, {
      id: "dynamic",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#dynamic",
        children: "#"
      }), jsx(_components.code, {
        children: "<Dynamic>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Dynamic"
        }), "<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": T & {\n    children?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ";\n    component?: ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Component"
        }), "<T> | ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " | keyof ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "IntrinsicElements"
        }), ";\n  }\n): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Questo componente ti consente di inserire un Componente o un tag arbitrario e gli passa gli oggetti di scena."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Dynamic"
        }), " component={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "component"
        }), "} someProp={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "something"
        }), "} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "portal",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#portal",
        children: "#"
      }), jsx(_components.code, {
        children: "<Portal>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "Portal"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["props: {\n  mount?: Node;\n  useShadow?: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "boolean"
          }), ";\n  isSVG?: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "boolean"
          }), ";\n  children: JSX.Element;\n}"]
        }), "): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Text"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Questo inserisce l'elemento nel nodo di montaggio. Utile per inserire Modali al di fuori del layout di pagina. Gli eventi si propagano ancora attraverso la Gerarchia dei componenti."
    }), "\n", jsxs(_components.p, {
      children: ["Il portale è montato in un ", jsx(_components.code, {
        children: "<div>"
      }), " a meno che la destinazione non sia l'intestazione del documento. \"useShadow\" posiziona l'elemento in una Shadow Root per l'isolamento dello stile e \"isSVG\" è richiesto se si inserisce in un elemento SVG in modo che \"", "\" non sia inserito."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Portal"
        }), " mount={", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "document"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "getElementById"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"modal\""
        }), ")}>\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "My Content", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Portal"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h1, {
      id: "special-jsx-attributes",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#special-jsx-attributes",
        children: "#"
      }), "Special JSX Attributes"]
    }), "\n", jsx(_components.p, {
      children: "Solidi tentativi di attenersi il più possibile alle convenzioni DOM. La maggior parte degli oggetti di scena viene trattata come attributi su elementi nativi e proprietà su Web Components. Tuttavia, alcuni di loro hanno un comportamento speciale."
    }), "\n", jsx(_components.p, {
      children: "Per gli attributi dello spazio dei nomi personalizzati con TypeScript è necessario estendere lo spazio dei nomi JSX di Solid:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "declare"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "module"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "namespace"
        }), " JSX {\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Directives"
        }), " {\n      ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// use:____"
        }), "\n    }\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ExplicitProperties"
        }), " {\n      ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// prop:____"
        }), "\n    }\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ExplicitAttributes"
        }), " {\n      ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// attr:____"
        }), "\n    }\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "CustomEvents"
        }), " {\n      ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// on:____"
        }), "\n    }\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "CustomCaptureEvents"
        }), " {\n      ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// oncapture:____"
        }), "\n    }\n  }\n}\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "ref",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#ref",
        children: "#"
      }), jsx(_components.code, {
        children: "ref"
      })]
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "Refs"
      }), " sono un modo per accedere agli elementi DOM sottostanti nel nostro JSX. È vero che si potrebbe assegnare un elemento a una variabile. È più ottimale lasciare i componenti nel flusso di JSX. I riferimenti vengono assegnati al momento del rendering ma prima che gli elementi siano collegati al DOM. Sono disponibili in 2 gusti."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// compito semplice"
        }), "\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "let"
        }), " mioDiv;\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// usa onMount o createEffect per leggere dopo esserti connesso a DOM"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onMount"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(mioDiv));\n", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "ref"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{mioDiv}"
            }), " />"]
          })
        }), "\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// o funzione di callback (chiamata prima della connessione al DOM)"
        }), "\n", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "ref"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{el"
            }), " =>"]
          }), " console.log(el)} />"]
        }), "\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "Refs"
      }), " può essere utilizzato anche sui componenti. Devono ancora essere attaccati dall'altra parte."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "MyComp"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "props"
        }), ") {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "ref"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{props.ref}"
            }), " />"]
          })
        }), ";\n}\n\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "App"
        }), "(", jsx(_components.span, {
          className: "hljs-params"
        }), ") {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "let"
        }), " mioDiv;\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onMount"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(mioDiv.", jsx(_components.span, {
          className: "hljs-property",
          children: "clientWidth"
        }), "));\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "MyComp"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "ref"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{mioDiv}"
            }), " />"]
          })
        }), ";\n}\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "classlist",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#classlist",
        children: "#"
      }), jsx(_components.code, {
        children: "classList"
      })]
    }), "\n", jsxs(_components.p, {
      children: ["Funzione di supporto che sfrutta ", jsx(_components.code, {
        children: "element.classList.toggle"
      }), ". Prende un oggetto le cui chiavi sono nomi di classe e le assegna quando il valore risolto è vero."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<div\n  classList={{ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "active"
        }), ": state.", jsx(_components.span, {
          className: "hljs-property",
          children: "active"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "editing"
        }), ": state.", jsx(_components.span, {
          className: "hljs-property",
          children: "currentId"
        }), " === row.", jsx(_components.span, {
          className: "hljs-property",
          children: "id"
        }), " }}\n/>\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "style",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#style",
        children: "#"
      }), jsx(_components.code, {
        children: "style"
      })]
    }), "\n", jsxs(_components.p, {
      children: ["L'helper di stile di Solid funziona con una stringa o con un oggetto. A differenza della versione di React, Solid usa ", jsx(_components.code, {
        children: "element.style.setProperty"
      }), ". Ciò significa che può supportare CSS vars. Significa anche che usiamo le versioni inferiori delle proprietà con trattini. Ciò porta effettivamente a prestazioni e coerenza migliori con l'output SSR."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// string"
        }), "\n<div style={", jsxs(_components.span, {
          className: "hljs-string",
          children: ["`color: green; background-color: ", jsx(_components.span, {
            className: "hljs-subst",
            children: "${stato.colore}"
          }), "; height: ", jsx(_components.span, {
            className: "hljs-subst",
            children: "${stato.altezza}"
          }), "px`"]
        }), "} />\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// object"
        }), "\n", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "style"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{{"
            }), "\n  ", jsx(_components.span, {
              className: "hljs-attr",
              children: "color:"
            }), " \"", jsx(_components.span, {
              className: "hljs-attr",
              children: "green"
            }), "\",\n  \"", jsx(_components.span, {
              className: "hljs-attr",
              children: "background-color"
            }), "\"", jsx(_components.span, {
              className: "hljs-attr",
              children: ":"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "stato.colore"
            }), ",\n  ", jsx(_components.span, {
              className: "hljs-attr",
              children: "height:"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "stato.altezza"
            }), " + \"", jsx(_components.span, {
              className: "hljs-attr",
              children: "px"
            }), "\" }}\n/>"]
          })
        }), "\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// css variabile"
        }), "\n", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "style"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{{"
            }), " \"", jsx(_components.span, {
              className: "hljs-attr",
              children: "--my-custom-color"
            }), "\"", jsx(_components.span, {
              className: "hljs-attr",
              children: ":"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "stato.temaColore"
            }), " }} />"]
          })
        }), "\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "innerhtmltextcontent",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#innerhtmltextcontent",
        children: "#"
      }), jsx(_components.code, {
        children: "innerHTML"
      }), "/", jsx(_components.code, {
        children: "textContent"
      })]
    }), "\n", jsxs(_components.p, {
      children: ["Questi metodi funzionano come i loro equivalenti di proprietà. Imposta una stringa e verranno impostati. ", jsx(_components.strong, {
        children: "Fai attenzione!!"
      }), " Impostando ", jsx(_components.code, {
        children: "innerHTML"
      }), " con tutti i dati che potrebbero essere esposti a un utente finale in quanto potrebbe essere un vettore per attacchi dannosi. ", jsx(_components.code, {
        children: "textContent"
      }), ", anche se generalmente non è necessario, è in realtà un'ottimizzazione delle prestazioni quando si sa che i bambini saranno solo testo poiché ignora la routine di diffing generica."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<div textContent={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "text"
        }), "} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "on___",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#on___",
        children: "#"
      }), jsx(_components.code, {
        children: "on___"
      })]
    }), "\n", jsx(_components.p, {
      children: "I gestori di eventi in Solid in genere assumono la forma di \"onclick\" o \"onClick\" a seconda dello stile. Il nome dell'evento è sempre minuscolo. Solid utilizza la delega di eventi semi-sintetici per eventi dell'interfaccia utente comuni composti e bolle. Ciò migliora le prestazioni per questi eventi comuni."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<div onClick={", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "e"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(e.", jsx(_components.span, {
          className: "hljs-property",
          children: "currentTarget"
        }), ")} />\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Solid supporta anche il passaggio di un array al gestore eventi per associare un valore al primo argomento del gestore eventi. Questo non usa ", jsx(_components.code, {
        children: "bind"
      }), " o crea una chiusura aggiuntiva, quindi è un modo altamente ottimizzato per delegare gli eventi."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "handler"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "itemId, e"
        }), ") {\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "/*...*/"
        }), "\n}\n\n<ul>\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "For"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "each"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{state.list}"
            }), ">"]
          }), "{(item) => ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "li"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "onClick"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{[handler,"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "item.id"
            }), "]} />"]
          }), "}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "For"
            }), ">"]
          })]
        }), "\n</ul>;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Gli eventi non possono essere rimbalzati e le associazioni non sono reattive. In genere è più costoso collegare/scollegare gli ascoltatori. Poiché gli eventi vengono chiamati naturalmente, non è necessaria la reattività, è sufficiente scorciatoia per il gestore se lo si desidera."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// se definito chiamalo, altrimenti no."
        }), "\n<div onClick={", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " props.", jsx(_components.span, {
          className: "hljs-property",
          children: "handleClick"
        }), "?.()} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "on___oncapture___",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#on___oncapture___",
        children: "#"
      }), jsx(_components.code, {
        children: "on:___"
      }), "/", jsx(_components.code, {
        children: "oncapture:___"
      })]
    }), "\n", jsx(_components.p, {
      children: "Per tutti gli altri eventi anche con nomi insoliti. Forse anche gli eventi che non desideri vengano delegati agli eventi dello spazio dei nomi. Questo aggiunge semplicemente un listener di eventi alla lettera."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<div ", jsx(_components.span, {
          className: "hljs-attr",
          children: "on"
        }), ":", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Weird"
        }), "-", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Event"
        }), "={", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "e"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "alert"
        }), "(e.", jsx(_components.span, {
          className: "hljs-property",
          children: "detail"
        }), ")} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "use___",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#use___",
        children: "#"
      }), jsx(_components.code, {
        children: "use:___"
      })]
    }), "\n", jsxs(_components.p, {
      children: ["Queste sono direttive personalizzate. In un certo senso questa è solo sintassi zucchero su ", jsx(_components.code, {
        children: "ref"
      }), " ma ci consente di collegare facilmente più direttive a un singolo elemento. Una direttiva è semplicemente una funzione con la seguente firma:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "directive"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["element: Element, accessor: () => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "any"
          })]
        }), "): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Queste funzioni vengono eseguite in fase di rendering e puoi fare quello che vuoi in esse. Crea segnali ed effetti, registra funzioni di pulizia, qualunque cosa desideri."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [name, setName] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"\""
        }), ");\n\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "model"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "el, value"
        }), ") {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [field, setField] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "value"
        }), "();\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createRenderEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " (el.", jsx(_components.span, {
          className: "hljs-property",
          children: "value"
        }), " = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "field"
        }), "()));\n  el.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "addEventListener"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"input\""
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "e"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setField"
        }), "(e.", jsx(_components.span, {
          className: "hljs-property",
          children: "target"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "value"
        }), "));\n}\n\n<input type=", jsx(_components.span, {
          className: "hljs-string",
          children: "\"text\""
        }), " ", jsx(_components.span, {
          className: "hljs-attr",
          children: "use"
        }), ":model={[name, setName]} />;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Per registrarlo con TypeScript, assicurati di estendere lo spazio dei nomi JSX."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "declare"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "module"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "namespace"
        }), " JSX {\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Directives"
        }), " {\n      ", jsx(_components.span, {
          className: "hljs-attr",
          children: "model"
        }), ": [", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "any"
            })]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), "];\n    }\n  }\n}\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "prop___",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#prop___",
        children: "#"
      }), jsx(_components.code, {
        children: "prop:___"
      })]
    }), "\n", jsx(_components.p, {
      children: "Questo obbliga a trattare il prop come una proprietà invece che come un attributo."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<div ", jsx(_components.span, {
          className: "hljs-attr",
          children: "prop"
        }), ":scrollTop={props.", jsx(_components.span, {
          className: "hljs-property",
          children: "scrollPos"
        }), " + ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"px\""
        }), "} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "attr___",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#attr___",
        children: "#"
      }), jsx(_components.code, {
        children: "attr:___"
      })]
    }), "\n", jsx(_components.p, {
      children: "Forza l'oggetto a essere trattato come un attributo anziché come una proprietà. Utile per i componenti Web in cui si desidera impostare gli attributi."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<mio-componente ", jsx(_components.span, {
          className: "hljs-attr",
          children: "attr"
        }), ":status={props.", jsx(_components.span, {
          className: "hljs-property",
          children: "status"
        }), "} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "-once-",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#-once-",
        children: "#"
      }), jsx(_components.code, {
        children: "/* @once */"
      })]
    }), "\n", jsx(_components.p, {
      children: "Il compilatore di Solid utilizza una semplice euristica per il wrapping reattivo e la valutazione pigra delle espressioni JSX. L'elemento in questione contiene una chiamata di funzione, un accesso a una proprietà o forse JSX? Se sì, lo avvolgiamo in un getter quando viene passato ai componenti o in un effetto se passato agli elementi nativi."
    }), "\n", jsxs(_components.p, {
      children: ["Sapendo questo, possiamo ridurre il sovraccarico di cose che sappiamo non cambieranno mai semplicemente accedendovi al di fuori del JSX. Una variabile semplice non verrà mai racchiusa. Possiamo anche dire al compilatore di non avvolgerli iniziando l'espressione con un decoratore di commenti ", jsx(_components.code, {
        children: "/_ @once _/"
      }), "."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MioComponent"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "static"
        }), "={", jsx(_components.span, {
          className: "hljs-comment",
          children: "/*@once*/"
        }), " stato.", jsx(_components.span, {
          className: "hljs-property",
          children: "nonAggioner"
        }), "ò} />\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Funziona anche sui bambini."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MioComponent"
        }), ">{", jsx(_components.span, {
          className: "hljs-comment",
          children: "/*@once*/"
        }), " stato.", jsx(_components.span, {
          className: "hljs-property",
          children: "nonAggioner"
        }), "ò}</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MioComponent"
        }), ">\n"]
      })
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
