import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [{
  "depth": 1,
  "value": "响应式基础",
  "children": [{
    "depth": 2,
    "value": "createSignal",
    "children": []
  }, {
    "depth": 2,
    "value": "createEffect",
    "children": []
  }, {
    "depth": 2,
    "value": "createMemo",
    "children": []
  }, {
    "depth": 2,
    "value": "createResource",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "生命周期",
  "children": [{
    "depth": 2,
    "value": "onMount",
    "children": []
  }, {
    "depth": 2,
    "value": "onCleanup",
    "children": []
  }, {
    "depth": 2,
    "value": "onError",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "响应式工具函数",
  "children": [{
    "depth": 2,
    "value": "untrack",
    "children": []
  }, {
    "depth": 2,
    "value": "batch",
    "children": []
  }, {
    "depth": 2,
    "value": "on",
    "children": []
  }, {
    "depth": 2,
    "value": "createRoot",
    "children": []
  }, {
    "depth": 2,
    "value": "mergeProps",
    "children": []
  }, {
    "depth": 2,
    "value": "splitProps",
    "children": []
  }, {
    "depth": 2,
    "value": "useTransition",
    "children": []
  }, {
    "depth": 2,
    "value": "observable",
    "children": []
  }, {
    "depth": 2,
    "value": "mapArray",
    "children": []
  }, {
    "depth": 2,
    "value": "indexArray",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "状态存储",
  "children": [{
    "depth": 2,
    "value": "createStore",
    "children": [{
      "depth": 3,
      "value": "Getters",
      "children": []
    }, {
      "depth": 3,
      "value": "更新 Store",
      "children": []
    }]
  }, {
    "depth": 2,
    "value": "produce",
    "children": []
  }, {
    "depth": 2,
    "value": "reconcile",
    "children": []
  }, {
    "depth": 2,
    "value": "createMutable",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "组件 API",
  "children": [{
    "depth": 2,
    "value": "createContext",
    "children": []
  }, {
    "depth": 2,
    "value": "useContext",
    "children": []
  }, {
    "depth": 2,
    "value": "children",
    "children": []
  }, {
    "depth": 2,
    "value": "lazy",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "第二 Primitive",
  "children": [{
    "depth": 2,
    "value": "createDeferred",
    "children": []
  }, {
    "depth": 2,
    "value": "createComputed",
    "children": []
  }, {
    "depth": 2,
    "value": "createRenderEffect",
    "children": []
  }, {
    "depth": 2,
    "value": "createSelector",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "渲染",
  "children": [{
    "depth": 2,
    "value": "render",
    "children": []
  }, {
    "depth": 2,
    "value": "hydrate",
    "children": []
  }, {
    "depth": 2,
    "value": "renderToString",
    "children": []
  }, {
    "depth": 2,
    "value": "renderToStringAsync",
    "children": []
  }, {
    "depth": 2,
    "value": "pipeToNodeWritable",
    "children": []
  }, {
    "depth": 2,
    "value": "pipeToWritable",
    "children": []
  }, {
    "depth": 2,
    "value": "isServer",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "控制流",
  "children": [{
    "depth": 2,
    "value": "<For>",
    "children": []
  }, {
    "depth": 2,
    "value": "<Show>",
    "children": []
  }, {
    "depth": 2,
    "value": "<Switch>/<Match>",
    "children": []
  }, {
    "depth": 2,
    "value": "<Index>",
    "children": []
  }, {
    "depth": 2,
    "value": "<ErrorBoundary>",
    "children": []
  }, {
    "depth": 2,
    "value": "<Suspense>",
    "children": []
  }, {
    "depth": 2,
    "value": "<SuspenseList> (实验)",
    "children": []
  }, {
    "depth": 2,
    "value": "<Dynamic>",
    "children": []
  }, {
    "depth": 2,
    "value": "<Portal>",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "特殊的 JSX 属性",
  "children": [{
    "depth": 2,
    "value": "ref",
    "children": []
  }, {
    "depth": 2,
    "value": "classList",
    "children": []
  }, {
    "depth": 2,
    "value": "style",
    "children": []
  }, {
    "depth": 2,
    "value": "innerHTML/textContent",
    "children": []
  }, {
    "depth": 2,
    "value": "on___",
    "children": []
  }, {
    "depth": 2,
    "value": "on:___/oncapture:___",
    "children": []
  }, {
    "depth": 2,
    "value": "use:___",
    "children": []
  }, {
    "depth": 2,
    "value": "prop:___",
    "children": []
  }, {
    "depth": 2,
    "value": "attr:___",
    "children": []
  }, {
    "depth": 2,
    "value": "/* @once */",
    "children": []
  }]
}];
function _createMdxContent(props) {
  const _components = Object.assign({
    h1: "h1",
    a: "a",
    h2: "h2",
    code: "code",
    pre: "pre",
    span: "span",
    p: "p",
    blockquote: "blockquote",
    h3: "h3",
    strong: "strong"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsxs(_components.h1, {
      id: "响应式基础",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#响应式基础",
        children: "#"
      }), "响应式基础"]
    }), "\n", jsxs(_components.h2, {
      id: "createsignal",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createsignal",
        children: "#"
      }), jsx(_components.code, {
        children: "createSignal"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createSignal<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "value"
        }), ": T,\n  options?: { name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), "; equals?: ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " | (", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev: T, next: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ") }\n): [", jsx(_components.span, {
          className: "hljs-attr",
          children: "get"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T, ", jsx(_components.span, {
          className: "hljs-attr",
          children: "set"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v: T"
          }), ") =>"]
        }), " T];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "这是最基本的反应式原语 (primitive)，用于跟踪随时间变化的单个值。 create 函数返回一对 get 和 set 函数来访问和更新信号 (signal)。"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [getValue, setValue] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(initialValue);\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 读取值"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "getValue"
        }), "();\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 设置值"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setValue"
        }), "(nextValue);\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 使用 setter 函数设置值"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setValue"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev"
          }), ") =>"]
        }), " prev + next);\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["如果您希望值对更新做出响应，请记住在跟踪范围内访问信号。跟踪范围是传递给计算的函数，如 ", jsx(_components.code, {
        children: "createEffect"
      }), " 或 JSX 表达式。"]
    }), "\n", jsxs(_components.blockquote, {
      children: ["\n", jsx(_components.p, {
        children: "如果你希望在 Signal 中存储函数，则必须使用函数的形式："
      }), "\n", jsx(_components.pre, {
        children: jsxs(_components.code, {
          className: "hljs language-js",
          children: [jsx(_components.span, {
            className: "hljs-title function_",
            children: "setValue"
          }), "(", jsx(_components.span, {
            className: "hljs-function",
            children: "() =>"
          }), " myFunction);\n"]
        })
      }), "\n"]
    }), "\n", jsxs(_components.h2, {
      id: "createeffect",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createeffect",
        children: "#"
      }), jsx(_components.code, {
        children: "createEffect"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createEffect<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v: T"
          }), ") =>"]
        }), " T,\n  value?: T,\n  options?: { name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " }\n): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["创建一个新的计算来自动跟踪依赖项并在依赖项发生变化的每次渲染之后运行。非常适合使用 ", jsx(_components.code, {
        children: "ref"
      }), "s 和管理其他副作用。"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [a, setA] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(initialValue);\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 依赖于 signal `a` 的 effect"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "doSideEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "a"
        }), "()));\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "effect 函数可以拿到上次执行返回的值。可以在第二个可选参数设置该值得初始化值。这可以让我们不用创建额外闭包的情况下就可以进行差异对比。"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev"
          }), ") =>"]
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " sum = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "a"
        }), "() + ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "b"
        }), "();\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "if"
        }), " (sum !== prev) ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(sum);\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " sum;\n}, ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "creatememo",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#creatememo",
        children: "#"
      }), jsx(_components.code, {
        children: "createMemo"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createMemo<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v: T"
          }), ") =>"]
        }), " T,\n  value?: T,\n  options?: { name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), "; equals?: ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " | (", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev: T, next: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ") }\n): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "创建一个只读派生的 signal，每当执行代码的依赖项被更新时，该 signal 就会重新计算其值。"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " getValue = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createMemo"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "computeExpensiveValue"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "a"
        }), "(), ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "b"
        }), "()));\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 读取"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "getValue"
        }), "();\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "使用 memo 函数上次执行返回的值调用 memo 函数。该值可以初始化为可选的第二个参数。这对于减少计算很有用。"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " sum = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createMemo"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "input"
        }), "() + prev, ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "createresource",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createresource",
        children: "#"
      }), jsx(_components.code, {
        children: "createResource"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ResourceReturn"
        }), "<T> = [\n  {\n    (): T | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), ";\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "loading"
        }), ": ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ";\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "error"
        }), ": ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ";\n  },\n  {\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "mutate"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: T | ", jsx(_components.span, {
              className: "hljs-literal",
              children: "undefined"
            })]
          }), ") =>"]
        }), " T | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), ";\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "refetch"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n  }\n];\n\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createResource<T, U = ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), ">(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fetcher"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["k: U, getPrev: () => T | ", jsx(_components.span, {
              className: "hljs-literal",
              children: "undefined"
            })]
          }), ") =>"]
        }), " T | ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<T>,\n  options?: { initialValue?: T; name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " }\n): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ResourceReturn"
        }), "<T>;\n\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createResource<T, U>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "source"
        }), ": U | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "null"
        }), " | (", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " U | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "null"
        }), "),\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fetcher"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["k: U, getPrev: () => T | ", jsx(_components.span, {
              className: "hljs-literal",
              children: "undefined"
            })]
          }), ") =>"]
        }), " T | ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<T>,\n  options?: { initialValue?: T; name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " }\n): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ResourceReturn"
        }), "<T>;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["创建一个可以管理异步请求的 signal。", jsx(_components.code, {
        children: "fetcher"
      }), " 是一个异步函数，它接收 ", jsx(_components.code, {
        children: "source"
      }), " 的返回值（如果提供）并返回一个 Promise，其解析值设置在 resource 中。fetcher 不是响应式的，因此如果希望它运行多次，请传入第一个可选参数。如果源解析为 false、null 或 undefined，则不会执行获取操作。"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [data, { mutate, refetch }] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createResource"
        }), "(getQuery, fetchData);\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 读取值"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "data"
        }), "();\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 检查是否加载中"
        }), "\ndata.", jsx(_components.span, {
          className: "hljs-property",
          children: "loading"
        }), ";\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 检查是否加载错误"
        }), "\ndata.", jsx(_components.span, {
          className: "hljs-property",
          children: "error"
        }), ";\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 无需创建 promise 直接设置值"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mutate"
        }), "(optimisticValue);\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 重新执行最后的请求"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "refetch"
        }), "();\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "loading"
      }), " 和 ", jsx(_components.code, {
        children: "error"
      }), " 是响应式 getter，可以被跟踪。"]
    }), "\n", jsxs(_components.h1, {
      id: "生命周期",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#生命周期",
        children: "#"
      }), "生命周期"]
    }), "\n", jsxs(_components.h2, {
      id: "onmount",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#onmount",
        children: "#"
      }), jsx(_components.code, {
        children: "onMount"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onMount"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["fn: () => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "void"
          })]
        }), "): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["注册一个在初始话化渲染和元素挂载完成后运行的方法。非常适合使用 ", jsx(_components.code, {
        children: "ref"
      }), " 或者管理其他的一次性副作用。它相当于一个没有任何依赖的 ", jsx(_components.code, {
        children: "createEffect"
      }), "。"]
    }), "\n", jsxs(_components.h2, {
      id: "oncleanup",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#oncleanup",
        children: "#"
      }), jsx(_components.code, {
        children: "onCleanup"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onCleanup"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["fn: () => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "void"
          })]
        }), "): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "注册一个清理方法，它会在当前响应范围内执行销毁或重新计算时候被触发。可用于任何组件或 Effect。"
    }), "\n", jsxs(_components.h2, {
      id: "onerror",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#onerror",
        children: "#"
      }), jsx(_components.code, {
        children: "onError"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onError"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["fn: (err: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "any"
          }), ") => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "void"
          })]
        }), "): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "注册一个错误处理函数，它会在子作用域抛出错误时执行。但是最近的范围的错误处理函数才会执行。重新抛出可以向上触发。"
    }), "\n", jsxs(_components.h1, {
      id: "响应式工具函数",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#响应式工具函数",
        children: "#"
      }), "响应式工具函数"]
    }), "\n", jsx(_components.p, {
      children: "有了这些工具函数，我们可以更好地调度更新以及控制响应式跟踪行为。"
    }), "\n", jsxs(_components.h2, {
      id: "untrack",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#untrack",
        children: "#"
      }), jsx(_components.code, {
        children: "untrack"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " untrack<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T): T;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "忽略跟踪执行代码块中的任何依赖项并返回值。"
    }), "\n", jsxs(_components.h2, {
      id: "batch",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#batch",
        children: "#"
      }), jsx(_components.code, {
        children: "batch"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " batch<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T): T;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "暂持块作用域内提交的更新直到块作用域结束以避免不必要的重新计算。这意味着下一行的读取到的值还没有被更新。Solid Store 的 set 方法和 Effect 会自动将它们的代码打包成一个批次来进行更新。"
    }), "\n", jsxs(_components.h2, {
      id: "on",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#on",
        children: "#"
      }), jsx(_components.code, {
        children: "on"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " on<T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Array"
        }), "<", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), "> | (", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), "), U>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "deps"
        }), ": T,\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "input: T, prevInput: T, prevValue?: U"
          }), ") =>"]
        }), " U,\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "options"
        }), ": { defer?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), " } = {}\n): ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prevValue?: U"
          }), ") =>"]
        }), " U | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "on"
      }), " 主要用来将其传递到计算行为中以使其依赖项更加清晰明了。如果传递依赖项是数组，则 ", jsx(_components.code, {
        children: "input"
      }), " 和 ", jsx(_components.code, {
        children: "prevInput"
      }), " 也是数组。"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "on"
        }), "(a, ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(v, ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "b"
        }), "())));\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 等同于"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " v = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "a"
        }), "();\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "untrack"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(v, ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "b"
        }), "()));\n});\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "你也可以不用立即执行计算，而是通过将 defer 选项设置为 true 来选择仅在更改时运行计算。"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// 不会立即运行"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "on"
        }), "(a, ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(v), { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "defer"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), " }));\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setA"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"new\""
        }), "); ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 现在会运行了"
        }), "\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "createroot",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createroot",
        children: "#"
      }), jsx(_components.code, {
        children: "createRoot"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createRoot<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["dispose: () => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "void"
            })]
          }), ") =>"]
        }), " T): T;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "创建一个崭新的，不自动处理的，非跟踪上下文。在嵌套响应式上下文的情况下，如果你不希望在父级重新求值时释放资源这个特性会很有用。这是一种强大的缓存模式。"
    }), "\n", jsxs(_components.p, {
      children: ["所有 Solid 代码都应被 createRoot 包裹，因为它们确保释放所有内存/计算。通常你不需要担心这个，因为 ", jsx(_components.code, {
        children: "createRoot"
      }), " 被嵌入到所有的 ", jsx(_components.code, {
        children: "render"
      }), " 入口函数中。"]
    }), "\n", jsxs(_components.h2, {
      id: "mergeprops",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#mergeprops",
        children: "#"
      }), jsx(_components.code, {
        children: "mergeProps"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mergeProps"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["...sources: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "any"
          })]
        }), "): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["响应式对象的合并 ", jsx(_components.code, {
        children: "merge"
      }), " 方法。用于为组件设置默认 props 以防调用者不提供这些属性值。或者克隆包含响应式的属性的 props 对象。"]
    }), "\n", jsx(_components.p, {
      children: "此方法的运作原理是使用代理并以相反的顺序解析属性。这可以对首次合并 props 对象时不存在的属性进行动态跟踪。"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// 设置默认 props"
        }), "\nprops = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mergeProps"
        }), "({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "name"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Smith\""
        }), " }, props);\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 克隆 props"
        }), "\nnewProps = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mergeProps"
        }), "(props);\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 合并 props"
        }), "\nprops = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mergeProps"
        }), "(props, otherProps);\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "splitprops",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#splitprops",
        children: "#"
      }), jsx(_components.code, {
        children: "splitProps"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " splitProps<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": T,\n  ...", jsx(_components.span, {
          className: "hljs-attr",
          children: "keys"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Array"
        }), "<(keyof T)[]>\n): [...", jsx(_components.span, {
          className: "hljs-attr",
          children: "parts"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Partial"
        }), "<T>];\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "splitProps"
      }), " 是解构的替代品。", jsx(_components.code, {
        children: "splitProps"
      }), " 在保持响应性的同时通过键来拆分响应式对象。"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [local, others] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "splitProps"
        }), "(props, [", jsx(_components.span, {
          className: "hljs-string",
          children: "\"children\""
        }), "]);\n\n<>\n  <Child {...others} />\n  <div>{local.children}<div>\n</>\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "usetransition",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#usetransition",
        children: "#"
      }), jsx(_components.code, {
        children: "useTransition"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "useTransition"
        }), "(", jsx(_components.span, {
          className: "hljs-params"
        }), "): [\n  ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ",\n  ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["fn: () => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "void"
            }), ", cb?: () => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "void"
            })]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), "\n];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "用于在所有异步处理完成后在延迟提交事务中批量异步更新。这与 Suspense 有所关联，并且仅跟踪在 Suspense 边界下读取的资源。"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [isPending, start] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "useTransition"
        }), "();\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 检查是否在 transition 中"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "isPending"
        }), "();\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 包裹在 transition 中"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "start"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setSignal"
        }), "(newValue), ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-comment",
          children: "/* transition 完成 */"
        }), ")\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "observable",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#observable",
        children: "#"
      }), jsx(_components.code, {
        children: "observable"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " observable<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "input"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Observable"
        }), "<T>;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["这个方法接受一个 signal 并产生一个简单的 Observable。从你选择的 Observable 库中使用它，通常使用 ", jsx(_components.code, {
        children: "from"
      }), " 操作符。"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"rxjs\""
        }), ";\n\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [s, set] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ");\n\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " obsv$ = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "from"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "observable"
        }), "(s));\n\nobsv$.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "subscribe"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(v));\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "maparray",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#maparray",
        children: "#"
      }), jsx(_components.code, {
        children: "mapArray"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " mapArray<T, U>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "list"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "readonly"
        }), " T[],\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "mapFn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: T, i: () => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "number"
            })]
          }), ") =>"]
        }), " U\n): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " U[];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "响应式映射工具函数，通过引用缓存每个子项，以减少不必要的映射更新。它只为每个值运行一次映射函数，然后根据需要移动或删除它。index 参数是一个 signal。映射函数本身没有被跟踪。"
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "mapArray"
      }), " 也是", jsx(_components.code, {
        children: "<For>"
      }), " 组件控制流程的底层工具函数"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " mapped = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mapArray"
        }), "(source, ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "model"
          }), ") =>"]
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [name, setName] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(model.", jsx(_components.span, {
          className: "hljs-property",
          children: "name"
        }), ");\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [description, setDescription] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(model.", jsx(_components.span, {
          className: "hljs-property",
          children: "description"
        }), ");\n\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " {\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": model.", jsx(_components.span, {
          className: "hljs-property",
          children: "id"
        }), ",\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "name"
        }), "() {\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "name"
        }), "();\n    },\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "description"
        }), "() {\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "description"
        }), "();\n    }\n    setName,\n    setDescription\n  }\n});\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "indexarray",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#indexarray",
        children: "#"
      }), jsx(_components.code, {
        children: "indexArray"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " indexArray<T, U>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "list"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "readonly"
        }), " T[],\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "mapFn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: () => T, i: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "number"
            })]
          }), ") =>"]
        }), " U\n): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " U[];\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["类似于 ", jsx(_components.code, {
        children: "mapArray"
      }), "，除了它按索引映射。每个子项都是 signal，索引是常量。"]
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "indexArray"
      }), " 也是 ", jsx(_components.code, {
        children: "<Index>"
      }), " 组件控制流程的底层工具函数"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " mapped = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "indexArray"
        }), "(source, ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "model"
          }), ") =>"]
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " {\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "id"
        }), "() {\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "model"
        }), "().", jsx(_components.span, {
          className: "hljs-property",
          children: "id"
        }), "\n    }\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "firstInitial"
        }), "() {\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "model"
        }), "().", jsx(_components.span, {
          className: "hljs-property",
          children: "firstName"
        }), "[", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), "];\n    },\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fullName"
        }), "() {\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsxs(_components.span, {
          className: "hljs-string",
          children: ["`", jsx(_components.span, {
            className: "hljs-subst",
            children: "${model().firstName}"
          }), " ", jsx(_components.span, {
            className: "hljs-subst",
            children: "${model().lastName}"
          }), "`"]
        }), ";\n    },\n  }\n});\n"]
      })
    }), "\n", jsxs(_components.h1, {
      id: "状态存储",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#状态存储",
        children: "#"
      }), "状态存储"]
    }), "\n", jsxs(_components.p, {
      children: ["以下 API 可以从", jsx(_components.code, {
        children: "solid-js/store"
      }), " 导入。"]
    }), "\n", jsxs(_components.h2, {
      id: "createstore",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createstore",
        children: "#"
      }), jsx(_components.code, {
        children: "createStore"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createStore<T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "StoreNode"
        }), ">(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "state"
        }), ": T | ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>,\n  options?: { name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " }\n): [", jsx(_components.span, {
          className: "hljs-attr",
          children: "get"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>, ", jsx(_components.span, {
          className: "hljs-attr",
          children: "set"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "SetStoreFunction"
        }), "<T>];\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "createStore"
      }), " 创建一个 Signal 树作为代理，允许独立跟踪嵌套数据结构中的各个值。create 函数返回一个只读代理对象和一个 setter 函数。"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "(initialValue);\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 读取值"
        }), "\nstate.", jsx(_components.span, {
          className: "hljs-property",
          children: "someValue"
        }), ";\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 设置值"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "merge"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"thisValue\""
        }), " });\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"path\""
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"to\""
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"value\""
        }), ", newValue);\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Store 代理对象仅跟踪访问的属性。并在访问 Store 时递归地生成嵌套数据上的嵌套 Store 对象。但是它只包装数组和普通对象。类不包装。所以像 ", jsx(_components.code, {
        children: "Date"
      }), "、", jsx(_components.code, {
        children: "HTMLElement"
      }), "、", jsx(_components.code, {
        children: "RegExp"
      }), "、", jsx(_components.code, {
        children: "Map"
      }), "、", jsx(_components.code, {
        children: "Set"
      }), " 之类的东西都不是响应式粒度的。此外，如果不访问对象上的属性，则无法跟踪顶级状态对象。因此它不适用于迭代对象，因为添加新键或索引无法触发更新。因此，将数组放在键上，而不是尝试使用状态对象本身。"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// 将列表作为状态对象的键"
        }), "\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "list"
        }), ": [] });\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 访问 state 对象上的 `list` 属性"
        }), "\n", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "For"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "each"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{state.list}"
            }), ">"]
          }), "{item => /*...*/}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "For"
            }), ">"]
          })]
        }), "\n"]
      })
    }), "\n", jsxs(_components.h3, {
      id: "getters",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#getters",
        children: "#"
      }), "Getters"]
    }), "\n", jsx(_components.p, {
      children: "Store 对象支持使用 getter 来存储计算值。"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "user"
        }), ": {\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "firstName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"John\""
        }), ",\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "lastName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Smith\""
        }), ",\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fullName"
        }), "() {\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsxs(_components.span, {
          className: "hljs-string",
          children: ["`", jsxs(_components.span, {
            className: "hljs-subst",
            children: ["${", jsx(_components.span, {
              className: "hljs-variable language_",
              children: "this"
            }), ".firstName}"]
          }), " ", jsxs(_components.span, {
            className: "hljs-subst",
            children: ["${", jsx(_components.span, {
              className: "hljs-variable language_",
              children: "this"
            }), ".lastName}"]
          }), "`"]
        }), ";\n    },\n  },\n});\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "以下是简单的 getter，所以如果你想缓存一个值，你仍然需要使用 Memo；"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "let"
        }), " fullName;\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "user"
        }), ": {\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "firstName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"John\""
        }), ",\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "lastName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Smith\""
        }), ",\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fullName"
        }), "() {\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fullName"
        }), "();\n    },\n  },\n});\nfullName = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createMemo"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsxs(_components.span, {
          className: "hljs-string",
          children: ["`", jsx(_components.span, {
            className: "hljs-subst",
            children: "${state.user.firstName}"
          }), " ", jsx(_components.span, {
            className: "hljs-subst",
            children: "${state.user.lastName}"
          }), "`"]
        }), ");\n"]
      })
    }), "\n", jsxs(_components.h3, {
      id: "更新-store",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#更新-store",
        children: "#"
      }), "更新 Store"]
    }), "\n", jsxs(_components.p, {
      children: ["更改状态可以采用传递先前状态并返回新状态或值的函数的形式。对象总是浅合并的。将值设置为 ", jsx(_components.code, {
        children: "undefined"
      }), " 以将属性从 Store 中删除。"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "firstName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"John\""
        }), ",\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "lastName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Miller\""
        }), ",\n});\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "firstName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Johnny\""
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "middleName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Lee\""
        }), " });\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// ({ firstName: 'Johnny', middleName: 'Lee', lastName: 'Miller' })"
        }), "\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "state"
          }), ") =>"]
        }), " ({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "preferredName"
        }), ": state.", jsx(_components.span, {
          className: "hljs-property",
          children: "firstName"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "lastName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Milner\""
        }), " }));\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// ({ firstName: 'Johnny', preferredName: 'Johnny', middleName: 'Lee', lastName: 'Milner' })"
        }), "\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "setState 支持的路径包括键数组、对象范围和过滤器函数。"
    }), "\n", jsx(_components.p, {
      children: "setState 还支持嵌套设置，你可以在其中指明要修改的路径。在嵌套的情况下，要更新的状态可能是非对象值。对象仍然合并，但其他值（包括数组）将会被替换。"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "counter"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "2"
        }), ",\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "list"
        }), ": [\n    { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "23"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "title"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Birds'"
        }), " }\n    { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "27"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "title"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Fish'"
        }), " }\n  ]\n});\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'counter'"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "c"
          }), " =>"]
        }), " c + ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), ");\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'list'"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "l"
          }), " =>"]
        }), " [...l, {", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "43"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "title"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Marsupials'"
        }), "}]);\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'list'"
        }), ", ", jsx(_components.span, {
          className: "hljs-number",
          children: "2"
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "'read'"
        }), ", ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), ");\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   counter: 3,"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   list: ["
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { id: 23, title: 'Birds' }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { id: 27, title: 'Fish' }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { id: 43, title: 'Marsupials', read: true }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   ]"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// }"
        }), "\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "路径可以是字符串键、键数组、迭代对象（{from、to、by}）或过滤器函数。这为描述状态变化提供了令人难以置信的表达能力。"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "todos"
        }), ": [\n    { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "task"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Finish work'"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "completed"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " }\n    { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "task"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Go grocery shopping'"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "completed"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " }\n    { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "task"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Make dinner'"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "completed"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " }\n  ]\n});\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'todos'"
        }), ", [", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ", ", jsx(_components.span, {
          className: "hljs-number",
          children: "2"
        }), "], ", jsx(_components.span, {
          className: "hljs-string",
          children: "'completed'"
        }), ", ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), ");\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   todos: ["
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Finish work', completed: true }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Go grocery shopping', completed: false }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Make dinner', completed: true }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   ]"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// }"
        }), "\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'todos'"
        }), ", { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "from"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "to"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), " }, ", jsx(_components.span, {
          className: "hljs-string",
          children: "'completed'"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "c"
          }), " =>"]
        }), " !c);\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   todos: ["
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Finish work', completed: false }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Go grocery shopping', completed: true }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Make dinner', completed: true }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   ]"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// }"
        }), "\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'todos'"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "todo"
          }), " =>"]
        }), " todo.", jsx(_components.span, {
          className: "hljs-property",
          children: "completed"
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "'task'"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "t"
          }), " =>"]
        }), " t + ", jsx(_components.span, {
          className: "hljs-string",
          children: "'!'"
        }), ")\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   todos: ["
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Finish work', completed: false }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Go grocery shopping!', completed: true }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Make dinner!', completed: true }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   ]"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// }"
        }), "\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'todos'"
        }), ", {}, ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "todo"
          }), " =>"]
        }), " ({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "marked"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "completed"
        }), ": !todo.", jsx(_components.span, {
          className: "hljs-property",
          children: "completed"
        }), " }))\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   todos: ["
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Finish work', completed: true, marked: true }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Go grocery shopping!', completed: false, marked: true }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Make dinner!', completed: false, marked: true }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   ]"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// }"
        }), "\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "produce",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#produce",
        children: "#"
      }), jsx(_components.code, {
        children: "produce"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " produce<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "state: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), "\n): ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["\n  state: T ", jsx(_components.span, {
              className: "hljs-keyword",
              children: "extends"
            }), " NotWrappable ? T : Store<T>\n"]
          }), ") =>"]
        }), " T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "NotWrappable"
        }), " ? T : ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Immer 启发了 Solid 的 Store 对象的 ", jsx(_components.code, {
        children: "produce"
      }), " API，它允许本地修改状态。"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "produce"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "s"
          }), ") =>"]
        }), " {\n    s.", jsx(_components.span, {
          className: "hljs-property",
          children: "user"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "name"
        }), " = ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Frank\""
        }), ";\n    s.", jsx(_components.span, {
          className: "hljs-property",
          children: "list"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "push"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Pencil Crayon\""
        }), ");\n  })\n);\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "reconcile",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#reconcile",
        children: "#"
      }), jsx(_components.code, {
        children: "reconcile"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " reconcile<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "value"
        }), ": T | ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>,\n  options?: {\n    key?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "null"
        }), ";\n    merge?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ";\n  } = { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "key"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"id\""
        }), " }\n): ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["\n  state: T ", jsx(_components.span, {
              className: "hljs-keyword",
              children: "extends"
            }), " NotWrappable ? T : Store<T>\n"]
          }), ") =>"]
        }), " T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "NotWrappable"
        }), " ? T : ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["当对比数据变更时，我们不能应用粒度更新。", jsx(_components.code, {
        children: "reconcile"
      }), " 在处理来自 store 或巨大 API 响应这些不可变数据时很有用。"]
    }), "\n", jsxs(_components.p, {
      children: ["该键在可用于匹配项目时使用。默认情况下，", jsx(_components.code, {
        children: "merge"
      }), " 为 ", jsx(_components.code, {
        children: "false"
      }), " 会在可能的情况下进行引用检查以确定相等，并替换不引用相等的数据。", jsx(_components.code, {
        children: "merge"
      }), " 为 ", jsx(_components.code, {
        children: "true"
      }), " 时，", jsx(_components.code, {
        children: "reconcile"
      }), " 会将所有差异推送到叶子节点，并高效地将先前的数据修改为新值。"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// 订阅一个 observable"
        }), "\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " unsubscribe = store.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "subscribe"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "{ todos }"
          }), ") =>"]
        }), " (\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'todos'"
        }), ", ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "reconcile"
        }), "(todos)));\n);\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onCleanup"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "unsubscribe"
        }), "());\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "createmutable",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createmutable",
        children: "#"
      }), jsx(_components.code, {
        children: "createMutable"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createMutable<T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "StoreNode"
        }), ">(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "state"
        }), ": T | ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>,\n  options?: { name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " }\n): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T> {\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "createMutable"
      }), " 创建一个新的可变 Store 代理对象。Store 仅在值更改时触发更新。跟踪是通过拦截属性访问来完成的，并通过代理自动跟踪深度嵌套数据。"]
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "createMutable"
      }), " 用于集成外部系统或作为与 MobX/Vue 的兼容层会很有用。"]
    }), "\n", jsxs(_components.blockquote, {
      children: ["\n", jsxs(_components.p, {
        children: [jsx(_components.strong, {
          children: "注意："
        }), " 由于可变状态可以在任何地方传递和修改，这会使其更难以遵循并且更容易打破单向流，因此通常建议使用 ", jsx(_components.code, {
          children: "createStore"
        }), " 代替。", jsx(_components.code, {
          children: "produce"
        }), " 修饰符可以提供许多相同的好处而没有任何缺点。"]
      }), "\n"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " state = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createMutable"
        }), "(initialValue);\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 读取值"
        }), "\nstate.", jsx(_components.span, {
          className: "hljs-property",
          children: "someValue"
        }), ";\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 设置值"
        }), "\nstate.", jsx(_components.span, {
          className: "hljs-property",
          children: "someValue"
        }), " = ", jsx(_components.span, {
          className: "hljs-number",
          children: "5"
        }), ";\n\nstate.", jsx(_components.span, {
          className: "hljs-property",
          children: "list"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "push"
        }), "(anotherValue);\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Mutables 支持同时设置 setter 和 getter。"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " user = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createMutable"
        }), "({\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "firstName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"John\""
        }), ",\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "lastName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Smith\""
        }), ",\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fullName"
        }), "() {\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsxs(_components.span, {
          className: "hljs-string",
          children: ["`", jsxs(_components.span, {
            className: "hljs-subst",
            children: ["${", jsx(_components.span, {
              className: "hljs-variable language_",
              children: "this"
            }), ".firstName}"]
          }), " ", jsxs(_components.span, {
            className: "hljs-subst",
            children: ["${", jsx(_components.span, {
              className: "hljs-variable language_",
              children: "this"
            }), ".lastName}"]
          }), "`"]
        }), ";\n  },\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "set"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fullName"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "value"
        }), ") {\n    [", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "this"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "firstName"
        }), ", ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "this"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "lastName"
        }), "] = value.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "split"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\" \""
        }), ");\n  },\n});\n"]
      })
    }), "\n", jsxs(_components.h1, {
      id: "组件-api",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#组件-api",
        children: "#"
      }), "组件 API"]
    }), "\n", jsxs(_components.h2, {
      id: "createcontext",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createcontext",
        children: "#"
      }), jsx(_components.code, {
        children: "createContext"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Context"
        }), "<T> {\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "symbol"
        }), ";\n  ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Provider"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["props: { value: T; children: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "any"
            }), " }"]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ";\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "defaultValue"
        }), ": T;\n}\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createContext<T>(defaultValue?: T): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Context"
        }), "<T | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), ">;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "在 Solid 中，Context 提供了一种依赖注入的形式。它可以用来避免需要通过中间组件将数据作为 props 传递的情况。"
    }), "\n", jsxs(_components.p, {
      children: ["该函数创建了一个新的上下文对象，可以通过 ", jsx(_components.code, {
        children: "useContext"
      }), " 来使用，并提供 ", jsx(_components.code, {
        children: "Provider"
      }), " 控制流。当在层次结构的上方找不到 ", jsx(_components.code, {
        children: "Provider"
      }), " 时，将使用默认上下文。"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "CounterContext"
        }), " = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createContext"
        }), "([{ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "count"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), " }, {}]);\n\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "CounterProvider"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "props"
        }), ") {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "count"
        }), ": props.", jsx(_components.span, {
          className: "hljs-property",
          children: "count"
        }), " || ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), " });\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " store = [\n    state,\n    {\n      ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "increment"
        }), "(", jsx(_components.span, {
          className: "hljs-params"
        }), ") {\n        ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"count\""
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "c"
          }), ") =>"]
        }), " c + ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), ");\n      },\n      ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "decrement"
        }), "(", jsx(_components.span, {
          className: "hljs-params"
        }), ") {\n        ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"count\""
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "c"
          }), ") =>"]
        }), " c - ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), ");\n      },\n    },\n  ];\n\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " (\n    ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "CounterContext.Provider"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "value"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{store}"
            }), ">"]
          }), "\n      {props.children}\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "CounterContext.Provider"
            }), ">"]
          })]
        }), "\n  );\n}\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["传递给 provider 的值按原样传递给 ", jsx(_components.code, {
        children: "useContext"
      }), "。这意味着包装为响应性的表达式将不起作用。你应该直接传入 Signal 和 Store，而不是在 JSX 中访问它们。"]
    }), "\n", jsxs(_components.h2, {
      id: "usecontext",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#usecontext",
        children: "#"
      }), jsx(_components.code, {
        children: "useContext"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " useContext<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "context"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Context"
        }), "<T>): T;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "用于获取上下文以允许深层传递 props，而不必通过每个组件函数传递它们。"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, { increment, decrement }] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "useContext"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "CounterContext"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "children",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#children",
        children: "#"
      }), jsx(_components.code, {
        children: "children"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "children"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["fn: () => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "any"
          })]
        }), "): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Used to make it easier to interact with ", jsx(_components.code, {
        children: "props.children"
      }), ". This helper resolves any nested reactivity and returns a memo. Recommended approach to using ", jsx(_components.code, {
        children: "props.children"
      }), " in anything other than passing directly through to JSX."]
    }), "\n", jsxs(_components.p, {
      children: ["用于更容易地与", jsx(_components.code, {
        children: "props.children"
      }), "交互。这个工具函数解决层级嵌套的响应性并返回一个 Memo。除了直接传递值给 JSX 这种情况之外，推荐使用 ", jsx(_components.code, {
        children: "props.children"
      }), " 的方法。"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " list = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "children"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " props.", jsx(_components.span, {
          className: "hljs-property",
          children: "children"
        }), ");\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 用 list 做点什么"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "list"
        }), "());\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "lazy",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#lazy",
        children: "#"
      }), jsx(_components.code, {
        children: "lazy"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " lazy<T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Component"
        }), "<", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ">>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<{ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "default"
        }), ": T }>\n): T & { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "preload"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<T> };\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["用于延迟加载组件以允许代码拆分。组件在渲染之前不会加载。延迟加载的组件可以与静态导入的组件同样使用，接收 props 等...... 延迟加载的组件还会触发 ", jsx(_components.code, {
        children: "<Suspense>"
      }), "。"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// 保证导入"
        }), "\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ComponentA"
        }), " = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "lazy"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "import"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"./ComponentA\""
        }), "));\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 在 JSX 中使用"
        }), "\n", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "ComponentA"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "title"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{props.title}"
            }), " />"]
          })
        }), ";\n"]
      })
    }), "\n", jsxs(_components.h1, {
      id: "第二-primitive",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#第二-primitive",
        children: "#"
      }), "第二 Primitive"]
    }), "\n", jsx(_components.p, {
      children: "你的第一个 app 可能不需要它们，但这些有用的工具也不可或缺。"
    }), "\n", jsxs(_components.h2, {
      id: "createdeferred",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createdeferred",
        children: "#"
      }), jsx(_components.code, {
        children: "createDeferred"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createDeferred<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "source"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T,\n  options?: {\n    timeoutMs?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "number"
        }), ";\n    name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\n    equals?: ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " | (", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev: T, next: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ");\n  }\n): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["创建只读值，仅在浏览器空闲时通知下游变更。", jsx(_components.code, {
        children: "timeoutMs"
      }), " 是强制更新前等待的最长时间。"]
    }), "\n", jsxs(_components.h2, {
      id: "createcomputed",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createcomputed",
        children: "#"
      }), jsx(_components.code, {
        children: "createComputed"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createComputed<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v: T"
          }), ") =>"]
        }), " T,\n  value?: T,\n  options?: { name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " }\n): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["创建一个新的计算，自动跟踪依赖关系并在渲染之前立即运行。使用它来编写其他响应式 primitive。如果可能，请使用 ", jsx(_components.code, {
        children: "createMemo"
      }), " 代替，因为写入中间更新的 signal 可能会导致其他计算需要重新计算。"]
    }), "\n", jsxs(_components.h2, {
      id: "createrendereffect",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createrendereffect",
        children: "#"
      }), jsx(_components.code, {
        children: "createRenderEffect"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createRenderEffect<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v: T"
          }), ") =>"]
        }), " T,\n  value?: T,\n  options?: { name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " }\n): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "创建一个新的计算，自动跟踪依赖项并在渲染阶段运行，因为 DOM 元素被创建和更新但不一定连接。所有内部 DOM 更新都在此时发生。"
    }), "\n", jsxs(_components.h2, {
      id: "createselector",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createselector",
        children: "#"
      }), jsx(_components.code, {
        children: "createSelector"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createSelector<T, U>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "source"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T,\n  fn?: ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "a: U, b: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ",\n  options?: { name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " }\n): ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "k: U"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "创建一个条件 signal，仅在进入或退出时键与值匹配时通知订阅者。处理委托选择状态很有用。因为它使得操作复杂度是 O(2) 而不是 O(n)。"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " isSelected = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSelector"
        }), "(selectedId);\n\n", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "For"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "each"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{list()}"
            }), ">"]
          }), "\n  {(item) => ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "li"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "classList"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{{"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "active:"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "isSelected"
            }), "(", jsx(_components.span, {
              className: "hljs-attr",
              children: "item.id"
            }), ") }}>"]
          }), "{item.name}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "li"
            }), ">"]
          }), "}\n", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "For"
            }), ">"]
          })]
        }), ";\n"]
      })
    }), "\n", jsxs(_components.h1, {
      id: "渲染",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#渲染",
        children: "#"
      }), "渲染"]
    }), "\n", jsxs(_components.p, {
      children: ["These imports are exposed from ", jsx(_components.code, {
        children: "solid-js/web"
      }), "."]
    }), "\n", jsxs(_components.p, {
      children: ["以下导入是从 ", jsx(_components.code, {
        children: "solid-js/web"
      }), " 暴露的。"]
    }), "\n", jsxs(_components.h2, {
      id: "render",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#render",
        children: "#"
      }), jsx(_components.code, {
        children: "render"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "render"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "\n  code: () => JSX.Element,\n  element: MountableElement\n"
        }), "): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "render"
      }), " 是浏览器应用程序入口点。它需要提供顶级组件定义或函数以及需要挂载的元素。建议该元素为空，因为返回的 dispose 函数将清理所有子元素。"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " dispose = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "render"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ", ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "document"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "getElementById"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"app\""
        }), "));\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "hydrate",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#hydrate",
        children: "#"
      }), jsx(_components.code, {
        children: "hydrate"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "hydrate"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "\n  fn: () => JSX.Element,\n  node: MountableElement\n"
        }), "): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["此方法类似于 ", jsx(_components.code, {
        children: "render"
      }), "，只是它会尝试重新注水到已经渲染到 DOM 的内容。在浏览器中初始化时，页面已被服务器渲染。"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " dispose = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "hydrate"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ", ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "document"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "getElementById"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"app\""
        }), "));\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "rendertostring",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#rendertostring",
        children: "#"
      }), jsx(_components.code, {
        children: "renderToString"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " renderToString<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T,\n  options?: {\n    eventNames?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), "[];\n    nonce?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\n  }\n): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "同步渲染为字符串。该函数还为渐进式注水生成脚本标签。选项包括在页面加载之前侦听并在注水时回放的 eventNames，以及放在脚本标签上的 nonce。"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " html = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "renderToString"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "rendertostringasync",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#rendertostringasync",
        children: "#"
      }), jsx(_components.code, {
        children: "renderToStringAsync"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " renderToStringAsync<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T,\n  options?: {\n    eventNames?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), "[];\n    timeoutMs?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "number"
        }), ";\n    nonce?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\n  }\n): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ">;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["与 ", jsx(_components.code, {
        children: "renderToString"
      }), " 相同，除了它在返回结果之前会等待所有 ", jsx(_components.code, {
        children: "<Suspense>"
      }), " 边界解析。资源数据会自动序列化到脚本标签中，并会在客户端加载时注水。"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " html = ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "await"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "renderToStringAsync"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "pipetonodewritable",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#pipetonodewritable",
        children: "#"
      }), jsx(_components.code, {
        children: "pipeToNodeWritable"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "PipeToWritableResults"
        }), " = {\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "startWriting"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "write"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "string"
            })]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "abort"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n};\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " pipeToNodeWritable<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T,\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "writable"
        }), ": { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "write"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "string"
            })]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), " },\n  options?: {\n    eventNames?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), "[];\n    nonce?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\n    noScript?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ";\n    onReady?: ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "r: PipeToWritableResults"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n    onComplete?: ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "r: PipeToWritableResults"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), " | ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ">;\n  }\n): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "此方法渲染出 Node 流。它同步渲染内容，包括任何 Suspense 回退占位符，然后在完成时继续从任何异步资源流式传输数据。"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "pipeToNodeWritable"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ", res);\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "onReady"
      }), " 选项用来写入核心应用程序渲染的流很有用。请记住，如果你想要使用 ", jsx(_components.code, {
        children: "onReady"
      }), " 手动调用 ", jsx(_components.code, {
        children: "startWriting"
      }), " 的话。"]
    }), "\n", jsxs(_components.h2, {
      id: "pipetowritable",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#pipetowritable",
        children: "#"
      }), jsx(_components.code, {
        children: "pipeToWritable"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "PipeToWritableResults"
        }), " = {\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "write"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "string"
            })]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "abort"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "script"
        }), ": ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\n};\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " pipeToWritable<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T,\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "writable"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "WritableStream"
        }), ",\n  options?: {\n    eventNames?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), "[];\n    nonce?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\n    noScript?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ";\n    onReady?: ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["\n      writable: { write: (v: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "string"
            }), ") => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "void"
            }), " },\n      r: PipeToWritableResults\n    "]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n    onComplete?: ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["\n      writable: { write: (v: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "string"
            }), ") => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "void"
            }), " },\n      r: PipeToWritableResults\n    "]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n  }\n): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "此方法渲染到 Web 流。它同步渲染内容，包括任何 Suspense 回退占位符，然后在完成时继续从任何异步资源流式传输数据。"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " { readable, writable } = ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "new"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "TransformStream"
        }), "();\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "pipeToWritable"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ", writable);\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "onReady"
      }), " 选项对于写入围绕核心应用程序渲染的流很有用。请记住，如果你需要使用 ", jsx(_components.code, {
        children: "onReady"
      }), " 手动调用 ", jsx(_components.code, {
        children: "startWriting"
      })]
    }), "\n", jsxs(_components.h2, {
      id: "isserver",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#isserver",
        children: "#"
      }), jsx(_components.code, {
        children: "isServer"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " ", jsx(_components.span, {
          className: "hljs-attr",
          children: "isServer"
        }), ": ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "这指明了代码是在服务器运行还是在浏览器运行。由于底层运行时将其导出为常量布尔值，所以它允许构建工具从相应的包中消除代码及其使用的导入代码。"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "if"
        }), " (isServer) {\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 永远不会进入浏览器打包代码"
        }), "\n} ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "else"
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 不会在服务器上运行；"
        }), "\n"]
      })
    }), "\n", jsxs(_components.h1, {
      id: "控制流",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#控制流",
        children: "#"
      }), "控制流"]
    }), "\n", jsxs(_components.p, {
      children: ["Solid 使用组件来控制流。原因是为了提高响应式性能，我们必须控制元素的创建方式。例如，对于列表而言，简单的 ", jsx(_components.code, {
        children: "map"
      }), " 效率低下，因为它总是映射所有内容。这意味着需要一个辅助函数。"]
    }), "\n", jsx(_components.p, {
      children: "将这些包装在组件中既能很方便地简化模板，也允许用户组合和构建自己的控制流。"
    }), "\n", jsxs(_components.p, {
      children: ["这些内置的控制流将被自动导入。除了 ", jsx(_components.code, {
        children: "Portal"
      }), " 和 ", jsx(_components.code, {
        children: "Dynamic"
      }), " 之外的所有内容都是从 ", jsx(_components.code, {
        children: "solid-js"
      }), " 导出的。这两个 DOM 特定的组件由 ", jsx(_components.code, {
        children: "solid-js/web"
      }), " 导出。"]
    }), "\n", jsxs(_components.blockquote, {
      children: ["\n", jsx(_components.p, {
        children: "注意：控制流的所有回调/渲染函数子项都是非跟踪性的。这允许创建嵌套状态，并更好地隔离响应。"
      }), "\n"]
    }), "\n", jsxs(_components.h2, {
      id: "for",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#for",
        children: "#"
      }), jsx(_components.code, {
        children: "<For>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), "<T, U ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ">(", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": {\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "each"
        }), ": ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "readonly"
        }), " T[];\n  fallback?: ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "children"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["item: T, index: () => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "number"
            })]
          }), ") =>"]
        }), " U;\n}): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " U[];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "简单的引用键控循环控制流程。"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), " each={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "list"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\n  {", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "item"
          }), ") =>"]
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "{item}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), ">\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "第二个可选参数是索引 signal："
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), " each={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "list"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\n  {", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "item, index"
          }), ") =>"]
        }), " (\n    ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "\n      #{index()} {item}\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "\n  )}\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "show",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#show",
        children: "#"
      }), jsx(_components.code, {
        children: "<Show>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), "<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": {\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "when"
        }), ": T | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "null"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), ";\n  fallback?: ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "children"
        }), ": ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), " | (", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "item: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ");\n}): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Show 控制流用于有条件地渲染视图的一部分。它跟三元运算符（", jsx(_components.code, {
        children: "a ? b : c"
      }), "）类似，但非常适合模板 JSX。"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), " when={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "count"
        }), " > ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "My Content", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), ">\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Show 还可以用来将区块控到特定数据模型。每当用户数据模型被替换时，该函数就会重新执行。"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), " when={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "user"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\n  {", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "user"
          }), ") =>"]
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "{user.firstName}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "switchmatch",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#switchmatch",
        children: "#"
      }), jsx(_components.code, {
        children: "<Switch>"
      }), "/", jsx(_components.code, {
        children: "<Match>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "Switch"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "props: {\n  fallback?: JSX.Element;\n  children: JSX.Element;\n}"
        }), "): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MatchProps"
        }), "<T> = {\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "when"
        }), ": T | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "null"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), ";\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "children"
        }), ": ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), " | (", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "item: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ");\n};\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Match"
        }), "<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MatchProps"
        }), "<T>);\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "当有 2 个以上的互斥条件时会很有用。可以用来做一些简单的路由之类的事情。"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Switch"
        }), " fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Not Found", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Match"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "when"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{state.route"
            }), " === ", jsx(_components.span, {
              className: "hljs-string",
              children: "\"home\""
            }), "}>"]
          }), "\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Home"
            }), " />"]
          }), "\n  ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "Match"
            }), ">"]
          })]
        }), "\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Match"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "when"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{state.route"
            }), " === ", jsx(_components.span, {
              className: "hljs-string",
              children: "\"settings\""
            }), "}>"]
          }), "\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Settings"
            }), " />"]
          }), "\n  ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "Match"
            }), ">"]
          })]
        }), "\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Switch"
        }), ">\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Match 还支持函数子项作为键映射流程。"
    }), "\n", jsxs(_components.h2, {
      id: "index",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#index",
        children: "#"
      }), jsx(_components.code, {
        children: "<Index>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), "<T, U ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ">(", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": {\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "each"
        }), ": ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "readonly"
        }), " T[];\n  fallback?: ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "children"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["item: () => T, index: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "number"
            })]
          }), ") =>"]
        }), " U;\n}): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " U[];\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "<Index>"
      }), " 在无 key 列表迭代时（或者说 index 作为 key）时很有用，比如数据是 primitive 并且是固定的索引而不是值。"]
    }), "\n", jsx(_components.p, {
      children: "该项是一个 signal："
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), " each={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "list"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\n  {", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "item"
          }), ") =>"]
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "{item()}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), ">\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "第二个可选参数是索引号："
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), " each={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "list"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\n  {", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "item, index"
          }), ") =>"]
        }), " (\n    ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "\n      #{index} {item()}\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "\n  )}\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "errorboundary",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#errorboundary",
        children: "#"
      }), jsx(_components.code, {
        children: "<ErrorBoundary>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "ErrorBoundary"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["props: {\n  fallback: JSX.Element | ((err: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "any"
          }), ", reset: () => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "void"
          }), ") => JSX.Element);\n  children: JSX.Element;\n}"]
        }), "): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "捕获未捕获的错误并渲染回退内容。"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ErrorBoundary"
        }), " fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Something went terribly wrong", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\n  ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "MyComp"
            }), " />"]
          })
        }), "\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ErrorBoundary"
        }), ">\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "还支持回调函数的形式传参，函数传入了错误和重置函数。"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ErrorBoundary"
        }), "\n  fallback={", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "err, reset"
          }), ") =>"]
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "onClick"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{reset}"
            }), ">"]
          }), "Error: {err}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}\n>\n  ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "MyComp"
            }), " />"]
          })
        }), "\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ErrorBoundary"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "suspense",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#suspense",
        children: "#"
      }), jsx(_components.code, {
        children: "<Suspense>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "Suspense"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "props: {\n  fallback?: JSX.Element;\n  children: JSX.Element;\n}"
        }), "): ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "<Suspense>"
      }), " 是一个跟踪其下所有读取资源并显示回退占位符状态的组件，直到它们被解析。", jsx(_components.code, {
        children: "Suspense"
      }), " 与 ", jsx(_components.code, {
        children: "Show"
      }), " 的不同之处在于它是非阻塞的，即使当前不在 DOM 中，两个分支也可以同时存在。"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Suspense"
        }), " fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\n  ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "AsyncComponent"
            }), " />"]
          })
        }), "\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Suspense"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "suspenselist-实验",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#suspenselist-实验",
        children: "#"
      }), jsx(_components.code, {
        children: "<SuspenseList>"
      }), " (实验)"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "SuspenseList"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["props: {\n  children: JSX.Element;\n  revealOrder: ", jsx(_components.span, {
            className: "hljs-string",
            children: "\"forwards\""
          }), " | ", jsx(_components.span, {
            className: "hljs-string",
            children: "\"backwards\""
          }), " | ", jsx(_components.span, {
            className: "hljs-string",
            children: "\"together\""
          }), ";\n  tail?: ", jsx(_components.span, {
            className: "hljs-string",
            children: "\"collapsed\""
          }), " | ", jsx(_components.span, {
            className: "hljs-string",
            children: "\"hidden\""
          }), ";\n}"]
        }), "): ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "SuspenseList"
      }), " 可以协调多个并行的 ", jsx(_components.code, {
        children: "Suspense"
      }), " 和 ", jsx(_components.code, {
        children: "SuspenseList"
      }), " 组件。它控制显示内容的顺序以减少布局抖动，并且可以通过选项控制折叠或隐藏回退状态。"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "SuspenseList"
        }), " revealOrder=", jsx(_components.span, {
          className: "hljs-string",
          children: "\"forwards\""
        }), " tail=", jsx(_components.span, {
          className: "hljs-string",
          children: "\"collapsed\""
        }), ">\n  ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "ProfileDetails"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "user"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{resource.user}"
            }), " />"]
          })
        }), "\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Suspense"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "fallback"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{"
            }), "<", jsx(_components.span, {
              className: "hljs-attr",
              children: "h2"
            }), ">"]
          }), "Loading posts...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "h2"
            }), ">"]
          }), "}>\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "ProfileTimeline"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "posts"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{resource.posts}"
            }), " />"]
          }), "\n  ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "Suspense"
            }), ">"]
          })]
        }), "\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Suspense"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "fallback"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{"
            }), "<", jsx(_components.span, {
              className: "hljs-attr",
              children: "h2"
            }), ">"]
          }), "Loading fun facts...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "h2"
            }), ">"]
          }), "}>\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "ProfileTrivia"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "trivia"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{resource.trivia}"
            }), " />"]
          }), "\n  ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "Suspense"
            }), ">"]
          })]
        }), "\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "SuspenseList"
        }), ">\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "SuspenseList 仍处于试验阶段，并没有完整的 SSR 支持。"
    }), "\n", jsxs(_components.h2, {
      id: "dynamic",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#dynamic",
        children: "#"
      }), jsx(_components.code, {
        children: "<Dynamic>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Dynamic"
        }), "<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": T & {\n    children?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ";\n    component?: ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Component"
        }), "<T> | ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " | keyof ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "IntrinsicElements"
        }), ";\n  }\n): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "该组件允许你插入任意组件或标签并将 props 传递给它。"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Dynamic"
        }), " component={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "component"
        }), "} someProp={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "something"
        }), "} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "portal",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#portal",
        children: "#"
      }), jsx(_components.code, {
        children: "<Portal>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "Portal"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["props: {\n  mount?: Node;\n  useShadow?: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "boolean"
          }), ";\n  isSVG?: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "boolean"
          }), ";\n  children: JSX.Element;\n}"]
        }), "): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Text"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "<Portal>"
      }), " 会在挂载节点中插入元素。用于在页面布局之外插入模态框。事件仍然通过组件层次结构传播。"]
    }), "\n", jsxs(_components.p, {
      children: ["除非目标是 document head，否则 portal 挂载在", jsx(_components.code, {
        children: "<div>"
      }), " 中。", jsx(_components.code, {
        children: "useShadow"
      }), " 将元素放在 Shadow Root 中以进行样式隔离，如果插入到 SVG 元素中，则需要 ", jsx(_components.code, {
        children: "isSVG"
      }), " 避免不插入 ", jsx(_components.code, {
        children: "<div>"
      }), "。"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Portal"
        }), " mount={", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "document"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "getElementById"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"modal\""
        }), ")}>\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "My Content", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Portal"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h1, {
      id: "特殊的-jsx-属性",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#特殊的-jsx-属性",
        children: "#"
      }), "特殊的 JSX 属性"]
    }), "\n", jsx(_components.p, {
      children: "一般来说，Solid 试图和 DOM 习惯保持一致。大多数 props 被视为原生元素的属性和 Web Components 的属性，但其中一些具有特殊的行为。"
    }), "\n", jsx(_components.p, {
      children: "使用 TypeScript 自定义命名空间属性时，你需要扩展 Solid 的 JSX 命名空间："
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "declare"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "module"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "namespace"
        }), " JSX {\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Directives"
        }), " {\n      ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// use:____"
        }), "\n    }\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ExplicitProperties"
        }), " {\n      ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// prop:____"
        }), "\n    }\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ExplicitAttributes"
        }), " {\n      ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// attr:____"
        }), "\n    }\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "CustomEvents"
        }), " {\n      ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// on:____"
        }), "\n    }\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "CustomCaptureEvents"
        }), " {\n      ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// oncapture:____"
        }), "\n    }\n  }\n}\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "ref",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#ref",
        children: "#"
      }), jsx(_components.code, {
        children: "ref"
      })]
    }), "\n", jsx(_components.p, {
      children: "Refs 是一种访问 JSX 中底层 DOM 元素的方式。虽然确实可以将一个元素分配给一个变量，但将组件留在 JSX 流中更为理想。Refs 在渲染时（在元素连接到 DOM 之前）分配。它有 2 种写法。"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// 简单赋值"
        }), "\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "let"
        }), " myDiv;\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 连接到 DOM 后使用 onMount 或 createEffect 进行读取"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onMount"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(myDiv));\n", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "ref"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{myDiv}"
            }), " />"]
          })
        }), "\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 或者，使用回调函数（在元素连接到 DOM 之前调用）"
        }), "\n", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "ref"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{el"
            }), " =>"]
          }), " console.log(el)} />"]
        }), "\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Refs 也可以用于组件。它们仍然需要连接到另一侧。"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "MyComp"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "props"
        }), ") {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "ref"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{props.ref}"
            }), " />"]
          })
        }), ";\n}\n\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "App"
        }), "(", jsx(_components.span, {
          className: "hljs-params"
        }), ") {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "let"
        }), " myDiv;\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onMount"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(myDiv.", jsx(_components.span, {
          className: "hljs-property",
          children: "clientWidth"
        }), "));\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "MyComp"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "ref"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{myDiv}"
            }), " />"]
          })
        }), ";\n}\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "classlist",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#classlist",
        children: "#"
      }), jsx(_components.code, {
        children: "classList"
      })]
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "classList"
      }), " 借助于 ", jsx(_components.code, {
        children: "element.classList.toggle"
      }), "。它接受一个键为 class 名的对象，并在解析值为 true 时分配它们。"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<div\n  classList={{ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "active"
        }), ": state.", jsx(_components.span, {
          className: "hljs-property",
          children: "active"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "editing"
        }), ": state.", jsx(_components.span, {
          className: "hljs-property",
          children: "currentId"
        }), " === row.", jsx(_components.span, {
          className: "hljs-property",
          children: "id"
        }), " }}\n/>\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "style",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#style",
        children: "#"
      }), jsx(_components.code, {
        children: "style"
      })]
    }), "\n", jsxs(_components.p, {
      children: ["Solid 的样式工具可以处理字符串或对象。与 React 的版本不同，Solid 在底层使用了 ", jsx(_components.code, {
        children: "element.style.setProperty"
      }), "。这意味着支持 CSS 变量，但也意味着我们使用较底层的、破折号版本的属性。这实际上会带来更好的性能并能 SSR 输出保持一致。"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// 字符串"
        }), "\n<div style={", jsxs(_components.span, {
          className: "hljs-string",
          children: ["`color: green; background-color: ", jsx(_components.span, {
            className: "hljs-subst",
            children: "${state.color}"
          }), "; height: ", jsx(_components.span, {
            className: "hljs-subst",
            children: "${state.height}"
          }), "px`"]
        }), "} />\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// 变量"
        }), "\n", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "style"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{{"
            }), "\n  ", jsx(_components.span, {
              className: "hljs-attr",
              children: "color:"
            }), " \"", jsx(_components.span, {
              className: "hljs-attr",
              children: "green"
            }), "\",\n  \"", jsx(_components.span, {
              className: "hljs-attr",
              children: "background-color"
            }), "\"", jsx(_components.span, {
              className: "hljs-attr",
              children: ":"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "state.color"
            }), ",\n  ", jsx(_components.span, {
              className: "hljs-attr",
              children: "height:"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "state.height"
            }), " + \"", jsx(_components.span, {
              className: "hljs-attr",
              children: "px"
            }), "\" }}\n/>"]
          })
        }), "\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// css 变量"
        }), "\n", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "style"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{{"
            }), " \"", jsx(_components.span, {
              className: "hljs-attr",
              children: "--my-custom-color"
            }), "\"", jsx(_components.span, {
              className: "hljs-attr",
              children: ":"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "state.themeColor"
            }), " }} />"]
          })
        }), "\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "innerhtmltextcontent",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#innerhtmltextcontent",
        children: "#"
      }), jsx(_components.code, {
        children: "innerHTML"
      }), "/", jsx(_components.code, {
        children: "textContent"
      })]
    }), "\n", jsxs(_components.p, {
      children: ["它们的工作原理与它们的等效属性相同。设置一个字符串，它们将被设置到 HTML 中。", jsx(_components.strong, {
        children: "小心!!"
      }), " 任何数据设置为 ", jsx(_components.code, {
        children: "innerHTML"
      }), " 都可能暴露给终端用户，因此它可能成为恶意攻击的载体。", jsx(_components.code, {
        children: "textContent"
      }), " 虽然通常不需要，但实际上是一种性能优化，因为它绕过了通用对比差异例程，因此子项将只是文本。"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<div textContent={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "text"
        }), "} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "on___",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#on___",
        children: "#"
      }), jsx(_components.code, {
        children: "on___"
      })]
    }), "\n", jsxs(_components.p, {
      children: ["Solid 中的事件处理程序通常采用 ", jsx(_components.code, {
        children: "onclick"
      }), " 或 ", jsx(_components.code, {
        children: "onClick"
      }), " 形式，具体取决于风格。事件名称总是小写。Solid 对组合和冒泡的常见 UI 事件使用半合成事件委托。这样提高了这些常见事件的性能。"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<div onClick={", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "e"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(e.", jsx(_components.span, {
          className: "hljs-property",
          children: "currentTarget"
        }), ")} />\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Solid 还支持将数组传递给事件处理句柄以将值绑定到事件处理句柄的第一个参数。这不用使用", jsx(_components.code, {
        children: "bind"
      }), " 或创建额外的闭包，因此它是一种高度优化的事件委托方式。"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "handler"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "itemId, e"
        }), ") {\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "/*...*/"
        }), "\n}\n\n<ul>\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "For"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "each"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{state.list}"
            }), ">"]
          }), "{(item) => ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "li"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "onClick"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{[handler,"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "item.id"
            }), "]} />"]
          }), "}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "For"
            }), ">"]
          })]
        }), "\n</ul>;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "事件不能被重新绑定并且绑定不是响应式。原因是添加/移除侦听器通常更消耗性能。由于事件自然地会被调用，因此不需要响应性，如果需要，只需跟下面一样简单处理你的事件句柄。"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// 如果定义了就会调用，否则不会。"
        }), "\n<div onClick={", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " props.", jsx(_components.span, {
          className: "hljs-property",
          children: "handleClick"
        }), "?.()} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "on___oncapture___",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#on___oncapture___",
        children: "#"
      }), jsx(_components.code, {
        children: "on:___"
      }), "/", jsx(_components.code, {
        children: "oncapture:___"
      })]
    }), "\n", jsxs(_components.p, {
      children: ["对其他的事件，可能是名称不寻常或者你不希望被委托，且有 ", jsx(_components.code, {
        children: "on"
      }), " 命名空间。那你只需要逐字添加事件侦听器。"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<div ", jsx(_components.span, {
          className: "hljs-attr",
          children: "on"
        }), ":", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Weird"
        }), "-", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Event"
        }), "={", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "e"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "alert"
        }), "(e.", jsx(_components.span, {
          className: "hljs-property",
          children: "detail"
        }), ")} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "use___",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#use___",
        children: "#"
      }), jsx(_components.code, {
        children: "use:___"
      })]
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "use:___"
      }), " 是自定义指令。从某种意义上说，这只是 ref 上的语法糖，但允许我们轻松地将多个指令附加到单个元素。指令只是一个具有以下签名的函数："]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "directive"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["element: Element, accessor: () => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "any"
          })]
        }), "): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "这些函数在渲染时运行，你可以在其中执行任何操作。创建 signal 和 effects，注册清理函数，随心所欲。"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [name, setName] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"\""
        }), ");\n\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "model"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "el, value"
        }), ") {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [field, setField] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "value"
        }), "();\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createRenderEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " (el.", jsx(_components.span, {
          className: "hljs-property",
          children: "value"
        }), " = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "field"
        }), "()));\n  el.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "addEventListener"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"input\""
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "e"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setField"
        }), "(e.", jsx(_components.span, {
          className: "hljs-property",
          children: "target"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "value"
        }), "));\n}\n\n<input type=", jsx(_components.span, {
          className: "hljs-string",
          children: "\"text\""
        }), " ", jsx(_components.span, {
          className: "hljs-attr",
          children: "use"
        }), ":model={[name, setName]} />;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "注册 TypeScript 扩展 JSX 命名空间。"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "declare"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "module"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "namespace"
        }), " JSX {\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Directives"
        }), " {\n      ", jsx(_components.span, {
          className: "hljs-attr",
          children: "model"
        }), ": [", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "any"
            })]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), "];\n    }\n  }\n}\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "prop___",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#prop___",
        children: "#"
      }), jsx(_components.code, {
        children: "prop:___"
      })]
    }), "\n", jsx(_components.p, {
      children: "强制将 prop 视为 property 而不是 attribute。"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<div ", jsx(_components.span, {
          className: "hljs-attr",
          children: "prop"
        }), ":scrollTop={props.", jsx(_components.span, {
          className: "hljs-property",
          children: "scrollPos"
        }), " + ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"px\""
        }), "} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "attr___",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#attr___",
        children: "#"
      }), jsx(_components.code, {
        children: "attr:___"
      })]
    }), "\n", jsx(_components.p, {
      children: "强制将 prop 视为 attribute 而不是 property。对于要设置 attribute 的 Web 组件很有用。"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<my-element ", jsx(_components.span, {
          className: "hljs-attr",
          children: "attr"
        }), ":status={props.", jsx(_components.span, {
          className: "hljs-property",
          children: "status"
        }), "} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "-once-",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#-once-",
        children: "#"
      }), jsx(_components.code, {
        children: "/* @once */"
      })]
    }), "\n", jsx(_components.p, {
      children: "Solid 的编译器使用简单的启发式方法对 JSX 表达式进行响应式包装和惰性求值。判断它是否包含函数调用、属性访问或 JSX？ 如果是，我们在传递给组件时将其包装在 getter 中，或者如果传递给原生元素，则将其包装在 effect 中。"
    }), "\n", jsxs(_components.p, {
      children: ["知道了这一点，我们可以通过在 JSX 之外访问它们来减少我们知道永远不会改变的东西的开销。一个简单的变量永远不会被包装。我们还可以通过以注释修饰符 ", jsx(_components.code, {
        children: "/_ @once _/"
      }), " 开头的表达式来告诉编译器不要包装它们。"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MyComponent"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "static"
        }), "={", jsx(_components.span, {
          className: "hljs-comment",
          children: "/*@once*/"
        }), " state.", jsx(_components.span, {
          className: "hljs-property",
          children: "wontUpdate"
        }), "} />\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "对 children 同样有效。"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MyComponent"
        }), ">{", jsx(_components.span, {
          className: "hljs-comment",
          children: "/*@once*/"
        }), " state.", jsx(_components.span, {
          className: "hljs-property",
          children: "wontUpdate"
        }), "}</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MyComponent"
        }), ">\n"]
      })
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
