import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [{
  "depth": 1,
  "value": "Grundlegende Reaktivität",
  "children": [{
    "depth": 2,
    "value": "createSignal",
    "children": []
  }, {
    "depth": 2,
    "value": "createEffect",
    "children": []
  }, {
    "depth": 2,
    "value": "createMemo",
    "children": []
  }, {
    "depth": 2,
    "value": "createResource",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Lifecycles",
  "children": [{
    "depth": 2,
    "value": "onMount",
    "children": []
  }, {
    "depth": 2,
    "value": "onCleanup",
    "children": []
  }, {
    "depth": 2,
    "value": "onError",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Reaktive Helfer",
  "children": [{
    "depth": 2,
    "value": "untrack",
    "children": []
  }, {
    "depth": 2,
    "value": "batch",
    "children": []
  }, {
    "depth": 2,
    "value": "on",
    "children": []
  }, {
    "depth": 2,
    "value": "createRoot",
    "children": []
  }, {
    "depth": 2,
    "value": "mergeProps",
    "children": []
  }, {
    "depth": 2,
    "value": "splitProps",
    "children": []
  }, {
    "depth": 2,
    "value": "useTransition",
    "children": []
  }, {
    "depth": 2,
    "value": "observable",
    "children": []
  }, {
    "depth": 2,
    "value": "mapArray",
    "children": []
  }, {
    "depth": 2,
    "value": "indexArray",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Stores",
  "children": [{
    "depth": 2,
    "value": "createStore",
    "children": [{
      "depth": 3,
      "value": "Getter",
      "children": []
    }, {
      "depth": 3,
      "value": "Stores aktualsieren",
      "children": []
    }]
  }, {
    "depth": 2,
    "value": "produce",
    "children": []
  }, {
    "depth": 2,
    "value": "reconcile",
    "children": []
  }, {
    "depth": 2,
    "value": "createMutable",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Component APIs",
  "children": [{
    "depth": 2,
    "value": "createContext",
    "children": []
  }, {
    "depth": 2,
    "value": "useContext",
    "children": []
  }, {
    "depth": 2,
    "value": "children",
    "children": []
  }, {
    "depth": 2,
    "value": "lazy",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Sekundäre Primitiven",
  "children": [{
    "depth": 2,
    "value": "createDeferred",
    "children": []
  }, {
    "depth": 2,
    "value": "createComputed",
    "children": []
  }, {
    "depth": 2,
    "value": "createRenderEffect",
    "children": []
  }, {
    "depth": 2,
    "value": "createSelector",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Rendering",
  "children": [{
    "depth": 2,
    "value": "render",
    "children": []
  }, {
    "depth": 2,
    "value": "hydrate",
    "children": []
  }, {
    "depth": 2,
    "value": "renderToString",
    "children": []
  }, {
    "depth": 2,
    "value": "renderToStringAsync",
    "children": []
  }, {
    "depth": 2,
    "value": "pipeToNodeWritable",
    "children": []
  }, {
    "depth": 2,
    "value": "pipeToWritable",
    "children": []
  }, {
    "depth": 2,
    "value": "isServer",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Kontrollfluss",
  "children": [{
    "depth": 2,
    "value": "<For>",
    "children": []
  }, {
    "depth": 2,
    "value": "<Show>",
    "children": []
  }, {
    "depth": 2,
    "value": "<Switch>/<Match>",
    "children": []
  }, {
    "depth": 2,
    "value": "<Index>",
    "children": []
  }, {
    "depth": 2,
    "value": "<ErrorBoundary>",
    "children": []
  }, {
    "depth": 2,
    "value": "<Suspense>",
    "children": []
  }, {
    "depth": 2,
    "value": "<SuspenseList> (Experimentell)",
    "children": []
  }, {
    "depth": 2,
    "value": "<Dynamic>",
    "children": []
  }, {
    "depth": 2,
    "value": "<Portal>",
    "children": []
  }]
}, {
  "depth": 1,
  "value": "Spezielle JSX-Attribute",
  "children": [{
    "depth": 2,
    "value": "ref",
    "children": []
  }, {
    "depth": 2,
    "value": "classList",
    "children": []
  }, {
    "depth": 2,
    "value": "style",
    "children": []
  }, {
    "depth": 2,
    "value": "innerHTML/textContent",
    "children": []
  }, {
    "depth": 2,
    "value": "on___",
    "children": []
  }, {
    "depth": 2,
    "value": "on:___/oncapture:___",
    "children": []
  }, {
    "depth": 2,
    "value": "use:___",
    "children": []
  }, {
    "depth": 2,
    "value": "prop:___",
    "children": []
  }, {
    "depth": 2,
    "value": "attr:___",
    "children": []
  }, {
    "depth": 2,
    "value": "/* @once */",
    "children": []
  }]
}];
function _createMdxContent(props) {
  const _components = Object.assign({
    h1: "h1",
    a: "a",
    h2: "h2",
    code: "code",
    pre: "pre",
    span: "span",
    p: "p",
    blockquote: "blockquote",
    h3: "h3",
    strong: "strong"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsxs(_components.h1, {
      id: "grundlegende-reaktivität",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#grundlegende-reaktivität",
        children: "#"
      }), "Grundlegende Reaktivität"]
    }), "\n", jsxs(_components.h2, {
      id: "createsignal",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createsignal",
        children: "#"
      }), jsx(_components.code, {
        children: "createSignal"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createSignal<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "value"
        }), ": T,\n  options?: { name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), "; equals?: ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " | (", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev: T, next: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ") }\n): [", jsx(_components.span, {
          className: "hljs-attr",
          children: "get"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T, ", jsx(_components.span, {
          className: "hljs-attr",
          children: "set"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v: T"
          }), ") =>"]
        }), " T];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Dies ist die grundsätzlichste Anweisung, um auf einen einzelnen Wert zu reagieren, der sich über die Zeit verändert. Die create-Funktion gibt ein Paar von get- und set-Funktionen zurück, um das Signal auszulesen und zu aktualisieren."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [getValue, setValue] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(initialValue);\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// read value"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "getValue"
        }), "();\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// set value"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setValue"
        }), "(nextValue);\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// set value with a function setter"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setValue"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev"
          }), ") =>"]
        }), " prev + next);\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Um auf Aktualisierungen zu reagieren, müssen diese Signale in einem überwachten Scopes verwendet werden. Überwachte Scopes sind Funktionen, die als Parameter von ", jsx(_components.code, {
        children: "createEffect"
      }), " oder JSX-Properties verwendet werden."]
    }), "\n", jsxs(_components.blockquote, {
      children: ["\n", jsx(_components.p, {
        children: "Um eine Funktion in einem Signal zu speichern, muss sie in eine weitere Funktion gekapselt werden:"
      }), "\n", jsx(_components.pre, {
        children: jsxs(_components.code, {
          className: "hljs language-js",
          children: [jsx(_components.span, {
            className: "hljs-title function_",
            children: "setValue"
          }), "(", jsx(_components.span, {
            className: "hljs-function",
            children: "() =>"
          }), " myFunction);\n"]
        })
      }), "\n"]
    }), "\n", jsxs(_components.h2, {
      id: "createeffect",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createeffect",
        children: "#"
      }), jsx(_components.code, {
        children: "createEffect"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createEffect<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v: T"
          }), ") =>"]
        }), " T,\n  value?: T,\n  options?: { name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " }\n): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Erstellt einen neuen Effekt, der automatisch Abhängigkeiten überwacht und nach jedem Rendering abläuft, wenn ein Wert geändert wurde. Ideal, um ", jsx(_components.code, {
        children: "ref"
      }), "s zu verwenden und andere Seiteneffekte zu handhaben."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [a, setA] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(initialValue);\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Effekt, der von dem Signal `a` abhängig ist"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "doSideEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "a"
        }), "()));\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Die Effektfunktion wird mit dem Rückgabewert der letzten Ausführung aufgerufen. Dieser Wert kann als optionaler zweiter Parameter initialisiert werden; das kann nützlich sein, um Vergleiche ohne eine zusätzliche Closure durchzuführen."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev"
          }), ") =>"]
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " sum = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "a"
        }), "() + ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "b"
        }), "();\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "if"
        }), " (sum !== prev) ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(sum);\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " sum;\n}, ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "creatememo",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#creatememo",
        children: "#"
      }), jsx(_components.code, {
        children: "createMemo"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createMemo<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v: T"
          }), ") =>"]
        }), " T,\n  value?: T,\n  options?: { name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), "; equals?: ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " | (", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev: T, next: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ") }\n): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Erstellt ein nur lesbares abgeleitetes Signal, das automatisch neu berechnet wird, wenn sich eine Abhängigkeit des darin ausgeführten Codes ändert."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " getValue = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createMemo"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "computeExpensiveValue"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "a"
        }), "(), ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "b"
        }), "()));\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Wert auslesen"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "getValue"
        }), "();\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Die memo-Funktion wird mit dem Rückgabewert der letzten Ausführung aufgerufen. Dieser Wert kann als optionaler zweiter Parameter initialisiert werden. Das ist nützlich, um Aufrufe zu reduzieren."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " sum = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createMemo"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "input"
        }), "() + prev, ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "createresource",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createresource",
        children: "#"
      }), jsx(_components.code, {
        children: "createResource"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ResourceReturn"
        }), "<T> = [\n  {\n    (): T | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), ";\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "loading"
        }), ": ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ";\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "error"
        }), ": ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ";\n  },\n  {\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "mutate"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: T | ", jsx(_components.span, {
              className: "hljs-literal",
              children: "undefined"
            })]
          }), ") =>"]
        }), " T | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), ";\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "refetch"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n  }\n];\n\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createResource<T, U = ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), ">(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fetcher"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["k: U, getPrev: () => T | ", jsx(_components.span, {
              className: "hljs-literal",
              children: "undefined"
            })]
          }), ") =>"]
        }), " T | ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<T>,\n  options?: { initialValue?: T; name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " }\n): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ResourceReturn"
        }), "<T>;\n\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createResource<T, U>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "source"
        }), ": U | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "null"
        }), " | (", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " U | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "null"
        }), "),\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fetcher"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["k: U, getPrev: () => T | ", jsx(_components.span, {
              className: "hljs-literal",
              children: "undefined"
            })]
          }), ") =>"]
        }), " T | ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<T>,\n  options?: { initialValue?: T; name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " }\n): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ResourceReturn"
        }), "<T>;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Erzeugt ein Signal, um asynchrone Anforderungen zu handhaben. Der ", jsx(_components.code, {
        children: "fetcher"
      }), " ist eine asynchrone Function, die den Ausgabewert der ", jsx(_components.code, {
        children: "source"
      }), "-Funktion entgegennimmt und ein Promise zurückgibt, dessen Ergebnis in der Resource gespeichert wird. Der ", jsx(_components.code, {
        children: "fetcher"
      }), " ist nicht reaktiv, also muss die optionale ", jsx(_components.code, {
        children: "source"
      }), "-Funktion genutzt werden, um ihn mehr als einmal zu starten. Wenn der ", jsx(_components.code, {
        children: "source"
      }), " false, null oder undefined zurückgibt, wird die Resource nicht abgerufen."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [data, { mutate, refetch }] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createResource"
        }), "(getQuery, fetchData);\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Wert auslesen"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "data"
        }), "();\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Prüfe, ob noch geladen wird"
        }), "\ndata.", jsx(_components.span, {
          className: "hljs-property",
          children: "loading"
        }), ";\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Prüfe, ob ein Fehler geworfen wurde"
        }), "\ndata.", jsx(_components.span, {
          className: "hljs-property",
          children: "error"
        }), ";\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Setze den Wert direkt, ohne ein Promise zu erzeugen"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mutate"
        }), "(optimisticValue);\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Wiederhole die letzte Anfrage einfach so"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "refetch"
        }), "();\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "loading"
      }), " und ", jsx(_components.code, {
        children: "error"
      }), " sind reaktive getter und können verfolgt werden."]
    }), "\n", jsxs(_components.h1, {
      id: "lifecycles",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#lifecycles",
        children: "#"
      }), "Lifecycles"]
    }), "\n", jsxs(_components.h2, {
      id: "onmount",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#onmount",
        children: "#"
      }), jsx(_components.code, {
        children: "onMount"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onMount"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["fn: () => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "void"
          })]
        }), "): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Registriert eine Methode, die aufgerufen wirde, nachdem initial gerendert wurde bzw. Elemente geladen wurden. Ideal, um ", jsx(_components.code, {
        children: "ref"
      }), "s zu benutzen oder einmalige Seiteneffekte aufzurufen. Es ist equivalent zu einem ", jsx(_components.code, {
        children: "createEffect"
      }), " ohne Abhängigkeiten."]
    }), "\n", jsxs(_components.h2, {
      id: "oncleanup",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#oncleanup",
        children: "#"
      }), jsx(_components.code, {
        children: "onCleanup"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onCleanup"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["fn: () => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "void"
          })]
        }), "): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Registriert eine Aufräummethode, die nach dem Entfernen oder Neuberechnung des gegenwärtigen Scopes aufgerufen wird. Kann in jeder Komponente und in jedem Effekt genutzt werden."
    }), "\n", jsxs(_components.h2, {
      id: "onerror",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#onerror",
        children: "#"
      }), jsx(_components.code, {
        children: "onError"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onError"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["fn: (err: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "any"
          }), ") => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "void"
          })]
        }), "): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Registriert eine Fehlerbehandlungsmethode, die aufgerufen wird, wenn innerhalb des Scopes der Kind-Elemente ein Fehler geworfen wird. Nur im jeweils nächsten Scope wird die Methode aufgerufen. Man kann den Fehler darin weiterwerfen, um die darüberliegende Methode zu erreichen."
    }), "\n", jsxs(_components.h1, {
      id: "reaktive-helfer",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#reaktive-helfer",
        children: "#"
      }), "Reaktive Helfer"]
    }), "\n", jsx(_components.p, {
      children: "Diese Helfer bringen die Fähigkeit, Aktualisierungen und Reaktivität feingranularer zu kontrollieren."
    }), "\n", jsxs(_components.h2, {
      id: "untrack",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#untrack",
        children: "#"
      }), jsx(_components.code, {
        children: "untrack"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " untrack<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T): T;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Ignoriert Änderungen von Abhängigkeiten innerhalb des ausführenden Code-Blocks und gibt den Wert zurück."
    }), "\n", jsxs(_components.h2, {
      id: "batch",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#batch",
        children: "#"
      }), jsx(_components.code, {
        children: "batch"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " batch<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T): T;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Verzögert Aktualisierungen innerhalb des Funktionsblocks bis zu dessen Ende, um unnötige Neuberechnungen zu vermeiden. Das bedeutet, dass die getter noch keine aktualisierten Werte enthalten. ", jsx(_components.a, {
        href: "#createstore",
        children: "Solid Store"
      }), "'s set-Methode und Effekte werden automatisch als batch behandelt."]
    }), "\n", jsxs(_components.h2, {
      id: "on",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#on",
        children: "#"
      }), jsx(_components.code, {
        children: "on"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " on<T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Array"
        }), "<", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), "> | (", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), "), U>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "deps"
        }), ": T,\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "input: T, prevInput: T, prevValue?: U"
          }), ") =>"]
        }), " U,\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "options"
        }), ": { defer?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), " } = {}\n): ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prevValue?: U"
          }), ") =>"]
        }), " U | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "on"
      }), " ist dazu gedacht, eine Berechnung mit definierten Abhängigkeiten auszuführen. Sofern ein Array von Abhängigkeiten übergeben wird, sind ", jsx(_components.code, {
        children: "input"
      }), " und ", jsx(_components.code, {
        children: "prevInput"
      }), " auch Arrays."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "on"
        }), "(a, ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(v, ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "b"
        }), "())));\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// ist das gleiche wie:"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " v = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "a"
        }), "();\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "untrack"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(v, ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "b"
        }), "()));\n});\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Man kann sich auch entscheiden, den Effekt nicht sofort, sondern erst bei Änderungen auszuführen, dazu muss man die option ", jsx(_components.code, {
        children: "defer"
      }), " auf ", jsx(_components.code, {
        children: "true"
      }), " setzen."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// läuft nicht sofort"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "on"
        }), "(a, ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(v), { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "defer"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), " }));\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setA"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"new\""
        }), "); ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Jetzt läuft der Effekt"
        }), "\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "createroot",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createroot",
        children: "#"
      }), jsx(_components.code, {
        children: "createRoot"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createRoot<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["dispose: () => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "void"
            })]
          }), ") =>"]
        }), " T): T;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Erzeugt einen neuen nicht überwachten Kontext der nicht automatisch aufgeräumt wird. Das ist nützlich für verschachtelte reaktive Kontexte, die nicht aufgeräumt werden sollen, wenn die darüberliegende Komponente neu berechnet wird. Es ist eine mächtige Möglichkeit für Caching."
    }), "\n", jsxs(_components.p, {
      children: ["Aller Solid-code sollte in einem solchen Kontext eingebunden werden, um sicherzustellen, dass Speicher und Berechnungen aufgeräumt werden. Normalerweise braucht man sich aber nicht darum zu kümmern, da ", jsx(_components.code, {
        children: "createRoot"
      }), " bereits in alle ", jsx(_components.code, {
        children: "render"
      }), "-Funktionen eingebunden ist."]
    }), "\n", jsxs(_components.h2, {
      id: "mergeprops",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#mergeprops",
        children: "#"
      }), jsx(_components.code, {
        children: "mergeProps"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mergeProps"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["...sources: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "any"
          })]
        }), "): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Eine reaktive Methode, um Objekte zu vereinen (", jsx(_components.code, {
        children: "merge"
      }), "). Nützlich, um Standardwerte der Eigenschaften (default props) für Komponenten zu setzen, falls diese nicht vom Aufruf übergeben werden oder die Eigenschaften mit reaktiven Werten zu klonen (clone props)."]
    }), "\n", jsx(_components.p, {
      children: "Diese Methode funktioniert, indem ein Proxy verwendet wird, um Eigenschaften in umgekehrter Reihenfolge aufzulösen. Das ermöglicht eine dynamische Verfolgung von Eigenschaften, die noch nicht präsent waren, als die Eigenschaften das erste Mal zusammengeführt wurden."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// Standardeinstellung"
        }), "\nprops = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mergeProps"
        }), "({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "name"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Smith\""
        }), " }, props);\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Props klonen"
        }), "\nnewProps = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mergeProps"
        }), "(props);\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Props zusammenführen"
        }), "\nprops = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mergeProps"
        }), "(props, otherProps);\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "splitprops",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#splitprops",
        children: "#"
      }), jsx(_components.code, {
        children: "splitProps"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " splitProps<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": T,\n  ...", jsx(_components.span, {
          className: "hljs-attr",
          children: "keys"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Array"
        }), "<(keyof T)[]>\n): [...", jsx(_components.span, {
          className: "hljs-attr",
          children: "parts"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Partial"
        }), "<T>];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Diese Methode ersetzt auf reaktive Weise das Auflösen von Objekten. Es teilt ein reaktives Objekt nach Schlüsseln (keys) und behält dabei die Reaktivität bei."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [local, others] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "splitProps"
        }), "(props, [", jsx(_components.span, {
          className: "hljs-string",
          children: "\"children\""
        }), "]);\n\n<>\n  <Child {...others} />\n  <div>{local.children}<div>\n</>\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "usetransition",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#usetransition",
        children: "#"
      }), jsx(_components.code, {
        children: "useTransition"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "useTransition"
        }), "(", jsx(_components.span, {
          className: "hljs-params"
        }), "): [\n  ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ",\n  ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["fn: () => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "void"
            }), ", cb?: () => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "void"
            })]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), "\n];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Wird verwendet, um asynchrone Aktualisierungen gemeinsamen auszuführen in einer Transaktion, die solange verzögert wird, bis alle asynchronen Prozesse ausgeführt sind. Dies hängt mit Suspense zusammen und verfolgt ausschließlich Ressourcen innerhalb der Grenzen von Suspense."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [isPending, start] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "useTransition"
        }), "();\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Prüfe, ob eine Transition stattfindet"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "isPending"
        }), "();\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Verpacke in Transition"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "start"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setSignal"
        }), "(newValue), ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-comment",
          children: "/* Transition ist abgeschlossen */"
        }), ")\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "observable",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#observable",
        children: "#"
      }), jsx(_components.code, {
        children: "observable"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " observable<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "input"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Observable"
        }), "<T>;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Diese Methode nimmt ein Signal und erzeugt ein einfaches Observable. Man kann es mit der Bibliothek seiner Wahl konsumieren, typischerweise mit dem ", jsx(_components.code, {
        children: "from"
      }), "-Operator."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"rxjs\""
        }), ";\n\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [s, set] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ");\n\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " obsv$ = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "from"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "observable"
        }), "(s));\n\nobsv$.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "subscribe"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(v));\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "maparray",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#maparray",
        children: "#"
      }), jsx(_components.code, {
        children: "mapArray"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " mapArray<T, U>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "list"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "readonly"
        }), " T[],\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "mapFn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: T, i: () => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "number"
            })]
          }), ") =>"]
        }), " U\n): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " U[];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Eine reaktive Hilfsfunktion vergleichbar mit Array.map die jedes Element speichert, um unnötige Berechnungen von Aktualisierungen zu vermeiden. Die map-Funktion läuft nur einmal pro Element und wird dann ganz nach Bedarf ergänzt oder entfernt. Das Index-Argument ist ein Signal. Die map-Funktion selbst wird nicht verfolgt."
    }), "\n", jsxs(_components.p, {
      children: ["Diese Funktion unterstützt den ", jsx(_components.code, {
        children: "<For>"
      }), "-Ablauf."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " mapped = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "mapArray"
        }), "(source, ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "model"
          }), ") =>"]
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [name, setName] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(model.", jsx(_components.span, {
          className: "hljs-property",
          children: "name"
        }), ");\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [description, setDescription] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(model.", jsx(_components.span, {
          className: "hljs-property",
          children: "description"
        }), ");\n\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " {\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": model.", jsx(_components.span, {
          className: "hljs-property",
          children: "id"
        }), ",\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "name"
        }), "() {\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "name"
        }), "();\n    },\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "description"
        }), "() {\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "description"
        }), "();\n    }\n    setName,\n    setDescription\n  }\n});\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "indexarray",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#indexarray",
        children: "#"
      }), jsx(_components.code, {
        children: "indexArray"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " indexArray<T, U>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "list"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "readonly"
        }), " T[],\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "mapFn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: () => T, i: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "number"
            })]
          }), ") =>"]
        }), " U\n): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " U[];\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Vergleichbar zu ", jsx(_components.code, {
        children: "mapArray"
      }), ", außer das es über den Index iteriert. Der Wert ist ein Signal und der index ist nun eine Konstante."]
    }), "\n", jsxs(_components.p, {
      children: ["Diese Funktion unterstützt den ", jsx(_components.code, {
        children: "<Index>"
      }), "-Ablauf."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " mapped = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "indexArray"
        }), "(source, ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "model"
          }), ") =>"]
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " {\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "id"
        }), "() {\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "model"
        }), "().", jsx(_components.span, {
          className: "hljs-property",
          children: "id"
        }), "\n    }\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "firstInitial"
        }), "() {\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "model"
        }), "().", jsx(_components.span, {
          className: "hljs-property",
          children: "firstName"
        }), "[", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), "];\n    },\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fullName"
        }), "() {\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsxs(_components.span, {
          className: "hljs-string",
          children: ["`", jsx(_components.span, {
            className: "hljs-subst",
            children: "${model().firstName}"
          }), " ", jsx(_components.span, {
            className: "hljs-subst",
            children: "${model().lastName}"
          }), "`"]
        }), ";\n    },\n  }\n});\n"]
      })
    }), "\n", jsxs(_components.h1, {
      id: "stores",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#stores",
        children: "#"
      }), "Stores"]
    }), "\n", jsxs(_components.p, {
      children: ["Diese APIs sind unter ", jsx(_components.code, {
        children: "solid-js/store"
      }), " verfügbar."]
    }), "\n", jsxs(_components.h2, {
      id: "createstore",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createstore",
        children: "#"
      }), jsx(_components.code, {
        children: "createStore"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createStore<T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "StoreNode"
        }), ">(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "state"
        }), ": T | ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>,\n  options?: { name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " }\n): [", jsx(_components.span, {
          className: "hljs-attr",
          children: "get"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>, ", jsx(_components.span, {
          className: "hljs-attr",
          children: "set"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "SetStoreFunction"
        }), "<T>];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Dieser Aufruf erzeugt eine Baumstruktur von Signalen als Proxy, der es erlaubt, individuelle Werte in verschachtelten Datenstrukturen unabhängig voneinander zu tracken. Die create-Funktion gibt ein nur lesbares Proxy-Objekt zurück und eine Funktion zum Überschreiben von Werten."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "(initialValue);\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Wert auslesen"
        }), "\nstate.", jsx(_components.span, {
          className: "hljs-property",
          children: "someValue"
        }), ";\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Wert setzen"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "merge"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"thisValue\""
        }), " });\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"path\""
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"to\""
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"value\""
        }), ", newValue);\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Store-Objekte als Proxies verfolgen nur den Zugriff auf Eigenschaften. Auf Zugriff produziert der Store rekursiv Objekte mit verschachtelten Daten. Allerdings werden nur Arrays und einfache Objekte derart verarbeitet. Dinge wie ", jsx(_components.code, {
        children: "Date"
      }), ", ", jsx(_components.code, {
        children: "HTMLElement"
      }), ", ", jsx(_components.code, {
        children: "Regexp"
      }), ", ", jsx(_components.code, {
        children: "Map"
      }), ", ", jsx(_components.code, {
        children: "Set"
      }), " sind nicht in Bezug auf ihre Daten reaktiv. Außerdem können die Store-Objekte selbst nicht verfolgt werden, ohne dass auf eine ihrer Eigenschaften zugegriffen wird. Dementsprechend ist es nicht dazu geeignet, darüber zu iterieren, da das Hinzufügen neuer Daten oder Indices keine Aktualisierungen auslösen. Somit sollte man Listen lieber als Datenpunkt eines Store-Objekts speichern, statt sie selbst als solches Objekt zu verwenden:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// Nehme die Liste als eine Eigenschaft des State-Objekts"
        }), "\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "list"
        }), ": [] });\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Greife auf `list` im State-Objekt zu"
        }), "\n", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "For"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "each"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{state.list}"
            }), ">"]
          }), "{item => /*...*/}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "For"
            }), ">"]
          })]
        }), "\n"]
      })
    }), "\n", jsxs(_components.h3, {
      id: "getter",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#getter",
        children: "#"
      }), "Getter"]
    }), "\n", jsx(_components.p, {
      children: "Store-Objekte unterstützen die Verwendung von Getter-Funktionen, um berechnete Werte verfügbar zu machen."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "user"
        }), ": {\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "firstName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"John\""
        }), ",\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "lastName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Smith\""
        }), ",\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fullName"
        }), "() {\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsxs(_components.span, {
          className: "hljs-string",
          children: ["`", jsxs(_components.span, {
            className: "hljs-subst",
            children: ["${", jsx(_components.span, {
              className: "hljs-variable language_",
              children: "this"
            }), ".firstName}"]
          }), " ", jsxs(_components.span, {
            className: "hljs-subst",
            children: ["${", jsx(_components.span, {
              className: "hljs-variable language_",
              children: "this"
            }), ".lastName}"]
          }), "`"]
        }), ";\n    },\n  },\n});\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Dies sind einfache Getter, daher muss man Memo verwenden, wenn ein Wert zwischengespeichert werden soll:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "let"
        }), " fullName;\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "user"
        }), ": {\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "firstName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"John\""
        }), ",\n    ", jsx(_components.span, {
          className: "hljs-attr",
          children: "lastName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Smith\""
        }), ",\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fullName"
        }), "() {\n      ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fullName"
        }), "();\n    },\n  },\n});\nfullName = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createMemo"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsxs(_components.span, {
          className: "hljs-string",
          children: ["`", jsx(_components.span, {
            className: "hljs-subst",
            children: "${state.firstName}"
          }), " ", jsx(_components.span, {
            className: "hljs-subst",
            children: "${state.lastName}"
          }), "`"]
        }), ");\n"]
      })
    }), "\n", jsxs(_components.h3, {
      id: "stores-aktualsieren",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#stores-aktualsieren",
        children: "#"
      }), "Stores aktualsieren"]
    }), "\n", jsxs(_components.p, {
      children: ["Änderungen können die Form von Funktionen annehmen, die den vorherigen Zustand übergeben bekommen und den neuen Zustand oder Wert ausgeben. Objekte werden immer nur auf der obersten Ebene zusammengeführt. Man kann Werte auf ", jsx(_components.code, {
        children: "undefined"
      }), " setzen, um sie aus dem Store zu entfernen."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "firstName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"John\""
        }), ",\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "lastName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Miller\""
        }), ",\n});\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "firstName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Johnny\""
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "middleName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Lee\""
        }), " });\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// ({ firstName: 'Johnny', middleName: 'Lee', lastName: 'Miller' })"
        }), "\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "state"
          }), ") =>"]
        }), " ({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "preferredName"
        }), ": state.", jsx(_components.span, {
          className: "hljs-property",
          children: "firstName"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "lastName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Milner\""
        }), " }));\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// ({ firstName: 'Johnny', preferredName: 'Johnny', middleName: 'Lee', lastName: 'Milner' })"
        }), "\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Es werden Pfade unterstützt, einschließlich Schlüssel-Arrays, Objekt-Teile und Filterfunktionen."
    }), "\n", jsx(_components.p, {
      children: "setState unterstützt verschachtelte Objekte, indem man den Pfad zu der Änderung angibt. Wenn der Zustand, der aktualisiert wird, in einem verschachtelten Objekt ist, kann der aktualisierte Wert auch ein anderer als ein Objekt sein. Objekte werden weiterhin zusammengeführt, andere Werte (einschließlich Arrays) werden überschrieben."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "counter"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "2"
        }), ",\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "list"
        }), ": [\n    { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "23"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "title"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Birds'"
        }), " }\n    { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "27"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "title"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Fish'"
        }), " }\n  ]\n});\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'counter'"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "c"
          }), " =>"]
        }), " c + ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), ");\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'list'"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "l"
          }), " =>"]
        }), " [...l, {", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "43"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "title"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Marsupials'"
        }), "}]);\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'list'"
        }), ", ", jsx(_components.span, {
          className: "hljs-number",
          children: "2"
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "'read'"
        }), ", ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), ");\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   counter: 3,"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   list: ["
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { id: 23, title: 'Birds' }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { id: 27, title: 'Fish' }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { id: 43, title: 'Marsupials', read: true }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   ]"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// }"
        }), "\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Der Pfad kann String-Keys, Arrays von String-Keys, Objekte mit Beschreibung einer Iteration ({from, to, by}), oder Filterfunktionen sein. Das gibt erstaundliche Ausdrucksvielfalt, Zustandsveränderungen zu beschreiben."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "todos"
        }), ": [\n    { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "task"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Finish work'"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "completed"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " }\n    { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "task"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Go grocery shopping'"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "completed"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " }\n    { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "task"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "'Make dinner'"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "completed"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " }\n  ]\n});\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'todos'"
        }), ", [", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ", ", jsx(_components.span, {
          className: "hljs-number",
          children: "2"
        }), "], ", jsx(_components.span, {
          className: "hljs-string",
          children: "'completed'"
        }), ", ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), ");\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   todos: ["
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Finish work', completed: true }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Go grocery shopping', completed: false }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Make dinner', completed: true }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   ]"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// }"
        }), "\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'todos'"
        }), ", { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "from"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "to"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), " }, ", jsx(_components.span, {
          className: "hljs-string",
          children: "'completed'"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "c"
          }), " =>"]
        }), " !c);\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   todos: ["
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Finish work', completed: false }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Go grocery shopping', completed: true }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Make dinner', completed: true }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   ]"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// }"
        }), "\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'todos'"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "todo"
          }), " =>"]
        }), " todo.", jsx(_components.span, {
          className: "hljs-property",
          children: "completed"
        }), ", ", jsx(_components.span, {
          className: "hljs-string",
          children: "'task'"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "t"
          }), " =>"]
        }), " t + ", jsx(_components.span, {
          className: "hljs-string",
          children: "'!'"
        }), ")\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   todos: ["
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Finish work', completed: false }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Go grocery shopping!', completed: true }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Make dinner!', completed: true }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   ]"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// }"
        }), "\n\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'todos'"
        }), ", {}, ", jsxs(_components.span, {
          className: "hljs-function",
          children: [jsx(_components.span, {
            className: "hljs-params",
            children: "todo"
          }), " =>"]
        }), " ({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "marked"
        }), ": ", jsx(_components.span, {
          className: "hljs-literal",
          children: "true"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "completed"
        }), ": !todo.", jsx(_components.span, {
          className: "hljs-property",
          children: "completed"
        }), " }))\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// {"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   todos: ["
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Finish work', completed: true, marked: true }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Go grocery shopping!', completed: false, marked: true }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//     { task: 'Make dinner!', completed: false, marked: true }"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "//   ]"
        }), "\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// }"
        }), "\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "produce",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#produce",
        children: "#"
      }), jsx(_components.code, {
        children: "produce"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " produce<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "state: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), "\n): ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["\n  state: T ", jsx(_components.span, {
              className: "hljs-keyword",
              children: "extends"
            }), " NotWrappable ? T : Store<T>\n"]
          }), ") =>"]
        }), " T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "NotWrappable"
        }), " ? T : ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Von Immer inspirierte API für Solids Store-Objekte, die eine lokalisierte Mutation erlauben."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "produce"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "s"
          }), ") =>"]
        }), " {\n    s.", jsx(_components.span, {
          className: "hljs-property",
          children: "user"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "name"
        }), " = ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Frank\""
        }), ";\n    s.", jsx(_components.span, {
          className: "hljs-property",
          children: "list"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "push"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Pencil Crayon\""
        }), ");\n  })\n);\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "reconcile",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#reconcile",
        children: "#"
      }), jsx(_components.code, {
        children: "reconcile"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " reconcile<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "value"
        }), ": T | ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>,\n  options?: {\n    key?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "null"
        }), ";\n    merge?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ";\n  } = { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "key"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"id\""
        }), " }\n): ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["\n  state: T ", jsx(_components.span, {
              className: "hljs-keyword",
              children: "extends"
            }), " NotWrappable ? T : Store<T>\n"]
          }), ") =>"]
        }), " T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "NotWrappable"
        }), " ? T : ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Unterscheidet Datenveränderungen, für den Fall, dass granulare Veränderungen nicht anwendbar sind. Nützlich, wenn man mit unveränderlichen Daten aus Stores oder großen API-Antworten arbeitet."
    }), "\n", jsxs(_components.p, {
      children: ["Die key-Option wird verwendet, um Elemente zu finden. Normalerweise überprüft ", jsx(_components.code, {
        children: "merge"
      }), " false nach Referenz, soweit möglich, um festzustellen, ob gleiche Werte vorliegen und ersetzt Werte, deren Referenz nicht übereinstimmt. ", jsx(_components.code, {
        children: "merge"
      }), " true geht in die Tiefe und führt alle vorherigen Werte mit den neuen zusammen."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// Ein observable anzapfen"
        }), "\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " unsubscribe = store.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "subscribe"
        }), "(", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "{ todos }"
          }), ") =>"]
        }), " (\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "'todos'"
        }), ", ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "reconcile"
        }), "(todos)));\n);\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onCleanup"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "unsubscribe"
        }), "());\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "createmutable",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createmutable",
        children: "#"
      }), jsx(_components.code, {
        children: "createMutable"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createMutable<T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "StoreNode"
        }), ">(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "state"
        }), ": T | ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T>,\n  options?: { name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " }\n): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Store"
        }), "<T> {\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Erzeugt ein überschreibbares Store-Proxy-Objekt. Der Store wird dabei nur aktualisiert, wenn Werte geändert werden. Die Verfolgung wird über das Abfangen von Eigenschafts-Zugriffen vorgenommen und verfolgt automatisch Verschachtelungen per Proxy."
    }), "\n", jsx(_components.p, {
      children: "Nützlich um externe Systeme zu integrieren oder als Kompatibilitätsschicht zu MobX/Vue."
    }), "\n", jsxs(_components.blockquote, {
      children: ["\n", jsxs(_components.p, {
        children: [jsx(_components.strong, {
          children: "Hinweis:"
        }), " Ein überschreibbarer Store kann überall übergeben und aktualisiert werden, was es erschweren kann, Änderungen nachzuvollziehen und es einfacher macht, den unidirektionalen Datenfluss zu brechen. Es wird generell empfohlen, stattdessen ", jsx(_components.code, {
          children: "createStore"
        }), " zu verwenden. Der ", jsx(_components.code, {
          children: "produce"
        }), "-Modifikator can die gleichen Vorteile erbringen, ohne die Nachteile."]
      }), "\n"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " state = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createMutable"
        }), "(initialValue);\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Wert auslesen"
        }), "\nstate.", jsx(_components.span, {
          className: "hljs-property",
          children: "someValue"
        }), ";\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Wert setzen"
        }), "\nstate.", jsx(_components.span, {
          className: "hljs-property",
          children: "someValue"
        }), " = ", jsx(_components.span, {
          className: "hljs-number",
          children: "5"
        }), ";\n\nstate.", jsx(_components.span, {
          className: "hljs-property",
          children: "list"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "push"
        }), "(anotherValue);\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Überschreibbare Stores unterstützen Setter und Getter."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " user = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createMutable"
        }), "({\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "firstName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"John\""
        }), ",\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "lastName"
        }), ": ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"Smith\""
        }), ",\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "get"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fullName"
        }), "() {\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsxs(_components.span, {
          className: "hljs-string",
          children: ["`", jsxs(_components.span, {
            className: "hljs-subst",
            children: ["${", jsx(_components.span, {
              className: "hljs-variable language_",
              children: "this"
            }), ".firstName}"]
          }), " ", jsxs(_components.span, {
            className: "hljs-subst",
            children: ["${", jsx(_components.span, {
              className: "hljs-variable language_",
              children: "this"
            }), ".lastName}"]
          }), "`"]
        }), ";\n  },\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "set"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fullName"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "value"
        }), ") {\n    [", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "this"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "firstName"
        }), ", ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "this"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "lastName"
        }), "] = value.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "split"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\" \""
        }), ");\n  },\n});\n"]
      })
    }), "\n", jsxs(_components.h1, {
      id: "component-apis",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#component-apis",
        children: "#"
      }), "Component APIs"]
    }), "\n", jsxs(_components.h2, {
      id: "createcontext",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createcontext",
        children: "#"
      }), jsx(_components.code, {
        children: "createContext"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Context"
        }), "<T> {\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "id"
        }), ": ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "symbol"
        }), ";\n  ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Provider"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["props: { value: T; children: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "any"
            }), " }"]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ";\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "defaultValue"
        }), ": T;\n}\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createContext<T>(defaultValue?: T): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Context"
        }), "<T | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), ">;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Context erlaubt eine Art Abhängigkeitsinjektion in Solid. Es wird verwendet, um zu verhindern, dass Daten als Props durch dazwischen liegende Komponenten hindurch weitergegeben werden muss."
    }), "\n", jsxs(_components.p, {
      children: ["Diese Funktion erzeugt ein neues Kontext-Objekt, das mit ", jsx(_components.code, {
        children: "useContext"
      }), " verwerdet werden kann und den ", jsx(_components.code, {
        children: "Provider"
      }), "-Kontrollfluss enthält. Der Standardwert des Kontexts wird verwendet, wenn kein ", jsx(_components.code, {
        children: "Provider"
      }), " in der Hierarchie gefunden werden kann."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "CounterContext"
        }), " = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createContext"
        }), "([{ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "count"
        }), ": ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), " }, {}]);\n\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "CounterProvider"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "props"
        }), ") {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, setState] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createStore"
        }), "({ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "count"
        }), ": props.", jsx(_components.span, {
          className: "hljs-property",
          children: "count"
        }), " || ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), " });\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " store = [\n    state,\n    {\n      ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "increment"
        }), "(", jsx(_components.span, {
          className: "hljs-params"
        }), ") {\n        ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"count\""
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "c"
          }), ") =>"]
        }), " c + ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), ");\n      },\n      ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "decrement"
        }), "(", jsx(_components.span, {
          className: "hljs-params"
        }), ") {\n        ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setState"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"count\""
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "c"
          }), ") =>"]
        }), " c - ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), ");\n      },\n    },\n  ];\n\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " (\n    ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "CounterContext.Provider"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "value"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{store}"
            }), ">"]
          }), "\n      {props.children}\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "CounterContext.Provider"
            }), ">"]
          })]
        }), "\n  );\n}\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Der Wert, der dem Provider übergeben wird, wird so, wie er ist, an ", jsx(_components.code, {
        children: "useContext"
      }), " weitergegeben. Das bedeutet, dass die Verwendung des Werts als reaktiver Ausdruck nicht funktioniert. Signals und Stores sollten komplett übergeben werden, anstatt einzelne Datenpunkte im JSX zu übergeben."]
    }), "\n", jsxs(_components.h2, {
      id: "usecontext",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#usecontext",
        children: "#"
      }), jsx(_components.code, {
        children: "useContext"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " useContext<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "context"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Context"
        }), "<T>): T;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Wird verwendet, um Daten aus einem Kontext zu erhalten, statt sie über alle dazwischen liegenden Komponenten als props durchzuleiten."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [state, { increment, decrement }] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "useContext"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "CounterContext"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "children",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#children",
        children: "#"
      }), jsx(_components.code, {
        children: "children"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "children"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["fn: () => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "any"
          })]
        }), "): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Wird verwendet, um die Interaktion mit ", jsx(_components.code, {
        children: "props.children"
      }), " zu vereinfachen. Dieser Helfer löst verschachtelte Reaktivität auf und gibt ein Memo zurück. Der bevorzugte Weg, um ", jsx(_components.code, {
        children: "props.children"
      }), " in allen Fällen zu verwenden, in denen die Kind-Elemente nicht einfach an das JSX durchgereicht werden."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " list = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "children"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " props.", jsx(_components.span, {
          className: "hljs-property",
          children: "children"
        }), ");\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Mache etwas damit"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "list"
        }), "());\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "lazy",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#lazy",
        children: "#"
      }), jsx(_components.code, {
        children: "lazy"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " lazy<T ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Component"
        }), "<", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ">>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<{ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "default"
        }), ": T }>\n): T & { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "preload"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<T> };\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Wird benutzt, um Komponenten verzögert zu laden, damit man den Code aufteilen kann. Komponenten werden nicht geladen, bis sie gerendert werden. Verzögert geladene Komponenten können genauso genutzt werden wie ihre statisch importierten Geschwister, können props empfangen etc... Verzögert geladene Komponenten basieren auf ", jsx(_components.code, {
        children: "<Suspense>"
      }), "."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// Verzögerter Import"
        }), "\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ComponentA"
        }), " = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "lazy"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "import"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"./ComponentA\""
        }), "));\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Im JSX verwenden"
        }), "\n", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "ComponentA"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "title"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{props.title}"
            }), " />"]
          })
        }), ";\n"]
      })
    }), "\n", jsxs(_components.h1, {
      id: "sekundäre-primitiven",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#sekundäre-primitiven",
        children: "#"
      }), "Sekundäre Primitiven"]
    }), "\n", jsx(_components.p, {
      children: "Für eine erste Anwendung wird man diese vermutlich nicht brauchen, aber es nützlich, diese Werkzeuge zu haben."
    }), "\n", jsxs(_components.h2, {
      id: "createdeferred",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createdeferred",
        children: "#"
      }), jsx(_components.code, {
        children: "createDeferred"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createDeferred<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "source"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T,\n  options?: {\n    timeoutMs?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "number"
        }), ";\n    name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\n    equals?: ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), " | (", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "prev: T, next: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ");\n  }\n): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Erzeugt einen nur lesbaren Wert, der reaktive Aktualisierungen so lange verzögert, bis der Browser untätig ist. ", jsx(_components.code, {
        children: "timeoutMs"
      }), " ist die maximale Zeit, die gewartet wird, bis die Aktualisierung in jedem Fall ausgeführt wird."]
    }), "\n", jsxs(_components.h2, {
      id: "createcomputed",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createcomputed",
        children: "#"
      }), jsx(_components.code, {
        children: "createComputed"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createComputed<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v: T"
          }), ") =>"]
        }), " T,\n  value?: T,\n  options?: { name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " }\n): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Erzeutt eine neue Berechnung, die automatisch Abhängigkeiten verfolgt und direkt vor dem Rendern läuft. Wird verwendet, um in andere reaktive Primitiven zu schreiben. Wenn möglich, sollte stattdessen ", jsx(_components.code, {
        children: "createMemo"
      }), " verwendet werden, da das Schreiben in ein Signal während einer Aktualisierung andere Berechnungen neu starten lassen kann."]
    }), "\n", jsxs(_components.h2, {
      id: "createrendereffect",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createrendereffect",
        children: "#"
      }), jsx(_components.code, {
        children: "createRenderEffect"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createRenderEffect<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "v: T"
          }), ") =>"]
        }), " T,\n  value?: T,\n  options?: { name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " }\n): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Erzeugt eine neue Berechnung, die automatisch Abhängigkeiten verfolgt und während der Render-Phase läuft, wenn DOM-Elemente erstellt und aktualisiert werden, aber noch nicht notwendigerweise verbunden sind. Alle internen DOM-Aktualisierungen laufen während dieser Zeit."
    }), "\n", jsxs(_components.h2, {
      id: "createselector",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#createselector",
        children: "#"
      }), jsx(_components.code, {
        children: "createSelector"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " createSelector<T, U>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "source"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T,\n  fn?: ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "a: U, b: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ",\n  options?: { name?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " }\n): ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "k: U"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Erzeugt ein bedingtes Signal, das nur dann die Verfolger aktualisieren lässt, wenn ihr Schlüssel dem Wert entspricht oder nicht mehr entspricht. Nützlich für delegierten Auswahlzustand, da es die Operation in O(2) statt O(n) ausführt."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " isSelected = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSelector"
        }), "(selectedId);\n\n", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "For"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "each"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{list()}"
            }), ">"]
          }), "\n  {(item) => ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "li"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "classList"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{{"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "active:"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "isSelected"
            }), "(", jsx(_components.span, {
              className: "hljs-attr",
              children: "item.id"
            }), ") }}>"]
          }), "{item.name}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "li"
            }), ">"]
          }), "}\n", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "For"
            }), ">"]
          })]
        }), ";\n"]
      })
    }), "\n", jsxs(_components.h1, {
      id: "rendering",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#rendering",
        children: "#"
      }), "Rendering"]
    }), "\n", jsxs(_components.p, {
      children: ["Diese Importe sind in ", jsx(_components.code, {
        children: "solid-js/web"
      }), " verfügbar."]
    }), "\n", jsxs(_components.h2, {
      id: "render",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#render",
        children: "#"
      }), jsx(_components.code, {
        children: "render"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "render"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "\n  code: () => JSX.Element,\n  element: MountableElement\n"
        }), "): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Das ist der Einstiegspunkt für den Browser. Man übergebe eine übergeordnete Componenten-Definition oder -Funktion und ein Element, in welches diese eingehängt wird. Es ist empfohlen, dass dieses Element leer ist, da die zurückgegebene Dispose-Funktion alle Kind-Elemente entfernt."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " dispose = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "render"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ", ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "document"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "getElementById"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"app\""
        }), "));\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "hydrate",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#hydrate",
        children: "#"
      }), jsx(_components.code, {
        children: "hydrate"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "hydrate"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "\n  fn: () => JSX.Element,\n  node: MountableElement\n"
        }), "): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Diese Methode ist ähnlich wie ", jsx(_components.code, {
        children: "render"
      }), ", außer dass es versucht, den vorhandenen Inhalt des DOMs zu rehydrieren. Für den Fall, dass im Browser eine Seite geladen ist, die bereits vom Server gerendert wurde."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " dispose = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "hydrate"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ", ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "document"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "getElementById"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"app\""
        }), "));\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "rendertostring",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#rendertostring",
        children: "#"
      }), jsx(_components.code, {
        children: "renderToString"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " renderToString<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T,\n  options?: {\n    eventNames?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), "[];\n    nonce?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\n  }\n): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Rendert synchron zu einem String. Die Funktion generiert auch ein Script für die fortlaufende Hydration. In options kann man die eventNames der events definieren, die aufgezeichnet werden, während die Seite hydriert wird, und nach der Hydration abgespielt werden und einen Content-Security-Policy nonce-String, der an das Script-Tag angefügt wird."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " html = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "renderToString"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "rendertostringasync",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#rendertostringasync",
        children: "#"
      }), jsx(_components.code, {
        children: "renderToStringAsync"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " renderToStringAsync<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T,\n  options?: {\n    eventNames?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), "[];\n    timeoutMs?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "number"
        }), ";\n    nonce?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\n  }\n): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ">;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Das gleiche wie ", jsx(_components.code, {
        children: "renderToString"
      }), ", außer dass es auf die Auflösung aller ", jsx(_components.code, {
        children: "<Suspense>"
      }), "-Promises wartet, bevor das Ergebnis zurückgegeben wird. Resource-Daten werden automatisch in das Script-Tag serialisiert und nach dem Laden im Client hydriert."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " html = ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "await"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "renderToStringAsync"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ");\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "pipetonodewritable",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#pipetonodewritable",
        children: "#"
      }), jsx(_components.code, {
        children: "pipeToNodeWritable"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "PipeToWritableResults"
        }), " = {\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "startWriting"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "write"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "string"
            })]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "abort"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n};\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " pipeToNodeWritable<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T,\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "writable"
        }), ": { ", jsx(_components.span, {
          className: "hljs-attr",
          children: "write"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "string"
            })]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), " },\n  options?: {\n    eventNames?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), "[];\n    nonce?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\n    noScript?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ";\n    onReady?: ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "r: PipeToWritableResults"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n    onComplete?: ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "r: PipeToWritableResults"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), " | ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Promise"
        }), "<", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ">;\n  }\n): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Diese Methode rendert in einen Node-Stream. Sie rendert den Inhalt synchron einschließlich eller Suspense-Platzhalter und fährt danach fort, die weiteren Daten von jeder asynchronen Ressource, sobald sie vollständig ist."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "pipeToNodeWritable"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ", res);\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Die ", jsx(_components.code, {
        children: "onReady"
      }), "-Option ist nützlich, um in den Stream zu schreiben, während die App gerendert wird. Man bedenke, dass bei Benutzung von ", jsx(_components.code, {
        children: "onReady"
      }), " die Methode ", jsx(_components.code, {
        children: "startWriting"
      }), " manuell aufgerufen werden muss."]
    }), "\n", jsxs(_components.h2, {
      id: "pipetowritable",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#pipetowritable",
        children: "#"
      }), jsx(_components.code, {
        children: "pipeToWritable"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "PipeToWritableResults"
        }), " = {\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "write"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "string"
            })]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "abort"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "script"
        }), ": ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\n};\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " pipeToWritable<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "fn"
        }), ": ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " T,\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "writable"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "WritableStream"
        }), ",\n  options?: {\n    eventNames?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), "[];\n    nonce?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), ";\n    noScript?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ";\n    onReady?: ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["\n      writable: { write: (v: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "string"
            }), ") => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "void"
            }), " },\n      r: PipeToWritableResults\n    "]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n    onComplete?: ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["\n      writable: { write: (v: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "string"
            }), ") => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "void"
            }), " },\n      r: PipeToWritableResults\n    "]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n  }\n): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Diese Methode rendert in einen Web Stream. Sie rendert den Inhalt synchron, einschließlich der Suspense-Platzhalter und fährt dann fort, die Inhalte der asynchronen Ressourcen zu rendern, sobald sie verfügbar werden."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " { readable, writable } = ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "new"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "TransformStream"
        }), "();\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "pipeToWritable"
        }), "(", jsx(_components.span, {
          className: "hljs-title class_",
          children: "App"
        }), ", writable);\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Die ", jsx(_components.code, {
        children: "onReady"
      }), "-Option ist nützlich, um in den Stream zu schreiben, während die App gerendert wird. Man bedenke, dass bei Benutzung von ", jsx(_components.code, {
        children: "onReady"
      }), " die Methode ", jsx(_components.code, {
        children: "startWriting"
      }), " manuell aufgerufen werden muss."]
    }), "\n", jsxs(_components.h2, {
      id: "isserver",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#isserver",
        children: "#"
      }), jsx(_components.code, {
        children: "isServer"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " ", jsx(_components.span, {
          className: "hljs-attr",
          children: "isServer"
        }), ": ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "boolean"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Erlaubt die Unterscheidung, ob der Code gerade auf dem Server oder im Browser ausgeführt wird. Da die darunterliegenden Runtimes den Wert als bool'sche Konstante exportieren, können Bundler den darunterliegenden Code und dessen verwendeten Importe von bestimmten Bundles eliminieren."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "if"
        }), " (isServer) {\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Das hier wird nie im Browser ausgeführt"
        }), "\n} ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "else"
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// und das hier nicht auf dem Server"
        }), "\n}\n"]
      })
    }), "\n", jsxs(_components.h1, {
      id: "kontrollfluss",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#kontrollfluss",
        children: "#"
      }), "Kontrollfluss"]
    }), "\n", jsxs(_components.p, {
      children: ["Solid verwendet Komponenten für den Kontrollfluss. Das liegt daran, dass wir für performante Reaktivität kontrollieren müssen, wie Elemente erzeugt werden. Zum Beispiel mit Listen, eine einfache ", jsx(_components.code, {
        children: "map"
      }), " ist ineffizient, da darin immer alles gemappt wird. Das bedeutet, wir brauchen dazu Helfer-Funktionen."]
    }), "\n", jsx(_components.p, {
      children: "Diese in Komponenten zu verpacken ist ein bequemer Weg, um kurze und bündige Templates mit der Möglichkeit für Nutzer zu verbinden, Kontrollfluss-Komponenten zu kombinieren oder eigene zu erstellen."
    }), "\n", jsxs(_components.p, {
      children: ["Diese eingebauten Kontrollfluss-Komponenten werden automatisch importiert. Alle ausser ", jsx(_components.code, {
        children: "Portal"
      }), " und ", jsx(_components.code, {
        children: "Dynamic"
      }), " werden von ", jsx(_components.code, {
        children: "solid-js"
      }), " verfügbar gemacht. Diese beiden sind spezifisch für das DOM und werden von ", jsx(_components.code, {
        children: "solid-js/web"
      }), " exportiert."]
    }), "\n", jsxs(_components.blockquote, {
      children: ["\n", jsx(_components.p, {
        children: "Hinweis: Alle fallback-Elemente und Kinder aus der children-render-Funktion werden nicht reaktiv verfolgt. Das ermöglicht die Verwendung von verschachtelten States und isoliert die Reaktivität besser."
      }), "\n"]
    }), "\n", jsxs(_components.h2, {
      id: "for",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#for",
        children: "#"
      }), jsx(_components.code, {
        children: "<For>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), "<T, U ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ">(", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": {\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "each"
        }), ": ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "readonly"
        }), " T[];\n  fallback?: ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "children"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["item: T, index: () => ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "number"
            })]
          }), ") =>"]
        }), " U;\n}): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " U[];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Einfacher referentiell-gebundener Iterations-Kontrollfluss."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), " each={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "list"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\n  {", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "item"
          }), ") =>"]
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "{item}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), ">\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Der optionale zweite Parameter ist ein index-Signal:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), " each={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "list"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\n  {", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "item, index"
          }), ") =>"]
        }), " (\n    ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "\n      #{index()} {item}\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "\n  )}\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "For"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "show",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#show",
        children: "#"
      }), jsx(_components.code, {
        children: "<Show>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), "<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": {\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "when"
        }), ": T | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "null"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), ";\n  fallback?: ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "children"
        }), ": ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), " | (", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "item: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ");\n}): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Der Show-Kontrollfluss wird verwendet, um das Rendern einer Komponente von einer Bedingung abhängig zu machen. Sie ist vergleichbar mit dem ternären Operator (", jsx(_components.code, {
        children: "a ? b : c"
      }), ") in der Form eines JSX-Templates."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), " when={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "count"
        }), " > ", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "My Content", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), ">\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Show kann auch benutzt werden, um Inhalte an ein bestimmtes Datenmodell zu koppeln. Bspw. wird die Funktion erneut ausgeführt, wennn das User-Model ersetzt wird."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), " when={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "user"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\n  {", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "user"
          }), ") =>"]
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "{user.firstName}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "switchmatch",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#switchmatch",
        children: "#"
      }), jsx(_components.code, {
        children: "<Switch>"
      }), "/", jsx(_components.code, {
        children: "<Match>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "Switch"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "props: {\n  fallback?: JSX.Element;\n  children: JSX.Element;\n}"
        }), "): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "type"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MatchProps"
        }), "<T> = {\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "when"
        }), ": T | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "undefined"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "null"
        }), " | ", jsx(_components.span, {
          className: "hljs-literal",
          children: "false"
        }), ";\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "children"
        }), ": ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), " | (", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "item: T"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ");\n};\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Match"
        }), "<T>(", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MatchProps"
        }), "<T>);\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Nützlich für Fälle, in denen es mehr als 2 einander ausschließende Bedingungen gibt. Kann benutzt werden, um Dinge wie einfaches Routing zu machen."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Switch"
        }), " fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Not Found", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Match"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "when"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{state.route"
            }), " === ", jsx(_components.span, {
              className: "hljs-string",
              children: "\"home\""
            }), "}>"]
          }), "\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Home"
            }), " />"]
          }), "\n  ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "Match"
            }), ">"]
          })]
        }), "\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Match"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "when"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{state.route"
            }), " === ", jsx(_components.span, {
              className: "hljs-string",
              children: "\"settings\""
            }), "}>"]
          }), "\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Settings"
            }), " />"]
          }), "\n  ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "Match"
            }), ">"]
          })]
        }), "\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Switch"
        }), ">\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Match unterstützt auch Kind-Elemente als bedingten Kontrollfluss."
    }), "\n", jsxs(_components.h2, {
      id: "index",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#index",
        children: "#"
      }), jsx(_components.code, {
        children: "<Index>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), "<T, U ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "extends"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ">(", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": {\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "each"
        }), ": ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "readonly"
        }), " T[];\n  fallback?: ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "children"
        }), ": ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["item: () => T, index: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "number"
            })]
          }), ") =>"]
        }), " U;\n}): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " U[];\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Unbedingte Listen-Iteration (Reihen werden nach Index iteriert). Das ist nützlich, wenn es konzeptionell keinen Schlüssel gibt, etwa wenn die Daten aus Primitiven bestehen und der Index gleichbleibend sein soll statt die darin referenzierten Werte."
    }), "\n", jsx(_components.p, {
      children: "Das Listenelement (im Beispiel item) ist ein Signal:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), " each={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "list"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\n  {", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "item"
          }), ") =>"]
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "{item()}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), ">\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Als optionalen zweiten Parameter wird der Index als Zahl übergeben:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), " each={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "list"
        }), "} fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\n  {", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "item, index"
          }), ") =>"]
        }), " (\n    ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "\n      #{index} {item()}\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "\n  )}\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "errorboundary",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#errorboundary",
        children: "#"
      }), jsx(_components.code, {
        children: "<ErrorBoundary>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "ErrorBoundary"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["props: {\n  fallback: JSX.Element | ((err: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "any"
          }), ", reset: () => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "void"
          }), ") => JSX.Element);\n  children: JSX.Element;\n}"]
        }), "): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Fängt ungefangene Fehler und rendert Fallback-Inhalte."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ErrorBoundary"
        }), " fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Something went terribly wrong", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\n  ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "MyComp"
            }), " />"]
          })
        }), "\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ErrorBoundary"
        }), ">\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Unterstützt auch eine Callback-Form, die den Fehler und eine Reset-Funktion übergibt."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ErrorBoundary"
        }), "\n  fallback={", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "err, reset"
          }), ") =>"]
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "onClick"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{reset}"
            }), ">"]
          }), "Error: {err.toString()}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}\n>\n  ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "MyComp"
            }), " />"]
          })
        }), "\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ErrorBoundary"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "suspense",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#suspense",
        children: "#"
      }), jsx(_components.code, {
        children: "<Suspense>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "Suspense"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "props: {\n  fallback?: JSX.Element;\n  children: JSX.Element;\n}"
        }), "): ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Eine Komponente, die alle Ressourcen verfolgt, die darunter gelesen werden und einen Fallback-Platzhalter anzeigt, bis diese aufgelöst sind. Was ", jsx(_components.code, {
        children: "Suspense"
      }), " von ", jsx(_components.code, {
        children: "Show"
      }), " unterscheidet ist, dass es nicht-blockierend funktioniert, so dass beide Zweige gleichzeitig existieren, selbst wenn sie nicht gegenwärtig im DOM eingehängt sind."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Suspense"
        }), " fallback={", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "Loading...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "}>\n  ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "AsyncComponent"
            }), " />"]
          })
        }), "\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Suspense"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "suspenselist-experimentell",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#suspenselist-experimentell",
        children: "#"
      }), jsx(_components.code, {
        children: "<SuspenseList>"
      }), " (Experimentell)"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "SuspenseList"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["props: {\n  children: JSX.Element;\n  revealOrder: ", jsx(_components.span, {
            className: "hljs-string",
            children: "\"forwards\""
          }), " | ", jsx(_components.span, {
            className: "hljs-string",
            children: "\"backwards\""
          }), " | ", jsx(_components.span, {
            className: "hljs-string",
            children: "\"together\""
          }), ";\n  tail?: ", jsx(_components.span, {
            className: "hljs-string",
            children: "\"collapsed\""
          }), " | ", jsx(_components.span, {
            className: "hljs-string",
            children: "\"hidden\""
          }), ";\n}"]
        }), "): ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "SuspenseList"
      }), " erlaubt es, parallel mehrere ", jsx(_components.code, {
        children: "Suspense"
      }), " und ", jsx(_components.code, {
        children: "SuspenseList"
      }), " Komponenten zu nutzen. Es kontrolliert die Reihenfolge, in welcher der Inhalt gezeigt wird, um Layout-Flackern zu vermeiden und hat Optionen, Fallback-Zustände auszuhängen oder zu verstecken."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "SuspenseList"
        }), " revealOrder=", jsx(_components.span, {
          className: "hljs-string",
          children: "\"forwards\""
        }), " tail=", jsx(_components.span, {
          className: "hljs-string",
          children: "\"collapsed\""
        }), ">\n  ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "ProfileDetails"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "user"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{resource.user}"
            }), " />"]
          })
        }), "\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Suspense"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "fallback"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{"
            }), "<", jsx(_components.span, {
              className: "hljs-attr",
              children: "h2"
            }), ">"]
          }), "Loading posts...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "h2"
            }), ">"]
          }), "}>\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "ProfileTimeline"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "posts"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{resource.posts}"
            }), " />"]
          }), "\n  ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "Suspense"
            }), ">"]
          })]
        }), "\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Suspense"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "fallback"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{"
            }), "<", jsx(_components.span, {
              className: "hljs-attr",
              children: "h2"
            }), ">"]
          }), "Loading fun facts...", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "h2"
            }), ">"]
          }), "}>\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "ProfileTrivia"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "trivia"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{resource.trivia}"
            }), " />"]
          }), "\n  ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "Suspense"
            }), ">"]
          })]
        }), "\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "SuspenseList"
        }), ">\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "SuspenseList ist noch experimentell und hat keine volle SSR-Unterstützung."
    }), "\n", jsxs(_components.h2, {
      id: "dynamic",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#dynamic",
        children: "#"
      }), jsx(_components.code, {
        children: "<Dynamic>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Dynamic"
        }), "<T>(\n  ", jsx(_components.span, {
          className: "hljs-attr",
          children: "props"
        }), ": T & {\n    children?: ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ";\n    component?: ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Component"
        }), "<T> | ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "string"
        }), " | keyof ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "IntrinsicElements"
        }), ";\n  }\n): ", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable constant_",
          children: "JSX"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "Element"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Diese Komponente lässt eine änderbare beliebige Komponente oder Tag einfügen und leitet die Props an diese weiter."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Dynamic"
        }), " component={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "component"
        }), "} someProp={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "something"
        }), "} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "portal",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#portal",
        children: "#"
      }), jsx(_components.code, {
        children: "<Portal>"
      })]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "Portal"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["props: {\n  mount?: Node;\n  useShadow?: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "boolean"
          }), ";\n  isSVG?: ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "boolean"
          }), ";\n  children: JSX.Element;\n}"]
        }), "): ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Text"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Dieser Fluss hängt das Element im Mount-Node ein. Nützlich, um modale Dialoge außerhalb des Seitenlayouts einzufügen. Events propagieren weiterhin durch die Komponentenhierarchie."
    }), "\n", jsxs(_components.p, {
      children: ["Das Portal wird automatisch in ein ", jsx(_components.code, {
        children: "<div>"
      }), " eingehängt, es sei denn, das Ziel ist document.head. ", jsx(_components.code, {
        children: "useShadow"
      }), " platziert das Element in ein Shadow-Root, um die Styles zu isolieren und ", jsx(_components.code, {
        children: "isSVG"
      }), " wird benötigt, um in ein SVG-Element einzufügen, da dabei kein", jsx(_components.code, {
        children: "<div>"
      }), " eingefügt werden darf."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Portal"
        }), " mount={", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "document"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "getElementById"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"modal\""
        }), ")}>\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          }), "My Content", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), ">"]
          })]
        }), "\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Portal"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.h1, {
      id: "spezielle-jsx-attribute",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#spezielle-jsx-attribute",
        children: "#"
      }), "Spezielle JSX-Attribute"]
    }), "\n", jsx(_components.p, {
      children: "Generell versucht Solid, sich an die DOM-Konventionen zu halten. Die meisten Props werden als Attribute für native Elemente gehandhabt und Eigenschaften von Web Components, aber ein paar von ihnen haben ein besonderes Verhalten."
    }), "\n", jsx(_components.p, {
      children: "Für benutzerdefinierte Attribute innerhalb eines Namespaces in TypeScript muss man Solid's JSX-Namespace erweitern:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "declare"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "module"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "namespace"
        }), " JSX {\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Directives"
        }), " {\n      ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// use:____"
        }), "\n    }\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ExplicitProperties"
        }), " {\n      ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// prop:____"
        }), "\n    }\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "ExplicitAttributes"
        }), " {\n      ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// attr:____"
        }), "\n    }\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "CustomEvents"
        }), " {\n      ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// on:____"
        }), "\n    }\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "CustomCaptureEvents"
        }), " {\n      ", jsx(_components.span, {
          className: "hljs-comment",
          children: "// oncapture:____"
        }), "\n    }\n  }\n}\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "ref",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#ref",
        children: "#"
      }), jsx(_components.code, {
        children: "ref"
      })]
    }), "\n", jsx(_components.p, {
      children: "Refs sind ein Weg, um Zugriff auf die unterliegenden DOM-Elemente vom JSX aus zu bekommen. Während es richtig ist, dass man einfach ein Element in eine Variable speichern kann, ist es besser, die Komponenten im JSX-Fluss zu belassen. Refs werden beim Rendern befüllt, aber bevor die Elemente ins DOM eingehängt werden. Es gibt sie in zwei Sorten."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// Einfache Variable"
        }), "\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "let"
        }), " myDiv;\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Man verwende onMount oder createEffect, um die ref nach dem Einhängen ins DOM zu verwenden"
        }), "\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onMount"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(myDiv));\n", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "ref"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{myDiv}"
            }), " />"]
          })
        }), "\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// Oder eine Callback-Function (die vor dem Einhängen ins DOM ausgeführt wird)"
        }), "\n", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "ref"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{el"
            }), " =>"]
          }), " console.log(el)} />"]
        }), "\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Refs können auch in Komponenten verwendet werden. Sie müssen darin aber auch verbunden werden."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "MyComp"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "props"
        }), ") {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "ref"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{props.ref}"
            }), " />"]
          })
        }), ";\n}\n\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "App"
        }), "(", jsx(_components.span, {
          className: "hljs-params"
        }), ") {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "let"
        }), " myDiv;\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onMount"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(myDiv.", jsx(_components.span, {
          className: "hljs-property",
          children: "clientWidth"
        }), "));\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " ", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "MyComp"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "ref"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{myDiv}"
            }), " />"]
          })
        }), ";\n}\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "classlist",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#classlist",
        children: "#"
      }), jsx(_components.code, {
        children: "classList"
      })]
    }), "\n", jsxs(_components.p, {
      children: ["Ein Helfer, der ", jsx(_components.code, {
        children: "element.classList.toggle"
      }), " nutzt. Er nimmt ein Objekt, dessen Schlüssel CSS-Klassennamen sind und setzt diese, wenn der damit referenzierte Wert true ist."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<div\n  classList={{ ", jsx(_components.span, {
          className: "hljs-attr",
          children: "active"
        }), ": state.", jsx(_components.span, {
          className: "hljs-property",
          children: "active"
        }), ", ", jsx(_components.span, {
          className: "hljs-attr",
          children: "editing"
        }), ": state.", jsx(_components.span, {
          className: "hljs-property",
          children: "currentId"
        }), " === row.", jsx(_components.span, {
          className: "hljs-property",
          children: "id"
        }), " }}\n/>\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "style",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#style",
        children: "#"
      }), jsx(_components.code, {
        children: "style"
      })]
    }), "\n", jsxs(_components.p, {
      children: ["Der Style-Helfer von Solid funktioniert entweder mit einem String oder einem Objekt. Anders als Reacts version nutzt Solid ", jsx(_components.code, {
        children: "element.style.setProperty"
      }), " unter der Haube. Somit werden CSS-Variablen unterstützt, allerdings auch die klein geschriebenen, mit Bindestrichen getrennten CSS-Attributnamen. Dies führt tatsächlich zu mehr Geschwindigkeit und Konsistenz mit der SSR-Ausgabe."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// string"
        }), "\n<div style={", jsxs(_components.span, {
          className: "hljs-string",
          children: ["`color: green; background-color: ", jsx(_components.span, {
            className: "hljs-subst",
            children: "${state.color}"
          }), "; height: ", jsx(_components.span, {
            className: "hljs-subst",
            children: "${state.height}"
          }), "px`"]
        }), "} />\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// object"
        }), "\n", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "style"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{{"
            }), "\n  ", jsx(_components.span, {
              className: "hljs-attr",
              children: "color:"
            }), " \"", jsx(_components.span, {
              className: "hljs-attr",
              children: "green"
            }), "\",\n  \"", jsx(_components.span, {
              className: "hljs-attr",
              children: "background-color"
            }), "\"", jsx(_components.span, {
              className: "hljs-attr",
              children: ":"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "state.color"
            }), ",\n  ", jsx(_components.span, {
              className: "hljs-attr",
              children: "height:"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "state.height"
            }), " + \"", jsx(_components.span, {
              className: "hljs-attr",
              children: "px"
            }), "\" }}\n/>"]
          })
        }), "\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// css variable"
        }), "\n", jsx(_components.span, {
          className: "xml",
          children: jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "div"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "style"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{{"
            }), " \"", jsx(_components.span, {
              className: "hljs-attr",
              children: "--my-custom-color"
            }), "\"", jsx(_components.span, {
              className: "hljs-attr",
              children: ":"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "state.themeColor"
            }), " }} />"]
          })
        }), "\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "innerhtmltextcontent",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#innerhtmltextcontent",
        children: "#"
      }), jsx(_components.code, {
        children: "innerHTML"
      }), "/", jsx(_components.code, {
        children: "textContent"
      })]
    }), "\n", jsxs(_components.p, {
      children: ["Die beiden funktionieren genauso wie die entsprechenden Eigenschaften. Wenn man einen String übergibt, wird dieser gesetzt. ", jsx(_components.strong, {
        children: "Vorsicht!!"
      }), " ", jsx(_components.code, {
        children: "innerHTML"
      }), " mit irgendwelchen Daten zu füttern, die der Nutzer beeinflussen kann, macht einen potentiellen Angriffsvektor für bösartige Attacken auf. ", jsx(_components.code, {
        children: "textContent"
      }), " wird normalerweise nicht benötigt, ist aber tatsächlich eine Geschwindigkeitsoptimierung, wenn die Kind-Inhalte ausschließlich Text sind, da damit die normale Abgleichsroutine umgangen werden kann."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<div textContent={state.", jsx(_components.span, {
          className: "hljs-property",
          children: "text"
        }), "} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "on___",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#on___",
        children: "#"
      }), jsx(_components.code, {
        children: "on___"
      })]
    }), "\n", jsxs(_components.p, {
      children: ["Event-Handler in Solid haben typischerweise die Form von ", jsx(_components.code, {
        children: "onclick"
      }), " oder ", jsx(_components.code, {
        children: "onClick"
      }), " je nach Stil. Der Event-Name ist immer klein geschrieben. Solid verwendet halb-synthetische Event-Delegation für normale UI-Events, die zusammengesetzt werden und bubbeln. Das verbessert die Geschwindigkeit dieser gewöhnlichen Events."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<div onClick={", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "e"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "console"
        }), ".", jsx(_components.span, {
          className: "hljs-title function_",
          children: "log"
        }), "(e.", jsx(_components.span, {
          className: "hljs-property",
          children: "currentTarget"
        }), ")} />\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Solid unterstützt auch die Möglichkeit, ein Array an Stelle eines Event-Handlers zu übergeben, um einen Wert an den ersten Parameter des Event-Handlers zu binden. Dabei wird kein ", jsx(_components.code, {
        children: "bind"
      }), " verwendet oder eine zusätzliche Closure erzeugt, daher ist es eine hochgradig optimierte Möglichkeit, Events zu delegieren."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "handler"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "itemId, e"
        }), ") {\n  ", jsx(_components.span, {
          className: "hljs-comment",
          children: "/*...*/"
        }), "\n}\n\n<ul>\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "For"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "each"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{state.list}"
            }), ">"]
          }), "{(item) => ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "li"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "onClick"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{[handler,"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "item.id"
            }), "]} />"]
          }), "}", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "For"
            }), ">"]
          })]
        }), "\n</ul>;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Events können nicht neu gebunden werden und die Bindungen sind nicht reaktiv. Der Grund dafür ist, dass es generell mehr Zeit kostet, Event-Listener anzubinden und zu entfernen. Da Events natürlich aufgerufen werden, gibt es keine Notwendigkeit für Reaktivität - falls gewünscht, kann man den Handler einfach optional machen."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-comment",
          children: "// Falls definiert, wird der Handler aufgerufen, ansonsten nicht."
        }), "\n<div onClick={", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " props.", jsx(_components.span, {
          className: "hljs-property",
          children: "handleClick"
        }), "?.()} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "on___oncapture___",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#on___oncapture___",
        children: "#"
      }), jsx(_components.code, {
        children: "on:___"
      }), "/", jsx(_components.code, {
        children: "oncapture:___"
      })]
    }), "\n", jsxs(_components.p, {
      children: ["Für andere Events, etwa welche mit unüblichen Namen oder welche, die nicht delegiert werden sollen, gibt es den ", jsx(_components.code, {
        children: "on"
      }), "-Namespace. Dieser gibt eine zusätzliche Möglichkeit, Event-Listener einzuhängen."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<div ", jsx(_components.span, {
          className: "hljs-attr",
          children: "on"
        }), ":", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Weird"
        }), "-", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Event"
        }), "={", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "e"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "alert"
        }), "(e.", jsx(_components.span, {
          className: "hljs-property",
          children: "detail"
        }), ")} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "use___",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#use___",
        children: "#"
      }), jsx(_components.code, {
        children: "use:___"
      })]
    }), "\n", jsx(_components.p, {
      children: "Das sind benutzerdefinierte Direktiven. Auf eine Art sind sie ein syntaktischer Zucker über ref, aber erlauben es, sehr einfach, multiple Direktiven an ein einzelnes Element zu binden. Eine Direktive ist einfach eine Funktion mit der folgenden Signatur:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "directive"
        }), "(", jsxs(_components.span, {
          className: "hljs-params",
          children: ["element: Element, accessor: () => ", jsx(_components.span, {
            className: "hljs-built_in",
            children: "any"
          })]
        }), "): ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "void"
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Directive Funktionen werden während des Renders aufgerufen, aber bevor das Element ins DOM eingebunden wird. Man kann darinnen alles machen, was man möchte, einschließlich Signale erzeugen, Effekte, Clean-Up-Funktionen registrieren, etc."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [name, setName] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"\""
        }), ");\n\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "model"
        }), "(", jsx(_components.span, {
          className: "hljs-params",
          children: "el, value"
        }), ") {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [field, setField] = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "value"
        }), "();\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createRenderEffect"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " (el.", jsx(_components.span, {
          className: "hljs-property",
          children: "value"
        }), " = ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "field"
        }), "()));\n  el.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "addEventListener"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "\"input\""
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "e"
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setField"
        }), "(e.", jsx(_components.span, {
          className: "hljs-property",
          children: "target"
        }), ".", jsx(_components.span, {
          className: "hljs-property",
          children: "value"
        }), "));\n}\n\n<input type=", jsx(_components.span, {
          className: "hljs-string",
          children: "\"text\""
        }), " ", jsx(_components.span, {
          className: "hljs-attr",
          children: "use"
        }), ":model={[name, setName]} />;\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Um Direktiven mit TypeScript zu verwenden, muss man den JSX-Namespace erweitern."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-ts",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "declare"
        }), " ", jsx(_components.span, {
          className: "hljs-variable language_",
          children: "module"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"solid-js\""
        }), " {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "namespace"
        }), " JSX {\n    ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "interface"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Directives"
        }), " {\n      ", jsx(_components.span, {
          className: "hljs-attr",
          children: "model"
        }), ": [", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), ", ", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsxs(_components.span, {
            className: "hljs-params",
            children: ["v: ", jsx(_components.span, {
              className: "hljs-built_in",
              children: "any"
            })]
          }), ") =>"]
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "any"
        }), "];\n    }\n  }\n}\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "prop___",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#prop___",
        children: "#"
      }), jsx(_components.code, {
        children: "prop:___"
      })]
    }), "\n", jsx(_components.p, {
      children: "Erzwingt die Behandlung als Eigenschaft statt als Attribut."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<div ", jsx(_components.span, {
          className: "hljs-attr",
          children: "prop"
        }), ":scrollTop={props.", jsx(_components.span, {
          className: "hljs-property",
          children: "scrollPos"
        }), " + ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"px\""
        }), "} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "attr___",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#attr___",
        children: "#"
      }), jsx(_components.code, {
        children: "attr:___"
      })]
    }), "\n", jsx(_components.p, {
      children: "Erzwingt die Behandlung als Attribut statt als Eigenschaft. Nützlich für Web Components, bei denen man Attribute setzen möchte."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<my-element ", jsx(_components.span, {
          className: "hljs-attr",
          children: "attr"
        }), ":status={props.", jsx(_components.span, {
          className: "hljs-property",
          children: "status"
        }), "} />\n"]
      })
    }), "\n", jsxs(_components.h2, {
      id: "-once-",
      children: [jsx(_components.a, {
        className: "header-anchor",
        href: "#-once-",
        children: "#"
      }), jsx(_components.code, {
        children: "/* @once */"
      })]
    }), "\n", jsx(_components.p, {
      children: "Solids JSX-Compiler verwendet eine einfache Heuristik für reaktives Verpacken und verzögerte Evaluierung von JSX-Ausdrücken. Erhält er einen Funktionsaufruf, ein Zugriff auf Props, oder JSX? Falls ja, werden diese in einen getter verpackt, wenn sie an native Elemente, Komponenten oder Effekte übergeben werden."
    }), "\n", jsxs(_components.p, {
      children: ["Das zu wissen, hilft uns, die unnötige Behandlung von Dingen zu vermeiden, von denen wir wissen, dass sie sich nicht ändern werden, indem wir sie außerhalb des JSX addressieren. Eine einfache Variable wird nicht verpackt. Wir können dem Compiler auch manuell mitteilen, dass er einen Wert nicht verpacken soll, indem wir ihm einen einfachen Dekorator ", jsx(_components.code, {
        children: "/* @once */"
      }), " voranstellen."]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MyComponent"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "static"
        }), "={", jsx(_components.span, {
          className: "hljs-comment",
          children: "/*@once*/"
        }), " state.", jsx(_components.span, {
          className: "hljs-property",
          children: "wontUpdate"
        }), "} />\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Das funktioniert auch bei Kind-Elementen."
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MyComponent"
        }), ">{", jsx(_components.span, {
          className: "hljs-comment",
          children: "/*@once*/"
        }), " state.", jsx(_components.span, {
          className: "hljs-property",
          children: "wontUpdate"
        }), "}</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "MyComponent"
        }), ">\n"]
      })
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
